HierarchicalItem subclass:#DOM3NodeItem
	instanceVariableNames:'node'
	classVariableNames:''
	poolDictionaries:''
	privateIn:XMLv2::DOM3Inspector
!

!DOM3Inspector::DOM3NodeItem class methodsFor:'instance creation'!

for: node 

    ^self new setNode: node; yourself

    "Created: / 12-12-2006 / 00:32:53 / janfrog"
!

for: node parent: parent

    ^self new setNode: node; parent: parent; yourself

    "Created: / 12-12-2006 / 00:30:51 / janfrog"
! !

!DOM3Inspector::DOM3NodeItem methodsFor:'accessing'!

children

    children ifNil:
        [children := node childNodes 
                        select:[:childNode| (childNode isText not) or:[childNode isIgnorableText not]]
                        thenCollect:[:childNode|self class for:childNode parent: self.]].
    ^children

    "Created: / 12-12-2006 / 00:21:50 / janfrog"
    "Modified: / 12-12-2006 / 10:32:05 / janfrog"
!

label

    node isElement ifTrue:[^'<',node nodeName,'>'].
    ^node nodeName

    "Created: / 12-12-2006 / 00:19:56 / janfrog"
!

node
    ^ node

    "Created: / 12-12-2006 / 09:46:03 / janfrog"
! !

!DOM3Inspector::DOM3NodeItem methodsFor:'initialization'!

setNode: aNode

    node := aNode

    "Created: / 12-12-2006 / 00:22:34 / janfrog"
! !

!DOM3Inspector::DOM3NodeItem methodsFor:'message delegation'!

doesNotUnderstand: aMessage

    ^(node respondsTo: aMessage selector)
        ifTrue:[aMessage reinvokeFor: node]
        ifFalse:[super doesNotUnderstand: aMessage]

    "Created: / 12-12-2006 / 09:04:49 / janfrog"
! !

