"{ Package: 'stx:goodies/xmlsuite/core' }"

LibraryDefinition subclass:#stx_goodies_xmlsuite_core
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_xmlsuite_core class methodsFor:'description'!

preRequisites
    ^ #(
        #'cvut:fel/libutilui'    "DomainModelUI - superclass of XMLv2::DOM3Inspector "
        #'stx:goodies/libtool3'    "Tools::Inspector2 - referenced by XMLv2::Node>>inspectorClass "
        #'stx:goodies/sunit'    "TestCase - superclass of XMLv2::AbstractDOM3TestCase "
        #'stx:goodies/xml/vw'    "XML::SAXBuilder - superclass of XMLv2::VWSAXBuilder "
        #'stx:goodies/xmlsuite/xmlreaderimpl'    "XMLv2::VWXMLReader - referenced by XMLv2::XMLReader class>>getDefaultImplementation "
        #'stx:libbasic'    "Object - superclass of XMLv2::DocumentFragment "
        #'stx:libbasic2'    "URI - referenced by XMLv2::InputSource>>getSystemId "
        #'stx:libcomp'    "ObjectFileLoader - referenced by stx_goodies_xmlsuite_xmlreaderimpl class>>preLoadAction "
        #'stx:libtool'    "InspectorView - referenced by XMLv2::DOM3Inspector>>domNodeInspectorView "
        #'stx:libview'    "Color - referenced by XMLv2::IndentingAndHighlightingXMLWriter class>>commentColor "
        #'stx:libview2'    "Model - superclass of XMLv2::DOM3Inspector::ElementPropertiesPane "
        #'stx:libwidg2'    "HierarchicalItem - superclass of XMLv2::DOM3Inspector::DOM3NodeItem "
    )
!

subProjects
   ^#(
   	#'stx:goodies/xmlsuite/xmlreaderimpl'
   )

! !

!stx_goodies_xmlsuite_core class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'XMLv2::AbstractDOM3TestCase'
        #'XMLv2::AbstractSAX2Handler'
        #'XMLv2::AbstractW3CDOM3TestCase'
        #'XMLv2::DOM3Inspector'
        #'XMLv2::DOM3NodeDumper'
        #'XMLv2::DOM3Tests'
        #'XMLv2::DOMBuilder'
        #'XMLv2::DOMConfiguration'
        #'XMLv2::DOMError'
        #'XMLv2::DOMErrorHandler'
        #'XMLv2::DOMErrorMonitor'
        #'XMLv2::DOMImplementation'
        #'XMLv2::DOMImplementationRegistry'
        #'XMLv2::EncodingTests'
        #'XMLv2::InputSource'
        #'XMLv2::JamesClarkCanonicalXMLWriterTestResource'
        #'XMLv2::JamesClarkCanonicalXMLWriterTests'
        #'XMLv2::JamesClarkXMLTests'
        #'XMLv2::NameList'
        #'XMLv2::Node'
        #'XMLv2::NodeList'
        #'XMLv2::NodeName'
        #'XMLv2::NodeNameTests'
        #'XMLv2::OASISXMLTests'
        #'XMLv2::ParseError'
        #'XMLv2::Parser'
        #'XMLv2::SAXError'
        #'XMLv2::TypeInfo'
        #'XMLv2::UserDataHandler'
        #'XMLv2::W3XMLTestSuiteResource'
        #'XMLv2::XMLBuilder'
        #'XMLv2::XMLBuilderTests'
        #'XMLv2::XMLEventRecorder'
        #'XMLv2::XMLReader'
        #'XMLv2::XMLReaderImplementationQuery'
        #'XMLv2::XMLReaderTests'
        #'XMLv2::XMLWriter'
        #'XMLv2::XMLWriterTests'
        #'stx_goodies_xmlsuite_core'
        #'XMLv2::Attr'
        #'XMLv2::CharacterData'
        #'XMLv2::CincomDOMXMLReader'
        #'XMLv2::CincomImplementation'
        #'XMLv2::ContentHandler'
        #'XMLv2::DOM3XMLReader'
        #'XMLv2::DOMException'
        #'XMLv2::DTDHandler'
        #'XMLv2::Document'
        #'XMLv2::DocumentFragment'
        #'XMLv2::DocumentType'
        #'XMLv2::Element'
        #'XMLv2::Entity'
        #'XMLv2::EntityReference'
        #'XMLv2::EntityResolver'
        #'XMLv2::ErrorHandler'
        #'XMLv2::IndentingXMLWriter'
        #'XMLv2::JamesClarkCanonicalXMLWriter'
        #'XMLv2::NamedNodeMap'
        #'XMLv2::NodeTests'
        #'XMLv2::Notation'
        #'XMLv2::ProcessingInstruction'
        #'XMLv2::SAXParseError'
        #'XMLv2::W3CDOM3CoreTests'
        #'XMLv2::XMLGenerator'
        #'XMLv2::XMLSuiteDOM3Implementation'
        #'XMLv2::Attributes'
        #'XMLv2::CDATASection'
        #'XMLv2::Comment'
        #'XMLv2::DOM3Builder'
        #'XMLv2::IndentingAndHighlightingXMLWriter'
        #'XMLv2::OldXMLWriter'
        #'XMLv2::Text'
        #'XMLv2::XMLSyntaxHighlightingWriter'
    )
!

extensionMethodNames
    ^ #(
        Character isInXMLCharSpec:
        Character isXMLBaseChar
        Character isXMLChar
        Character isXMLCombiningChar
        Character isXMLDigit
        Character isXMLExtender
        Character isXMLIdeographic
        Character isXMLLetter
        Character isXMLPubidChar
        Character isXMLWhiteSpace
        CharacterArray asJamesClarkCanonicalXMLEscapedString
        CharacterArray asXMLEscapedString
        #'XML::Comment' xPath
        #'XML::NodeTag' qualifiedName
        #'XML::NodeTag' qualifier:
        'Character class' xmlBaseCharValues
        'Character class' xmlCombiningCharValues
        'Character class' xmlDigitValues
        'Character class' xmlExtenderValues
        'CharacterArray class' fromXMLEscapedString:
    )
! !

!stx_goodies_xmlsuite_core class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2008\nCopyright eXept Software AG 1998-2008'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_xmlsuite_core class methodsFor:'documentation'!

version
    ^'$Id$'
! !
