"{ Package: 'stx:goodies/xmlsuite/xmlreaderimpl' }"

LibraryDefinition subclass:#stx_goodies_xmlsuite_xmlreaderimpl
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_xmlsuite_xmlreaderimpl class methodsFor:'description'!

preLoadAction
	ObjectFileLoader searchedLibraries:
	        (ObjectFileLoader searchedLibraries asOrderedCollection
			add: '/usr/lib/libexpat.so';
			yourself) asArray

!
postLoadAction

    | packageDir expatXMLReaderLib |
    packageDir := Smalltalk getPackageDirectoryForPackage: self package. 

    expatXMLReaderLib := ((packageDir construct: 'precompiled') construct: Smalltalk versionString) construct:
                                    ('XMLv2__ExpatXMLReader' , 
                                    ObjectFileLoader sharedLibraryExtension). 
    expatXMLReaderLib exists ifFalse:
        [expatXMLReaderLib := ((packageDir construct: 'precompiled') construct: 'common') construct:
                                        ('XMLv2__ExpatXMLReader' , 
                                        ObjectFileLoader sharedLibraryExtension)].
    expatXMLReaderLib exists ifTrue:
        [Transcript showCR:'Loading precompiled ExpatXMLReader class from: ' , expatXMLReaderLib nameString.
        ObjectFileLoader loadObjectFile: expatXMLReaderLib nameString].

    "
        self postLoadAction   
    "

    "Modified: / 25-03-2009 / 13:46:27 / Martin Plicka <plickm1@fel.cvut.cz>"

!

preRequisites
    ^ #(
        #'stx:goodies/xml/vw'    "XML::XMLParser - superclass of XMLv2::VWXMLReader::XMLParser "
        #'stx:goodies/xmlsuite/core'    "XMLv2::XMLReader - superclass of XMLv2::ExpatXMLReader "
        #'stx:libbasic'    "Object - superclass of XMLv2::VWXMLReader "
        #'stx:libcomp'    "ObjectFileLoader - referenced by stx_goodies_xmlsuite_xmlreaderimpl class>>preLoadAction "
    )

    "Modified: / 02-06-2008 / 22:37:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!stx_goodies_xmlsuite_xmlreaderimpl class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        (#'XMLv2::ExpatXMLReader' autoload)
	(#'XMLv2::XercesCXMLReader' autoload)
        #'XMLv2::VWSAXBuilder'
        #'XMLv2::VWXMLReader'
        #'stx_goodies_xmlsuite_xmlreaderimpl'
    )
!

extensionMethodNames
    ^ #(
    )
! !

!stx_goodies_xmlsuite_xmlreaderimpl class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2008\nCopyright eXept Software AG 1998-2008'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

