"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

InsertCommand subclass:#InsertAsLastIntoCommand
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Update Facility'
!


!InsertAsLastIntoCommand class methodsFor:'priorities'!

priority
    "Superclass says that I am responsible to implement this method"

    ^20
! !

!InsertAsLastIntoCommand methodsFor:'checks'!

checkSourceSequence:anXQuerySequence 

    | foundNonAttribute |
    foundNonAttribute := false.
    anXQuerySequence do:
        [:seqItem|
        self 
            assert: ((seqItem type == XQuerySequenceItem typeAttribute and:[foundNonAttribute])) not
            description:'An attribute found after non-attribute (see section 2.3.1.)'.
        foundNonAttribute := (seqItem type == XQuerySequenceItem typeAttribute) not]

    "Modified: / 21-11-2007 / 11:24:56 / janfrog"
!

checkTargetSequence: anXQuerySequence 

    self
        assert: anXQuerySequence containsSingleElement
        description: 'target must be a single element or document node (see section 2.3.1.)'.

    "Modified: / 05-12-2007 / 21:56:19 / janfrog"
! !

!InsertAsLastIntoCommand methodsFor:'executing'!

execute
    "Superclass says that I am responsible to implement this method"

    self sourceSequence
        do:[:node|self insert: node asLastInto: self targetSequence first]

    "Created: / 21-11-2007 / 11:22:31 / janfrog"
! !

!InsertAsLastIntoCommand methodsFor:'inserting'!

insert:sourceNode asLastInto:targetNode 
    |importedSourceNodeId|

    importedSourceNodeId := targetNode documentAdaptor 
                importForeignNode:sourceNode item nodeId
                adaptor:sourceNode documentAdaptor.
    (sourceNode type == XQuerySequenceItem typeAttribute) ifTrue:[
        targetNode documentAdaptor updInsertAttribute:importedSourceNodeId
            into:targetNode item nodeId
    ] ifFalse:[
        targetNode documentAdaptor updInsert:importedSourceNodeId
            asLastInto:targetNode item nodeId
    ]

    "Created: / 21-11-2007 / 11:28:21 / janfrog"
    "Modified: / 05-12-2007 / 14:26:29 / janfrog"
! !

!InsertAsLastIntoCommand class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__InsertAsLastIntoCommand.st,v 1.4 2008-01-02 14:08:16 wrobll1 Exp $'
! !
