"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

UpdateCommand subclass:#RenameCommand
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Update Facility'
!


!RenameCommand class methodsFor:'priorities'!

priority
    "Superclass says that I am responsible to implement this method"

    ^10
! !

!RenameCommand methodsFor:'checks'!

checkSourceSequence: anXQuerySequence

    self 
        assert: anXQuerySequence containsSingleString
        description:'Sequence must contain excatly one item with type QNAME (see section 2.3.4)'
!

checkTargetSequence: anXQuerySequence 

    self 
        assert: (anXQuerySequence containsSingleElement or:[anXQuerySequence containsSingleAttribute])
        description:'Only elements or attributes can be renamed (see section 2.3.4)'.
! !

!RenameCommand methodsFor:'executing'!

execute
    "Superclass says that I am responsible to implement this method"

    self renameNode: self targetSequence first  to: self sourceSequence first
! !

!RenameCommand methodsFor:'renaming'!

renameNode: node to: name

    node documentAdaptor
       updRename: node nodeId to: name item         
! !

!RenameCommand class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__RenameCommand.st,v 1.4 2008-01-02 14:09:00 wrobll1 Exp $'
! !
