"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Object subclass:#UpdateCommand
	instanceVariableNames:'sourceSequence targetSequence'
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Update Facility'
!


!UpdateCommand class methodsFor:'priorities'!

priority

self subclassResponsibility
! !

!UpdateCommand methodsFor:'accessing'!

sourceSequence
    ^ sourceSequence
!

sourceSequence:anXQuerySequence

    self checkSourceSequence: anXQuerySequence.

    sourceSequence := anXQuerySequence.
!

targetSequence
    ^ targetSequence
!

targetSequence:anXQuerySequence

    self checkTargetSequence: anXQuerySequence.

    targetSequence := anXQuerySequence.
! !

!UpdateCommand methodsFor:'checks'!

assert: aBlockOrBoolean description: aString

    aBlockOrBoolean value ifFalse:
        [XQueryInterpreterError raiseErrorString:'err:TBD - ', aString]
!

checkSourceSequence:anXQUerySequence

    self subclassResponsibility
!

checkTargetSequence:anXQUerySequence

    self subclassResponsibility
! !

!UpdateCommand methodsFor:'enumerating'!

do: aBlock

        aBlock value: self
! !

!UpdateCommand methodsFor:'executing'!

execute

    ^self subclassResponsibility
! !

!UpdateCommand methodsFor:'flattening'!

flatten
!

flattenOn: stream

        stream nextPut: self
! !

!UpdateCommand methodsFor:'merging'!

mergeWith: anotherCommand

        ^CompositeCommand
                with:self
                with:anotherCommand
! !

!UpdateCommand methodsFor:'priorities'!

< anotherCommand

  self priority < anotherCommand priority
!

<= anotherCommand

  self priority <= anotherCommand priority
!

> anotherCommand

  self priority > anotherCommand priority
!

>= anotherCommand

  self priority >= anotherCommand priority
!

priority

        ^self class priority
! !

!UpdateCommand class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__UpdateCommand.st,v 1.4 2008-01-02 14:08:22 wrobll1 Exp $'
! !
