"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

TestCase subclass:#XQTSTestCase
	instanceVariableNames:'interpreter'
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Tests-XQTS'
!


!XQTSTestCase class methodsFor:'accessing'!

resources

    ^Array with: XQTSTestResource

    "Created: / 10-11-2008 / 16:23:19 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQTSTestCase class methodsFor:'testing'!

isAbstract

    ^self == XQTSTestCase

    "Created: / 10-11-2008 / 16:22:09 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQTSTestCase methodsFor:'assertions'!

should: block raiseErrorCodes: arrayOfErrorCodes

    <resource: #skipInDebuggersWalkBack>

    ^ self assert:
            (self 
                executeShould:block 
                inScopeOf:(XQueryParserError, XQueryInterpreterError)
                suchThat:[:ex|arrayOfErrorCodes includes:ex errorCode])

    "Created: / 10-11-2008 / 16:53:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 10-11-2008 / 18:39:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQTSTestCase methodsFor:'initialization & release'!

setUp

    super setUp.
    interpreter := XQueryInterpreter new.

    "Created: / 10-11-2008 / 17:01:23 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQTSTestCase methodsFor:'private'!

executeShould: aBlock inScopeOf: anExceptionalEvent suchThat: suchBlock

    [aBlock value]
        on: anExceptionalEvent
        do: [:ex | ^suchBlock value: ex].
    ^false.

    "Created: / 10-11-2008 / 18:40:05 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQTSTestCase methodsFor:'xqts utilities'!

xqtsBind: variableName toContentsOf: fileName
    | variableValue document documentAdaptor |

    document := XMLv2::Parser forDOM3 processDocumentInFilename:
                    (XQTSTestResource current xqtsInputFile: fileName).
    documentAdaptor := XMLv2::XPathDOM3DocumentAdaptor new document: document.
    variableValue := XQuerySequence withNode:
                        (XQueryAccessedNode new 
                            documentAdaptor: documentAdaptor;
                            nodeId: documentAdaptor xpathDocument).

    interpreter
        bindExternalVar: variableName
        to: variableValue.

    "Created: / 10-11-2008 / 17:23:19 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 18-04-2009 / 13:00:37 / Jan Kurs <kursj1@fel.cvut.cz>"
!

xqtsResultTextFromFile: fileName
    ^(XQTSTestResource current xqtsResultFile: fileName) contents asStringWithoutFinalCR

    "Created: / 10-11-2008 / 17:10:35 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-04-2009 / 13:12:45 / Jan Kurs <kursj1@fel.cvut.cz>"
!

xqtsResultTextFromResult: xqueryResult

    ^xqueryResult asString

    "Created: / 10-11-2008 / 17:10:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 18-04-2009 / 15:04:02 / Jan Kurs <kursj1@fel.cvut.cz>"
!

xqtxBind: what toContentsOf: contents
    "Method to overcome xqts-generator bug"
    ^self xqtsBind: what toContentsOf: contents

    "Created: / 08-03-2009 / 20:21:46 / Jan Kurs <kursj1@fel.cvut.cz>"
! !

!XQTSTestCase class methodsFor:'documentation'!

version
    ^'$Id$'
! !
