"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Perseus::Scanner subclass:#XQueryScanner
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Core'
!


!XQueryScanner class methodsFor:'generated-comments'!

scannerDefinitionComment

	"<whitespace> : \s+;
<comment> : \(\:.*\:\);
<char> : [a-zA-Z];
<digit> : [0-9];
<char_ref> : ((&\#[0-9]+\;) | (&\#x[0-9a-fA-F]+\;));

<ncnamechar> : (<char> | <digit> | \. | \- | \_);
<ncname> : (<char> | \_) (<ncnamechar>)*;
<qname> : (<ncname> \:)? <ncname>;

<digits> : [0-9]+;
<integer_literal> : <digits>;
<decimal_literal> : (\.<digits>) | (<digits>\.[0-9]*);
<double_literal> : ((\.<digits>) | (<digits>(\.[0-9]*)?)) [eE] [\+\-]? <digits>;

<predefined_entity_ref> : &(lt | gt | amp | quot | apos)\;;
<escape_quot> : """";
<escape_apos> : '';

<string_literal> : ("" (<predefined_entity_ref> | <char_ref> | <escape_quot> | [^""&])* "") | (' (<predefined_entity_ref> | <char_ref> | <escape_apos> | [^'&])* ');

<element_content_char> : <char> - [{}<&];
<qout_attr_content_char> : <char> - [""{}<&];
<apos_attr_content_char> : <char> - ['{}<&];
"
! !

!XQueryScanner class methodsFor:'generated-initialization'!

initializeKeywordMap
    keywordMap := Dictionary new.
    #( #(121 'after' 77)
     #(121 'ancestor' 106)
     #(121 'and' 2)
     #(121 'as' 16)
     #(121 'ascending' 50)
     #(121 'at' 51)
     #(121 'attribute' 113)
     #(121 'before' 78)
     #(121 'by' 48)
     #(121 'child' 103)
     #(121 'comment' comment)
     #(121 'copy' 80)
     #(121 'declare' 36)
     #(121 'default' 34)
     #(121 'delete' 86)
     #(121 'descendant' 109)
     #(121 'descending' 58)
     #(121 'div' 11)
     #(121 'do' 71)
     #(121 'document' 61)
     #(121 'element' 31)
     #(121 'else' 4)
     #(121 'empty' 28)
     #(121 'eq' 99)
     #(121 'every' 14)
     #(121 'except' 27)
     #(121 'external' 35)
     #(121 'first' 79)
     #(121 'following' 117)
     #(121 'for' 59)
     #(121 'function' 32)
     #(121 'ge' 94)
     #(121 'greatest' 15)
     #(121 'gt' 96)
     #(121 'idiv' 26)
     #(121 'if' 12)
     #(121 'import' 38)
     #(121 'in' 57)
     #(121 'insert' 87)
     #(121 'instance' 21)
     #(121 'intersect' 29)
     #(121 'into' 81)
     #(121 'is' 91)
     #(121 'item' 18)
     #(121 'last' 76)
     #(121 'le' 102)
     #(121 'least' 8)
     #(121 'let' 49)
     #(121 'lt' 104)
     #(121 'mod' 23)
     #(121 'modify' 60)
     #(121 'module' 39)
     #(121 'namespace' 44)
     #(121 'ne' 100)
     #(121 'node' 65)
     #(121 'of' 19)
     #(121 'or' 1)
     #(121 'order' 47)
     #(121 'ordered' 69)
     #(121 'parent' 111)
     #(121 'preceding' 112)
     #(121 'rename' 83)
     #(121 'replace' 84)
     #(121 'return' 55)
     #(121 'satisfies' 10)
     #(121 'self' 114)
     #(121 'some' 9)
     #(121 'stable' 52)
     #(121 'text' 62)
     #(121 'then' 6)
     #(121 'to' 3)
     #(121 'transform' 82)
     #(121 'union' 24)
     #(121 'unordered' 72)
     #(121 'updating' 41)
     #(121 'value' 85)
     #(121 'variable' 33)
     #(121 'where' 46)
     #(121 'with' 89)
     #(122 'after' 77)
     #(122 'ancestor' 106)
     #(122 'and' 2)
     #(122 'as' 16)
     #(122 'ascending' 50)
     #(122 'at' 51)
     #(122 'attribute' 113)
     #(122 'before' 78)
     #(122 'by' 48)
     #(122 'child' 103)
     #(122 'comment' comment)
     #(122 'copy' 80)
     #(122 'declare' 36)
     #(122 'default' 34)
     #(122 'delete' 86)
     #(122 'descendant' 109)
     #(122 'descending' 58)
     #(122 'div' 11)
     #(122 'do' 71)
     #(122 'document' 61)
     #(122 'element' 31)
     #(122 'else' 4)
     #(122 'empty' 28)
     #(122 'eq' 99)
     #(122 'every' 14)
     #(122 'except' 27)
     #(122 'external' 35)
     #(122 'first' 79)
     #(122 'following' 117)
     #(122 'for' 59)
     #(122 'function' 32)
     #(122 'ge' 94)
     #(122 'greatest' 15)
     #(122 'gt' 96)
     #(122 'idiv' 26)
     #(122 'if' 12)
     #(122 'import' 38)
     #(122 'in' 57)
     #(122 'insert' 87)
     #(122 'instance' 21)
     #(122 'intersect' 29)
     #(122 'into' 81)
     #(122 'is' 91)
     #(122 'item' 18)
     #(122 'last' 76)
     #(122 'le' 102)
     #(122 'least' 8)
     #(122 'let' 49)
     #(122 'lt' 104)
     #(122 'mod' 23)
     #(122 'modify' 60)
     #(122 'module' 39)
     #(122 'namespace' 44)
     #(122 'ne' 100)
     #(122 'node' 65)
     #(122 'of' 19)
     #(122 'or' 1)
     #(122 'order' 47)
     #(122 'ordered' 69)
     #(122 'parent' 111)
     #(122 'preceding' 112)
     #(122 'rename' 83)
     #(122 'replace' 84)
     #(122 'return' 55)
     #(122 'satisfies' 10)
     #(122 'self' 114)
     #(122 'some' 9)
     #(122 'stable' 52)
     #(122 'text' 62)
     #(122 'then' 6)
     #(122 'to' 3)
     #(122 'transform' 82)
     #(122 'union' 24)
     #(122 'unordered' 72)
     #(122 'updating' 41)
     #(122 'value' 85)
     #(122 'variable' 33)
     #(122 'where' 46)
     #(122 'with' 89) ) 
            do:[:each | 
                (keywordMap at:each first ifAbsentPut:[ Dictionary new ]) at:(each at:2)
                    put:each last
            ].
    ^ keywordMap
! !

!XQueryScanner methodsFor:'accessing'!

source

    ^stream isExternalStream
        ifTrue:[self sourceFromExternalStream]
        ifFalse:[self sourceFromInternalStream]

    "Created: / 12-04-2007 / 11:52:21 / janfrog"
!

sourceFromExternalStream

    ^self shouldImplement "not yet implemented"

    "Created: / 12-04-2007 / 11:53:47 / janfrog"
!

sourceFromInternalStream

    ^stream collection asString.

    "Created: / 12-04-2007 / 11:54:00 / janfrog"
!

stream
    ^stream

    "Created: / 24-10-2007 / 15:55:43 / janfrog"
! !

!XQueryScanner methodsFor:'generated-scanner'!

scan1
    [
        self step.
        currentCharacter ~~ $:
    ] whileTrue.
    ^ self scan20
!

scan10
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self scan11
    ].
    ^ self reportLastMatch
!

scan11
    [
        self step.
        (currentCharacter <= $% or:[ currentCharacter >= $( ])
    ] whileTrue.
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan9
        ].
        (currentCharacter == $#) ifTrue:[
            self step.
            (currentCharacter isXMLDigit) ifTrue:[
                [
                    self step.
                    (currentCharacter isXMLDigit)
                ] whileTrue.
                (currentCharacter == $;) ifTrue:[
                    ^ self scan11
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $x) ifTrue:[
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$A and:$F) 
                            or:[ (currentCharacter between:$a and:$f) ]
                    ]) 
                        ifTrue:[
                            [
                                self step.
                                (currentCharacter isXMLDigit 
                                    or:[
                                        (currentCharacter between:$A and:$F) 
                                            or:[ (currentCharacter between:$a and:$f) ]
                                    ])
                            ] whileTrue.
                            (currentCharacter == $;) ifTrue:[
                                ^ self scan11
                            ].
                            ^ self reportLastMatch
                        ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan10
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan10
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan9
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $') ifTrue:[
        self recordMatch:#( 127 ).
        self step.
        (currentCharacter == $') ifTrue:[
            ^ self scan11
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan12
    [
        self recordMatch:#( 121 122 ).
        self step.
        (currentCharacter isLetterOrDigit 
            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ])
    ] whileTrue.
    (currentCharacter == $:) ifTrue:[
        ^ self scan2
    ].
    ^ self reportLastMatch
!

scan13
    self recordMatch:#( 121 122 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[
                                            (currentCharacter between:$f and:$n) 
                                                or:[ (currentCharacter between:$p and:$z) ]
                                        ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan12 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan2
    ].
    (currentCharacter == $e) ifTrue:[
        self recordMatch:#( 121 122 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$r) 
                                            or:[ (currentCharacter between:$t and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan12 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $s) ifTrue:[
            self recordMatch:#( 121 122 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$b) 
                                                or:[ (currentCharacter between:$d and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan12 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan2
            ].
            (currentCharacter == $c) ifTrue:[
                self recordMatch:#( 121 122 ).
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$d) 
                                                    or:[ (currentCharacter between:$f and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan12 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan2
                ].
                (currentCharacter == $e) ifTrue:[
                    self recordMatch:#( 121 122 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$m) 
                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan12 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan2
                    ].
                    (currentCharacter == $n) ifTrue:[
                        self recordMatch:#( 121 122 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$c) 
                                                            or:[ (currentCharacter between:$e and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan12 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan2
                        ].
                        (currentCharacter == $d) ifTrue:[
                            self recordMatch:#( 121 122 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[ currentCharacter == $_ or:[ (currentCharacter between:$b and:$z) ] ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan12 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan2
                            ].
                            (currentCharacter == $a) ifTrue:[
                                self recordMatch:#( 121 122 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan12 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan2
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 121 122 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$s) 
                                                                        or:[ (currentCharacter between:$u and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan12 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan2
                                    ].
                                    (currentCharacter == $t) ifTrue:[
                                        self recordMatch:#( 121 122 ).
                                        self step.
                                        (currentCharacter isLetterOrDigit 
                                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                ifTrue:[ ^ self scan12 ].
                                        (currentCharacter == $-) ifTrue:[
                                            self recordMatch:#( 121 122 ).
                                            self step.
                                            (currentCharacter isXMLDigit 
                                                or:[
                                                    (currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$n) 
                                                                                or:[ (currentCharacter between:$p and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan12 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan2
                                            ].
                                            (currentCharacter == $o) ifTrue:[
                                                self recordMatch:#( 121 122 ).
                                                self step.
                                                ((currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$0 and:$9) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$q) 
                                                                                    or:[ (currentCharacter between:$s and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan12 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan2
                                                ].
                                                (currentCharacter == $r) ifTrue:[
                                                    self recordMatch:#( 121 122 ).
                                                    self step.
                                                    (currentCharacter isLetterOrDigit 
                                                        or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                            ifTrue:[ ^ self scan12 ].
                                                    (currentCharacter == $-) ifTrue:[
                                                        self recordMatch:#( 121 122 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$r) 
                                                                                            or:[ (currentCharacter between:$t and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan12 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan2
                                                        ].
                                                        (currentCharacter == $s) ifTrue:[
                                                            self recordMatch:#( 121 122 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$d) 
                                                                                                or:[ (currentCharacter between:$f and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan12 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan2
                                                            ].
                                                            (currentCharacter == $e) ifTrue:[
                                                                self recordMatch:#( 121 122 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$k) 
                                                                                                    or:[ (currentCharacter between:$m and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan12 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan2
                                                                ].
                                                                (currentCharacter == $l) ifTrue:[
                                                                    self recordMatch:#( 121 122 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$e) 
                                                                                                        or:[ (currentCharacter between:$g and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan12 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan2
                                                                    ].
                                                                    (currentCharacter == $f) ifTrue:[
                                                                        self recordMatch:#( 115 121 122 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan12 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan2
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan2
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan2
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $o) ifTrue:[
        self recordMatch:#( 121 122 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$b) 
                                            or:[ (currentCharacter between:$d and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan12 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $c) ifTrue:[
            self recordMatch:#( 121 122 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$t) 
                                                or:[ (currentCharacter between:$v and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan12 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan2
            ].
            (currentCharacter == $u) ifTrue:[
                self recordMatch:#( 121 122 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$l) 
                                                    or:[ (currentCharacter between:$n and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan12 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan2
                ].
                (currentCharacter == $m) ifTrue:[
                    self recordMatch:#( 121 122 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$d) 
                                                        or:[ (currentCharacter between:$f and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan12 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan2
                    ].
                    (currentCharacter == $e) ifTrue:[
                        self recordMatch:#( 121 122 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$m) 
                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan12 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan2
                        ].
                        (currentCharacter == $n) ifTrue:[
                            self recordMatch:#( 121 122 ).
                            self step.
                            ((currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$0 and:$9) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$s) 
                                                                or:[ (currentCharacter between:$u and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan12 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan2
                            ].
                            (currentCharacter == $t) ifTrue:[
                                self recordMatch:#( 121 122 ).
                                self step.
                                (currentCharacter isLetterOrDigit 
                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                        ifTrue:[ ^ self scan12 ].
                                (currentCharacter == $-) ifTrue:[
                                    self recordMatch:#( 121 122 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$m) 
                                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan12 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan2
                                    ].
                                    (currentCharacter == $n) ifTrue:[
                                        self recordMatch:#( 121 122 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$n) 
                                                                            or:[ (currentCharacter between:$p and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan12 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan2
                                        ].
                                        (currentCharacter == $o) ifTrue:[
                                            self recordMatch:#( 121 122 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$c) 
                                                                                or:[ (currentCharacter between:$e and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan12 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan2
                                            ].
                                            (currentCharacter == $d) ifTrue:[
                                                self recordMatch:#( 121 122 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$d) 
                                                                                    or:[ (currentCharacter between:$f and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan12 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan2
                                                ].
                                                (currentCharacter == $e) ifTrue:[
                                                    self recordMatch:#( 73 121 122 ).
                                                    self step.
                                                    (currentCharacter isLetterOrDigit 
                                                        or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                            ifTrue:[ ^ self scan12 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan2
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan2
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan14
    self recordMatch:#( 121 122 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$q) 
                                        or:[ (currentCharacter between:$s and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan12 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan2
    ].
    (currentCharacter == $r) ifTrue:[
        ^ self scan16
    ].
    ^ self reportLastMatch
!

scan15
    [
        self recordMatch:#( 124 ).
        self step.
        (currentCharacter isXMLDigit)
    ] whileTrue.
    (currentCharacter == $E or:[ currentCharacter == $e ]) ifTrue:[
        ^ self scan3
    ].
    ^ self reportLastMatch
!

scan16
    self recordMatch:#( 121 122 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[
                                            (currentCharacter between:$f and:$n) 
                                                or:[ (currentCharacter between:$p and:$z) ]
                                        ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan12 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan2
    ].
    (currentCharacter == $e) ifTrue:[
        self recordMatch:#( 121 122 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$b) 
                                            or:[ (currentCharacter between:$d and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan12 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $c) ifTrue:[
            self recordMatch:#( 121 122 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$d) 
                                                or:[ (currentCharacter between:$f and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan12 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan2
            ].
            (currentCharacter == $e) ifTrue:[
                self recordMatch:#( 121 122 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$c) 
                                                    or:[ (currentCharacter between:$e and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan12 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan2
                ].
                (currentCharacter == $d) ifTrue:[
                    self recordMatch:#( 121 122 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$h) 
                                                        or:[ (currentCharacter between:$j and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan12 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan2
                    ].
                    (currentCharacter == $i) ifTrue:[
                        self recordMatch:#( 121 122 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$m) 
                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan12 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan2
                        ].
                        (currentCharacter == $n) ifTrue:[
                            self recordMatch:#( 121 122 ).
                            self step.
                            ((currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$0 and:$9) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$f) 
                                                                or:[ (currentCharacter between:$h and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan12 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan2
                            ].
                            (currentCharacter == $g) ifTrue:[
                                self recordMatch:#( 121 122 ).
                                self step.
                                (currentCharacter isLetterOrDigit 
                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                        ifTrue:[ ^ self scan12 ].
                                (currentCharacter == $-) ifTrue:[
                                    self recordMatch:#( 121 122 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$r) 
                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan12 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan2
                                    ].
                                    (currentCharacter == $s) ifTrue:[
                                        self recordMatch:#( 121 122 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$h) 
                                                                            or:[ (currentCharacter between:$j and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan12 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan2
                                        ].
                                        (currentCharacter == $i) ifTrue:[
                                            self recordMatch:#( 121 122 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[ currentCharacter == $a or:[ (currentCharacter between:$c and:$z) ] ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan12 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan2
                                            ].
                                            (currentCharacter == $b) ifTrue:[
                                                self recordMatch:#( 121 122 ).
                                                self step.
                                                ((currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$0 and:$9) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$k) 
                                                                                    or:[ (currentCharacter between:$m and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan12 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan2
                                                ].
                                                (currentCharacter == $l) ifTrue:[
                                                    self recordMatch:#( 121 122 ).
                                                    self step.
                                                    (currentCharacter isXMLDigit 
                                                        or:[
                                                            (currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$h) 
                                                                                        or:[ (currentCharacter between:$j and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan12 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan2
                                                    ].
                                                    (currentCharacter == $i) ifTrue:[
                                                        self recordMatch:#( 121 122 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$m) 
                                                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan12 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan2
                                                        ].
                                                        (currentCharacter == $n) ifTrue:[
                                                            self recordMatch:#( 121 122 ).
                                                            self step.
                                                            ((currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$0 and:$9) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$f) 
                                                                                                or:[ (currentCharacter between:$h and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan12 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan2
                                                            ].
                                                            (currentCharacter == $g) ifTrue:[
                                                                self recordMatch:#( 108 121 122 ).
                                                                self step.
                                                                (currentCharacter isLetterOrDigit 
                                                                    or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                        ifTrue:[ ^ self scan12 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan2
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan2
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $o) ifTrue:[
        ^ self scan17
    ].
    ^ self reportLastMatch
!

scan17
    self recordMatch:#( 121 122 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$b) 
                                        or:[ (currentCharacter between:$d and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan12 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan2
    ].
    (currentCharacter == $c) ifTrue:[
        ^ self scan18
    ].
    ^ self reportLastMatch
!

scan18
    self recordMatch:#( 121 122 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[ (currentCharacter between:$f and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan12 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan2
    ].
    (currentCharacter == $e) ifTrue:[
        ^ self scan19
    ].
    ^ self reportLastMatch
!

scan19
    self recordMatch:#( 121 122 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$r) 
                                        or:[ (currentCharacter between:$t and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan12 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan2
    ].
    (currentCharacter == $s) ifTrue:[
        self recordMatch:#( 121 122 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$r) 
                                            or:[ (currentCharacter between:$t and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan12 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $s) ifTrue:[
            self recordMatch:#( 121 122 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$h) 
                                                or:[ (currentCharacter between:$j and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan12 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan2
            ].
            (currentCharacter == $i) ifTrue:[
                self recordMatch:#( 121 122 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$m) 
                                                    or:[ (currentCharacter between:$o and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan12 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan2
                ].
                (currentCharacter == $n) ifTrue:[
                    self recordMatch:#( 121 122 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$f) 
                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan12 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan2
                    ].
                    (currentCharacter == $g) ifTrue:[
                        self recordMatch:#( 121 122 ).
                        self step.
                        (currentCharacter isLetterOrDigit 
                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                ifTrue:[ ^ self scan12 ].
                        (currentCharacter == $-) ifTrue:[
                            self recordMatch:#( 121 122 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$h) 
                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan12 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan2
                            ].
                            (currentCharacter == $i) ifTrue:[
                                self recordMatch:#( 121 122 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan12 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan2
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 121 122 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$r) 
                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan12 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan2
                                    ].
                                    (currentCharacter == $s) ifTrue:[
                                        self recordMatch:#( 121 122 ).
                                        self step.
                                        ((currentCharacter between:$- and:$.) 
                                            or:[
                                                (currentCharacter between:$0 and:$9) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$s) 
                                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan12 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan2
                                        ].
                                        (currentCharacter == $t) ifTrue:[
                                            self recordMatch:#( 121 122 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$q) 
                                                                                or:[ (currentCharacter between:$s and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan12 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan2
                                            ].
                                            (currentCharacter == $r) ifTrue:[
                                                self recordMatch:#( 121 122 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$t) 
                                                                                    or:[ (currentCharacter between:$v and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan12 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan2
                                                ].
                                                (currentCharacter == $u) ifTrue:[
                                                    self recordMatch:#( 121 122 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$b) 
                                                                                        or:[ (currentCharacter between:$d and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan12 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan2
                                                    ].
                                                    (currentCharacter == $c) ifTrue:[
                                                        self recordMatch:#( 121 122 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$s) 
                                                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan12 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan2
                                                        ].
                                                        (currentCharacter == $t) ifTrue:[
                                                            self recordMatch:#( 121 122 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$h) 
                                                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan12 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan2
                                                            ].
                                                            (currentCharacter == $i) ifTrue:[
                                                                self recordMatch:#( 121 122 ).
                                                                self step.
                                                                (currentCharacter isXMLDigit 
                                                                    or:[
                                                                        (currentCharacter between:$- and:$.) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$n) 
                                                                                                    or:[ (currentCharacter between:$p and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan12 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan2
                                                                ].
                                                                (currentCharacter == $o) ifTrue:[
                                                                    self recordMatch:#( 121 122 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$m) 
                                                                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan12 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan2
                                                                    ].
                                                                    (currentCharacter == $n) ifTrue:[
                                                                        self recordMatch:#( 67 121 122 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan12 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan2
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan2
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan2
    self step.
    (currentCharacter isLetter or:[ currentCharacter == $_ ]) ifTrue:[
        [
            self recordMatch:#( 122 ).
            self step.
            (currentCharacter isLetterOrDigit 
                or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ])
        ] whileTrue.
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan20
    [
        self step.
        (currentCharacter <= $( 
            or:[ (currentCharacter between:$* and:$9) or:[ currentCharacter >= $; ] ]) 
                ifTrue:[ ^ self scan1 ].
        (currentCharacter == $)) ifTrue:[
            self recordMatch:#comment.
            self step.
            (currentCharacter ~~ $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan20
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $:)
    ] whileTrue.
    ^ self reportLastMatch
!

scan3
    self step.
    (currentCharacter isXMLDigit) ifTrue:[
        [
            self recordMatch:#( 125 ).
            self step.
            (currentCharacter isXMLDigit)
        ] whileTrue.
        ^ self reportLastMatch
    ].
    (currentCharacter == $+ or:[ currentCharacter == $- ]) ifTrue:[
        self step.
        (currentCharacter isXMLDigit) ifTrue:[
            [
                self recordMatch:#( 125 ).
                self step.
                (currentCharacter isXMLDigit)
            ] whileTrue.
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan4
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan5
    ].
    ^ self reportLastMatch
!

scan5
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self recordAndReportMatch:#( 126 ).
    ].
    ^ self reportLastMatch
!

scan6
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan7
    ].
    ^ self reportLastMatch
!

scan7
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self scan8
    ].
    ^ self reportLastMatch
!

scan8
    [
        self step.
        (currentCharacter <= $!! 
            or:[ (currentCharacter between:$# and:$%) or:[ currentCharacter >= $' ] ])
    ] whileTrue.
    (currentCharacter == $") ifTrue:[
        self recordMatch:#( 127 ).
        self step.
        (currentCharacter == $") ifTrue:[
            ^ self scan8
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan6
        ].
        (currentCharacter == $#) ifTrue:[
            self step.
            (currentCharacter isXMLDigit) ifTrue:[
                [
                    self step.
                    (currentCharacter isXMLDigit)
                ] whileTrue.
                (currentCharacter == $;) ifTrue:[
                    ^ self scan8
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $x) ifTrue:[
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$A and:$F) 
                            or:[ (currentCharacter between:$a and:$f) ]
                    ]) 
                        ifTrue:[
                            [
                                self step.
                                (currentCharacter isXMLDigit 
                                    or:[
                                        (currentCharacter between:$A and:$F) 
                                            or:[ (currentCharacter between:$a and:$f) ]
                                    ])
                            ] whileTrue.
                            (currentCharacter == $;) ifTrue:[
                                ^ self scan8
                            ].
                            ^ self reportLastMatch
                        ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan7
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan7
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan6
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch
!

scan9
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan10
    ].
    ^ self reportLastMatch
!

scanForToken
    self step.
    ((currentCharacter between:$A and:$Z) 
        or:[
            currentCharacter == $_ 
                or:[
                    (currentCharacter between:$b and:$c) 
                        or:[
                            (currentCharacter between:$g and:$o) 
                                or:[ (currentCharacter between:$q and:$z) ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan12 ].
    (currentCharacter isXMLDigit) ifTrue:[
        [
            self recordMatch:#( 123 ).
            self step.
            (currentCharacter isXMLDigit)
        ] whileTrue.
        (currentCharacter == $E or:[ currentCharacter == $e ]) ifTrue:[
            ^ self scan3
        ].
        (currentCharacter == $.) ifTrue:[
            ^ self scan15
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter isSeparator 
        or:[ currentCharacter == (Character codePoint:16rB) ]) 
            ifTrue:[
                [
                    self recordMatch:#whitespace.
                    self step.
                    (currentCharacter isSeparator 
                        or:[ currentCharacter == (Character codePoint:16rB) ])
                ] whileTrue.
                ^ self reportLastMatch
            ].
    (currentCharacter == $!!) ifTrue:[
        self step.
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 20 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $") ifTrue:[
        ^ self scan8
    ].
    (currentCharacter == $$) ifTrue:[
        ^ self recordAndReportMatch:#( 37 ).
    ].
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan4
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan5
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan5
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan4
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $') ifTrue:[
        ^ self scan11
    ].
    (currentCharacter == $() ifTrue:[
        self recordMatch:#( 56 ).
        self step.
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $)) ifTrue:[
        ^ self recordAndReportMatch:#( 53 ).
    ].
    (currentCharacter == $*) ifTrue:[
        ^ self recordAndReportMatch:#( 13 ).
    ].
    (currentCharacter == $+) ifTrue:[
        ^ self recordAndReportMatch:#( 7 ).
    ].
    (currentCharacter == $,) ifTrue:[
        ^ self recordAndReportMatch:#( 54 ).
    ].
    (currentCharacter == $-) ifTrue:[
        ^ self recordAndReportMatch:#( 5 ).
    ].
    (currentCharacter == $.) ifTrue:[
        self recordMatch:#( 68 ).
        self step.
        (currentCharacter isXMLDigit) ifTrue:[
            ^ self scan15
        ].
        (currentCharacter == $.) ifTrue:[
            ^ self recordAndReportMatch:#( 110 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $/) ifTrue:[
        self recordMatch:#( 97 ).
        self step.
        (currentCharacter == $/) ifTrue:[
            ^ self recordAndReportMatch:#( 95 ).
        ].
        (currentCharacter == $>) ifTrue:[
            ^ self recordAndReportMatch:#( 66 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $:) ifTrue:[
        self recordMatch:#( 105 ).
        self step.
        (currentCharacter == $:) ifTrue:[
            ^ self recordAndReportMatch:#( 101 ).
        ].
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 43 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $;) ifTrue:[
        ^ self recordAndReportMatch:#( 40 ).
    ].
    (currentCharacter == $<) ifTrue:[
        self recordMatch:#( 30 ).
        self step.
        (currentCharacter == $/) ifTrue:[
            ^ self recordAndReportMatch:#( 64 ).
        ].
        (currentCharacter == $<) ifTrue:[
            ^ self recordAndReportMatch:#( 92 ).
        ].
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 45 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $=) ifTrue:[
        ^ self recordAndReportMatch:#( 42 ).
    ].
    (currentCharacter == $>) ifTrue:[
        self recordMatch:#( 90 ).
        self step.
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 98 ).
        ].
        (currentCharacter == $>) ifTrue:[
            ^ self recordAndReportMatch:#( 93 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $?) ifTrue:[
        ^ self recordAndReportMatch:#( 22 ).
    ].
    (currentCharacter == $@) ifTrue:[
        ^ self recordAndReportMatch:#( 116 ).
    ].
    (currentCharacter == $[) ifTrue:[
        ^ self recordAndReportMatch:#( 88 ).
    ].
    (currentCharacter == $]) ifTrue:[
        ^ self recordAndReportMatch:#( 75 ).
    ].
    (currentCharacter == $a) ifTrue:[
        self recordMatch:#( 121 122 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$m) 
                                            or:[ (currentCharacter between:$o and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan12 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $n) ifTrue:[
            self recordMatch:#( 121 122 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$b) 
                                                or:[ (currentCharacter between:$d and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan12 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan2
            ].
            (currentCharacter == $c) ifTrue:[
                self recordMatch:#( 121 122 ).
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$d) 
                                                    or:[ (currentCharacter between:$f and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan12 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan2
                ].
                (currentCharacter == $e) ifTrue:[
                    self recordMatch:#( 121 122 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$r) 
                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan12 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan2
                    ].
                    (currentCharacter == $s) ifTrue:[
                        self recordMatch:#( 121 122 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$s) 
                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan12 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan2
                        ].
                        (currentCharacter == $t) ifTrue:[
                            self recordMatch:#( 121 122 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$n) 
                                                                or:[ (currentCharacter between:$p and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan12 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan2
                            ].
                            (currentCharacter == $o) ifTrue:[
                                self recordMatch:#( 121 122 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$q) 
                                                                    or:[ (currentCharacter between:$s and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan12 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan2
                                ].
                                (currentCharacter == $r) ifTrue:[
                                    self recordMatch:#( 121 122 ).
                                    self step.
                                    (currentCharacter isLetterOrDigit 
                                        or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                            ifTrue:[ ^ self scan12 ].
                                    (currentCharacter == $-) ifTrue:[
                                        self recordMatch:#( 121 122 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$n) 
                                                                            or:[ (currentCharacter between:$p and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan12 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan2
                                        ].
                                        (currentCharacter == $o) ifTrue:[
                                            self recordMatch:#( 121 122 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$q) 
                                                                                or:[ (currentCharacter between:$s and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan12 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan2
                                            ].
                                            (currentCharacter == $r) ifTrue:[
                                                self recordMatch:#( 121 122 ).
                                                self step.
                                                (currentCharacter isLetterOrDigit 
                                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                        ifTrue:[ ^ self scan12 ].
                                                (currentCharacter == $-) ifTrue:[
                                                    self recordMatch:#( 121 122 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$r) 
                                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan12 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan2
                                                    ].
                                                    (currentCharacter == $s) ifTrue:[
                                                        self recordMatch:#( 121 122 ).
                                                        self step.
                                                        (currentCharacter isXMLDigit 
                                                            or:[
                                                                (currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$d) 
                                                                                            or:[ (currentCharacter between:$f and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan12 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan2
                                                        ].
                                                        (currentCharacter == $e) ifTrue:[
                                                            self recordMatch:#( 121 122 ).
                                                            self step.
                                                            ((currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$0 and:$9) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$k) 
                                                                                                or:[ (currentCharacter between:$m and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan12 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan2
                                                            ].
                                                            (currentCharacter == $l) ifTrue:[
                                                                self recordMatch:#( 121 122 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$e) 
                                                                                                    or:[ (currentCharacter between:$g and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan12 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan2
                                                                ].
                                                                (currentCharacter == $f) ifTrue:[
                                                                    self recordMatch:#( 107 121 122 ).
                                                                    self step.
                                                                    (currentCharacter isLetterOrDigit 
                                                                        or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                            ifTrue:[ ^ self scan12 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan2
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan2
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan2
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $d) ifTrue:[
        ^ self scan13
    ].
    (currentCharacter == $e) ifTrue:[
        self recordMatch:#( 121 122 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$l) 
                                            or:[ (currentCharacter between:$n and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan12 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $m) ifTrue:[
            self recordMatch:#( 121 122 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$o) 
                                                or:[ (currentCharacter between:$q and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan12 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan2
            ].
            (currentCharacter == $p) ifTrue:[
                self recordMatch:#( 121 122 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$s) 
                                                    or:[ (currentCharacter between:$u and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan12 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan2
                ].
                (currentCharacter == $t) ifTrue:[
                    self recordMatch:#( 121 122 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[ (currentCharacter between:$a and:$x) or:[ currentCharacter == $z ] ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan12 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan2
                    ].
                    (currentCharacter == $y) ifTrue:[
                        self recordMatch:#( 121 122 ).
                        self step.
                        (currentCharacter isLetterOrDigit 
                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                ifTrue:[ ^ self scan12 ].
                        (currentCharacter == $-) ifTrue:[
                            self recordMatch:#( 121 122 ).
                            self step.
                            ((currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$0 and:$9) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$r) 
                                                                or:[ (currentCharacter between:$t and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan12 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan2
                            ].
                            (currentCharacter == $s) ifTrue:[
                                self recordMatch:#( 121 122 ).
                                self step.
                                (currentCharacter isXMLDigit 
                                    or:[
                                        (currentCharacter between:$- and:$.) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$d) 
                                                                    or:[ (currentCharacter between:$f and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan12 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan2
                                ].
                                (currentCharacter == $e) ifTrue:[
                                    self recordMatch:#( 121 122 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$p) 
                                                                        or:[ (currentCharacter between:$r and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan12 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan2
                                    ].
                                    (currentCharacter == $q) ifTrue:[
                                        self recordMatch:#( 121 122 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$t) 
                                                                            or:[ (currentCharacter between:$v and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan12 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan2
                                        ].
                                        (currentCharacter == $u) ifTrue:[
                                            self recordMatch:#( 121 122 ).
                                            self step.
                                            (currentCharacter isXMLDigit 
                                                or:[
                                                    (currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$d) 
                                                                                or:[ (currentCharacter between:$f and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan12 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan2
                                            ].
                                            (currentCharacter == $e) ifTrue:[
                                                self recordMatch:#( 121 122 ).
                                                self step.
                                                ((currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$0 and:$9) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$m) 
                                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan12 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan2
                                                ].
                                                (currentCharacter == $n) ifTrue:[
                                                    self recordMatch:#( 121 122 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$b) 
                                                                                        or:[ (currentCharacter between:$d and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan12 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan2
                                                    ].
                                                    (currentCharacter == $c) ifTrue:[
                                                        self recordMatch:#( 121 122 ).
                                                        self step.
                                                        (currentCharacter isXMLDigit 
                                                            or:[
                                                                (currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$d) 
                                                                                            or:[ (currentCharacter between:$f and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan12 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan2
                                                        ].
                                                        (currentCharacter == $e) ifTrue:[
                                                            self recordMatch:#( 17 121 122 ).
                                                            self step.
                                                            (currentCharacter isLetterOrDigit 
                                                                or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                    ifTrue:[ ^ self scan12 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan2
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan2
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $f) ifTrue:[
        self recordMatch:#( 121 122 ).
        self step.
        (currentCharacter isXMLDigit 
            or:[
                (currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$n) 
                                            or:[ (currentCharacter between:$p and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan12 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $o) ifTrue:[
            self recordMatch:#( 121 122 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$k) 
                                                or:[ (currentCharacter between:$m and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan12 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan2
            ].
            (currentCharacter == $l) ifTrue:[
                self recordMatch:#( 121 122 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$k) 
                                                    or:[ (currentCharacter between:$m and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan12 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan2
                ].
                (currentCharacter == $l) ifTrue:[
                    self recordMatch:#( 121 122 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$n) 
                                                        or:[ (currentCharacter between:$p and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan12 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan2
                    ].
                    (currentCharacter == $o) ifTrue:[
                        self recordMatch:#( 121 122 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$v) 
                                                            or:[ (currentCharacter between:$x and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan12 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan2
                        ].
                        (currentCharacter == $w) ifTrue:[
                            self recordMatch:#( 121 122 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$h) 
                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan12 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan2
                            ].
                            (currentCharacter == $i) ifTrue:[
                                self recordMatch:#( 121 122 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan12 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan2
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 121 122 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$f) 
                                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan12 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan2
                                    ].
                                    (currentCharacter == $g) ifTrue:[
                                        self recordMatch:#( 121 122 ).
                                        self step.
                                        (currentCharacter isLetterOrDigit 
                                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                ifTrue:[ ^ self scan12 ].
                                        (currentCharacter == $-) ifTrue:[
                                            self recordMatch:#( 121 122 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$r) 
                                                                                or:[ (currentCharacter between:$t and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan12 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan2
                                            ].
                                            (currentCharacter == $s) ifTrue:[
                                                self recordMatch:#( 121 122 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$h) 
                                                                                    or:[ (currentCharacter between:$j and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan12 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan2
                                                ].
                                                (currentCharacter == $i) ifTrue:[
                                                    self recordMatch:#( 121 122 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[ currentCharacter == $a or:[ (currentCharacter between:$c and:$z) ] ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan12 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan2
                                                    ].
                                                    (currentCharacter == $b) ifTrue:[
                                                        self recordMatch:#( 121 122 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$k) 
                                                                                            or:[ (currentCharacter between:$m and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan12 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan2
                                                        ].
                                                        (currentCharacter == $l) ifTrue:[
                                                            self recordMatch:#( 121 122 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$h) 
                                                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan12 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan2
                                                            ].
                                                            (currentCharacter == $i) ifTrue:[
                                                                self recordMatch:#( 121 122 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$m) 
                                                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan12 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan2
                                                                ].
                                                                (currentCharacter == $n) ifTrue:[
                                                                    self recordMatch:#( 121 122 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$f) 
                                                                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan12 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan2
                                                                    ].
                                                                    (currentCharacter == $g) ifTrue:[
                                                                        self recordMatch:#( 118 121 122 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan12 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan2
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan2
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $p) ifTrue:[
        ^ self scan14
    ].
    (currentCharacter == ${) ifTrue:[
        ^ self recordAndReportMatch:#( 70 ).
    ].
    (currentCharacter == $|) ifTrue:[
        ^ self recordAndReportMatch:#( 25 ).
    ].
    (currentCharacter == $}) ifTrue:[
        ^ self recordAndReportMatch:#( 74 ).
    ].
    ^ self reportLastMatch
! !

!XQueryScanner methodsFor:'generated-tokens'!

emptySymbolTokenId
	^250
!

errorTokenId
	^251
! !

!XQueryScanner class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryScanner.st,v 1.11 2008-01-02 14:07:19 wrobll1 Exp $'
! !
