"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

TestCase subclass:#XQueryTypeTests
	instanceVariableNames:'interpreter'
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Tests'
!


!XQueryTypeTests methodsFor:'initialization & release'!

setUp

    interpreter := XQueryInterpreter new
                        setDocumentProvider: XQueryDocumentProviderTestResource current;
                        yourself

!

tearDown

    interpreter := nil.

! !

!XQueryTypeTests methodsFor:'tests'!

test_01

    self 
        assert: (TypeElement instance isSubtypeOf: TypeNode instance);
        assert: (TypeXSInteger instance isSubtypeOf: TypeXSAnyAtomicType instance);
        assert: (TypeXSInteger instance isSubtypeOf: TypeXSInteger instance)

    "Created: / 05-12-2007 / 14:59:24 / janfrog"
!

test_02

    self 
        assert: (TypeXSInteger instance isSubtypeOf: TypeXSBoolean instance) not.

    "Created: / 05-12-2007 / 15:00:11 / janfrog"
!

test_fn_attribute
    | document result |

    "constructed node attribute test"
    document := '<root><a attr="1" /> <a attr="2" /> <c attr="3"/></root>'.
    result := interpreter basicEvaluate: document, '/attribute()'.
    "constructed node does not implement attributes yet"
    "/    self assert: (result size = 3).

    "TODO
        - accessed element attribute test
        - attribute(name) function
    "

    "Created: / 18-04-2009 / 20:41:52 / Jan Kurs <kursj1@fel.cvut.cz>"
    "Modified: / 19-04-2009 / 10:17:16 / Jan Kurs <kursj1@fel.cvut.cz>"
!

test_fn_element
    | document result |

    document := '<root><a /> <b /> <a /> <c /></root>'.
    result := interpreter basicEvaluate: document, '//element()'.
    self assert: (result size = 4).
    result := interpreter basicEvaluate: document, '//element(a)'.
    self assert: (result size = 2).
    self assert: (result first asString = '<a />').
    self assert: (result second asString = '<a />').

    "Created: / 18-04-2009 / 20:34:00 / Jan Kurs <kursj1@fel.cvut.cz>"
! !

!XQueryTypeTests class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryTypeTests.st,v 1.1 2007-12-05 21:08:48 vranyj1 Exp $'
! !
