"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Object subclass:#FunctionLibrary
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Functions'
!


!FunctionLibrary class methodsFor:'instance creation'!

forURI: uriString

    ^((self allSubclasses reject:[:cls|cls isAbstract])
        detect:[:cls|cls namespaceURI = uriString]
        ifNone:[^nil]) new

    "
        XQuery::FunctionLibrary forURI: 'http://www.w3.org/2005/xpath-functions'
        XQuery::FunctionLibrary forURI: 'urn:xquery:js'
    "

    "Created: / 01-12-2008 / 10:04:30 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-01-2009 / 21:43:43 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

new
    ^ self basicNew initialize.

    "Created: / 01-12-2008 / 11:29:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!FunctionLibrary class methodsFor:'function library API'!

namespaceURI

    ^self subclassResponsibility

    "Created: / 01-12-2008 / 10:02:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!FunctionLibrary class methodsFor:'testing'!

isAbstract

    ^self == XQuery::FunctionLibrary

    "Created: / 01-12-2008 / 10:04:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!FunctionLibrary class methodsFor:'utilities'!

smalltalkize: localName

    "transforms distinct-values into disticntValues"
    | input output minusFound|
    input := localName readStream.
    output := (String new: localName size) writeStream.
    minusFound := false.
    [ input atEnd ] whileFalse: [
        | c |
        c := input next.
        c = $- 
            ifTrue:
                [minusFound := true]
            ifFalse:
                [minusFound 
                    ifTrue:
                        [output nextPut:c asUppercase.
                        minusFound := false]
                    ifFalse:
                        [output nextPut:c]]].

    ^output contents

    "
        self smalltalkize: 'doc' 

        self smalltalkize: 'distinct-values'  
    "

    "Created: / 19-01-2009 / 20:46:10 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!FunctionLibrary methodsFor:'function library API'!

defaultPrefix

    ^self subclassResponsibility

    "Created: / 29-08-2007 / 09:37:28 / janfrog"
!

functionLocalNames

    "Should return a collection of function local names"
    ^self subclassResponsibility

    "Created: / 28-08-2007 / 23:06:40 / janfrog"
    "Modified: / 29-08-2007 / 09:29:15 / janfrog"
!

functions

    ^self functionLocalNames collect:
        [:localName|
        ExternalFunction new
            setFunctionLibrary: self;
            setLocalName: localName;
            yourself]

    "Created: / 28-08-2007 / 23:06:40 / janfrog"
    "Modified: / 01-12-2008 / 10:15:45 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

namespaceURI
    ^ self class namespaceURI

    "Created: / 01-12-2008 / 10:02:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

performPrimitive:primName inContext:context withArguments:arguments forInterpreter:interpreter 
    ^ self 
        performPrimitive:primName
        withArguments:arguments
        forInterpreter:interpreter

    "Created: / 20-01-2009 / 09:23:41 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

performPrimitive:primName withArguments:arguments 
    |selector|

    selector := (self selectorForXQueryFunctionName:(Array with:primName with:arguments size)) asSymbol.
    selector numArgs = arguments size ifTrue:[
        ^ self perform:selector withArguments:arguments
    ].
    self error:'Wrong number of arguments'

    "Created: / 20-01-2009 / 09:23:02 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

performPrimitive:primName withArguments:arguments forInterpreter:interpreter 
    ^ self performPrimitive:primName withArguments:arguments

    "Created: / 20-01-2009 / 09:22:37 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

selectorForXQueryFunctionName:arg
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility

    "Created: / 19-01-2009 / 20:17:59 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!FunctionLibrary methodsFor:'message sending'!

perform:aSelector withArguments:argArray

    ^Perseus::Interpreter 
        activeInterpreter: Perseus::ByteCodeInterpreter new
        do: [self perform:aSelector withArguments:argArray].

    "Created: / 19-01-2009 / 22:32:43 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 20-01-2009 / 10:18:15 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!FunctionLibrary class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__FunctionLibrary.st,v 1.2 2007-09-21 11:17:29 vranyj1 Exp $'
! !
