"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Perseus::AstInterpreter subclass:#XQueryInterpreter
	instanceVariableNames:'xqueryExecutor documentProvider documentAdaptorsPool funcTable
		defaultElementNamespaceURI defaultFunctionNamespaceURI
		prefixToNamespaceURIMapping currentFocus pendingUpdateList'
	classVariableNames:'Verbose'
	poolDictionaries:''
	category:'XQuery-Core'
!


!XQueryInterpreter class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.

    "Created: / 24-12-2006 / 15:42:05 / janfrog"
! !

!XQueryInterpreter class methodsFor:'accessing'!

isVerbose

    ^Verbose == true

    "Created: / 12-04-2007 / 11:14:25 / janfrog"
!

verbose: aBoolean

    Verbose := aBoolean

    "Created: / 12-04-2007 / 11:14:09 / janfrog"
! !

!XQueryInterpreter class methodsFor:'defaults'!

defaultDocumentProvider
    "default value for the 'documentProvider' instance variable (automatically generated)"

    ^XMLv2::XPathDocumentProvider default.

    "Modified: / 02-12-2006 / 12:00:09 / ked"
    "Modified: / 05-12-2006 / 14:59:22 / janfrog"
    "Created: / 18-09-2008 / 16:38:05 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

defaultFuncTable
    "default value for the 'funcTable' instance variable (automatically generated)"

    ^XQueryFuncTable new.

    "Created: / 09-09-2006 / 09:53:19 / ked"
! !

!XQueryInterpreter methodsFor:'accessing'!

currentNodeSet

    ^context nodeSet

    "Created: / 05-12-2007 / 10:37:08 / janfrog"
    "Modified: / 18-09-2008 / 16:13:10 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

currentNodeSet:anObject 
    self assert:(anObject isNil or:[ anObject class == XQuerySequence ]).
    ^context nodeSet: anObject

    "Created: / 18-11-2007 / 08:11:01 / janfrog"
    "Modified: / 05-12-2007 / 10:39:38 / janfrog"
    "Modified: / 18-09-2008 / 16:41:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

defaultFunctionNamespaceURI
    ^ defaultFunctionNamespaceURI

    "Created: / 28-12-2006 / 12:38:13 / janfrog"
!

documentProvider
    documentProvider isNil ifTrue:[documentProvider := self class defaultDocumentProvider].
    ^ documentProvider

    "Modified: / 10-12-2006 / 13:30:28 / janfrog"
    "Created: / 18-09-2008 / 16:36:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

funcTable
    funcTable isNil ifTrue:[
        funcTable := self class defaultFuncTable.
    ].
    ^ funcTable

    "Created: / 09-09-2006 / 09:53:19 / ked"
!

funcTable:something
    funcTable := something.

    "Created: / 09-09-2006 / 09:53:19 / ked"
!

prefixToNamespaceURIMapping
    ^ prefixToNamespaceURIMapping

    "Created: / 28-12-2006 / 12:34:19 / janfrog"
!

xqueryExecutor
    ^ xqueryExecutor

    "Created: / 06-07-2006 / 18:40:42 / ked"
!

xqueryExecutor:something
    xqueryExecutor := something.

    "Created: / 06-07-2006 / 18:40:42 / ked"
! !

!XQueryInterpreter methodsFor:'accessing - classes'!

compilerClass
    "Superclass Perseus::Interpreter says that I am responsible to implement this method"

    ^XQueryCompiler

    "Created: / 18-09-2008 / 17:04:25 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

contextClass

    ^XQueryContext

    "Created: / 18-09-2008 / 17:11:21 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

contextProxyClass

    ^ContextProxy

    "Created: / 18-09-2008 / 18:25:29 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

parserClass
    "Superclass Perseus::Interpreter says that I am responsible to implement this method"

    ^XQueryParser

    "Created: / 18-09-2008 / 16:58:05 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryInterpreter methodsFor:'accessing - document'!

documentAdaptorsFor: aURI

    documentAdaptorsPool ifNil:[
        documentAdaptorsPool := Dictionary new.
    ].

    ^documentAdaptorsPool at: aURI ifAbsentPut:[
        
        (self documentProvider documentAdaptorsFor: aURI)
    ].

    "Modified: / 02-12-2006 / 11:59:45 / ked"
    "Created: / 20-09-2007 / 10:34:10 / janfrog"
    "Modified: / 18-09-2008 / 16:36:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

releaseDocumentAdaptors
    documentAdaptorsPool ifNotNil:
        [documentAdaptorsPool do:
            [:documentAdaptors |
            documentAdaptors do:
                [:documentAdaptor|
                documentAdaptor releaseResources]].
        documentAdaptorsPool := nil].

    "Modified: / 02-11-2006 / 10:28:44 / ked"
    "Created: / 18-09-2008 / 16:36:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryInterpreter methodsFor:'accessing - vars'!

bindVar:aName to:aValue

    ^self bindVar:aName to:aValue inContext: context

    "Modified: / 02-11-2006 / 10:29:47 / ked"
    "Created: / 28-03-2007 / 17:28:05 / janfrog"
    "Modified: / 18-09-2008 / 15:40:07 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

bindVar:aName to:aValue inContext:aContext 

    aContext variableAt: aName put: aValue

    "Modified: / 02-11-2006 / 10:29:47 / ked"
    "Created: / 20-03-2007 / 23:01:25 / janfrog"
!

bindVar:aName toInteger:anInteger

    ^self bindVar:aName to:(XQuerySequenceItem withNumber: anInteger)

    "Modified: / 02-11-2006 / 10:29:47 / ked"
    "Created: / 28-03-2007 / 20:19:43 / janfrog"
!

bindVarIfNotNil:aName to:aValue

    ^self bindVarIfNotNil:aName to:aValue inContext: context

    "Modified: / 02-11-2006 / 10:29:47 / ked"
    "Created: / 28-03-2007 / 21:24:49 / janfrog"
    "Modified: / 18-09-2008 / 15:40:07 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

bindVarIfNotNil:aName to:aValue inContext:aContext 

    aName ifNotNil:[self bindVar: aName to: aValue inContext: aContext]

    "Modified: / 02-11-2006 / 10:29:47 / ked"
    "Created: / 28-03-2007 / 21:24:40 / janfrog"
!

unbindVar:aName 

    ^self unbindVar:aName inContext: context

    "Modified: / 02-11-2006 / 10:30:18 / ked"
    "Created: / 28-03-2007 / 17:29:05 / janfrog"
    "Modified: / 18-09-2008 / 15:40:07 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

unbindVar:aName inContext:aContext 
    aContext variables removeKey:aName ifAbsent:[]

    "Modified: / 02-11-2006 / 10:30:18 / ked"
    "Created: / 28-03-2007 / 17:28:42 / janfrog"
    "Modified: / 28-03-2007 / 21:24:04 / janfrog"
!

valueOfVar:aName inContext:aContext

    self see:'Proc to clone?'.
    ^(aContext variableAt: aName) clone.

    "Created: / 03-09-2006 / 13:41:51 / ked"
    "Modified: / 14-12-2006 / 23:29:54 / ked"
    "Modified: / 20-03-2007 / 23:05:35 / janfrog"
! !

!XQueryInterpreter methodsFor:'evaluation'!

evaluate:aStringOrCompiledCode on:anExceptionClassOrExceptionSet do:aBlock

    |millisecondsToRun resultSequence|

    millisecondsToRun := Time millisecondsToRun:
                            [resultSequence := self basicEvaluate:aStringOrCompiledCode on:anExceptionClassOrExceptionSet do:aBlock].

    ^(XQueryResult withAll:resultSequence ? #())       
        setQueryString: aStringOrCompiledCode;
        setQueryTime: 
            (millisecondsToRun > 0
                ifTrue:[TimeDuration new setMilliseconds: millisecondsToRun]
                ifFalse:[nil]);
        yourself.

    "Created: / 18-09-2008 / 16:55:29 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 23-11-2008 / 19:48:09 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryInterpreter methodsFor:'evaluation - private'!

basicEvaluate:aStringOrCompiledCode

    ^self 
        basicEvaluate: aStringOrCompiledCode 
        on: Error 
        do: [:ex|self handleRuntimeError: ex].

    "Created: / 18-09-2008 / 16:53:32 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 02-12-2008 / 12:51:13 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

basicEvaluate:aStringOrCompiledCode on:anExceptionClassOrExceptionSet do:aBlock 

    ^super evaluate:aStringOrCompiledCode on:anExceptionClassOrExceptionSet do:aBlock

    "Created: / 18-09-2008 / 16:52:22 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryInterpreter methodsFor:'informing'!

informAboutNodeEvaluation: aString

    (Smalltalk isStandAloneApp or:[self class isVerbose]) ifTrue:
        [Transcript show: '[XQuery::Interpreter] evaluating node '; showCR: aString]

    "Created: / 10-02-2007 / 13:03:53 / janfrog"
    "Modified: / 12-04-2007 / 11:16:18 / janfrog"
! !

!XQueryInterpreter methodsFor:'initialization'!

initialize

    super initialize.
    self initializeDefaultNamespaces.
    self initializeNamespaces.
    self initializeFunctionTable.
    self initializePendingUpdateList.

    "Created: / 24-12-2006 / 15:42:00 / janfrog"
    "Modified: / 28-12-2006 / 12:39:29 / janfrog"
!

initializeDefaultNamespaces

    defaultElementNamespaceURI := ''.
    defaultFunctionNamespaceURI := 'http://www.w3.org/2005/xpath-functions'.

    "Created: / 24-12-2006 / 17:21:00 / janfrog"
!

initializeFunctionTable

    funcTable := XQueryFuncTable new.
    "NativeFunctionFn allSubclasses do:[:cls|funcTable defineFunction: cls new]."
    self loadFunctionLibrary: FnLibrary new.

    "Created: / 28-12-2006 / 12:40:25 / janfrog"
    "Modified: / 28-08-2007 / 23:04:47 / janfrog"
!

initializeNamespaces

    prefixToNamespaceURIMapping := Dictionary new
        "Taken from XQuery specification section 4.12"
        at:'xml'   put:'http://www.w3.org/XML/1998/namespace';
        at:'xs'    put:'http://www.w3.org/2001/XMLSchema';
        at:'xsi'   put:'http://www.w3.org/2001/XMLSchema-instance';
        at:'fn'    put:'http://www.w3.org/2005/xpath-functions';
        at:'local' put:'http://www.w3.org/2005/xquery-local-functions';
        yourself

    "Created: / 24-12-2006 / 15:41:17 / janfrog"
    "Modified: / 24-12-2006 / 17:16:56 / janfrog"
!

initializePendingUpdateList

    pendingUpdateList := EmptyCommand new.
!

setDocumentProvider: aDocumentProvider

    documentProvider := aDocumentProvider

    "Created: / 18-09-2008 / 16:36:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryInterpreter methodsFor:'libraries'!

loadFunctionLibrary: aFunctionLibrary

    aFunctionLibrary functions do:
        [:f|funcTable defineFunction:f].

    "Created: / 28-08-2007 / 23:05:52 / janfrog"
    "Modified: / 29-08-2007 / 09:42:19 / janfrog"
!

loadFunctionLibraryWithURI: uriString

    ^self loadFunctionLibrary: (FunctionLibrary forURI: uriString).

    "Created: / 01-12-2008 / 10:06:15 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryInterpreter methodsFor:'private'!

appendSequence:sequence toConstructedElement:parent whichIsDocument:isDocument 

    sequence do:
        [:item|
        item asXQueryConstructedNode appendInto: parent]

    "Modified: / 02-12-2006 / 12:20:21 / ked"
    "Created: / 21-03-2007 / 15:54:45 / janfrog"
    "Modified: / 29-03-2007 / 13:34:55 / janfrog"
!

appendSequence:sequence toConstructedTextOrAttribute:textOrAttr 
    |textNodeContentAccum|

    "spojeni atomizovanych hodnot"
    textNodeContentAccum := nil.
    sequence do:[:sequenceItem | 
        textNodeContentAccum 
            ifNil:[ textNodeContentAccum := ''. ]
            ifNotNil:[ textNodeContentAccum := textNodeContentAccum , ' '. ].
        textNodeContentAccum := textNodeContentAccum 
                    , sequenceItem value asString.
    ].
    textNodeContentAccum ifNil:[ textNodeContentAccum := ''. ].
    textOrAttr nodeValue:textNodeContentAccum.

    "Modified: / 09-11-2006 / 23:51:06 / ked"
    "Created: / 21-03-2007 / 16:05:22 / janfrog"
!

orderCriterionFor: left and: right

    | leftValue rightValue ascDesc emptyGreatestLeast ascTrue ascFalse |

    self assert: left orderSpecItems size = right orderSpecItems size.

    (1 to: left orderSpecItems size) do:[:pos |
        ascDesc := (left orderSpecItems at:pos) ascDesc.
        emptyGreatestLeast := (left orderSpecItems at:pos) emptyGreatestLeast.

        ascDesc ifNil:[
            ascDesc := #asc.
        ].
        emptyGreatestLeast ifNil:[
            emptyGreatestLeast := #greatest.
        ].

        ascDesc = #asc ifTrue:[
            ascTrue := true.
            ascFalse := false.
        ] ifFalse:[
            ascTrue := false.
            ascFalse := true.
        ].

        (left orderSpecItems at:pos) orderValue size = 0 ifTrue:[
            leftValue := nil.
        ] ifFalse:[
            self assert: (left orderSpecItems at:pos) orderValue size = 1.
            leftValue := (left orderSpecItems at:pos) orderValue first value.
        ].

        (right orderSpecItems at:pos) orderValue size = 0 ifTrue:[
            rightValue := nil.
        ] ifFalse:[
            self assert: (right orderSpecItems at:pos) orderValue size = 1.
            rightValue := (right orderSpecItems at:pos) orderValue first value.
        ].

        (leftValue isNil not or:[rightValue isNil not]) ifTrue:[

            leftValue isNil ifTrue:[
                emptyGreatestLeast = #greatest ifTrue:[
                    ^ascFalse.
                ] ifFalse:[
                    ^ascTrue.
                ]
            ].

            rightValue isNil ifTrue:[
                emptyGreatestLeast = #greatest ifTrue:[
                    ^ascTrue.
                ] ifFalse:[
                    ^ascFalse.
                ]
            ].    

            leftValue > rightValue ifTrue:[
                ^ascFalse.
            ].

            leftValue < rightValue ifTrue:[
                ^ascTrue.
            ].

        ].
    ].

    ^true. "stable ordering"

    "Created: / 30-11-2006 / 15:45:05 / ked"
    "Modified: / 30-11-2006 / 23:58:05 / ked"
!

reduceCurrentNodeSetUsing:aBlock 
    ^ self currentNodeSet:(self currentNodeSet 
                inject:(XQuerySequence new:self currentNodeSet size * 2)
                into:[:seq :node | 
                    seq
                        addAll:((aBlock value:node item) 
                                    collect:[:e | XQuerySequenceItem withNode:e ]);
                        yourself
                ])

    "Created: / 17-11-2007 / 15:51:19 / janfrog"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
!

uniqueAddNodeSequence:anInsertedDataContext to:aTargetDataContext 
    anInsertedDataContext do:[:insertedDataContextItem | 
        self assert:(insertedDataContextItem type 
                    isSubtypeOf:XQuerySequenceItem typeNode).
        (aTargetDataContext 
            anySatisfy:[:targetDataContextItem | 
                self assert:(targetDataContextItem type 
                            isSubtypeOf:XQuerySequenceItem typeNode).
                insertedDataContextItem item = targetDataContextItem item
            ]) 
                ifFalse:[ aTargetDataContext add:insertedDataContextItem. ].
    ].

    "Created: / 01-12-2006 / 15:40:36 / ked"
    "Modified: / 05-12-2007 / 21:21:33 / janfrog"
!

withCurrentNodeSetDo:aBlock 
    |oldNodeSet retval|

    oldNodeSet := self currentNodeSet.
    self currentNodeSet:self currentNodeSet copy.
    retval := aBlock value.
    self currentNodeSet:oldNodeSet.
    ^ retval

    "Created: / 21-03-2007 / 23:17:34 / janfrog"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
!

withFocusDo:aBlock 
    |oldFocus retval|

    oldFocus := currentFocus.
    currentFocus := XQueryFocus new contextSize:self currentNodeSet size.
    retval := aBlock value.
    currentFocus := oldFocus.
    ^ retval

    "Created: / 21-03-2007 / 20:31:59 / janfrog"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
!

xmlNodeNameFromQName:qname 
    ^ XMLv2::NodeName 
        fromString:qname
        andPrefixToNamespaceURIMapping:prefixToNamespaceURIMapping
        defaultNS:defaultElementNamespaceURI

    "Created: / 20-03-2007 / 23:19:29 / janfrog"
! !

!XQueryInterpreter methodsFor:'private - FLWOR'!

bloomForClauses: forClauses by: forClauseIndex using: bloomingBlock

    | forClause valueVarName positionVarName valueSeq |

    forClause := forClauses at: forClauseIndex.
    valueVarName := self visit: forClause varName.
    positionVarName := self visit: forClause positionalVar.
    valueSeq := self visit: forClause exprSingle.
    
    valueSeq keysAndValuesDo:
        [:position :value|
        self 
            bindVar: valueVarName to: value;
            bindVarIfNotNil: positionVarName to: (XQuerySequenceItem withNumber: position).

        forClauses size = forClauseIndex"is last for clause?"
            ifTrue:
                [bloomingBlock value]
            ifFalse:
                [self
                    bloomForClauses: forClauses 
                    by: forClauseIndex + 1
                    using: bloomingBlock]]

    "Created: / 28-03-2007 / 21:26:54 / janfrog"
!

bloomForClauses: forClauses using: bloomingBlock

    forClauses isEmpty
        ifTrue:
            [bloomingBlock value]
        ifFalse:
            [self
                bloomForClauses: forClauses 
                by: 1
                using: bloomingBlock]

    "Created: / 28-03-2007 / 21:02:21 / janfrog"
!

bloomForLetClauses: forLetClauses by: forLetClauseIndex using: primaryBloomingBlock

    | forLetClause forClauses |

    forLetClause := forLetClauses at: forLetClauseIndex.
    forClauses := forLetClause asCollectionOfForClauses.


    self 
        bloomForClauses: forClauses
        using:
            [self visitAll: forLetClause asCollectionOfLetClauses.
            forLetClauses size = forLetClauseIndex"is last for-let clause?"
                ifTrue:
                    [primaryBloomingBlock value]
                ifFalse:
                    [self
                        bloomForLetClauses: forLetClauses
                        by: forLetClauseIndex + 1
                        using: primaryBloomingBlock]]

    "Created: / 28-03-2007 / 20:48:07 / janfrog"
!

bloomForLetClauses: forLetClauses using: primaryBloomingBlock

    ^self 
        bloomForLetClauses: forLetClauses
        by: 1
        using: primaryBloomingBlock

    "Created: / 28-03-2007 / 20:42:51 / janfrog"
!

bloomQuantifiedExprImpls: quantifiedExprImpls by: quantifiedExprImplIndex using: bloomingBlock

    | quantifiedExprImpl valueVarName valueSeq |

    quantifiedExprImpl := quantifiedExprImpls at: quantifiedExprImplIndex.
    valueVarName := self visit:  quantifiedExprImpl varName.
    valueSeq := self visit: quantifiedExprImpl exprSingle.

    valueSeq do:
        [:value|
        self bindVar: valueVarName to: value.
        quantifiedExprImpls size = quantifiedExprImplIndex"is last?"
            ifTrue:
                [bloomingBlock value]
            ifFalse:
                [self
                    bloomQuantifiedExprImpls: quantifiedExprImpls 
                    by: quantifiedExprImplIndex + 1
                    using: bloomingBlock]]

    "Created: / 28-03-2007 / 22:16:08 / janfrog"
!

bloomQuantifiedExprImpls: quantifiedExprImpls using: bloomingBlock

    self
        bloomQuantifiedExprImpls: quantifiedExprImpls 
        by: 1
        using: bloomingBlock

    "Created: / 28-03-2007 / 22:06:54 / janfrog"
! !

!XQueryInterpreter methodsFor:'queries'!

evaluateNode:anXQueryExecutor 
    |resultSeq|

    self xqueryExecutor:anXQueryExecutor.
    self context:(XQueryContext new dataContextEmpty).
    resultSeq := self visit:(xqueryExecutor astTree).
    pendingUpdateList execute.
    ^ resultSeq

    "self xqueryExecutor releaseDocumentAdaptors."

    "Modified: / 03-12-2006 / 12:58:23 / ked"
    "Created: / 21-11-2007 / 15:41:07 / janfrog"
    "Modified: / 05-12-2007 / 11:24:45 / janfrog"
    "Modified: / 18-09-2008 / 15:43:35 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

shouldTryToUseIndex
    "If you want to try to experiment with indexes, change it to return true"
    ^false.

    "Created: / 05-11-2007 / 17:52:05 / beyboy"
    "Modified: / 05-11-2007 / 22:36:21 / beyboy"
! !

!XQueryInterpreter methodsFor:'visiting'!

visit:anObject 

    self informAboutNodeEvaluation: anObject class name.
    ^super visit:anObject

    "Modified: / 08-10-2006 / 14:17:01 / ked"
    "Modified: / 10-02-2007 / 13:04:10 / janfrog"
    "Modified: / 18-09-2008 / 15:50:08 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstAbbrevForwardStep:anObject 
    "dispatched back from the visited astAbbrevForwardStep-object (visitor pattern)"
    
    |expandedStepNode|

    expandedStepNode := (AstForwardStep new)
                forwardAxis:anObject stepType;
                nodeTest:anObject nodeTest.
    ^ self currentNodeSet:(self visit:expandedStepNode).

    "Created: / 08-10-2006 / 17:03:54 / ked"
    "Modified: / 12-10-2006 / 23:08:51 / ked"
    "Modified: / 18-11-2007 / 08:11:01 / janfrog"
!

visitAstAdditiveExpr:anObject 
    "dispatched back from the visited astAdditiveExpr-object (visitor pattern)"
    
    |leftSequence rightSequence|

    leftSequence := self visit:anObject multiplicativeExpr.
    rightSequence := self visit:anObject additiveExpr.
    self announceTracepointInterrupt.
     "If the atomized operand is an empty sequence, the result of the value comparison is an empty sequence"
    (leftSequence size = 0) ifTrue:[
        ^ XQuerySequence new:0
    ].
    (rightSequence size = 0) ifTrue:[
        ^ XQuerySequence new:0
    ].
     "If the atomized operand is a sequence of length greater than one, a type error is raised"
    self assert:(leftSequence size = 1).
    self assert:(rightSequence size = 1).
     "evaluate operation"
    ^ XQuerySequence withNumber:(anObject operand == #plus 
                ifTrue:[ leftSequence first value + rightSequence first value ]
                ifFalse:[ leftSequence first value - rightSequence first value ]).

    "Created: / 06-07-2006 / 19:12:08 / ked"
    "Modified: / 08-10-2006 / 20:15:15 / ked"
    "Modified: / 21-03-2007 / 14:08:39 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstAndExpr:anObject 
    "dispatched back from the visited astAdditiveExpr-object (visitor pattern)"
    
    |leftSequence rightSequence|

    leftSequence := self visit:anObject comparisonExpr.
    rightSequence := self visit:anObject andExpr.
    self announceTracepointInterrupt.
     "evaluate operation"
    ^ XQuerySequence withBoolean:(leftSequence effectiveBooleanValue 
                and:[ leftSequence effectiveBooleanValue ])

    "Created: / 06-07-2006 / 19:12:08 / ked"
    "Modified: / 08-10-2006 / 20:15:15 / ked"
    "Modified: / 21-03-2007 / 15:08:08 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstAnyKindTest:anObject 
    "dispatched back from the visited astAnyKindTest-object (visitor pattern)"
    
    ^ self currentNodeSet:(self currentNodeSet 
                select:[:nodeSetItem | nodeSetItem type isSubtypeOf:XQuerySequenceItem typeNode ]).

    "Created: / 21-11-2006 / 21:54:14 / ked"
    "Modified: / 23-11-2006 / 12:24:11 / ked"
    "Modified: / 05-12-2007 / 21:21:33 / janfrog"
!

visitAstAttribNameOrWildcard:anObject 
    "dispatched back from the visited astAttribNameOrWildcard-object (visitor pattern)"
    
    |givenContext resultDataContext|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    resultDataContext := OrderedCollection new.
    givenContext dataContext do:[:dataContextItem | 
        (dataContextItem type isSubtypeOf:XQuerySequenceItem typeNode) ifTrue:[
            dataContextItem item xpathIsAttribute ifTrue:[
                anObject attributeName 
                    ifNil:[ resultDataContext add:dataContextItem. ]
                    ifNotNil:[
                        self visit:(anObject attributeName).
                        context dataContext first value = dataContextItem item xpathName ifTrue:[
                            resultDataContext add:dataContextItem.
                        ].
                        context := givenContext.
                    ].
            ].
        ].
    ].
    context := givenContext copyContext dataContext:resultDataContext.

    "Created: / 21-11-2006 / 21:58:27 / ked"
    "Modified: / 23-11-2006 / 13:27:56 / ked"
    "Modified: / 05-12-2007 / 21:21:33 / janfrog"
    "Modified: / 18-09-2008 / 17:47:00 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstAttributeTest:anObject 
    "dispatched back from the visited astAttributeTest-object (visitor pattern)"
    
    |givenContext attribNameNode|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    anObject attribName 
        ifNil:[
            attribNameNode := AstAttribNameOrWildcard new.
            self visit:attribNameNode.
        ]
        ifNotNil:[ self visit:(anObject attribName). ].

    "Created: / 21-11-2006 / 21:57:25 / ked"
    "Modified: / 23-11-2006 / 13:06:49 / ked"
    "Modified: / 18-09-2008 / 17:47:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstAxisStep:anObject 
    "dispatched back from the visited astAxisStep-object (visitor pattern)"
    
    self currentNodeSet:(anObject forwardStep 
                ifNil:[ self visit:anObject reverseStep ]
                ifNotNil:[ self visit:anObject forwardStep ]).
    ^ self currentNodeSet:(self visit:(anObject predicateList)).

    "Created: / 06-07-2006 / 19:12:08 / ked"
    "Modified: / 02-11-2006 / 10:30:45 / ked"
    "Modified: / 18-11-2007 / 08:11:01 / janfrog"
!

visitAstBooleanLiteral:anObject 

    ^XQuerySequence withBoolean: anObject content

    "Created: / 28-03-2007 / 17:35:35 / janfrog"
!

visitAstCompAttrConstructor:anObject 
    "dispatched back from the visited astCompAttrConstructor-object (visitor pattern)"
    
    |qName contentSeq attributeNode|

    attributeNode := XQueryConstructedNode new 
                nodeType:XQueryConstructedNode nodeTypeAttribute.
    qName := anObject qname 
                ifNotNil:[ self visit:anObject qname ]
                ifNil:[ self visit:anObject expr ].
    self announceTracepointInterrupt.
    attributeNode nodeName:(self xmlNodeNameFromQName:qName).
    contentSeq := anObject contentExpr 
                ifNil:[ XQuerySequence new:0 ]
                ifNotNil:[ self visit:(anObject contentExpr) ].
    self appendSequence:contentSeq toConstructedTextOrAttribute:attributeNode.
    ^ XQuerySequence withAttribute:attributeNode.

    "Created: / 06-07-2006 / 19:12:08 / ked"
    "Modified: / 09-11-2006 / 23:45:28 / ked"
    "Modified: / 21-03-2007 / 16:05:22 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstCompDocConstructor:anObject 
    "dispatched back from the visited astCompElemConstructor-object (visitor pattern)"
    
    |documentNode|

    documentNode := XQueryConstructedNode new 
                nodeType:XQueryConstructedNode nodeTypeDocument.
    anObject expr 
        ifNil:[
            self 
                appendSequence:(OrderedCollection new)
                toConstructedElement:documentNode
                whichIsDocument:false.
        ]
        ifNotNil:[
            |documentChildrenSeq|

            documentChildrenSeq := self visit:anObject expr.
            self announceTracepointInterrupt.
            self 
                appendSequence:documentChildrenSeq
                toConstructedElement:documentNode
                whichIsDocument:false.
        ].
    ^ XQuerySequence withNode:documentNode.

    "Created: / 06-07-2006 / 19:12:09 / ked"
    "Modified: / 09-11-2006 / 23:53:01 / ked"
    "Modified: / 29-03-2007 / 11:29:20 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstCompElemConstructor:anObject 
    "dispatched back from the visited astCompElemConstructor-object (visitor pattern)"
    
    |qName elementNode|

    elementNode := XQueryConstructedNode new 
                nodeType:XQueryConstructedNode nodeTypeElement.
    qName := anObject qname 
                ifNotNil:[ self visit:anObject qname ]
                ifNil:[ self visit:anObject expr ].
    self announceTracepointInterrupt.
    elementNode nodeName:(self xmlNodeNameFromQName:qName).
    anObject contentExpr 
        ifNil:[
            self 
                appendSequence:(OrderedCollection new)
                toConstructedElement:elementNode
                whichIsDocument:false.
        ]
        ifNotNil:[
            self 
                appendSequence:(self visit:anObject contentExpr)
                toConstructedElement:elementNode
                whichIsDocument:false.
        ].
    ^ XQuerySequence withNode:elementNode.

    "Created: / 06-07-2006 / 19:12:09 / ked"
    "Modified: / 09-11-2006 / 23:53:01 / ked"
    "Modified: / 29-03-2007 / 11:27:01 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstCompTextConstructor:anObject 
    "dispatched back from the visited astCompTextConstructor-object (visitor pattern)"
    
    |textSeq textNode|

    textSeq := self visit:(anObject expr).
    self announceTracepointInterrupt.
    textNode := XQueryConstructedNode new 
                nodeType:XQueryConstructedNode nodeTypeText.
    self appendSequence:textSeq toConstructedTextOrAttribute:textNode.
    ^ XQuerySequence withNode:textNode

    "Created: / 06-07-2006 / 19:12:09 / ked"
    "Modified: / 06-11-2006 / 22:53:07 / ked"
    "Modified: / 29-03-2007 / 13:43:21 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstComparisonExpr:anObject 
    "dispatched back from the visited astComparisonExpr-object (visitor pattern)"
    
    |leftSeq rightSeq comparisonOperations|

    leftSeq := self visit:anObject rangeExprLeft.
    rightSeq := self visit:anObject rangeExprRight.
    self announceTracepointInterrupt.
    comparisonOperations := Dictionary new.
    anObject valueComp 
        ifNotNil:[
            "If the atomized operand is an empty sequence, the result of the value comparison is an empty sequence"
            (leftSeq size = 0) ifTrue:[
                ^ XQuerySequence new:0
            ].
            (rightSeq size = 0) ifTrue:[
                ^ XQuerySequence new:0
            ].
             "If the atomized operand is a sequence of length greater than one, a type error is raised"
            self assert:(leftSeq size = 1).
            self assert:(rightSeq size = 1).
            comparisonOperations
                at:#eqValue put:[:left :right | left = right ];
                at:#neValue put:[:left :right | left ~= right ];
                at:#ltValue put:[:left :right | left < right ];
                at:#leValue put:[:left :right | left <= right ];
                at:#gtValue put:[:left :right | left > right ];
                at:#geValue put:[:left :right | left >= right ].
            ^ XQuerySequence 
                withBoolean:((comparisonOperations at:anObject valueComp) 
                        value:(leftSeq first value)
                        value:(rightSeq first value))
        ].
    anObject generalComp 
        ifNotNil:[
            comparisonOperations
                at:#eqGeneral
                    put:[:left :right | 
                        left 
                            anySatisfy:[:itemLeft | 
                                right anySatisfy:[:itemRight | itemLeft value = itemRight value ]
                            ]
                    ];
                at:#neGeneral
                    put:[:left :right | 
                        left 
                            anySatisfy:[:itemLeft | 
                                right anySatisfy:[:itemRight | itemLeft value ~= itemRight value ]
                            ]
                    ];
                at:#ltGeneral
                    put:[:left :right | 
                        left 
                            anySatisfy:[:itemLeft | 
                                right anySatisfy:[:itemRight | itemLeft value < itemRight value ]
                            ]
                    ];
                at:#leGeneral
                    put:[:left :right | 
                        left 
                            anySatisfy:[:itemLeft | 
                                right anySatisfy:[:itemRight | itemLeft value <= itemRight value ]
                            ]
                    ];
                at:#gtGeneral
                    put:[:left :right | 
                        left 
                            anySatisfy:[:itemLeft | 
                                right anySatisfy:[:itemRight | itemLeft value > itemRight value ]
                            ]
                    ];
                at:#geGeneral
                    put:[:left :right | 
                        left 
                            anySatisfy:[:itemLeft | 
                                right anySatisfy:[:itemRight | itemLeft value >= itemRight value ]
                            ]
                    ].
            ^ XQuerySequence 
                withBoolean:((comparisonOperations at:anObject generalComp) 
                        value:(leftSeq)
                        value:(rightSeq))
        ].
    anObject nodeComp 
        ifNotNil:[
            "If either operand is an empty sequence, the result of the comparison is an empty sequence"
            (leftSeq size = 0) ifTrue:[
                ^ XQuerySequence new:0
            ].
            (rightSeq size = 0) ifTrue:[
                ^ XQuerySequence new:0
            ].
             "Each operand must be either a single node or an empty sequence; otherwise a type error is raised"
            self assert:(leftSeq size = 1).
            self assert:(rightSeq size = 1).
            self assert:(leftSeq first type isSubtypeOf:XQuerySequenceItem typeNode).
            self assert:(rightSeq first type isSubtypeOf:XQuerySequenceItem typeNode).
            comparisonOperations
                at:#is put:[:left :right | left = right ];
                at:#isLess put:[:left :right | self error:'not yet implemented' ];
                at:#isMore put:[:left :right | self error:'not yet implemented' ].
            ^ XQuerySequence 
                withBoolean:((comparisonOperations at:anObject nodeComp) 
                        value:(leftSeq first value)
                        value:(rightSeq first value))
        ].

    "Created: / 06-07-2006 / 19:12:09 / ked"
    "Modified: / 02-12-2006 / 12:20:34 / ked"
    "Modified: / 05-12-2007 / 21:21:33 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstContextItemExpr:anObject 

    ^XQuerySequence with: currentFocus contextItem

    "Created: / 07-11-2006 / 22:04:03 / ked"
    "Modified: / 21-03-2007 / 23:01:12 / janfrog"
!

visitAstDecimalLiteral:anObject 
    "dispatched back from the visited astDecimalLiteral-object (visitor pattern)"
    
    ^XQuerySequence withNumber: (anObject content)

    "Created: / 06-07-2006 / 19:12:09 / ked"
    "Modified: / 08-10-2006 / 13:35:40 / ked"
    "Modified: / 21-03-2007 / 13:54:01 / janfrog"
!

visitAstDefaultNamespaceDecl: anObject

    | nsUri |
    nsUri := anObject uri content. "because it is instance of AstStringLiteral"
    nsUri := nsUri copyFrom:2 to: nsUri size - 1.

    anObject type == #element
        ifTrue:[defaultElementNamespaceURI := nsUri]
        ifFalse:[defaultFunctionNamespaceURI := nsUri]

    "Created: / 24-12-2006 / 15:12:53 / janfrog"
    "Modified: / 24-12-2006 / 17:18:40 / janfrog"
!

visitAstDeleteExpr:anObject 
    |targetSeq deleteCmd|

    targetSeq := self visit:anObject targetExpr.
    self announceTracepointInterrupt.
    deleteCmd := DeleteCommand new targetSequence:targetSeq.
    pendingUpdateList := pendingUpdateList mergeWith:deleteCmd.
    ^ (XQuerySequence new)

    "Modified: / 08-11-2007 / 00:25:34 / beyboy"
    "Modified: / 14-11-2007 / 11:31:24 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstDirAttributeList:anObject 
    "dispatched back from the visited astDirAttributeList-object (visitor pattern)"
    
    |givenContext qnameContext dirAttributeValueContext attributeNode dataContextItem|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    attributeNode := XQueryConstructedNode new 
                nodeType:XQueryConstructedNode nodeTypeAttribute.
    self visit:(anObject qname).
    self announceTracepointInterrupt.
    qnameContext := context.
    context := givenContext.
    self assert:qnameContext dataContext size = 1.
    attributeNode nodeName:(XMLv2::NodeName 
                fromString:qnameContext dataContext first value asString
                andPrefixToNamespaceURIMapping:prefixToNamespaceURIMapping).
    anObject dirAttributeValue 
        ifNil:[
            self appendSequence:(OrderedCollection new)
                toConstructedTextOrAttribute:attributeNode.
        ]
        ifNotNil:[
            self visit:(anObject dirAttributeValue).
            dirAttributeValueContext := context.
            self appendSequence:dirAttributeValueContext dataContext
                toConstructedTextOrAttribute:attributeNode.
        ].
    dataContextItem := (XQuerySequenceItem new)
                item:attributeNode;
                type:(XQuerySequenceItem typeNode).
    anObject dirAttributeList 
        ifNil:[
            context := givenContext copyContext dataContextSingle:dataContextItem.
        ]
        ifNotNil:[
            context := givenContext.
            self visit:(anObject dirAttributeList).
            context dataContext addFirst:dataContextItem.
        ].

    "Created: / 06-07-2006 / 19:12:09 / ked"
    "Modified: / 03-12-2006 / 20:54:34 / ked"
    "Modified: / 21-03-2007 / 16:05:22 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstDirElemConstructor:anObject 
    "dispatched back from the visited astCompElemConstructor-object (visitor pattern)"
    
    |qName elementNode|

    elementNode := XQueryConstructedNode new 
                nodeType:XQueryConstructedNode nodeTypeElement.
    qName := anObject qname 
                ifNotNil:[ self visit:anObject qname ]
                ifNil:[ self visit:anObject expr ].
    self announceTracepointInterrupt.
    elementNode nodeName:(self xmlNodeNameFromQName:qName).
    anObject dirElemContent 
        ifNil:[
            self 
                appendSequence:(OrderedCollection new)
                toConstructedElement:elementNode
                whichIsDocument:false.
        ]
        ifNotNil:[
            self 
                appendSequence:(self visit:anObject dirElemContent)
                toConstructedElement:elementNode
                whichIsDocument:false.
        ].
    ^ XQuerySequence withNode:elementNode.

    "Created: / 06-07-2006 / 19:12:09 / ked"
    "Modified: / 09-11-2006 / 23:53:01 / ked"
    "Modified: / 28-03-2007 / 22:40:16 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstDirElemContent:anObject 
    |resultSeq contentSeq contentItem|

    resultSeq := anObject dirElemContent 
                ifNotNil:[ self visit:anObject dirElemContent ]
                ifNil:[ XQuerySequence new:4 ].
    contentSeq := self visit:anObject content.
    self announceTracepointInterrupt.
    contentItem := contentSeq isString ifTrue:[
                contentSeq
            ] ifFalse:[
                contentSeq first
            ].
    contentItem isString ifTrue:[
        contentItem := XQuerySequenceItem withText:contentItem
    ].
    resultSeq addFirst:contentItem.
    ^ resultSeq

    "Modified: / 28-03-2007 / 23:11:41 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstDocumentTest:anObject 
    "dispatched back from the visited astDocumentTest-object (visitor pattern)"
    
    |givenContext resultDataContext childrenDataContext|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    resultDataContext := OrderedCollection new.
    givenContext dataContext do:[:dataContextItem | 
        (dataContextItem type isSubtypeOf:XQuerySequenceItem typeNode) ifTrue:[
            dataContextItem item xpathIsDocument ifTrue:[
                anObject elementTest 
                    ifNil:[ resultDataContext add:dataContextItem. ]
                    ifNotNil:[
                        childrenDataContext := dataContextItem item xpathChild.
                        childrenDataContext size = 1 ifTrue:[
                            context := givenContext copyContext dataContext:childrenDataContext.
                            self visit:(anObject elementTest).
                            context dataContext size = 1 ifTrue:[
                                resultDataContext add:dataContextItem.
                            ].
                        ].
                    ].
            ].
        ].
    ].
    context := givenContext copyContext dataContext:resultDataContext.

    "Created: / 21-11-2006 / 21:55:21 / ked"
    "Modified: / 23-11-2006 / 12:23:53 / ked"
    "Modified: / 05-12-2007 / 21:21:33 / janfrog"
    "Modified: / 18-09-2008 / 17:47:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstDoubleLiteral:anObject 
    "dispatched back from the visited astDoubleLiteral-object (visitor pattern)"
    
    context := context copyContext
                dataContextSingle:(XQuerySequenceItem new
                        item:(anObject content))

    "Created: / 06-07-2006 / 19:12:10 / ked"
    "Modified: / 08-10-2006 / 13:35:49 / ked"
    "Modified: / 05-12-2007 / 15:21:44 / janfrog"
    "Modified: / 18-09-2008 / 15:40:08 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstDummyNode: anObject

    ^self visit: anObject dummyNode

    "Created: / 28-03-2007 / 20:25:32 / janfrog"
!

visitAstElementNameOrWildcard:anObject 
    "dispatched back from the visited astElementNameOrWildcard-object (visitor pattern)"
    
    |givenContext resultDataContext|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    resultDataContext := OrderedCollection new.
    givenContext dataContext do:[:dataContextItem | 
        (dataContextItem type isSubtypeOf:XQuerySequenceItem typeNode) ifTrue:[
            dataContextItem item xpathIsElement ifTrue:[
                anObject elementName 
                    ifNil:[ resultDataContext add:dataContextItem. ]
                    ifNotNil:[
                        self visit:(anObject elementName).
                        context dataContext first value = dataContextItem item xpathName ifTrue:[
                            resultDataContext add:dataContextItem.
                        ].
                        context := givenContext.
                    ].
            ].
        ].
    ].
    context := givenContext copyContext dataContext:resultDataContext.

    "Created: / 21-11-2006 / 22:00:20 / ked"
    "Modified: / 23-11-2006 / 13:33:54 / ked"
    "Modified: / 05-12-2007 / 21:21:33 / janfrog"
    "Modified: / 18-09-2008 / 17:47:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstElementTest:anObject 
    "dispatched back from the visited astElementTest-object (visitor pattern)"
    
    |givenContext elementNameNode|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    anObject elementName 
        ifNil:[
            elementNameNode := AstElementNameOrWildcard new.
            self visit:elementNameNode.
        ]
        ifNotNil:[ self visit:(anObject elementName). ].
    self announceTracepointInterrupt.

    "Created: / 21-11-2006 / 21:59:28 / ked"
    "Modified: / 23-11-2006 / 13:07:57 / ked"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstEnclosedExpr:anObject 

    ^self visit:(anObject expr).

    "Created: / 06-11-2006 / 22:40:40 / ked"
    "Modified: / 09-11-2006 / 18:45:20 / ked"
    "Modified: / 28-03-2007 / 23:05:47 / janfrog"
!

visitAstExpr:anObject 

    ^(self visit:anObject exprSingle)
        addAll:(self visit:anObject expr);
        yourself.

    "Created: / 06-07-2006 / 19:12:10 / ked"
    "Modified: / 08-10-2006 / 13:36:20 / ked"
    "Modified: / 21-03-2007 / 14:20:09 / janfrog"
!

visitAstFLWORExpr:anObject 
    |forLetClauses result|

    "/self visit:anObject flworExpr_ForLet.
    forLetClauses := anObject flworExpr_ForLet asCollectionOfForLetClauses.
    result := XQuerySequence new:16.

    self 
        bloomForLetClauses: forLetClauses
        using:
            [(self visit: anObject whereClause) effectiveBooleanValue
                ifTrue:[result addAll: (self visit: anObject exprSingle)]].

    ^result

    "Modified: / 30-11-2006 / 23:49:28 / ked"
    "Created: / 26-03-2007 / 23:22:18 / janfrog"
    "Modified: / 28-03-2007 / 21:28:14 / janfrog"
!

visitAstFLWORExpr_ForLet:anObject 
    "dispatched back from the visited astFLWORExpr_ForLet-object (visitor pattern)"
    
    anObject letClause 
        ifNotNil:[
            self visit:(anObject letClause).
            self announceTracepointInterrupt
        ].
    anObject forClause 
        ifNotNil:[
            self visit:(anObject forClause).
            self announceTracepointInterrupt.
        ].
    anObject flworExpr_ForLet 
        ifNotNil:[ self visit:(anObject flworExpr_ForLet) ].

    "Created: / 06-07-2006 / 19:12:10 / ked"
    "Modified: / 02-11-2006 / 10:33:16 / ked"
    "Modified: / 28-03-2007 / 16:52:22 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstFilterExpr:anObject 
    "dispatched back from the visited astFilterExpr-object (visitor pattern)"
    
    self currentNodeSet:(self visit:(anObject primaryExpr)).
    self announceTracepointInterrupt.
    anObject predicateList do:[:xpathPredicate | 
        self currentNodeSet:(self visit:xpathPredicate).
        self announceTracepointInterrupt.
    ].
    ^ self currentNodeSet

    "Created: / 06-07-2006 / 19:12:10 / ked"
    "Modified: / 13-10-2006 / 14:37:06 / ked"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstForClause:anObject 

    "there is no so much work to do - see visitFLWORExpr:"
    anObject forClause ifNotNil:
        [self visit:(anObject forClause)].

    "Created: / 06-07-2006 / 19:12:10 / ked"
    "Modified: / 02-11-2006 / 10:33:38 / ked"
    "Modified: / 28-03-2007 / 16:54:14 / janfrog"
    "Modified: / 24-09-2008 / 07:49:33 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstForwardStep:anObject 
    "dispatched back from the visited astForwardStep-object (visitor pattern)"
    
    anObject abbrevForwardStep 
        ifNil:[
            "evaluate axis"
            self currentNodeSet:(self currentNodeSet 
                        inject:(XQuerySequence new:(self currentNodeSet size * 2))
                        into:[:newNodeSet :nodeSetItem | 
                            newNodeSet
                                addAll:(nodeSetItem item perform:anObject forwardAxis);
                                yourself
                        ]).
            self currentNodeSet:(self visit:anObject nodeTest).
        ]
        ifNotNil:[ self currentNodeSet:(self visit:anObject abbrevForwardStep) ].
    ^ self currentNodeSet

    "Created: / 06-07-2006 / 19:12:10 / ked"
    "Modified: / 02-12-2006 / 11:05:30 / ked"
    "Modified: / 08-11-2007 / 00:25:01 / beyboy"
    "Modified: / 05-12-2007 / 10:37:09 / janfrog"
!

visitAstFunctionCall:anObject 
    "dispatched back from the visited astFunctionCall-object (visitor pattern)"
    
    |functionQName retval  |

    functionQName := self visit:anObject qname.
    anObject functionParametersList 
        ifNil:[
            retval := self funcTable 
                        evaluate:functionQName
                        inContext:context
                        withParameters:(OrderedCollection new)
                        forInterpreter:self.
        ]
        ifNotNil:[
            |params|

            params := self visit:anObject functionParametersList.
            retval := self funcTable 
                        evaluate:functionQName
                        inContext:context
                        withParameters:params
                        forInterpreter:self.
        ].
    ^ retval

    "Created: / 06-07-2006 / 19:12:11 / ked"
    "Modified: / 23-11-2006 / 19:12:01 / ked"
    "Modified: / 28-08-2007 / 22:48:21 / janfrog"
    "Modified: / 18-09-2008 / 15:40:07 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstFunctionDecl:anObject

    | function |
    function := UserDefinedFunction new
                    name: (XMLv2::NodeName
                        fromString: anObject name content
                        andPrefixToNamespaceURIMapping: prefixToNamespaceURIMapping
                        defaultNS: defaultFunctionNamespaceURI );

                    params: (anObject paramList collect:[:e|FunctionParam new name:e name content]);

                    body: anObject body.

    funcTable defineFunction: function

    "Modified: / 28-12-2006 / 16:34:12 / janfrog"
!

visitAstFunctionParametersList:anObject 

    | params |
    params := anObject functionParametersList
                    ifNil:[OrderedCollection new: 4]
                    ifNotNil:[self visit: anObject functionParametersList].

    params addFirst: (self visit:anObject exprSingle).

    ^params

    "Created: / 11-11-2006 / 18:51:30 / ked"
    "Modified: / 23-11-2006 / 18:54:41 / ked"
    "Modified: / 28-03-2007 / 23:00:55 / janfrog"
!

visitAstIfExpr:anObject 
    |conditionValue|

    conditionValue := (self visit:anObject expr) effectiveBooleanValue.
    self announceTracepointInterrupt.
    ^ conditionValue 
        ifTrue:[ self visit:anObject trueExprSingle ]
        ifFalse:[ self visit:anObject falseExprSingle ]

    "Modified: / 21-03-2007 / 14:57:38 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstInsertAfterExpr:anObject 
    |sourceSeq targetSeq insertCmd|

    targetSeq := self visit:anObject targetExpr.
    sourceSeq := self visit:anObject sourceExpr.
    self announceTracepointInterrupt.
    insertCmd := (InsertAfterCommand new)
                targetSequence:targetSeq;
                sourceSequence:sourceSeq.
    pendingUpdateList := pendingUpdateList mergeWith:insertCmd.
    ^ (XQuerySequence new)

    "Modified: / 21-11-2007 / 09:04:57 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstInsertAsFirstIntoExpr:anObject 
    |sourceSeq targetSeq insertCmd|

    targetSeq := self visit:anObject targetExpr.
    sourceSeq := self visit:anObject sourceExpr.
    self announceTracepointInterrupt.
    insertCmd := (InsertAsFirstIntoCommand new)
                targetSequence:targetSeq;
                sourceSequence:sourceSeq.
    pendingUpdateList := pendingUpdateList mergeWith:insertCmd.
    ^ (XQuerySequence new)

    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstInsertAsLastIntoExpr:anObject 
    |sourceSeq targetSeq insertCmd|

    targetSeq := self visit:anObject targetExpr.
    sourceSeq := self visit:anObject sourceExpr.
    self announceTracepointInterrupt.
    insertCmd := (InsertAsLastIntoCommand new)
                targetSequence:targetSeq;
                sourceSequence:sourceSeq.
    pendingUpdateList := pendingUpdateList mergeWith:insertCmd.
    ^ (XQuerySequence new)

    "Modified: / 21-11-2007 / 12:46:18 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstInsertBeforeExpr:anObject 
    |sourceSeq targetSeq insertCmd|

    targetSeq := self visit:anObject targetExpr.
    sourceSeq := self visit:anObject sourceExpr.
    self announceTracepointInterrupt.
    insertCmd := (InsertBeforeCommand new)
                targetSequence:targetSeq;
                sourceSequence:sourceSeq.
    pendingUpdateList := pendingUpdateList mergeWith:insertCmd.
    ^ (XQuerySequence new)

    "Modified: / 21-11-2007 / 12:46:32 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstInsertIntoExpr:anObject 
    |sourceSeq targetSeq insertCmd|

    targetSeq := self visit:anObject targetExpr.
    sourceSeq := self visit:anObject sourceExpr.
    self announceTracepointInterrupt.
    insertCmd := (InsertIntoCommand new)
                targetSequence:targetSeq;
                sourceSequence:sourceSeq.
    pendingUpdateList := pendingUpdateList mergeWith:insertCmd.
    ^ (XQuerySequence new)

    "Modified: / 21-11-2007 / 12:46:40 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstIntegerLiteral:anObject 
    "dispatched back from the visited astIntegerLiteral-object (visitor pattern)"
    
    self announceTracepointInterrupt.
    ^ XQuerySequence withNumber:anObject content

    "Created: / 06-07-2006 / 19:12:11 / ked"
    "Modified: / 08-10-2006 / 13:40:04 / ked"
    "Modified: / 21-03-2007 / 13:53:11 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstIntersectExceptExpr:anObject 
    "dispatched back from the visited astIntersectExceptExpr-object (visitor pattern)"
    
    |givenContext unaryContext intersectExceptContext nonuniqueDataContext resultDataContext|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    self visit:(anObject unaryExpr).
    unaryContext := context.
    context := givenContext.
    self visit:(anObject intersectExceptExpr).
    intersectExceptContext := context.
    context := givenContext copyContext.
    nonuniqueDataContext := OrderedCollection new.
    anObject operand = #intersect ifTrue:[
        "The intersect operator takes two node sequences as operands and returns a sequence
         containing all the nodes that occur in both operands."
        unaryContext dataContext do:[:unaryDataContextItem | 
            self 
                assert:(unaryDataContextItem type isSubtypeOf:XQuerySequenceItem typeNode).
            (intersectExceptContext dataContext 
                anySatisfy:[:intersectExceptDataContextItem | 
                    self assert:(intersectExceptDataContextItem type 
                                isSubtypeOf:XQuerySequenceItem typeNode).
                    intersectExceptDataContextItem item = unaryDataContextItem item.
                ]) 
                    ifTrue:[ nonuniqueDataContext add:unaryDataContextItem. ].
        ].
    ] ifFalse:[
        "The except operator takes two node sequences as operands and returns a sequence
         containing all the nodes that occur in the first operand but not in the second operand."
        unaryContext dataContext do:[:unaryDataContextItem | 
            self 
                assert:(unaryDataContextItem type isSubtypeOf:XQuerySequenceItem typeNode).
            (intersectExceptContext dataContext 
                anySatisfy:[:intersectExceptDataContextItem | 
                    self assert:(intersectExceptDataContextItem type 
                                isSubtypeOf:XQuerySequenceItem typeNode).
                    intersectExceptDataContextItem item = unaryDataContextItem item.
                ]) 
                    ifFalse:[ nonuniqueDataContext add:unaryDataContextItem. ].
        ].
    ].
    resultDataContext := OrderedCollection new.
    self uniqueAddNodeSequence:nonuniqueDataContext to:resultDataContext.
    context dataContext:resultDataContext.

    "Created: / 06-07-2006 / 19:12:11 / ked"
    "Modified: / 01-12-2006 / 16:48:18 / ked"
    "Modified: / 05-12-2007 / 21:21:33 / janfrog"
    "Modified: / 18-09-2008 / 17:47:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstLetClause:anObject 
    |name value|

    name := self visit:anObject varName.
    value := self visit:anObject exprSingle.
    self announceTracepointInterrupt.
    self bindVar:name to:value.
    self visit:anObject letClause.

    "Created: / 06-07-2006 / 19:12:11 / ked"
    "Modified: / 03-12-2006 / 17:06:43 / ked"
    "Modified: / 28-03-2007 / 18:10:35 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstMainModule:anObject 

    ^self 
        visit: anObject prolog;
        visit: anObject queryBody

    "Modified: / 12-10-2006 / 23:08:51 / ked"
    "Created: / 24-12-2006 / 14:57:06 / janfrog"
    "Modified: / 24-12-2006 / 16:19:06 / janfrog"
!

visitAstModuleImport: anObject

    | prefix uri |
    uri := anObject uri content. "because it is instance of AstStringLiteral"
    uri := uri copyFrom:2 to: uri size - 1.

    anObject prefix ifNotNil: 
        [prefix := anObject prefix content.
        prefix = 'xml' ifTrue:[self error:'Cannot redefine ''xml'' namespace prefix.'].
        prefix = 'xmlns' ifTrue:[self error:'Cannot bind ''xmlns'' prefix to namespace uri'].
        prefixToNamespaceURIMapping 
            at: prefix
            put: uri].

    self loadFunctionLibraryWithURI: uri

    "Modified: / 24-12-2006 / 17:16:56 / janfrog"
    "Created: / 01-12-2008 / 09:54:03 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstMultiplicativeExpr:anObject 
    |leftSequence rightSequence multiplicativeOperations|

    leftSequence := self visit:anObject unionExpr.
    rightSequence := self visit:anObject multiplicativeExpr.
    self announceTracepointInterrupt.
     "If the atomized operand is an empty sequence, the result of the value comparison is an empty sequence"
    (leftSequence size = 0) ifTrue:[
        ^ XQuerySequence new:0
    ].
    (rightSequence size = 0) ifTrue:[
        ^ XQuerySequence new:0
    ].
     "If the atomized operand is a sequence of length greater than one, a type error is raised"
    self assert:(leftSequence size = 1).
    self assert:(rightSequence size = 1).
     "evaluate operation"
    multiplicativeOperations := (Dictionary new)
                at:#krat put:[:left :right | left * right ];
                at:#div put:[:left :right | (left / right) asDouble ];
                at:#idiv put:[:left :right | left // right ];
                at:#mod put:[:left :right | left \\ right ];
                yourself.
    ^ XQuerySequence 
        withNumber:((multiplicativeOperations at:anObject operand) 
                value:leftSequence first value
                value:rightSequence first value)

    "Created: / 06-07-2006 / 19:12:11 / ked"
    "Modified: / 08-10-2006 / 20:15:22 / ked"
    "Modified: / 21-03-2007 / 15:46:55 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstNCName:anObject 
    "dispatched back from the visited astNCName-object (visitor pattern)"

    ^anObject content.

    "Created: / 06-07-2006 / 19:12:11 / ked"
    "Modified: / 18-11-2006 / 16:26:33 / ked"
    "Modified: / 28-03-2007 / 23:12:55 / janfrog"
!

visitAstNameTest:anObject 
    "dispatched back from the visited astNameTest-object (visitor pattern)"
    
    anObject qname 
        ifNotNil:[
            |nodename|

            nodename := self xmlNodeNameFromQName:(self visit:anObject qname).
            ^ self currentNodeSet:(self currentNodeSet 
                        select:[:nodeSetItem | 
                            (nodeSetItem type isSubtypeOf:XQuerySequenceItem typeNode) 
                                and:[
                                    nodeSetItem item isElementOrAttributeNode 
                                        and:[
                                            nodeSetItem item xpathNamespace = nodename ns 
                                                and:[ nodeSetItem item xpathLocalName = nodename localName ]
                                        ]
                                ]
                        ])
        ].
    anObject wildcard 
        ifNotNil:[
            |wildcard|

            wildcard := self visit:anObject wildcard.
            ^ self currentNodeSet:(self currentNodeSet select:[:nodeSetItem | true ])
        ].
    self shouldNeverBeReached

    "Created: / 12-10-2006 / 21:58:21 / ked"
    "Modified: / 02-12-2006 / 12:20:41 / ked"
    "Modified: / 05-12-2007 / 21:21:33 / janfrog"
!

visitAstNamespaceDecl: anObject

    | prefix nsUri |
    prefix := anObject prefix content. "because it is instance of AstNCName"
    nsUri := anObject nsuri content. "because it is instance of AstStringLiteral"
    nsUri := nsUri copyFrom:2 to: nsUri size - 1.

    prefix = 'xml' ifTrue:[self error:'Cannot redefine ''xml'' namespace prefix.'].
    prefix = 'xmlns' ifTrue:[self error:'Cannot bind ''xmlns'' prefix to namespace uri'].

    prefixToNamespaceURIMapping 
        at: prefix
        put: nsUri

    "Created: / 24-12-2006 / 15:12:58 / janfrog"
    "Modified: / 24-12-2006 / 17:16:56 / janfrog"
!

visitAstOrExpr:anObject 
    "dispatched back from the visited astAdditiveExpr-object (visitor pattern)"
    
    |leftSequence rightSequence|

    leftSequence := self visit:anObject andExpr.
    rightSequence := self visit:anObject orExpr.
    self announceTracepointInterrupt.
     "evaluate operation"
    ^ XQuerySequence withBoolean:(leftSequence effectiveBooleanValue 
                or:[ leftSequence effectiveBooleanValue ])

    "Created: / 06-07-2006 / 19:12:08 / ked"
    "Modified: / 08-10-2006 / 20:15:15 / ked"
    "Modified: / 21-03-2007 / 15:09:13 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstOrderByClause:anObject 
    "dispatched back from the visited astOrderByClause-object (visitor pattern)"
    
    |givenContext|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    context := givenContext copyContext optContextEmpty.
    context optContext at:#orderSpecList put:(OrderedCollection new).
    self visit:(anObject orderSpecList).

    "Created: / 06-07-2006 / 19:12:12 / ked"
    "Modified: / 26-11-2006 / 20:06:09 / ked"
    "Modified: / 18-09-2008 / 17:47:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstOrderModifier:anObject 
    "dispatched back from the visited astOrderModifier-object (visitor pattern)"

    "fall back to general object-case - please change as required"

    ^ self visitObject:anObject

    "Created: / 06-07-2006 / 19:12:12 / ked"
!

visitAstOrderSpec:anObject 
    "dispatched back from the visited astOrderSpec-object (visitor pattern)"
    
    |givenContext orderSpecItem|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    self visit:(anObject exprSingle).
    orderSpecItem := XQueryOrderSpecItem new orderValue:context dataContext.
    context := givenContext copyContext.
    anObject orderModifier 
        ifNotNil:[
            anObject orderModifier ascDesc 
                ifNotNil:[ orderSpecItem ascDesc:anObject orderModifier ascDesc. ].
            anObject orderModifier greatestLeast 
                ifNotNil:[
                    orderSpecItem emptyGreatestLeast:anObject orderModifier greatestLeast.
                ].
        ].
    (context optContext at:#orderSpecList) addFirst:orderSpecItem.

    "Created: / 06-07-2006 / 19:12:12 / ked"
    "Modified: / 30-11-2006 / 15:18:28 / ked"
    "Modified: / 18-09-2008 / 17:47:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstOrderSpecList:anObject 
    "dispatched back from the visited astOrderSpecList-object (visitor pattern)"
    
    |givenContext orderSpecContext orderSpecItem|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    context := givenContext copyContext optContextEmpty.
    context optContext at:#orderSpecList put:(OrderedCollection new).
    self visit:(anObject orderSpec).
    orderSpecContext := context.
    context := givenContext.
    orderSpecItem := (orderSpecContext optContext at:#orderSpecList) first.
    anObject orderSpecList ifNotNil:[ self visit:(anObject orderSpecList). ].
    (context optContext at:#orderSpecList) addFirst:orderSpecItem.

    "Created: / 06-07-2006 / 19:12:12 / ked"
    "Modified: / 30-11-2006 / 15:21:31 / ked"
    "Modified: / 18-09-2008 / 17:47:02 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstParenthesizedExpr:anObject 
    "dispatched back from the visited astParenthesizedExpr-object (visitor pattern)"

    ^anObject expr 
        ifNotNil:[self visit:anObject expr]
        ifNil:[XQuerySequence new]

    "Created: / 08-07-2006 / 18:40:13 / ked"
    "Modified: / 02-11-2006 / 10:42:34 / ked"
    "Modified: / 29-03-2007 / 10:06:39 / janfrog"
!

visitAstPathExpr:anObject 
    "dispatched back from the visited astPathExpr-object (visitor pattern)"
    
    |givenContext expandedDataContext resultDataContext|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    context := givenContext copyContext.
    anObject startSign = #slash ifTrue:[
        resultDataContext := OrderedCollection new.
        self 
            innerFocusIn:context
            do:[:dataContextItem :innerFocusItem | 
                self 
                    assert:(dataContextItem type isSubtypeOf:XQuerySequenceItem typeNode).
                expandedDataContext := OrderedCollection new.
                expandedDataContext addAll:(dataContextItem item xpathDocument).
            ]
            withResultDo:[:dataContextItem :innerFocusItem :exprContext | 
                self uniqueAddNodeSequence:expandedDataContext to:resultDataContext.
            ].
        context := givenContext dataContext:resultDataContext.
    ].
    anObject startSign = #slashSlash ifTrue:[
        resultDataContext := OrderedCollection new.
        self 
            innerFocusIn:context
            do:[:dataContextItem :innerFocusItem | 
                self 
                    assert:(dataContextItem type isSubtypeOf:XQuerySequenceItem typeNode).
                expandedDataContext := OrderedCollection new.
                expandedDataContext 
                    addAll:(dataContextItem item xpathDocument first item 
                            xpathDescendantOrSelf).
            ]
            withResultDo:[:dataContextItem :innerFocusItem :exprContext | 
                self uniqueAddNodeSequence:expandedDataContext to:resultDataContext.
            ].
        context := givenContext dataContext:resultDataContext.
    ].
    resultDataContext := OrderedCollection new.
    self 
        innerFocusIn:context
        do:[:dataContextItem :innerFocusItem | self visit:(anObject relativePathExpr). ]
        withResultDo:[:dataContextItem :innerFocusItem :exprContext | 
            self uniqueAddNodeSequence:exprContext dataContext to:resultDataContext.
        ].
    context dataContext:resultDataContext.

    "Created: / 06-07-2006 / 19:12:12 / ked"
    "Modified: / 02-12-2006 / 11:25:43 / ked"
    "Modified: / 05-12-2007 / 21:03:38 / janfrog"
    "Modified: / 18-09-2008 / 17:47:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstPredefinedEntityRef:anObject 
    "dispatched back from the visited astPredefinedEntityRef-object (visitor pattern)"

    | predefinedEntities |

    predefinedEntities := Dictionary new
                            at: '&lt;' put: '<';
                            at: '&gt;' put: '>';
                            at: '&amp;' put: '&';
                            at: '&apos;' put: '''';
                            yourself.

    context := context copyContext
                dataContextSingle:(XQuerySequenceItem new
                        item:(predefinedEntities at:(anObject content));
                        type:(XQuerySequenceItem typeString)).

    "Created: / 06-07-2006 / 19:12:12 / ked"
    "Modified: / 03-12-2006 / 16:53:19 / ked"
    "Modified: / 21-03-2007 / 13:16:53 / janfrog"
    "Modified: / 18-09-2008 / 15:40:07 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstPredicate:anObject 
    "dispatched back from the visited astPredicate-object (visitor pattern)"
    
    ^ self 
        withFocusDo:[
            self currentNodeSet:(self currentNodeSet 
                        select:[:nodeSetItem | 
                            |exprSeq|

                            currentFocus
                                contextItem:nodeSetItem;
                                contextPositionAdvance.
                            self hack:'This is little bit tricky'.
                            self currentNodeSet:(XQuerySequence with:currentFocus contextItem).
                            exprSeq := self visit:anObject expr.
                            exprSeq containsSingleInteger ifTrue:[
                                currentFocus contextPosition = exprSeq asInteger
                            ] ifFalse:[
                                exprSeq effectiveBooleanValue
                            ]
                        ])
        ]

    "Created: / 06-07-2006 / 19:12:13 / ked"
    "Modified: / 01-12-2006 / 23:38:55 / ked"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
!

visitAstProlog: anObject

    anObject declarations do:[:e|self visit:e]

    "Created: / 24-12-2006 / 15:12:37 / janfrog"
!

visitAstQName:anObject 
    "dispatched back from the visited astQName-object (visitor pattern)"

    ^anObject content.
    "currentContext := currentContext copyContext
                dataContextSingle:(XQueryDataContextItem new
                        item:(anObject content);
                        type:(XQueryDataContextItem typeQName))."

    "Created: / 06-07-2006 / 19:12:13 / ked"
    "Modified: / 08-10-2006 / 13:22:15 / ked"
    "Modified: / 20-03-2007 / 23:13:15 / janfrog"
!

visitAstQuantifiedExpr:anObject 
    |quantifiedExprImpls bloomingBlock|

    quantifiedExprImpls := anObject quantifiedExpr_Impl 
                asCollectionOfQuantifiedExprImpls.
    bloomingBlock := anObject someEvery = #some ifTrue:[
                [
                |exprValue|

                exprValue := (self visit:anObject exprSingle) effectiveBooleanValue.
                self announceTracepointInterrupt.
                exprValue ifTrue:[
                    ^ XQuerySequence withBoolean:true
                ]
            ]
            ] ifFalse:[
                [
                |exprValue|

                exprValue := (self visit:anObject exprSingle) effectiveBooleanValue.
                self announceTracepointInterrupt.
                exprValue ifTrue:[
                    ^ XQuerySequence withBoolean:false
                ]
            ]
            ].
    self bloomQuantifiedExprImpls:quantifiedExprImpls using:bloomingBlock.
    ^ anObject someEvery = #some 
        ifTrue:[ XQuerySequence withBoolean:false ]
        ifFalse:[ XQuerySequence withBoolean:true ]

    "Modified: / 28-03-2007 / 22:30:30 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstQuantifiedExpr_Impl:anObject 
    "dispatched back from the visited astQuantifiedExpr_Impl-object (visitor pattern)"
    
    |givenContext quantifiedTuple|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    quantifiedTuple := XQueryTupleItem new.
    quantifiedTuple forLet:#for.
    quantifiedTuple varExpr:(anObject exprSingle).
    quantifiedTuple varName:(self visit:anObject varName).
    context := givenContext copyContext.
    (context optContext at:#quantifiedTuple) add:quantifiedTuple.
    anObject quantifiedExpr_Impl 
        ifNotNil:[ self visit:(anObject quantifiedExpr_Impl). ].

    "Created: / 06-07-2006 / 19:12:13 / ked"
    "Modified: / 02-11-2006 / 11:21:32 / ked"
    "Modified: / 20-03-2007 / 23:36:54 / janfrog"
    "Modified: / 18-09-2008 / 17:47:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstRangeExpr:anObject 
    "dispatched back from the visited astRangeExpr-object (visitor pattern)"
    
    |fromSequence toSequence|

    fromSequence := self visit:(anObject additiveExprFrom).
    toSequence := self visit:(anObject additiveExprTo).
    self announceTracepointInterrupt.
    self assert:(fromSequence size = 1).
    self assert:(toSequence size = 1).
    ^ XQuerySequence withNumbers:((fromSequence first value asInteger) 
                to:(toSequence first value asInteger))

    "Created: / 06-07-2006 / 19:12:13 / ked"
    "Modified: / 08-10-2006 / 13:25:33 / ked"
    "Modified: / 21-03-2007 / 14:28:03 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstRelativePathExpr:anObject 
    "dispatched back from the visited astRelativePathExpr-object (visitor pattern)"
    
    self currentNodeSet:(self visit:anObject relativePathExpr).
    self announceTracepointInterrupt.
    anObject divSign = #slashSlash ifTrue:[
        |"descendant-or-self" abbrevExpandedNode|

        abbrevExpandedNode := (AstForwardStep new)
                    forwardAxis:#xpathDescendantOrSelf;
                    nodeTest:(AstAnyKindTest new).
        self currentNodeSet:(self visit:abbrevExpandedNode).
    ].
    anObject stepExpr 
        ifNotNil:[ self currentNodeSet:(self visit:anObject stepExpr) ].
    self currentNodeSet class == self class ifTrue:[
        self halt
    ].
    ^ self currentNodeSet

    "Created: / 06-07-2006 / 19:12:13 / ked"
    "Modified: / 01-12-2006 / 23:36:32 / ked"
    "Modified: / 08-11-2007 / 00:25:54 / beyboy"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstRenameExpr:anObject 
    |targetNode newName renameCmd|

    targetNode := self visit:anObject targetExpr.
    newName := self visit:anObject newNameExpr.
    self announceTracepointInterrupt.
    renameCmd := (RenameCommand new)
                targetSequence:targetNode;
                sourceSequence:newName.
    pendingUpdateList := pendingUpdateList mergeWith:renameCmd.
    ^ (XQuerySequence new)

    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstReplaceExpr:anObject 
    |targetNode sourceNodes replaceCmd|

    targetNode := self visit:anObject targetExpr.
    sourceNodes := self visit:anObject sourceExpr.
    self announceTracepointInterrupt.
    replaceCmd := (ReplaceCommand new)
                targetSequence:targetNode;
                sourceSequence:sourceNodes.
    pendingUpdateList := pendingUpdateList mergeWith:replaceCmd.
    ^ (XQuerySequence new)

    "Modified: / 21-11-2007 / 12:00:06 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstReplaceValueOfExpr:anObject 
    |targetSequence newValue replaceValueOfCmd|

    targetSequence := self visit:anObject targetExpr.
    newValue := self visit:anObject sourceExpr.
    self announceTracepointInterrupt.
    targetSequence containsSingleElement ifFalse:[
        replaceValueOfCmd := (ReplaceValueOfCommand new)
                    targetSequence:targetSequence;
                    sourceSequence:newValue.
    ] ifTrue:[
        replaceValueOfCmd := (ReplaceElementContentCommand new)
                    targetSequence:targetSequence;
                    sourceSequence:newValue.
    ].
    pendingUpdateList := pendingUpdateList mergeWith:replaceValueOfCmd.
    ^ (XQuerySequence new)

    "Modified: / 14-11-2007 / 14:51:16 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstReverseStep:anObject 
    anObject abbrevReverseStep 
        ifNil:[
            "evaluate axis"
            self currentNodeSet:(self currentNodeSet 
                        inject:(XQuerySequence new:(self currentNodeSet size * 2))
                        into:[:newNodeSet :nodeSetItem | 
                            newNodeSet
                                addAll:(nodeSetItem item perform:anObject reverseAxis);
                                yourself
                        ]).
            self currentNodeSet:(self visit:anObject nodeTest)
        ]
        ifNotNil:[
            |expandedNode|

            expandedNode := (AstReverseStep new)
                        reverseAxis:#xpathParent;
                        nodeTest:(AstAnyKindTest new).
            self currentNodeSet:(self visit:expandedNode)
        ].
    ^ self currentNodeSet

    "Created: / 06-07-2006 / 19:12:14 / ked"
    "Modified: / 02-12-2006 / 11:07:04 / ked"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
!

visitAstStringLiteral:anObject 
    "dispatched back from the visited astStringLiteral-object (visitor pattern)"
    
    self announceTracepointInterrupt.
    ^ XQuerySequence 
        withString:((anObject content) copyFrom:2 to:(anObject content) size - 1)

    "Created: / 06-07-2006 / 19:12:14 / ked"
    "Modified: / 13-10-2006 / 16:34:02 / ked"
    "Modified: / 21-03-2007 / 15:46:13 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstTextTest:anObject 
    "dispatched back from the visited astNameTest-object (visitor pattern)"
    
    ^ self currentNodeSet:(self currentNodeSet 
                select:[:item | (item type isSubtypeOf: XQuerySequenceItem typeNode) and:[ item item isTextNode ] ]).

    "Created: / 12-10-2006 / 21:58:21 / ked"
    "Modified: / 02-12-2006 / 12:20:41 / ked"
    "Modified: / 05-12-2007 / 21:04:05 / janfrog"
!

visitAstTransformCopyClause:anObject 
    |name value valueCopy|

    name := self visit:anObject varName.
    value := self visit:anObject exprSingle.
    self announceTracepointInterrupt.
    self assert:value containsSingleNode
        message:'Only singleton sequences with node can be copied (now)'.
    valueCopy := XQuerySequence withNode:(value first item copy).
    self bindVar:name to:valueCopy.
    anObject transformCopyClause 
        ifNotNil:[ self visit:anObject transformCopyClause ].

    "Modified: / 05-12-2007 / 14:28:25 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstTransformExpr:anObject 
    |pul|

    self visit:anObject transformCopyClause.
    self announceTracepointInterrupt.
    pul := pendingUpdateList.
    pendingUpdateList := EmptyCommand new.
    self visit:anObject modifyExpr.
    pendingUpdateList execute.
    pendingUpdateList := pul.
    ^ XQuerySequence withAll:(self visit:anObject returnExpr).

    "Modified: / 05-12-2007 / 14:05:02 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstUnaryExpr:anObject 
    "dispatched back from the visited astUnaryExpr-object (visitor pattern)"
    
    |valueSeq unaryOperations|

    valueSeq := self visit:(anObject unaryExpr).
    self announceTracepointInterrupt.
    (valueSeq size = 0) ifTrue:[
        ^ XQuerySequence new:0
    ].
    self assert:(valueSeq size = 1).
    unaryOperations := Dictionary new.
    unaryOperations
        at:#plus put:[:val | val ];
        at:#minus put:[:val | 0 - val ].
    ^ XQuerySequence withNumber:((unaryOperations at:anObject operand) 
                value:valueSeq first value)

    "Created: / 06-07-2006 / 19:12:14 / ked"
    "Modified: / 08-10-2006 / 13:26:15 / ked"
    "Modified: / 21-03-2007 / 15:40:22 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstUnionExpr:anObject 
    "dispatched back from the visited astUnionExpr-object (visitor pattern)"
    
    |givenContext intersectExceptContext unionContext resultDataContext|

    self 
        halt:'Not yet ported. Ask Jan Vrany <vranyj1@fel.cvut.cz> for further explanation'.
    self visit:(anObject intersectExceptExpr).
    intersectExceptContext := context.
    context := givenContext.
    self visit:(anObject unionExpr).
    unionContext := context.
    context := givenContext copyContext.
    resultDataContext := OrderedCollection new.
    self uniqueAddNodeSequence:intersectExceptContext dataContext
        to:resultDataContext.
    self uniqueAddNodeSequence:unionContext dataContext to:resultDataContext.
    context dataContext:resultDataContext.

    "Created: / 06-07-2006 / 19:12:14 / ked"
    "Modified: / 01-12-2006 / 16:15:05 / ked"
    "Modified: / 18-09-2008 / 17:47:02 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstVarRef:anObject 
    "dispatched back from the visited astVarRef-object (visitor pattern)"
    
    |qName value|

    qName := self visit:anObject varName.
    value := self valueOfVar:qName inContext:context.
    self announceTracepointInterrupt.
    ^ (value isKindOf:XQuerySequence) 
        ifTrue:[ value ]
        ifFalse:[ XQuerySequence with:value ]

    "Created: / 06-07-2006 / 19:12:14 / ked"
    "Modified: / 08-10-2006 / 13:26:44 / ked"
    "Modified: / 28-03-2007 / 17:04:40 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitAstWhereClause:anObject 
    "dispatched back from the visited astWhereClause-object (visitor pattern)"

    ^self visit:(anObject exprSingle).

    "Created: / 06-07-2006 / 19:12:14 / ked"
    "Modified: / 08-10-2006 / 13:27:03 / ked"
    "Modified: / 28-03-2007 / 21:29:32 / janfrog"
!

visitAstWildcard:anObject 
    "dispatched back from the visited astWildcard-object (visitor pattern)"

    "fall back to general object-case - please change as required"

    ^ anObject ncName ? '*'

    "Created: / 06-07-2006 / 19:12:14 / ked"
    "Modified: / 21-03-2007 / 20:37:22 / janfrog"
!

visitNilWith: ignored

    ^nil

    "Created: / 28-03-2007 / 17:41:58 / janfrog"
!

visitObject:anObject 
    "dispatched back from the visited objects (visitor pattern)"

    "general fallBack - please change as required"

    self error:'not yet implemented'

    "Modified: / 06-07-2006 / 19:12:14 / ked"
    "Modified: / 21-11-2007 / 12:19:57 / janfrog"
!

visitXPathAnyKindTest:anObject 
    ^ self currentNodeSet

    "Created: / 17-11-2007 / 15:31:51 / janfrog"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
!

visitXPathAttributeTest:anObject 
    "dispatched back from the visited xPathAttributeTest-object (visitor pattern)"

    "fall back to general object-case - please change as required"

    ^ self visitObject:anObject

    "Created: / 17-11-2007 / 15:31:51 / janfrog"
!

visitXPathAxisAncestor:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathAncestor]

    "Modified: / 17-11-2007 / 19:49:19 / janfrog"
!

visitXPathAxisAncestorOrSelf:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathAncestorOrSelf]

    "Modified: / 17-11-2007 / 19:49:30 / janfrog"
!

visitXPathAxisAttribute:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathAttribute]

    "Modified: / 17-11-2007 / 19:50:01 / janfrog"
!

visitXPathAxisChild:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathChild]

    "Modified: / 17-11-2007 / 19:50:10 / janfrog"
!

visitXPathAxisDescendant:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathDescendant]

    "Modified: / 17-11-2007 / 19:50:20 / janfrog"
!

visitXPathAxisDescendantOrSelf:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathDescendantOrSelf]

    "Modified: / 17-11-2007 / 19:50:32 / janfrog"
!

visitXPathAxisFollowing:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathFollowing]

    "Modified: / 17-11-2007 / 19:50:44 / janfrog"
!

visitXPathAxisFollowingSibling:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathFollowingSibling]

    "Modified: / 17-11-2007 / 19:52:09 / janfrog"
!

visitXPathAxisParent:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathParent]

    "Modified: / 17-11-2007 / 19:52:17 / janfrog"
!

visitXPathAxisPreceding:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathPreceding]

    "Modified: / 17-11-2007 / 19:52:44 / janfrog"
!

visitXPathAxisPrecedingSibling:anObject 

    ^self reduceCurrentNodeSetUsing:
            [:node|node xpathPrecedingSibling]

    "Modified: / 17-11-2007 / 19:52:40 / janfrog"
!

visitXPathAxisSelf:anObject 
    ^ self currentNodeSet

    "Modified: / 05-12-2007 / 10:37:09 / janfrog"
!

visitXPathCommentTest:anObject 
    "dispatched back from the visited xPathCommentTest-object (visitor pattern)"

    "fall back to general object-case - please change as required"

    ^ self visitObject:anObject

    "Created: / 17-11-2007 / 15:31:52 / janfrog"
!

visitXPathDocumentTest:anObject 
    "dispatched back from the visited xPathDocumentTest-object (visitor pattern)"

    "fall back to general object-case - please change as required"

    ^ self visitObject:anObject

    "Created: / 17-11-2007 / 15:31:52 / janfrog"
!

visitXPathElementTest:anObject 
    "dispatched back from the visited xPathElementTest-object (visitor pattern)"

    "fall back to general object-case - please change as required"

    ^ self visitObject:anObject

    "Created: / 17-11-2007 / 15:31:52 / janfrog"
!

visitXPathExpression:xpathExpression 
    ^ self 
        withCurrentNodeSetDo:[
            xpathExpression do:[:xpathLocationStepOrFilter | 
                self currentNodeSet:(self visit:xpathLocationStepOrFilter).
                self announceTracepointInterrupt.
            ].
            self currentNodeSet
        ]

    "Created: / 17-11-2007 / 15:12:54 / janfrog"
    "Modified: / 05-12-2007 / 10:37:08 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitXPathLocationStep:xpathLocationStep 
    self currentNodeSet:(self visit:xpathLocationStep axis).
    self currentNodeSet:(self visit:xpathLocationStep nodeTest).
    xpathLocationStep predicates do:[:xpathPredicate | 
        self currentNodeSet:(self visit:xpathPredicate).

    ].
    ^ self currentNodeSet

    "Created: / 17-11-2007 / 15:13:07 / janfrog"
    "Modified: / 05-12-2007 / 10:37:47 / janfrog"
    "Modified: / 24-09-2008 / 07:57:14 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitXPathNameTest:anObject 
    |ns localName|

    ns := anObject prefix = '*' ifTrue:[
                '*'
            ] ifFalse:[
                anObject prefix isNil ifTrue:[
                    ''
                ] ifFalse:[
                    prefixToNamespaceURIMapping at:anObject prefix
                        ifAbsent:[ self errorNamespacePrefixNotDeclared:anObject prefix ]
                ]
            ].
    localName := anObject localName.
    ^ self currentNodeSet:(self currentNodeSet 
                select:[:nodeSetItem | 
                    ((nodeSetItem type isSubtypeOf: XQuerySequenceItem typeElement)
                        or:[ nodeSetItem type isSubtypeOf: XQuerySequenceItem typeAttribute ]) 
                            and:[
                                nodeSetItem item isElementOrAttributeNode 
                                    and:[
                                        (ns = '*' or:[ nodeSetItem item xpathNamespace = ns ]) 
                                            and:[ localName = '*' or:[ nodeSetItem item xpathLocalName = localName ] ]
                                    ]
                            ]
                ]).

    "Created: / 17-11-2007 / 15:31:52 / janfrog"
    "Modified: / 05-12-2007 / 15:55:13 / janfrog"
!

visitXPathPredicate:xpathPredicate 
    ^ self 
        withFocusDo:[
            self currentNodeSet:(self currentNodeSet 
                        select:[:nodeSetItem | 
                            |exprSeq|

                            currentFocus
                                contextItem:nodeSetItem;
                                contextPositionAdvance.
                            self hack:'This is little bit tricky'.
                            self currentNodeSet:(XQuerySequence with:currentFocus contextItem).
                            exprSeq := self visit:xpathPredicate expr.
                            self announceTracepointInterrupt.
                            exprSeq containsSingleInteger ifTrue:[
                                currentFocus contextPosition = exprSeq asInteger
                            ] ifFalse:[
                                exprSeq effectiveBooleanValue
                            ]
                        ])
        ]

    "Created: / 17-11-2007 / 15:23:51 / janfrog"
    "Modified: / 05-12-2007 / 10:37:44 / janfrog"
    "Modified: / 13-12-2008 / 10:52:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

visitXPathProcessingInstructionTest:anObject 
    "dispatched back from the visited xPathProcessingInstructionTest-object (visitor pattern)"

    "fall back to general object-case - please change as required"

    ^ self visitObject:anObject

    "Created: / 17-11-2007 / 15:31:52 / janfrog"
!

visitXPathTextTest:anObject 
    ^ self currentNodeSet:(self currentNodeSet 
                select:[:item | item containsNode and:[ item item xpathIsText ] ])

    "Created: / 17-11-2007 / 15:31:52 / janfrog"
    "Modified: / 05-12-2007 / 10:37:39 / janfrog"
! !

!XQueryInterpreter class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryInterpreter.st,v 1.26 2008-01-09 14:07:54 wrobll1 Exp $'
! !
