"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Perseus::Scanner subclass:#XQueryScanner
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XQuery-Core'
!


!XQueryScanner class methodsFor:'generated-comments'!

scannerDefinitionComment

	"<whitespace> : \s+;
<char> : [a-zA-Z];
<digit> : [0-9];
<char_ref> : ((&\#[0-9]+\;) | (&\#x[0-9a-fA-F]+\;));

<ncnamechar> : (<char> | <digit> | \. | \- | \_);
<ncname> : (<char> | \_) (<ncnamechar>)*;
<qname> : (<ncname> \:)? <ncname>;

<digits> : [0-9]+;
<integer_literal> : <digits>;
<decimal_literal> : (\.<digits>) | (<digits>\.[0-9]*);
<double_literal> : ((\.<digits>) | (<digits>(\.[0-9]*)?)) [eE] [\+\-]? <digits>;

<predefined_entity_ref> : &(lt | gt | amp | quot | apos)\;;
<escape_quot> : """";
<escape_apos> : '';

<string_literal> : ("" (<predefined_entity_ref> | <char_ref> | <escape_quot> | [^""&])* "") | (' (<predefined_entity_ref> | <char_ref> | <escape_apos> | [^'&])* ');

<element_content_char> : <char> - [{}<&];
<qout_attr_content_char> : <char> - [""{}<&];
<apos_attr_content_char> : <char> - ['{}<&];
"

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryScanner class methodsFor:'generated-initialization'!

initializeKeywordMap
    keywordMap := Dictionary new.
    #( #(114 'after' 73)
     #(114 'ancestor' 112)
     #(114 'and' 2)
     #(114 'as' 68)
     #(114 'ascending' 49)
     #(114 'at' 56)
     #(114 'attribute' 92)
     #(114 'before' 74)
     #(114 'by' 44)
     #(114 'child' 86)
     #(114 'comment' comment)
     #(114 'copy' 76)
     #(114 'declare' 34)
     #(114 'default' 32)
     #(114 'delete' 62)
     #(114 'descendant' 88)
     #(114 'descending' 47)
     #(114 'div' 11)
     #(114 'do' 64)
     #(114 'document' 69)
     #(114 'element' 29)
     #(114 'else' 4)
     #(114 'empty' 27)
     #(114 'eq' 19)
     #(114 'every' 14)
     #(114 'except' 20)
     #(114 'first' 75)
     #(114 'following' 107)
     #(114 'for' 51)
     #(114 'function' 30)
     #(114 'ge' 94)
     #(114 'greatest' 25)
     #(114 'gt' 93)
     #(114 'idiv' 22)
     #(114 'if' 12)
     #(114 'import' 36)
     #(114 'in' 52)
     #(114 'insert' 83)
     #(114 'intersect' 26)
     #(114 'into' 77)
     #(114 'is' 95)
     #(114 'last' 72)
     #(114 'le' 110)
     #(114 'least' 8)
     #(114 'let' 54)
     #(114 'lt' 53)
     #(114 'mod' 23)
     #(114 'modify' 57)
     #(114 'module' 37)
     #(114 'namespace' 42)
     #(114 'ne' 55)
     #(114 'node' 59)
     #(114 'of' 81)
     #(114 'or' 1)
     #(114 'order' 43)
     #(114 'ordered' 84)
     #(114 'parent' 109)
     #(114 'preceding' 103)
     #(114 'rename' 70)
     #(114 'replace' 79)
     #(114 'return' 50)
     #(114 'satisfies' 10)
     #(114 'self' 90)
     #(114 'some' 9)
     #(114 'stable' 45)
     #(114 'text' 63)
     #(114 'then' 6)
     #(114 'to' 3)
     #(114 'transform' 78)
     #(114 'union' 24)
     #(114 'unordered' 66)
     #(114 'updating' 31)
     #(114 'value' 80)
     #(114 'where' 46)
     #(114 'with' 85)
     #(115 'after' 73)
     #(115 'ancestor' 112)
     #(115 'and' 2)
     #(115 'as' 68)
     #(115 'ascending' 49)
     #(115 'at' 56)
     #(115 'attribute' 92)
     #(115 'before' 74)
     #(115 'by' 44)
     #(115 'child' 86)
     #(115 'comment' comment)
     #(115 'copy' 76)
     #(115 'declare' 34)
     #(115 'default' 32)
     #(115 'delete' 62)
     #(115 'descendant' 88)
     #(115 'descending' 47)
     #(115 'div' 11)
     #(115 'do' 64)
     #(115 'document' 69)
     #(115 'element' 29)
     #(115 'else' 4)
     #(115 'empty' 27)
     #(115 'eq' 19)
     #(115 'every' 14)
     #(115 'except' 20)
     #(115 'first' 75)
     #(115 'following' 107)
     #(115 'for' 51)
     #(115 'function' 30)
     #(115 'ge' 94)
     #(115 'greatest' 25)
     #(115 'gt' 93)
     #(115 'idiv' 22)
     #(115 'if' 12)
     #(115 'import' 36)
     #(115 'in' 52)
     #(115 'insert' 83)
     #(115 'intersect' 26)
     #(115 'into' 77)
     #(115 'is' 95)
     #(115 'last' 72)
     #(115 'le' 110)
     #(115 'least' 8)
     #(115 'let' 54)
     #(115 'lt' 53)
     #(115 'mod' 23)
     #(115 'modify' 57)
     #(115 'module' 37)
     #(115 'namespace' 42)
     #(115 'ne' 55)
     #(115 'node' 59)
     #(115 'of' 81)
     #(115 'or' 1)
     #(115 'order' 43)
     #(115 'ordered' 84)
     #(115 'parent' 109)
     #(115 'preceding' 103)
     #(115 'rename' 70)
     #(115 'replace' 79)
     #(115 'return' 50)
     #(115 'satisfies' 10)
     #(115 'self' 90)
     #(115 'some' 9)
     #(115 'stable' 45)
     #(115 'text' 63)
     #(115 'then' 6)
     #(115 'to' 3)
     #(115 'transform' 78)
     #(115 'union' 24)
     #(115 'unordered' 66)
     #(115 'updating' 31)
     #(115 'value' 80)
     #(115 'where' 46)
     #(115 'with' 85) ) 
            do:[:each | 
                (keywordMap at:each first ifAbsentPut:[ Dictionary new ]) at:(each at:2)
                    put:each last
            ].
    ^ keywordMap

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryScanner methodsFor:'accessing'!

source

    ^stream isExternalStream
        ifTrue:[self sourceFromExternalStream]
        ifFalse:[self sourceFromInternalStream]

    "Created: / 12-04-2007 / 11:52:21 / janfrog"
!

sourceFromExternalStream

    ^self shouldImplement "not yet implemented"

    "Created: / 12-04-2007 / 11:53:47 / janfrog"
!

sourceFromInternalStream

    ^stream collection asString.

    "Created: / 12-04-2007 / 11:54:00 / janfrog"
!

stream
    ^stream

    "Created: / 24-10-2007 / 15:55:43 / janfrog"
! !

!XQueryScanner methodsFor:'generated-scanner'!

scan1
    self step.
    (currentCharacter isLetter or:[ currentCharacter == $_ ]) ifTrue:[
        [
            self recordMatch:#( 115 ).
            self step.
            (currentCharacter isLetterOrDigit 
                or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ])
        ] whileTrue.
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan10
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self scan8
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan11
    [
        self recordMatch:#( 114 115 ).
        self step.
        (currentCharacter isLetterOrDigit 
            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ])
    ] whileTrue.
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan12
    self recordMatch:#( 114 115 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$q) 
                                        or:[ (currentCharacter between:$s and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $r) ifTrue:[
        ^ self scan15
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan13
    self recordMatch:#( 114 115 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[
                                            (currentCharacter between:$f and:$n) 
                                                or:[ (currentCharacter between:$p and:$z) ]
                                        ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $e) ifTrue:[
        self recordMatch:#( 114 115 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$r) 
                                            or:[ (currentCharacter between:$t and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $s) ifTrue:[
            self recordMatch:#( 114 115 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$b) 
                                                or:[ (currentCharacter between:$d and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $c) ifTrue:[
                self recordMatch:#( 114 115 ).
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$d) 
                                                    or:[ (currentCharacter between:$f and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $e) ifTrue:[
                    self recordMatch:#( 114 115 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$m) 
                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $n) ifTrue:[
                        self recordMatch:#( 114 115 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$c) 
                                                            or:[ (currentCharacter between:$e and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $d) ifTrue:[
                            self recordMatch:#( 114 115 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[ currentCharacter == $_ or:[ (currentCharacter between:$b and:$z) ] ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $a) ifTrue:[
                                self recordMatch:#( 114 115 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 114 115 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$s) 
                                                                        or:[ (currentCharacter between:$u and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $t) ifTrue:[
                                        self recordMatch:#( 114 115 ).
                                        self step.
                                        (currentCharacter isLetterOrDigit 
                                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $-) ifTrue:[
                                            self recordMatch:#( 114 115 ).
                                            self step.
                                            (currentCharacter isXMLDigit 
                                                or:[
                                                    (currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$n) 
                                                                                or:[ (currentCharacter between:$p and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $o) ifTrue:[
                                                self recordMatch:#( 114 115 ).
                                                self step.
                                                ((currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$0 and:$9) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$q) 
                                                                                    or:[ (currentCharacter between:$s and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $r) ifTrue:[
                                                    self recordMatch:#( 114 115 ).
                                                    self step.
                                                    (currentCharacter isLetterOrDigit 
                                                        or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $-) ifTrue:[
                                                        self recordMatch:#( 114 115 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$r) 
                                                                                            or:[ (currentCharacter between:$t and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $s) ifTrue:[
                                                            self recordMatch:#( 114 115 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$d) 
                                                                                                or:[ (currentCharacter between:$f and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $e) ifTrue:[
                                                                self recordMatch:#( 114 115 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$k) 
                                                                                                    or:[ (currentCharacter between:$m and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                (currentCharacter == $l) ifTrue:[
                                                                    self recordMatch:#( 114 115 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$e) 
                                                                                                        or:[ (currentCharacter between:$g and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan11 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan1
                                                                    ].
                                                                    (currentCharacter == $f) ifTrue:[
                                                                        self recordMatch:#( 98 114 115 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan11 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan1
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $o) ifTrue:[
        self recordMatch:#( 114 115 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$b) 
                                            or:[ (currentCharacter between:$d and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $c) ifTrue:[
            self recordMatch:#( 114 115 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$t) 
                                                or:[ (currentCharacter between:$v and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $u) ifTrue:[
                self recordMatch:#( 114 115 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$l) 
                                                    or:[ (currentCharacter between:$n and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $m) ifTrue:[
                    self recordMatch:#( 114 115 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$d) 
                                                        or:[ (currentCharacter between:$f and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $e) ifTrue:[
                        self recordMatch:#( 114 115 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$m) 
                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $n) ifTrue:[
                            self recordMatch:#( 114 115 ).
                            self step.
                            ((currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$0 and:$9) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$s) 
                                                                or:[ (currentCharacter between:$u and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $t) ifTrue:[
                                self recordMatch:#( 114 115 ).
                                self step.
                                (currentCharacter isLetterOrDigit 
                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $-) ifTrue:[
                                    self recordMatch:#( 114 115 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$m) 
                                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $n) ifTrue:[
                                        self recordMatch:#( 114 115 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$n) 
                                                                            or:[ (currentCharacter between:$p and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        (currentCharacter == $o) ifTrue:[
                                            self recordMatch:#( 114 115 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$c) 
                                                                                or:[ (currentCharacter between:$e and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $d) ifTrue:[
                                                self recordMatch:#( 114 115 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$d) 
                                                                                    or:[ (currentCharacter between:$f and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $e) ifTrue:[
                                                    self recordMatch:#( 60 114 115 ).
                                                    self step.
                                                    (currentCharacter isLetterOrDigit 
                                                        or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan14
    [
        self recordMatch:#( 117 ).
        self step.
        (currentCharacter isXMLDigit)
    ] whileTrue.
    (currentCharacter == $E or:[ currentCharacter == $e ]) ifTrue:[
        ^ self scan2
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan15
    self recordMatch:#( 114 115 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[
                                            (currentCharacter between:$f and:$n) 
                                                or:[ (currentCharacter between:$p and:$z) ]
                                        ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $e) ifTrue:[
        self recordMatch:#( 114 115 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$b) 
                                            or:[ (currentCharacter between:$d and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $c) ifTrue:[
            self recordMatch:#( 114 115 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$d) 
                                                or:[ (currentCharacter between:$f and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $e) ifTrue:[
                self recordMatch:#( 114 115 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$c) 
                                                    or:[ (currentCharacter between:$e and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $d) ifTrue:[
                    self recordMatch:#( 114 115 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$h) 
                                                        or:[ (currentCharacter between:$j and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $i) ifTrue:[
                        self recordMatch:#( 114 115 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$m) 
                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $n) ifTrue:[
                            self recordMatch:#( 114 115 ).
                            self step.
                            ((currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$0 and:$9) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$f) 
                                                                or:[ (currentCharacter between:$h and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $g) ifTrue:[
                                self recordMatch:#( 114 115 ).
                                self step.
                                (currentCharacter isLetterOrDigit 
                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $-) ifTrue:[
                                    self recordMatch:#( 114 115 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$r) 
                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $s) ifTrue:[
                                        self recordMatch:#( 114 115 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$h) 
                                                                            or:[ (currentCharacter between:$j and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        (currentCharacter == $i) ifTrue:[
                                            self recordMatch:#( 114 115 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[ currentCharacter == $a or:[ (currentCharacter between:$c and:$z) ] ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $b) ifTrue:[
                                                self recordMatch:#( 114 115 ).
                                                self step.
                                                ((currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$0 and:$9) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$k) 
                                                                                    or:[ (currentCharacter between:$m and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $l) ifTrue:[
                                                    self recordMatch:#( 114 115 ).
                                                    self step.
                                                    (currentCharacter isXMLDigit 
                                                        or:[
                                                            (currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$h) 
                                                                                        or:[ (currentCharacter between:$j and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    (currentCharacter == $i) ifTrue:[
                                                        self recordMatch:#( 114 115 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$m) 
                                                                                            or:[ (currentCharacter between:$o and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $n) ifTrue:[
                                                            self recordMatch:#( 114 115 ).
                                                            self step.
                                                            ((currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$0 and:$9) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$f) 
                                                                                                or:[ (currentCharacter between:$h and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $g) ifTrue:[
                                                                self recordMatch:#( 105 114 115 ).
                                                                self step.
                                                                (currentCharacter isLetterOrDigit 
                                                                    or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $o) ifTrue:[
        ^ self scan16
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan16
    self recordMatch:#( 114 115 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$b) 
                                        or:[ (currentCharacter between:$d and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $c) ifTrue:[
        ^ self scan17
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan17
    self recordMatch:#( 114 115 ).
    self step.
    (currentCharacter isXMLDigit 
        or:[
            (currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$d) 
                                        or:[ (currentCharacter between:$f and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $e) ifTrue:[
        ^ self scan18
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan18
    self recordMatch:#( 114 115 ).
    self step.
    ((currentCharacter between:$- and:$.) 
        or:[
            (currentCharacter between:$0 and:$9) 
                or:[
                    (currentCharacter between:$A and:$Z) 
                        or:[
                            currentCharacter == $_ 
                                or:[
                                    (currentCharacter between:$a and:$r) 
                                        or:[ (currentCharacter between:$t and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter == $:) ifTrue:[
        ^ self scan1
    ].
    (currentCharacter == $s) ifTrue:[
        self recordMatch:#( 114 115 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$r) 
                                            or:[ (currentCharacter between:$t and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $s) ifTrue:[
            self recordMatch:#( 114 115 ).
            self step.
            (currentCharacter isXMLDigit 
                or:[
                    (currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$h) 
                                                or:[ (currentCharacter between:$j and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $i) ifTrue:[
                self recordMatch:#( 114 115 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$m) 
                                                    or:[ (currentCharacter between:$o and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $n) ifTrue:[
                    self recordMatch:#( 114 115 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$f) 
                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $g) ifTrue:[
                        self recordMatch:#( 114 115 ).
                        self step.
                        (currentCharacter isLetterOrDigit 
                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $-) ifTrue:[
                            self recordMatch:#( 114 115 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$h) 
                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $i) ifTrue:[
                                self recordMatch:#( 114 115 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 114 115 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$r) 
                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $s) ifTrue:[
                                        self recordMatch:#( 114 115 ).
                                        self step.
                                        ((currentCharacter between:$- and:$.) 
                                            or:[
                                                (currentCharacter between:$0 and:$9) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$s) 
                                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        (currentCharacter == $t) ifTrue:[
                                            self recordMatch:#( 114 115 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$q) 
                                                                                or:[ (currentCharacter between:$s and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $r) ifTrue:[
                                                self recordMatch:#( 114 115 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$t) 
                                                                                    or:[ (currentCharacter between:$v and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $u) ifTrue:[
                                                    self recordMatch:#( 114 115 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$b) 
                                                                                        or:[ (currentCharacter between:$d and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    (currentCharacter == $c) ifTrue:[
                                                        self recordMatch:#( 114 115 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$s) 
                                                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $t) ifTrue:[
                                                            self recordMatch:#( 114 115 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$h) 
                                                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $i) ifTrue:[
                                                                self recordMatch:#( 114 115 ).
                                                                self step.
                                                                (currentCharacter isXMLDigit 
                                                                    or:[
                                                                        (currentCharacter between:$- and:$.) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$n) 
                                                                                                    or:[ (currentCharacter between:$p and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                (currentCharacter == $o) ifTrue:[
                                                                    self recordMatch:#( 114 115 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$m) 
                                                                                                        or:[ (currentCharacter between:$o and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan11 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan1
                                                                    ].
                                                                    (currentCharacter == $n) ifTrue:[
                                                                        self recordMatch:#( 58 114 115 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan11 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan1
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan2
    self step.
    (currentCharacter isXMLDigit) ifTrue:[
        [
            self recordMatch:#( 118 ).
            self step.
            (currentCharacter isXMLDigit)
        ] whileTrue.
        ^ self reportLastMatch
    ].
    (currentCharacter == $+ or:[ currentCharacter == $- ]) ifTrue:[
        self step.
        (currentCharacter isXMLDigit) ifTrue:[
            [
                self recordMatch:#( 118 ).
                self step.
                (currentCharacter isXMLDigit)
            ] whileTrue.
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan3
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan4
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan4
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self recordAndReportMatch:#( 119 ).
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan5
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan6
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan6
    self step.
    (currentCharacter == $;) ifTrue:[
        ^ self scan7
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan7
    [
        self step.
        (currentCharacter <= $!! 
            or:[ (currentCharacter between:$# and:$%) or:[ currentCharacter >= $' ] ])
    ] whileTrue.
    (currentCharacter == $") ifTrue:[
        self recordMatch:#( 120 ).
        self step.
        (currentCharacter == $") ifTrue:[
            ^ self scan7
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan5
        ].
        (currentCharacter == $#) ifTrue:[
            self step.
            (currentCharacter isXMLDigit) ifTrue:[
                [
                    self step.
                    (currentCharacter isXMLDigit)
                ] whileTrue.
                (currentCharacter == $;) ifTrue:[
                    ^ self scan7
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $x) ifTrue:[
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$A and:$F) 
                            or:[ (currentCharacter between:$a and:$f) ]
                    ]) 
                        ifTrue:[
                            [
                                self step.
                                (currentCharacter isXMLDigit 
                                    or:[
                                        (currentCharacter between:$A and:$F) 
                                            or:[ (currentCharacter between:$a and:$f) ]
                                    ])
                            ] whileTrue.
                            (currentCharacter == $;) ifTrue:[
                                ^ self scan7
                            ].
                            ^ self reportLastMatch
                        ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan6
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan6
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan5
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan8
    [
        self step.
        (currentCharacter <= $% or:[ currentCharacter >= $( ])
    ] whileTrue.
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan9
        ].
        (currentCharacter == $#) ifTrue:[
            self step.
            (currentCharacter isXMLDigit) ifTrue:[
                [
                    self step.
                    (currentCharacter isXMLDigit)
                ] whileTrue.
                (currentCharacter == $;) ifTrue:[
                    ^ self scan8
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $x) ifTrue:[
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$A and:$F) 
                            or:[ (currentCharacter between:$a and:$f) ]
                    ]) 
                        ifTrue:[
                            [
                                self step.
                                (currentCharacter isXMLDigit 
                                    or:[
                                        (currentCharacter between:$A and:$F) 
                                            or:[ (currentCharacter between:$a and:$f) ]
                                    ])
                            ] whileTrue.
                            (currentCharacter == $;) ifTrue:[
                                ^ self scan8
                            ].
                            ^ self reportLastMatch
                        ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan10
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan10
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan9
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $') ifTrue:[
        self recordMatch:#( 120 ).
        self step.
        (currentCharacter == $') ifTrue:[
            ^ self scan8
        ].
        ^ self reportLastMatch
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scan9
    self step.
    (currentCharacter == $t) ifTrue:[
        ^ self scan10
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

scanForToken
    self step.
    ((currentCharacter between:$A and:$Z) 
        or:[
            currentCharacter == $_ 
                or:[
                    (currentCharacter between:$b and:$c) 
                        or:[
                            currentCharacter == $e 
                                or:[
                                    (currentCharacter between:$g and:$o) 
                                        or:[ (currentCharacter between:$q and:$z) ]
                                ]
                        ]
                ]
        ]) 
            ifTrue:[ ^ self scan11 ].
    (currentCharacter isXMLDigit) ifTrue:[
        [
            self recordMatch:#( 116 ).
            self step.
            (currentCharacter isXMLDigit)
        ] whileTrue.
        (currentCharacter == $E or:[ currentCharacter == $e ]) ifTrue:[
            ^ self scan2
        ].
        (currentCharacter == $.) ifTrue:[
            ^ self scan14
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter isSeparator 
        or:[ currentCharacter == (Character codePoint:16rB) ]) 
            ifTrue:[
                [
                    self recordMatch:#whitespace.
                    self step.
                    (currentCharacter isSeparator 
                        or:[ currentCharacter == (Character codePoint:16rB) ])
                ] whileTrue.
                ^ self reportLastMatch
            ].
    (currentCharacter == $!!) ifTrue:[
        self step.
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 18 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $") ifTrue:[
        ^ self scan7
    ].
    (currentCharacter == $$) ifTrue:[
        ^ self recordAndReportMatch:#( 39 ).
    ].
    (currentCharacter == $&) ifTrue:[
        self step.
        (currentCharacter == $g or:[ currentCharacter == $l ]) ifTrue:[
            ^ self scan3
        ].
        (currentCharacter == $a) ifTrue:[
            self step.
            (currentCharacter == $m) ifTrue:[
                self step.
                (currentCharacter == $p) ifTrue:[
                    ^ self scan4
                ].
                ^ self reportLastMatch
            ].
            (currentCharacter == $p) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    self step.
                    (currentCharacter == $s) ifTrue:[
                        ^ self scan4
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        (currentCharacter == $q) ifTrue:[
            self step.
            (currentCharacter == $u) ifTrue:[
                self step.
                (currentCharacter == $o) ifTrue:[
                    ^ self scan3
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $') ifTrue:[
        ^ self scan8
    ].
    (currentCharacter == $() ifTrue:[
        ^ self recordAndReportMatch:#( 35 ).
    ].
    (currentCharacter == $)) ifTrue:[
        ^ self recordAndReportMatch:#( 33 ).
    ].
    (currentCharacter == $*) ifTrue:[
        ^ self recordAndReportMatch:#( 13 ).
    ].
    (currentCharacter == $+) ifTrue:[
        ^ self recordAndReportMatch:#( 7 ).
    ].
    (currentCharacter == $,) ifTrue:[
        ^ self recordAndReportMatch:#( 41 ).
    ].
    (currentCharacter == $-) ifTrue:[
        ^ self recordAndReportMatch:#( 5 ).
    ].
    (currentCharacter == $.) ifTrue:[
        self recordMatch:#( 104 ).
        self step.
        (currentCharacter isXMLDigit) ifTrue:[
            ^ self scan14
        ].
        (currentCharacter == $.) ifTrue:[
            ^ self recordAndReportMatch:#( 100 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $/) ifTrue:[
        self recordMatch:#( 91 ).
        self step.
        (currentCharacter == $/) ifTrue:[
            ^ self recordAndReportMatch:#( 89 ).
        ].
        (currentCharacter == $>) ifTrue:[
            ^ self recordAndReportMatch:#( 67 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $:) ifTrue:[
        self recordMatch:#( 101 ).
        self step.
        (currentCharacter == $:) ifTrue:[
            ^ self recordAndReportMatch:#( 87 ).
        ].
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 48 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $;) ifTrue:[
        ^ self recordAndReportMatch:#( 38 ).
    ].
    (currentCharacter == $<) ifTrue:[
        self recordMatch:#( 15 ).
        self step.
        (currentCharacter == $/) ifTrue:[
            ^ self recordAndReportMatch:#( 71 ).
        ].
        (currentCharacter == $<) ifTrue:[
            ^ self recordAndReportMatch:#( 99 ).
        ].
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 16 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $=) ifTrue:[
        ^ self recordAndReportMatch:#( 40 ).
    ].
    (currentCharacter == $>) ifTrue:[
        self recordMatch:#( 17 ).
        self step.
        (currentCharacter == $=) ifTrue:[
            ^ self recordAndReportMatch:#( 21 ).
        ].
        (currentCharacter == $>) ifTrue:[
            ^ self recordAndReportMatch:#( 97 ).
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $@) ifTrue:[
        ^ self recordAndReportMatch:#( 108 ).
    ].
    (currentCharacter == $[) ifTrue:[
        ^ self recordAndReportMatch:#( 102 ).
    ].
    (currentCharacter == $]) ifTrue:[
        ^ self recordAndReportMatch:#( 106 ).
    ].
    (currentCharacter == $a) ifTrue:[
        self recordMatch:#( 114 115 ).
        self step.
        ((currentCharacter between:$- and:$.) 
            or:[
                (currentCharacter between:$0 and:$9) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$m) 
                                            or:[ (currentCharacter between:$o and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $n) ifTrue:[
            self recordMatch:#( 114 115 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$b) 
                                                or:[ (currentCharacter between:$d and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $c) ifTrue:[
                self recordMatch:#( 114 115 ).
                self step.
                (currentCharacter isXMLDigit 
                    or:[
                        (currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$d) 
                                                    or:[ (currentCharacter between:$f and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $e) ifTrue:[
                    self recordMatch:#( 114 115 ).
                    self step.
                    ((currentCharacter between:$- and:$.) 
                        or:[
                            (currentCharacter between:$0 and:$9) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$r) 
                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $s) ifTrue:[
                        self recordMatch:#( 114 115 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$s) 
                                                            or:[ (currentCharacter between:$u and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $t) ifTrue:[
                            self recordMatch:#( 114 115 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$n) 
                                                                or:[ (currentCharacter between:$p and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $o) ifTrue:[
                                self recordMatch:#( 114 115 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$q) 
                                                                    or:[ (currentCharacter between:$s and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                (currentCharacter == $r) ifTrue:[
                                    self recordMatch:#( 114 115 ).
                                    self step.
                                    (currentCharacter isLetterOrDigit 
                                        or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $-) ifTrue:[
                                        self recordMatch:#( 114 115 ).
                                        self step.
                                        (currentCharacter isXMLDigit 
                                            or:[
                                                (currentCharacter between:$- and:$.) 
                                                    or:[
                                                        (currentCharacter between:$A and:$Z) 
                                                            or:[
                                                                currentCharacter == $_ 
                                                                    or:[
                                                                        (currentCharacter between:$a and:$n) 
                                                                            or:[ (currentCharacter between:$p and:$z) ]
                                                                    ]
                                                            ]
                                                    ]
                                            ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        (currentCharacter == $o) ifTrue:[
                                            self recordMatch:#( 114 115 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$q) 
                                                                                or:[ (currentCharacter between:$s and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $r) ifTrue:[
                                                self recordMatch:#( 114 115 ).
                                                self step.
                                                (currentCharacter isLetterOrDigit 
                                                    or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $-) ifTrue:[
                                                    self recordMatch:#( 114 115 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[
                                                                                    (currentCharacter between:$a and:$r) 
                                                                                        or:[ (currentCharacter between:$t and:$z) ]
                                                                                ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    (currentCharacter == $s) ifTrue:[
                                                        self recordMatch:#( 114 115 ).
                                                        self step.
                                                        (currentCharacter isXMLDigit 
                                                            or:[
                                                                (currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$d) 
                                                                                            or:[ (currentCharacter between:$f and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $e) ifTrue:[
                                                            self recordMatch:#( 114 115 ).
                                                            self step.
                                                            ((currentCharacter between:$- and:$.) 
                                                                or:[
                                                                    (currentCharacter between:$0 and:$9) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$k) 
                                                                                                or:[ (currentCharacter between:$m and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $l) ifTrue:[
                                                                self recordMatch:#( 114 115 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$e) 
                                                                                                    or:[ (currentCharacter between:$g and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                (currentCharacter == $f) ifTrue:[
                                                                    self recordMatch:#( 111 114 115 ).
                                                                    self step.
                                                                    (currentCharacter isLetterOrDigit 
                                                                        or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                            ifTrue:[ ^ self scan11 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan1
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $d) ifTrue:[
        ^ self scan13
    ].
    (currentCharacter == $f) ifTrue:[
        self recordMatch:#( 114 115 ).
        self step.
        (currentCharacter isXMLDigit 
            or:[
                (currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$A and:$Z) 
                            or:[
                                currentCharacter == $_ 
                                    or:[
                                        (currentCharacter between:$a and:$n) 
                                            or:[ (currentCharacter between:$p and:$z) ]
                                    ]
                            ]
                    ]
            ]) 
                ifTrue:[ ^ self scan11 ].
        (currentCharacter == $:) ifTrue:[
            ^ self scan1
        ].
        (currentCharacter == $o) ifTrue:[
            self recordMatch:#( 114 115 ).
            self step.
            ((currentCharacter between:$- and:$.) 
                or:[
                    (currentCharacter between:$0 and:$9) 
                        or:[
                            (currentCharacter between:$A and:$Z) 
                                or:[
                                    currentCharacter == $_ 
                                        or:[
                                            (currentCharacter between:$a and:$k) 
                                                or:[ (currentCharacter between:$m and:$z) ]
                                        ]
                                ]
                        ]
                ]) 
                    ifTrue:[ ^ self scan11 ].
            (currentCharacter == $:) ifTrue:[
                ^ self scan1
            ].
            (currentCharacter == $l) ifTrue:[
                self recordMatch:#( 114 115 ).
                self step.
                ((currentCharacter between:$- and:$.) 
                    or:[
                        (currentCharacter between:$0 and:$9) 
                            or:[
                                (currentCharacter between:$A and:$Z) 
                                    or:[
                                        currentCharacter == $_ 
                                            or:[
                                                (currentCharacter between:$a and:$k) 
                                                    or:[ (currentCharacter between:$m and:$z) ]
                                            ]
                                    ]
                            ]
                    ]) 
                        ifTrue:[ ^ self scan11 ].
                (currentCharacter == $:) ifTrue:[
                    ^ self scan1
                ].
                (currentCharacter == $l) ifTrue:[
                    self recordMatch:#( 114 115 ).
                    self step.
                    (currentCharacter isXMLDigit 
                        or:[
                            (currentCharacter between:$- and:$.) 
                                or:[
                                    (currentCharacter between:$A and:$Z) 
                                        or:[
                                            currentCharacter == $_ 
                                                or:[
                                                    (currentCharacter between:$a and:$n) 
                                                        or:[ (currentCharacter between:$p and:$z) ]
                                                ]
                                        ]
                                ]
                        ]) 
                            ifTrue:[ ^ self scan11 ].
                    (currentCharacter == $:) ifTrue:[
                        ^ self scan1
                    ].
                    (currentCharacter == $o) ifTrue:[
                        self recordMatch:#( 114 115 ).
                        self step.
                        ((currentCharacter between:$- and:$.) 
                            or:[
                                (currentCharacter between:$0 and:$9) 
                                    or:[
                                        (currentCharacter between:$A and:$Z) 
                                            or:[
                                                currentCharacter == $_ 
                                                    or:[
                                                        (currentCharacter between:$a and:$v) 
                                                            or:[ (currentCharacter between:$x and:$z) ]
                                                    ]
                                            ]
                                    ]
                            ]) 
                                ifTrue:[ ^ self scan11 ].
                        (currentCharacter == $:) ifTrue:[
                            ^ self scan1
                        ].
                        (currentCharacter == $w) ifTrue:[
                            self recordMatch:#( 114 115 ).
                            self step.
                            (currentCharacter isXMLDigit 
                                or:[
                                    (currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$A and:$Z) 
                                                or:[
                                                    currentCharacter == $_ 
                                                        or:[
                                                            (currentCharacter between:$a and:$h) 
                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                        ]
                                                ]
                                        ]
                                ]) 
                                    ifTrue:[ ^ self scan11 ].
                            (currentCharacter == $:) ifTrue:[
                                ^ self scan1
                            ].
                            (currentCharacter == $i) ifTrue:[
                                self recordMatch:#( 114 115 ).
                                self step.
                                ((currentCharacter between:$- and:$.) 
                                    or:[
                                        (currentCharacter between:$0 and:$9) 
                                            or:[
                                                (currentCharacter between:$A and:$Z) 
                                                    or:[
                                                        currentCharacter == $_ 
                                                            or:[
                                                                (currentCharacter between:$a and:$m) 
                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                            ]
                                                    ]
                                            ]
                                    ]) 
                                        ifTrue:[ ^ self scan11 ].
                                (currentCharacter == $:) ifTrue:[
                                    ^ self scan1
                                ].
                                (currentCharacter == $n) ifTrue:[
                                    self recordMatch:#( 114 115 ).
                                    self step.
                                    ((currentCharacter between:$- and:$.) 
                                        or:[
                                            (currentCharacter between:$0 and:$9) 
                                                or:[
                                                    (currentCharacter between:$A and:$Z) 
                                                        or:[
                                                            currentCharacter == $_ 
                                                                or:[
                                                                    (currentCharacter between:$a and:$f) 
                                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                                ]
                                                        ]
                                                ]
                                        ]) 
                                            ifTrue:[ ^ self scan11 ].
                                    (currentCharacter == $:) ifTrue:[
                                        ^ self scan1
                                    ].
                                    (currentCharacter == $g) ifTrue:[
                                        self recordMatch:#( 114 115 ).
                                        self step.
                                        (currentCharacter isLetterOrDigit 
                                            or:[ currentCharacter == $. or:[ currentCharacter == $_ ] ]) 
                                                ifTrue:[ ^ self scan11 ].
                                        (currentCharacter == $-) ifTrue:[
                                            self recordMatch:#( 114 115 ).
                                            self step.
                                            ((currentCharacter between:$- and:$.) 
                                                or:[
                                                    (currentCharacter between:$0 and:$9) 
                                                        or:[
                                                            (currentCharacter between:$A and:$Z) 
                                                                or:[
                                                                    currentCharacter == $_ 
                                                                        or:[
                                                                            (currentCharacter between:$a and:$r) 
                                                                                or:[ (currentCharacter between:$t and:$z) ]
                                                                        ]
                                                                ]
                                                        ]
                                                ]) 
                                                    ifTrue:[ ^ self scan11 ].
                                            (currentCharacter == $:) ifTrue:[
                                                ^ self scan1
                                            ].
                                            (currentCharacter == $s) ifTrue:[
                                                self recordMatch:#( 114 115 ).
                                                self step.
                                                (currentCharacter isXMLDigit 
                                                    or:[
                                                        (currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$A and:$Z) 
                                                                    or:[
                                                                        currentCharacter == $_ 
                                                                            or:[
                                                                                (currentCharacter between:$a and:$h) 
                                                                                    or:[ (currentCharacter between:$j and:$z) ]
                                                                            ]
                                                                    ]
                                                            ]
                                                    ]) 
                                                        ifTrue:[ ^ self scan11 ].
                                                (currentCharacter == $:) ifTrue:[
                                                    ^ self scan1
                                                ].
                                                (currentCharacter == $i) ifTrue:[
                                                    self recordMatch:#( 114 115 ).
                                                    self step.
                                                    ((currentCharacter between:$- and:$.) 
                                                        or:[
                                                            (currentCharacter between:$0 and:$9) 
                                                                or:[
                                                                    (currentCharacter between:$A and:$Z) 
                                                                        or:[
                                                                            currentCharacter == $_ 
                                                                                or:[ currentCharacter == $a or:[ (currentCharacter between:$c and:$z) ] ]
                                                                        ]
                                                                ]
                                                        ]) 
                                                            ifTrue:[ ^ self scan11 ].
                                                    (currentCharacter == $:) ifTrue:[
                                                        ^ self scan1
                                                    ].
                                                    (currentCharacter == $b) ifTrue:[
                                                        self recordMatch:#( 114 115 ).
                                                        self step.
                                                        ((currentCharacter between:$- and:$.) 
                                                            or:[
                                                                (currentCharacter between:$0 and:$9) 
                                                                    or:[
                                                                        (currentCharacter between:$A and:$Z) 
                                                                            or:[
                                                                                currentCharacter == $_ 
                                                                                    or:[
                                                                                        (currentCharacter between:$a and:$k) 
                                                                                            or:[ (currentCharacter between:$m and:$z) ]
                                                                                    ]
                                                                            ]
                                                                    ]
                                                            ]) 
                                                                ifTrue:[ ^ self scan11 ].
                                                        (currentCharacter == $:) ifTrue:[
                                                            ^ self scan1
                                                        ].
                                                        (currentCharacter == $l) ifTrue:[
                                                            self recordMatch:#( 114 115 ).
                                                            self step.
                                                            (currentCharacter isXMLDigit 
                                                                or:[
                                                                    (currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$A and:$Z) 
                                                                                or:[
                                                                                    currentCharacter == $_ 
                                                                                        or:[
                                                                                            (currentCharacter between:$a and:$h) 
                                                                                                or:[ (currentCharacter between:$j and:$z) ]
                                                                                        ]
                                                                                ]
                                                                        ]
                                                                ]) 
                                                                    ifTrue:[ ^ self scan11 ].
                                                            (currentCharacter == $:) ifTrue:[
                                                                ^ self scan1
                                                            ].
                                                            (currentCharacter == $i) ifTrue:[
                                                                self recordMatch:#( 114 115 ).
                                                                self step.
                                                                ((currentCharacter between:$- and:$.) 
                                                                    or:[
                                                                        (currentCharacter between:$0 and:$9) 
                                                                            or:[
                                                                                (currentCharacter between:$A and:$Z) 
                                                                                    or:[
                                                                                        currentCharacter == $_ 
                                                                                            or:[
                                                                                                (currentCharacter between:$a and:$m) 
                                                                                                    or:[ (currentCharacter between:$o and:$z) ]
                                                                                            ]
                                                                                    ]
                                                                            ]
                                                                    ]) 
                                                                        ifTrue:[ ^ self scan11 ].
                                                                (currentCharacter == $:) ifTrue:[
                                                                    ^ self scan1
                                                                ].
                                                                (currentCharacter == $n) ifTrue:[
                                                                    self recordMatch:#( 114 115 ).
                                                                    self step.
                                                                    ((currentCharacter between:$- and:$.) 
                                                                        or:[
                                                                            (currentCharacter between:$0 and:$9) 
                                                                                or:[
                                                                                    (currentCharacter between:$A and:$Z) 
                                                                                        or:[
                                                                                            currentCharacter == $_ 
                                                                                                or:[
                                                                                                    (currentCharacter between:$a and:$f) 
                                                                                                        or:[ (currentCharacter between:$h and:$z) ]
                                                                                                ]
                                                                                        ]
                                                                                ]
                                                                        ]) 
                                                                            ifTrue:[ ^ self scan11 ].
                                                                    (currentCharacter == $:) ifTrue:[
                                                                        ^ self scan1
                                                                    ].
                                                                    (currentCharacter == $g) ifTrue:[
                                                                        self recordMatch:#( 96 114 115 ).
                                                                        self step.
                                                                        (currentCharacter isLetterOrDigit 
                                                                            or:[ (currentCharacter between:$- and:$.) or:[ currentCharacter == $_ ] ]) 
                                                                                ifTrue:[ ^ self scan11 ].
                                                                        (currentCharacter == $:) ifTrue:[
                                                                            ^ self scan1
                                                                        ].
                                                                        ^ self reportLastMatch
                                                                    ].
                                                                    ^ self reportLastMatch
                                                                ].
                                                                ^ self reportLastMatch
                                                            ].
                                                            ^ self reportLastMatch
                                                        ].
                                                        ^ self reportLastMatch
                                                    ].
                                                    ^ self reportLastMatch
                                                ].
                                                ^ self reportLastMatch
                                            ].
                                            ^ self reportLastMatch
                                        ].
                                        (currentCharacter == $:) ifTrue:[
                                            ^ self scan1
                                        ].
                                        ^ self reportLastMatch
                                    ].
                                    ^ self reportLastMatch
                                ].
                                ^ self reportLastMatch
                            ].
                            ^ self reportLastMatch
                        ].
                        ^ self reportLastMatch
                    ].
                    ^ self reportLastMatch
                ].
                ^ self reportLastMatch
            ].
            ^ self reportLastMatch
        ].
        ^ self reportLastMatch
    ].
    (currentCharacter == $p) ifTrue:[
        ^ self scan12
    ].
    (currentCharacter == ${) ifTrue:[
        ^ self recordAndReportMatch:#( 82 ).
    ].
    (currentCharacter == $|) ifTrue:[
        ^ self recordAndReportMatch:#( 28 ).
    ].
    (currentCharacter == $}) ifTrue:[
        ^ self recordAndReportMatch:#( 65 ).
    ].
    ^ self reportLastMatch

    "Modified: / 01-12-2008 / 10:19:47 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryScanner methodsFor:'generated-tokens'!

emptySymbolTokenId
	^237

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

errorTokenId
	^238

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryScanner class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryScanner.st,v 1.11 2008-01-02 14:07:19 wrobll1 Exp $'
! !
