"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Perseus::Parser subclass:#XQueryParser
	instanceVariableNames:''
	classVariableNames:'Verbose'
	poolDictionaries:''
	category:'XQuery-Core'
!


!XQueryParser class methodsFor:'instance creation'!

new
    Verbose := true.
    ^ self basicNew initialize.

    "Created: / 08-03-2009 / 21:22:46 / Jan Kurs <kursj1@fel.cvut.cz>"
! !

!XQueryParser class methodsFor:'accessing'!

isVerbose

    ^Verbose == true

    "Created: / 12-04-2007 / 11:15:13 / janfrog"
!

parseQuery: aString
        ^self parse: aString startingAt: self startingStateForQueryBody

    "Created: / 17-03-2006 / 15:00:57 / ked"
    "Modified: / 02-06-2006 / 12:26:34 / ked"
!

verbose: aBoolean

    "
        self verbose: true  

        self verbose: false
    "

    Verbose := aBoolean

    "Created: / 12-04-2007 / 11:15:13 / janfrog"
    "Modified: / 17-11-2007 / 14:37:07 / janfrog"
! !

!XQueryParser class methodsFor:'generated-accessing'!

scannerClass
	^XQuery::XQueryScanner
! !

!XQueryParser class methodsFor:'generated-comments'!

parserDefinitionComment

	"%start MainModule;

MainModule :
    Prolog QueryBody
	{ AstMainModule new
	    prolog: '1' ;
	    queryBody: '2' }
    ;

Prolog:
    PrologDeclarationClassA* PrologDeclarationClassB*
	{ AstProlog new
		declarations: ('1' addAll: '2'; yourself) }
    ;

PrologDeclarationClassA:
      ""import"" ""module"" URILiteral "";""
          { AstModuleImport new
	      uri: '3' }	      	      
    | ""import"" ""module"" ""namespace"" NCName ""="" URILiteral "";""
          { AstModuleImport new
	      prefix: '4';
	      uri: '6' }
    ;


PrologDeclarationClassB:
      DefaultNamespaceDecl
	{ '1' }
    | NamespaceDecl
	{ '1' }
    | VarDecl
    { '1' }
    | FunctionDecl
	{ '1' }
    ;

DefaultNamespaceDecl:
      ""declare"" ""default"" ""element"" ""namespace"" URILiteral "";""
	{ AstDefaultNamespaceDecl new
	    uri: '5';
	    type: #element }
    | ""declare"" ""default"" ""function"" ""namespace"" URILiteral "";""
	{ AstDefaultNamespaceDecl new
	    uri: '5';
	    type: #function }
    ;

NamespaceDecl:
    ""declare"" ""namespace"" NCName ""="" URILiteral "";""
	{ AstNamespaceDecl new
	    prefix: '3' ;
	    nsuri: '5'  }
    ;



URILiteral:
    StringLiteral
	{ '1' }
    ;

VarDecl:
    ""declare"" ""variable"" ""$"" QName ""external"" "";"" {
        self informAboutRuleReduction:'VarDecl1'.
        AstVarDecl new
            name: '4';
            expressionIsExternal
    } | 
    ""declare"" ""variable"" ""$"" QName TypeDeclaration ""external"" "";""  {
        self informAboutRuleReduction:'VarDecl2'.
        AstVarDecl new
            name: '4';
            type: '5';
            expressionIsExternal
    } | 
    ""declare"" ""variable"" ""$"" QName "":="" ExprSingle "";"" {
        self informAboutRuleReduction:'VarDecl3'.
        AstVarDecl new
            name: '4';
            expression: '6' 
    } |
    ""declare"" ""variable"" ""$"" QName TypeDeclaration "":="" ExprSingle "";"" {
        self informAboutRuleReduction:'VarDecl4'.
        AstVarDecl new
            name: '4';
            type: '5';
            expression: '7' 
    } ;

FunctionDecl:
    ""declare"" ""updating""? ""function"" QName ""("" ParamList "")"" EnclosedExpr "";""
	{ AstFunctionDecl new
	    name: '4';
	    paramList: '6';
	    body: '8'
	} ;

ParamList:
    OneOrMoreParamList
	{ '1' }
    | EmptyParamList
	{ '2' }
    ;

EmptyParamList:
	{ #() }
    ;

OneOrMoreParamList:
    ParamList "","" Param
	{ '1' add: '3' ; yourself }
    | Param
	{ OrderedCollection with:'1' }
    ;

Param:
    ""$"" QName
	{ AstParam new
	    name: '2'  }
    ;






QueryBody :
  Expr {
    self informAboutRuleReduction:'QueryBody1'.
    '1'.
  };

Expr :
  ExprSingle {
    self informAboutRuleReduction:'Expr1'.
    '1'.
  } |
  ExprSingle "","" Expr {
    self informAboutRuleReduction:'Expr2'.
    AstExpr new exprSingle: '1'; expr: '3'.
  } ;

ExprSingle :
  FLWORExpr {
    self informAboutRuleReduction:'ExprSingle1'.
    '1'.
  } |
  QuantifiedExpr {
    self informAboutRuleReduction:'ExprSingle2'.
    '1'.
  } |
  IfExpr {
    self informAboutRuleReduction:'ExprSingle3'.
    '1'.
  } |
  OrExpr {
    self informAboutRuleReduction:'ExprSingle4'.
    '1'.
  } |
  DeleteExpr {
    self informAboutRuleReduction:'ExprSingle5'.
    '1'.
  } |
  RenameExpr {
    self informAboutRuleReduction:'ExprSingle6'.
    '1'.
  } |
  ReplaceExpr {
    self informAboutRuleReduction:'ExprSingle7'.
    '1'.
  } |
  InsertExpr {
    self informAboutRuleReduction:'ExprSingle8'.
    '1'.
  } |  
  TransformExpr {
    self informAboutRuleReduction:'ExprSingle9'.
    '1'. 
  } ;

FLWORExpr :
  FLWORExpr_ForLet ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr1'.
    AstFLWORExpr new flworExpr_ForLet: '1'; exprSingle: '3'.
  } |
  FLWORExpr_ForLet WhereClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr2'.
    AstFLWORExpr new flworExpr_ForLet: '1'; whereClause: '2'; exprSingle: '4'.
  } |
  FLWORExpr_ForLet OrderByClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr3'.
    AstFLWORExpr new flworExpr_ForLet: '1'; orderByClause: '2'; exprSingle: '4'.
  } |
  FLWORExpr_ForLet WhereClause OrderByClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr4'.
    AstFLWORExpr new flworExpr_ForLet: '1'; whereClause: '2'; orderByClause: '3'; exprSingle: '5'.
  } ;

FLWORExpr_ForLet :
  ForClause {
    self informAboutRuleReduction:'FLWORExpr_ForLet1'.
    '1'.
  } |
  LetClause {
    self informAboutRuleReduction:'FLWORExpr_ForLet2'.
    '1'.
  } |
  ForClause FLWORExpr_ForLet {
    self informAboutRuleReduction:'FLWORExpr_ForLet3'.
    AstFLWORExpr_ForLet new forClause: '1'; flworExpr_ForLet: '2'.
  } |
  LetClause FLWORExpr_ForLet {
    self informAboutRuleReduction:'FLWORExpr_ForLet4'.
    AstFLWORExpr_ForLet new letClause: '1'; flworExpr_ForLet: '2'.
  } ;

ForClause :
  ""for"" ForClause_Impl {
    self informAboutRuleReduction:'ForClause1'.
    '2'.
  } ;

ForClause_Impl :
  ""$"" VarName ""in"" ExprSingle {
    self informAboutRuleReduction:'ForClause_Impl1'.
    AstForClause new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName ""in"" ExprSingle "","" ForClause_Impl {
    self informAboutRuleReduction:'ForClause_Impl2'.
    AstForClause new varName: '2'; exprSingle: '4'; forClause: '6'.
  } |
  ""$"" VarName PositionalVar ""in"" ExprSingle {
    self informAboutRuleReduction:'ForClause_Impl3'.
    AstForClause new varName: '2'; positionalVar: '3'; exprSingle: '5'.
  } |
  ""$"" VarName PositionalVar ""in"" ExprSingle "","" ForClause_Impl {
    self informAboutRuleReduction:'ForClause_Impl4'.
    AstForClause new varName: '2'; positionalVar: '3'; exprSingle: '5'; forClause: '7'.
  } ;

PositionalVar:
  ""at"" ""$"" VarName {
    self informAboutRuleReduction:'PositionalVar1'.
    '3'.
  } ;

LetClause :
  ""let"" LetClause_Impl {
    self informAboutRuleReduction:'LetClause1'.
    '2'.
  } ;

LetClause_Impl :
  ""$"" VarName "":="" ExprSingle {
    self informAboutRuleReduction:'LetClause_Impl1'.
    AstLetClause new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName "":="" ExprSingle "","" LetClause_Impl {
    self informAboutRuleReduction:'LetClause_Impl2'.
    AstLetClause new varName: '2'; exprSingle: '4'; letClause: '6'.
  } ;

WhereClause :
  ""where"" ExprSingle {
    self informAboutRuleReduction:'WhereClause1'.
    AstWhereClause new exprSingle: '2'.
  } ;

OrderByClause :
  ""order"" ""by"" OrderSpecList {
    self informAboutRuleReduction:'OrderByClause1'.
    AstOrderByClause new isStable: false; orderSpecList: '3'.
  } |
  ""stable"" ""order"" ""by"" OrderSpecList {
    self informAboutRuleReduction:'OrderByClause2'.
    AstOrderByClause new isStable: true; orderSpecList: '4'.
  } ;

OrderSpecList :
  OrderSpec {
    self informAboutRuleReduction:'OrderSpecList1'.
   '1'.
  } |
  OrderSpec "","" OrderSpecList {
    self informAboutRuleReduction:'OrderSpecList2'.
    AstOrderSpecList new orderSpec: '1'; orderSpecList: '3'.
  } ;

OrderSpec :
  ExprSingle {
    self informAboutRuleReduction:'OrderSpec1'.
    AstOrderSpec new exprSingle: '1'.
  } |
  ExprSingle OrderModifier {
    self informAboutRuleReduction:'OrderSpec2'.
    AstOrderSpec new exprSingle: '1'; orderModifier: '2'.
  } ;

OrderModifier :
  OrderModifier_AscDesc {
    self informAboutRuleReduction:'OrderModifier1'.
    AstOrderModifier new ascDesc: '1'.
  } |
  OrderModifier_GreatestLeast {
    self informAboutRuleReduction:'OrderModifier2'.
    AstOrderModifier new greatestLeast: '1'.
  } |
  OrderModifier_AscDesc OrderModifier_GreatestLeast {
    self informAboutRuleReduction:'OrderModifier3'.
    AstOrderModifier new ascDesc: '1'; greatestLeast: '2'.
  } ;

OrderModifier_AscDesc:
  ""ascending"" {
    self informAboutRuleReduction:'OrderModifier_AscDesc1'.
    ^#asc.
  } |
  ""descending"" {
    self informAboutRuleReduction:'OrderModifier_AscDesc2'.
    ^#desc.
  } ;

OrderModifier_GreatestLeast:
  ""empty"" ""greatest"" {
    self informAboutRuleReduction:'OrderModifier_GreatestLeast1'.
    ^#greatest.
  } |
  ""empty"" ""least"" {
    self informAboutRuleReduction:'OrderModifier_GreatestLeast2'.
    ^#least.
  } ;

QuantifiedExpr :
  ""some"" QuantifiedExpr_Impl ""satisfies"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr1'.
    AstQuantifiedExpr new someEvery: #some; quantifiedExpr_Impl: '2'; exprSingle: '4'.
  } |
  ""every"" QuantifiedExpr_Impl ""satisfies"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr2'.
    AstQuantifiedExpr new someEvery: #every; quantifiedExpr_Impl: '2'; exprSingle: '4'.
  } ;

QuantifiedExpr_Impl :
  ""$"" VarName ""in"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr_Impl1'.
    AstQuantifiedExpr_Impl new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName ""in"" ExprSingle "","" QuantifiedExpr_Impl {
    self informAboutRuleReduction:'QuantifiedExpr_Impl2'.
    AstQuantifiedExpr_Impl new varName: '2'; exprSingle: '4'; quantifiedExpr_Impl: '6'.
  } ;

IfExpr :
  ""if"" ""("" Expr "")"" ""then"" ExprSingle ""else"" ExprSingle {
    self informAboutRuleReduction:'IfExpr1'.
    AstIfExpr new expr: '3'; trueExprSingle: '6'; falseExprSingle: '8'.
  } ;

OrExpr :
  AndExpr {
    self informAboutRuleReduction:'OrExpr1'.
    '1'.
  } |
  AndExpr ""or"" OrExpr {
    self informAboutRuleReduction:'OrExpr2'.
    AstOrExpr new andExpr: '1'; orExpr: '3'.
  } ;

AndExpr :
  ComparisonExpr {
    self informAboutRuleReduction:'AndExpr1'.
    '1'.
  } |
  ComparisonExpr ""and"" AndExpr {
    self informAboutRuleReduction:'AndExpr2'.
    AstAndExpr new comparisonExpr: '1'; andExpr: '3'.
  } ;

ComparisonExpr :
  RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr1'.
    '1'.
  } |
  RangeExpr ValueComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr2'.
    AstComparisonExpr new rangeExprLeft: '1'; valueComp: '2'; rangeExprRight: '3'.
  } |
  RangeExpr GeneralComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr3'.
    AstComparisonExpr new rangeExprLeft: '1'; generalComp: '2'; rangeExprRight: '3'.
  } |
  RangeExpr NodeComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr4'.
    AstComparisonExpr new rangeExprLeft: '1'; nodeComp: '2'; rangeExprRight: '3'.
  } ;

RangeExpr :
  AdditiveExpr {
    self informAboutRuleReduction:'RangeExpr1'.
    '1'.
  } |
  AdditiveExpr ""to"" AdditiveExpr {
    self informAboutRuleReduction:'RangeExpr2'.
    AstRangeExpr new additiveExprFrom: '1'; additiveExprTo: '3'.
  } ;

AdditiveExpr :
  MultiplicativeExpr {
    self informAboutRuleReduction:'AdditiveExpr1'.
    '1'.
  } |
  MultiplicativeExpr ""+"" AdditiveExpr {
    self informAboutRuleReduction:'AdditiveExpr2'.
    AstAdditiveExpr new multiplicativeExpr: '1'; operand: #plus; additiveExpr: '3'.
  } |
  MultiplicativeExpr ""-"" AdditiveExpr {
    self informAboutRuleReduction:'AdditiveExpr3'.
    AstAdditiveExpr new multiplicativeExpr: '1'; operand: #minus; additiveExpr: '3'.
  } ;

MultiplicativeExpr :
  UnionExpr {
    self informAboutRuleReduction:'MultiplicativeExpr1'.
    '1'.
  } |
  UnionExpr ""*"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr2'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #krat; multiplicativeExpr: '3'.
  } |
  UnionExpr ""div"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr3'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #div; multiplicativeExpr: '3'.
  } |
  UnionExpr ""idiv"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr4'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #idiv; multiplicativeExpr: '3'.
  } |
  UnionExpr ""mod"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr5'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #mod; multiplicativeExpr: '3'.
  } ;

UnionExpr :
  IntersectExceptExpr {
    self informAboutRuleReduction:'UnionExpr1'.
    '1'.
  } |
  IntersectExceptExpr ""union"" UnionExpr {
    self informAboutRuleReduction:'UnionExpr2'.
    AstUnionExpr new intersectExceptExpr: '1'; unionExpr: '3'.
  } |
  IntersectExceptExpr ""|"" UnionExpr {
    self informAboutRuleReduction:'UnionExpr3'.
    AstUnionExpr new intersectExceptExpr: '1'; unionExpr: '3'.
  } ;

IntersectExceptExpr :
  InstanceOfExpr {
    self informAboutRuleReduction:'IntersectExceptExpr1'.
    '1'.
  } |
  InstanceOfExpr ""intersect"" IntersectExceptExpr {
    self informAboutRuleReduction:'IntersectExceptExpr2'.
    AstIntersectExceptExpr new unaryExpr: '1'; operand: #intersect; intersectExceptExpr: '3'.
  } |
  InstanceOfExpr ""except"" IntersectExceptExpr {
    self informAboutRuleReduction:'IntersectExceptExpr3'.
    AstIntersectExceptExpr new unaryExpr: '1'; operand: #except; intersectExceptExpr: '3'.
  } ;

InstanceOfExpr : 
  UnaryExpr {
    self informAboutRuleReduction:'InstanceOfExpr1'.
    '1'.
  } |
  UnaryExpr ""instance"" ""of"" SequenceType {
    self informAboutRuleReduction:'InstanceOfExpr2'.
    AstInstanceOfExpr new unaryExpr: '1'; sequenceType: '4'
  } ;

TypeDeclaration :
  ""as"" SequenceType {
    self informAboutRuleReduction:'TypeDeclaration1'.
    '2'  
  } ;

SequenceType :
  ""empty-sequence"" ""("" "")"" {
    self informAboutRuleReduction:'SequenceType1'.
    #emptyseq.
  } |
  ItemType {
    self informAboutRuleReduction:'SequenceType2'.
    '1'.
  } ;

ItemType : 
  ""item"" ""("" "")"" {
    self informAboutRuleReduction:'ItemType1'.
    #item.
  } |
  KindTest {
    self informAboutRuleReduction:'ItemType2'.
    '1'.
  } |
  AtomicType {
    self informAboutRuleReduction:'ItemType3'.
    '1'.
  } ;

AtomicType : 
  QName {
    self informAboutRuleReduction:'AtomicType1'.
    '1'.
  } ;

OccurenceIndicator :
  ""?"" {
    self informAboutRuleReduction:'OccurenceIndicator1'.
  } |
  ""*"" {
    self informAboutRuleReduction:'OccurenceIndicator2'.
  } |
  ""+"" {
    self informAboutRuleReduction:'OccurenceIndicator3'.
  } ;

UnaryExpr :
  ""-"" UnaryExpr {
    self informAboutRuleReduction:'UnaryExpr1'.
    AstUnaryExpr new operand: #minus; unaryExpr: '2'.
  } |
  ""+"" UnaryExpr {
    self informAboutRuleReduction:'UnaryExpr2'.
    AstUnaryExpr new operand: #plus; unaryExpr: '2'.
  } |
  ValueExpr {
   self informAboutRuleReduction:'UnaryExpr3'.
   '1'.
  } ;


ValueExpr :
  PathExpr {
    self informAboutRuleReduction:'ValueExpr'.
    '1'.
  } ;

GeneralComp :
  ""="" {
    self informAboutRuleReduction:'GeneralComp1'.
    ^#eqGeneral.
  } |
  ""!!="" {
    self informAboutRuleReduction:'GeneralComp2'.
    ^#neGeneral.
  } |
  ""<"" {
    self informAboutRuleReduction:'GeneralComp3'.
    ^#ltGeneral.
  } |
  ""<="" {
    self informAboutRuleReduction:'GeneralComp4'.
    ^#leGeneral.
  } |
  "">"" {
    self informAboutRuleReduction:'GeneralComp5'.
    ^#gtGeneral.
  } |
  "">="" {
    self informAboutRuleReduction:'GeneralComp6'.
    ^#geGeneral.
  } ;

ValueComp :
  ""eq"" {
    self informAboutRuleReduction:'ValueComp1'.
    ^#eqValue.
  } |
  ""ne"" {
    self informAboutRuleReduction:'ValueComp2'.
    ^#neValue.
  } |
  ""lt"" {
    self informAboutRuleReduction:'ValueComp3'.
    ^#ltValue.
  } |
  ""le"" {
    self informAboutRuleReduction:'ValueComp4'.
    ^#leValue.
  } |
  ""gt"" {
    self informAboutRuleReduction:'ValueComp5'.
    ^#gtValue.
  } |
  ""ge""{
    self informAboutRuleReduction:'ValueComp6'.
    ^#geValue.
  } ;

NodeComp :
  ""is"" {
    self informAboutRuleReduction:'NodeComp1'.
    ^#is.
  } |
  ""<<"" {
    self informAboutRuleReduction:'NodeComp2'.
    ^#isLess.
  } |
  "">>"" {
    self informAboutRuleReduction:'NodeComp3'.
    ^#isMore.
  } ;

PathExpr :
	  ""/"" RelativePathExpr 
	  	{
		    self informAboutRuleReduction:'PathExpr2'.
		    '2' absolute: true; yourself 
 		 } 
	| ""//"" RelativePathExpr 
		{
		    self informAboutRuleReduction:'PathExpr3'.
			'2'
				addFirst:
			    	(XMLv2::XPathLocationStep new
			        	axis: XMLv2::XPathAxisDescendantOrSelf new;
						nodeTest: XMLv2::XPathAnyKindTest new);
				yourself		    
		}	
	| RelativePathExpr 
		{
		    self informAboutRuleReduction:'PathExpr4'.
		    '1'.
		}
	;

RelativePathExpr :
	  StepExpr 
	  	{
		    self informAboutRuleReduction:'RelativePathExpr1'.
    		XMLv2::XPathExpression with: '1'.
		}    	
	| RelativePathExpr ""/"" StepExpr  
		{
		    self informAboutRuleReduction:'RelativePathExpr2'.
		    '1' add: '3'; yourself
		}		  
	| RelativePathExpr ""//"" StepExpr 
		{
		    self informAboutRuleReduction:'RelativePathExpr3'.
		    '1'
		    	add:
		    		(XMLv2::XPathLocationStep new
		    			axis: XMLv2::XPathAxisDescendantOrSelf new;
		    			nodeTest: XMLv2::XPathAnyKindTest new);
				add: '3';
				yourself
		}
	;

StepExpr :
	  AxisStep 
	  	{
		    self informAboutRuleReduction:'StepExpr1'.
		    '1'.
		}		   
	| FilterExpr 
		{
		    self informAboutRuleReduction:'StepExpr2'.
		    '1'.
		}		   
	;

AxisStep :
  ForwardStep Predicate* {
    self informAboutRuleReduction:'AxisStep2'.
    '1' predicates: '2'; yourself
  } |
  ReverseStep Predicate* {
    self informAboutRuleReduction:'AxisStep4'.
    '1' predicates: '2'; yourself
  } ;

ForwardStep :
	  ForwardAxis NodeTest
		{
    		self informAboutRuleReduction:'ForwardStep1'.
			XMLv2::XPathLocationStep new
				axis: '1';
				nodeTest: '2';
				yourself
		} 
	| AbbrevForwardStep 
		{
			self informAboutRuleReduction:'ForwardStep2'.
			'1'
  		} 
  	;

ForwardAxis :
	  ""child"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ForwardAxis1'.
		    XMLv2::XPathAxisChild new
		}	    
	|  ""descendant"" ""::"" 
		{
		    self informAboutRuleReduction:'ForwardAxis2'.
			XMLv2::XPathAxisDescendant new
		}
	| ""attribute"" ""::""
	  	{
  			self informAboutRuleReduction:'ForwardAxis3'.
		    XMLv2::XPathAxisAttribute new
		}	    	
	| ""self"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ForwardAxis4'.
		    XMLv2::XPathAxisSelf new
		}	    	
	| ""descendant-or-self"" ""::""	
	  	{
  			self informAboutRuleReduction:'ForwardAxis5'.
		    XMLv2::XPathAxisSedcendantOrSelf new
		}	    	
	| ""following-sibling"" ""::"" 
		{
  			self informAboutRuleReduction:'ForwardAxis6'.
		    XMLv2::XPathAxisFollowingSibling new
		}	    	
	| ""following"" ""::"" 
		{
  			self informAboutRuleReduction:'ForwardAxis7'.
		    XMLv2::XPathAxisFollowing new
		}	    	
	;

AbbrevForwardStep :
	  ""@"" NodeTest 
	  	{
			self informAboutRuleReduction:'AbbrevForwardStep1'.
			XMLv2::XPathLocationStep new
				axis: XMLv2::XPathAxisAttribute new;
				nodeTest: '2';
				yourself
		}			
	| NodeTest
	  	{
			self informAboutRuleReduction:'AbbrevForwardStep2'.
			XMLv2::XPathLocationStep new
				setDefaultAxisFor: '1';
				nodeTest: '1';
				yourself
		}			
	;
	
ReverseStep :
	  ReverseAxis NodeTest
		{
    		self informAboutRuleReduction:'ReverseStep1'.
			XMLv2::XPathLocationStep new
				axis: '1';
				nodeTest: '2';
				yourself
		} 
	| AbbrevReverseStep 
		{
			self informAboutRuleReduction:'ReverseStep2'.
			'1'
  		} 
  	;

ReverseAxis :
	  ""parent"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis1'.
		    XMLv2::XPathAxisParent new
		}	    
	| ""ancestor"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis2'.
		    XMLv2::XPathAxisAncestor new
		}
	| ""ancestor-or-self"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis3'.
		    XMLv2::XPathAxisAncestorOrSelf new
		}
	| ""preceding-sibling"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis4'.
		    XMLv2::XPathAxisPrecedingSibling new
		}
	| ""preceding"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis5'.
		    XMLv2::XPathAxisPreceding new
		}
	;
		
AbbrevReverseStep :
	"".."" 
		{
			XMLv2::XPathLocationStep new
				axis: XMLv2::XPathAxisParent new;
				nodeTest: XMLv2::XPathAnyKindTest new;
				yourself
		}
	;

NodeTest :
	  NameTest
		{
	  	 	self informAboutRuleReduction:'NodeTest1'.
		    '1'.
		}
	| KindTest 
		{
		    self informAboutRuleReduction:'NodeTest2'.
		    '1'.
		} 
	;

NameTest :
	QName 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new qName: '1' content
		}			
	| ""*"" 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new prefix:'*'; localName:'*'
		}			
	| ""*"" "":"" NCName 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new prefix:'*'; localName:'3' content
		}			
	;

FilterExpr :
	PrimaryExpr Predicate* 
		{
		    self informAboutRuleReduction:'FilterExpr2'.
		    AstFilterExpr new primaryExpr: '1'; predicateList: '2'.
		}
	;


Predicate :
  ""["" Expr ""]"" {
    self informAboutRuleReduction:'Predicate1'.
    XMLv2::XPathPredicate new expr: '2'.
  } |
  ""["" ""]"" {
    self informAboutRuleReduction:'Predicate2'.
    XMLv2::XPathPredicate new
  } ;

PrimaryExpr :
  Literal {
    self informAboutRuleReduction:'PrimaryExpr1'.
    '1'.
  } |
  VarRef {
    self informAboutRuleReduction:'PrimaryExpr2'.
    '1'.
  } |
  ParenthesizedExpr {
    self informAboutRuleReduction:'PrimaryExpr3'.
    '1'.
  } |
  ContextItemExpr {
    self informAboutRuleReduction:'PrimaryExpr4'.
    '1'.
  } |
  FunctionCall {
    self informAboutRuleReduction:'PrimaryExpr5'.
    '1'.
  } |
  Constructor {
    self informAboutRuleReduction:'PrimaryExpr6'.
    '1'.
  } |
  OrderedExpr {
    self informAboutRuleReduction:'PrimaryExpr7'.
    '1'.
  } |
  UnorderedExpr {
    self informAboutRuleReduction:'PrimaryExpr8'.
    '1'.
  } ;

Literal :
  NumericLiteral {
    self informAboutRuleReduction:'Literal1'.
    '1'.
  } |
  StringLiteral {
    self informAboutRuleReduction:'Literal2'.
    '1'.
  } ;

NumericLiteral :
  IntegerLiteral {
    self informAboutRuleReduction:'NumericLiteral1'.
    '1'.
  } |
  DecimalLiteral {
    self informAboutRuleReduction:'NumericLiteral2'.
    '1'.
  } |
  DoubleLiteral {
    self informAboutRuleReduction:'NumericLiteral3'.
    '1'.
  } ;

VarRef :
  ""$"" VarName {
    self informAboutRuleReduction:'VarRef1'.
    AstVarRef new varName: '2'.
  } ;

VarName :
  QName {
    self informAboutRuleReduction:'VarName1'.
    '1'.
  };

ParenthesizedExpr :
  ""("" "")"" {
    self informAboutRuleReduction:'ParenthesizedExpr1'.
    AstParenthesizedExpr new.
  } |
  ""("" Expr "")"" {
    self informAboutRuleReduction:'ParenthesizedExpr2'.
    AstParenthesizedExpr new expr: '2'.
  } ;

ContextItemExpr :
  ""."" {
    self informAboutRuleReduction:'ContextItemExpr1'.
    AstContextItemExpr new.
  } ;

OrderedExpr :
  ""ordered"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'OrderedExpr1'.
    '3'.
  } ;

UnorderedExpr :
  ""unordered"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'UnorderedExpr1'.
    '3'.
  } ;

FunctionCall :
  QName ""("" "")"" {
    self informAboutRuleReduction:'FunctionCall1'.
    AstFunctionCall new qname: '1'.
  } |
  QName ""("" FunctionParametersList "")"" {
    self informAboutRuleReduction:'FunctionCall2'.
    AstFunctionCall new qname: '1'; functionParametersList: '3'.
  } ;

FunctionParametersList:
    ExprSingle {
	self informAboutRuleReduction:'FunctionParametersList1'.
	AstFunctionParametersList new exprSingle: '1'.
    } |
    ExprSingle "","" FunctionParametersList {
	self informAboutRuleReduction:'FunctionParametersList2'.
	AstFunctionParametersList new exprSingle: '1'; functionParametersList: '3'.
    } ;

Constructor :
  DirectConstructor {
    self informAboutRuleReduction:'Constructor1'.
    '1'.
  } |
  ComputedConstructor {
    self informAboutRuleReduction:'Constructor2'.
    '1'.
  } ;

DirectConstructor :
  DirElemConstructor {
    self informAboutRuleReduction:'DirectConstructor1'.
    '1'.
  } ;

DirElemConstructor :
  ""<"" QName ""/>"" {
    self informAboutRuleReduction:'DirElemConstructor1'.
    AstDirElemConstructor new qname: '2'.
  } |
  ""<"" QName DirAttributeList ""/>"" {
    self informAboutRuleReduction:'DirElemConstructor2'.
    AstDirElemConstructor new qname: '2'; dirAttributeList: '3'.
  } |
  ""<"" QName "">"" DirElemContent ""</"" QName "">"" {
    self informAboutRuleReduction:'DirElemConstructor3'.
    AstDirElemConstructor new qname: '2'; dirElemContent: '4'.
  } |
  ""<"" QName DirAttributeList "">"" DirElemContent ""</"" QName "">"" {
    self informAboutRuleReduction:'DirElemConstructor4'.
    AstDirElemConstructor new qname: '2'; dirAttributeList: '3'; dirElemContent: '5'.
  } ;

DirAttributeList :
  QName ""="" DirAttributeValue {
    self informAboutRuleReduction:'DirAttributeList1'.
    AstDirAttributeList new qname: '1'; dirAttributeValue: '3'.
  } |
  QName ""="" DirAttributeValue DirAttributeList {
    self informAboutRuleReduction:'DirAttributeList2'.
    AstDirAttributeList new qname: '1'; dirAttributeValue: '3'; dirAttributeList: '4'.
  } ;

DirAttributeValue :
  StringLiteral {
    self informAboutRuleReduction:'DirAttributeValue1'.
    '1'.
  } |
  EnclosedExpr {
    self informAboutRuleReduction:'DirAttributeValue2'.
    '1'.
  } ;

DirElemContent :
  DirectConstructor {
    self informAboutRuleReduction:'DirElemContent1'.
    AstDirElemContent new content: '1'.
  } |
  DirectConstructor DirElemContent {
    self informAboutRuleReduction:'DirElemContent2'.
    AstDirElemContent new content: '1'; dirElemContent: '2'.
  } |
  CommonContent {
    self informAboutRuleReduction:'DirElemContent3'.
    AstDirElemContent new content: '1'.
  } |
  CommonContent DirElemContent {
    self informAboutRuleReduction:'DirElemContent4'.
    AstDirElemContent new content: '1'; dirElemContent: '2'.
  } ;

CommonContent :
  PredefinedEntityRef {
    self informAboutRuleReduction:'CommonContent1'.
    '1'.
  } |
  EnclosedExpr {
    self informAboutRuleReduction:'CommonContent2'.
    '1'.
  } |
  Literal {
    self informAboutRuleReduction:'CommonContent3'.
    '1'.
  } |
  NCName {
    self informAboutRuleReduction:'CommonContent7'.
    '1'.
  } |
  QName {
    self informAboutRuleReduction:'CommonContent8'.
    '1'.
  } ;

ComputedConstructor :
  CompDocConstructor {
    self informAboutRuleReduction:'ComputedConstructor1'.
    '1'.
  } |
  CompElemConstructor {
    self informAboutRuleReduction:'ComputedConstructor2'.
    '1'.
  } |
  CompAttrConstructor {
    self informAboutRuleReduction:'ComputedConstructor3'.
    '1'.
  } |
  CompTextConstructor {
    self informAboutRuleReduction:'ComputedConstructor4'.
    '1'.
  } ;

CompDocConstructor :
  ""document"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompDocConstructor1'.
    AstCompDocConstructor new expr: '3'.
  } ;

CompElemConstructor :
  ""element"" QName ""{"" ""}"" {
    self informAboutRuleReduction:'CompElemConstructor1'.
    AstCompElemConstructor new qname: '2'.
  } |
  ""element"" QName ""{"" ContentExpr ""}"" {
    self informAboutRuleReduction:'CompElemConstructor2'.
    AstCompElemConstructor new qname: '2'; contentExpr: '4'.
  } |
  ""element"" ""{"" Expr ""}"" ""{"" ""}"" {
    self informAboutRuleReduction:'CompElemConstructor3'.
    AstCompElemConstructor new expr: '3'.
  } |
  ""element"" ""{"" Expr ""}"" ""{"" ContentExpr ""}"" {
    self informAboutRuleReduction:'CompElemConstructor4'.
    AstCompElemConstructor new expr: '3'; contentExpr: '6'.
  } ;

ContentExpr :
  Expr {
    self informAboutRuleReduction:'ContentExpr'.
    '1'.
  } ;

CompAttrConstructor :
  ""attribute"" QName ""{"" ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor1'.
    AstCompAttrConstructor new qname: '2'.
  } |
  ""attribute"" QName ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor2'.
    AstCompAttrConstructor new qname: '2'; contentExpr: '4'.
  } |
  ""attribute"" ""{"" Expr ""}"" ""{"" ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor3'.
    AstCompAttrConstructor new expr: '3'.
  } |
  ""attribute"" ""{"" Expr ""}"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor4'.
    AstCompAttrConstructor new expr: '3'; contentExpr: '6'.
  } ;

CompTextConstructor :
  ""text"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompTextConstructor1'.
    AstCompTextConstructor new expr: '3'.
  } ;

KindTest :
  DocumentTest {
    self informAboutRuleReduction:'KindTest1'.
    '1'.
  } |
  ElementTest {
    self informAboutRuleReduction:'KindTest2'.
    '1'.
  } |
  AttributeTest {
    self informAboutRuleReduction:'KindTest3'.
    '1'.
  } |
  TextTest {
    self informAboutRuleReduction:'KindTest4'.
    '1'.
  } |
  AnyKindTest {
    self informAboutRuleReduction:'KindTest5'.
    '1'.
  }
  | ""comment"" ""("" "")""
  	{ XMLv2::XPathCommentTest new }  	
  | ""processing-instruction"" ""("" "")""
  	{ XMLv2::XPathProcessingInstructionTest new }
  ;

AnyKindTest :
  ""node"" ""("" "")"" {
    self informAboutRuleReduction:'AnyKindTest1'.
    XMLv2::XPathAnyKindTest new
  } ;

DocumentTest :
  ""document-node"" ""("" "")"" {
    self informAboutRuleReduction:'DocumentTest1'.
    XMLv2::XPathDocumentTest new.
  } |
  ""document-node"" ""("" ElementTest "")"" {
    self informAboutRuleReduction:'DocumentTest2'.
    XMLv2::XPathDocumentTest new elementTest: '3'.
  } ;

TextTest :
  ""text"" ""("" "")"" {
    self informAboutRuleReduction:'TextTest1'.
    XMLv2::XPathTextTest new.
  } ;
  
AttributeTest :
  ""attribute"" ""("" "")"" {
    self informAboutRuleReduction:'AttributeTest1'.
    XMLv2::XPathAttributeTest new
  } |
  ""attribute"" ""("" AttribNameOrWildcard "")"" {
    self informAboutRuleReduction:'AttributeTest2'.
	XMLv2::XPathAttributeTest halt:'Not yet implemented. See grammar'
  } ;

AttribNameOrWildcard :
  AttributeName {
    self informAboutRuleReduction:'AttributeNameOrWildcard1'.
    AstAttribNameOrWildcard new attributeName: '1'.
  } |
  ""*"" {
    self informAboutRuleReduction:'AttributeNameOrWildcard2'.
    AstAttribNameOrWildcard new.
  } ;

ElementTest :
  ""element"" ""("" "")"" {
    self informAboutRuleReduction:'ElementTest1'.
    XMLv2::XPathElementTest new.
  } |
  ""element"" ""("" ElementNameOrWildcard "")"" {
    self informAboutRuleReduction:'ElementTest2'.
    XMLv2::XPathElementTest new elementName: '3'.
  } ;

ElementNameOrWildcard :
  ElementName {
    self informAboutRuleReduction:'ElementNameOrWildcard1'.
    AstElementNameOrWildcard new elementName: '1'.
  } |
  ""*"" {
    self informAboutRuleReduction:'ElementNameOrWildcard2'.
    AstElementNameOrWildcard new.
  } ;

AttributeName :
  QName {
    self informAboutRuleReduction:'AttributeName1'.
    '1'.
  } ;

ElementName :
  QName {
    self informAboutRuleReduction:'ElementName1'.
    '1'.
  } ;

EnclosedExpr :
  ""{"" Expr ""}"" {
    self informAboutRuleReduction:'EnclosedExpr1'.
    AstEnclosedExpr new expr: '2'.
  } ;

PredefinedEntityRef :
  <predefined_entity_ref> {
    self informAboutRuleReduction:'PredefinedEntityRef1 -', ('1' asString).
    AstPredefinedEntityRef new content: ('1' value).
  } ;

QName :
  <qname> {
    self informAboutRuleReduction:'QName1 - ', ('1' asString).
    AstQName new content: ('1' value).
  } ;

NCName :
  <ncname> {
    self informAboutRuleReduction:'NCName1 - ', ('1' asString).
    AstNCName new content: ('1' value).
  } ;

StringLiteral :
  <string_literal> {
    self informAboutRuleReduction:'StringLiteral1 -', ('1' asString).
    AstStringLiteral new content: ('1' value).
  } ;

IntegerLiteral :
  <integer_literal> {
    self informAboutRuleReduction:'IntegerLiteral1 -', ('1' asString).
    AstIntegerLiteral new content: ('1' value asInteger).
  } ;

DecimalLiteral :
  <decimal_literal> {
    self informAboutRuleReduction:'DecimalLiteral1 -', ('1' asString).
    AstDecimalLiteral new content: ('1' value asFloat).
  } ;

DoubleLiteral :
  <double_literal> {
    self informAboutRuleReduction:'DoubleLiteral1 -', ('1' asString).
    AstDoubleLiteral new content: ('1' value asDouble).
  } ;

DeleteExpr :
  ""do"" ""delete"" TargetExpr {
    self informAboutRuleReduction:'DeleteExpr'.
    (AstDeleteExpr new) targetExpr: '3'
  };

RenameExpr:
  ""do"" ""rename"" TargetExpr ""as"" NewNameExpr {
    self informAboutRuleReduction:'RenameExpr'.
    (AstRenameExpr new) targetExpr: '3'; newNameExpr: '5'.
  };

ReplaceExpr :
  ""do"" ""replace"" ReplaceClause {
    self informAboutRuleReduction:'ReplaceExpr'.
    '3'.
  };

ReplaceClause :
  ""value"" ""of"" TargetExpr ""with"" ExprSingle {
    self informAboutRuleReduction:'ReplaceValueOfClause'.
    (AstReplaceValueOfExpr new) targetExpr: '3'; sourceExpr: '5'.
  } |
  TargetExpr ""with"" ExprSingle {
    self informAboutRuleReduction:'ReplaceClause'.
    (AstReplaceExpr new) targetExpr: '1'; sourceExpr: '3'.
  };



InsertExpr :
  ""do"" ""insert"" InsertClause  {
    self informAboutRuleReduction:'InsertExpr'.
    '3'.
  };

InsertClause :
  SourceExpr ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertIntoClause'.
    (AstInsertIntoExpr new) targetExpr: '3'; sourceExpr: '1'.
  } |
  SourceExpr ""as"" ""first"" ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertAsFirstIntoClause'.
    (AstInsertAsFirstIntoExpr new) targetExpr: '5'; sourceExpr: '1'.
  } |
  SourceExpr ""as"" ""last"" ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertAsLastIntoClause'.
    (AstInsertAsLastIntoExpr new) targetExpr: '5'; sourceExpr: '1'.
  } |
  SourceExpr ""after"" TargetExpr {
    self informAboutRuleReduction:'InsertAfterClause'.
    (AstInsertAfterExpr new) targetExpr: '3'; sourceExpr: '1'.
  } |
  SourceExpr ""before"" TargetExpr {
    self informAboutRuleReduction:'InsertBeforeClause'.
    (AstInsertBeforeExpr new) targetExpr: '3'; sourceExpr: '1'.
  };
  
TransformExpr:
  ""transform"" ""copy"" TransformCopyClause ""modify"" ExprSingle ""return"" ExprSingle {
    self informAboutRuleReduction:'TransformExpr'.
    (AstTransformExpr new) transformCopyClause: '3'; modifyExpr: '5'; returnExpr: '7'.
  };

TransformCopyClause:
	""$"" VarName "":="" ExprSingle {
	    self informAboutRuleReduction:'TransformCopyClause1'.
	    (AstTransformCopyClause new) varName: '2'; exprSingle: '4'.
  }|
	""$"" VarName "":="" ExprSingle "","" TransformCopyClause {
  		self informAboutRuleReduction:'TransformCopyClause2'.
	    (AstTransformCopyClause new) varName: '2'; exprSingle: '4' ; transformCopyClause: '6'.
  };


TargetExpr :
  ExprSingle{
    self informAboutRuleReduction:'TargetExpr'.
    '1'.
  };

SourceExpr :
  ExprSingle{
    self informAboutRuleReduction:'SourceExpr'.
    '1'.
  };


NewNameExpr :
  ExprSingle{
    self informAboutRuleReduction:'NewNameExpr'.
    '1'.
  };









"
!

symbolComment

	"
1. ""and""
2. ""to""
3. ""+""
4. ""or""
5. ""*""
6. ""else""
7. ""-""
8. ""some""
9. ""satisfies""
10. ""every""
11. ""idiv""
12. ""then""
13. ""div""
14. ""if""
15. ""least""
16. ""item""
17. ""?""
18. ""!!=""
19. ""empty-sequence""
20. ""<=""
21. ""of""
22. ""<""
23. ""union""
24. ""|""
25. ""intersect""
26. ""mod""
27. ""instance""
28. ""greatest""
29. ""except""
30. ""element""
31. ""function""
32. ""updating""
33. ""default""
34. "")""
35. ""declare""
36. ""(""
37. ""import""
38. ""module""
39. "";""
40. ""$""
41. ""=""
42. "",""
43. ""namespace""
44. "">=""
45. ""by""
46. ""stable""
47. ""ascending""
48. ""order""
49. ""empty""
50. ""where""
51. ""descending""
52. ""for""
53. ""in""
54. ""at""
55. ""return""
56. "":=""
57. "">""
58. ""let""
59. ""modify""
60. ""text""
61. ""comment""
62. ""processing-instruction""
63. ""document""
64. ""document-node""
65. ""</""
66. ""node""
67. ""ordered""
68. ""{""
69. ""}""
70. ""delete""
71. ""/>""
72. ""do""
73. ""unordered""
74. ""eq""
75. ""last""
76. ""after""
77. ""before""
78. ""first""
79. ""copy""
80. ""into""
81. ""transform""
82. ""as""
83. ""replace""
84. ""value""
85. ""rename""
86. ""insert""
87. "".""
88. ""with""
89. "">>""
90. ""/""
91. ""//""
92. ""<<""
93. ""::""
94. ""is""
95. ""child""
96. ""ne""
97. ""lt""
98. ""le""
99. ""attribute""
100. ""ge""
101. ""descendant""
102. ""gt""
103. ""]""
104. ""preceding-sibling""
105. ""preceding""
106. ""..""
107. ""self""
108. ""[""
109. ""ancestor-or-self""
110. "":""
111. ""descendant-or-self""
112. ""following-sibling""
113. ""following""
114. ""ancestor""
115. ""parent""
116. ""@""
117. <whitespace>
118. <comment>
119. <ncname>
120. <qname>
121. <integer_literal>
122. <decimal_literal>
123. <double_literal>
124. <predefined_entity_ref>
125. <string_literal>
126. NCName
127. DefaultNamespaceDecl
128. NamespaceDecl
129. FunctionDecl
130. StringLiteral
131. Optional: ""updating""
132. QName
133. ParamList
134. EnclosedExpr
135. OneOrMoreParamList
136. EmptyParamList
137. Param
138. Expr
139. ExprSingle
140. FLWORExpr
141. QuantifiedExpr
142. IfExpr
143. OrExpr
144. DeleteExpr
145. RenameExpr
146. ReplaceExpr
147. InsertExpr
148. TransformExpr
149. FLWORExpr_ForLet
150. WhereClause
151. OrderByClause
152. ForClause
153. LetClause
154. ForClause_Impl
155. VarName
156. PositionalVar
157. LetClause_Impl
158. OrderSpecList
159. OrderSpec
160. OrderModifier
161. OrderModifier_AscDesc
162. OrderModifier_GreatestLeast
163. QuantifiedExpr_Impl
164. AndExpr
165. ComparisonExpr
166. RangeExpr
167. ValueComp
168. GeneralComp
169. NodeComp
170. AdditiveExpr
171. MultiplicativeExpr
172. UnionExpr
173. IntersectExceptExpr
174. InstanceOfExpr
175. UnaryExpr
176. SequenceType
177. ItemType
178. Prolog
179. AtomicType
180. OccurenceIndicator
181. ValueExpr
182. PathExpr
183. RelativePathExpr
184. StepExpr
185. AxisStep
186. FilterExpr
187. ForwardStep
188. Predicate
189. Repeat: Predicate
190. ReverseStep
191. ForwardAxis
192. NodeTest
193. AbbrevForwardStep
194. ReverseAxis
195. AbbrevReverseStep
196. NameTest
197. PrimaryExpr
198. Literal
199. VarRef
200. ParenthesizedExpr
201. ContextItemExpr
202. FunctionCall
203. Constructor
204. OrderedExpr
205. UnorderedExpr
206. NumericLiteral
207. IntegerLiteral
208. DecimalLiteral
209. DoubleLiteral
210. FunctionParametersList
211. DirectConstructor
212. ComputedConstructor
213. DirElemConstructor
214. DirAttributeList
215. DirElemContent
216. DirAttributeValue
217. CommonContent
218. PredefinedEntityRef
219. CompDocConstructor
220. CompElemConstructor
221. CompAttrConstructor
222. CompTextConstructor
223. ContentExpr
224. DocumentTest
225. ElementTest
226. AttributeTest
227. TextTest
228. AnyKindTest
229. AttribNameOrWildcard
230. AttributeName
231. ElementNameOrWildcard
232. ElementName
233. PrologDeclarationClassB
234. Repeat: PrologDeclarationClassA
235. PrologDeclarationClassA
236. Repeat: PrologDeclarationClassB
237. B e g i n
238. KindTest
239. QueryBody
240. TargetExpr
241. NewNameExpr
242. ReplaceClause
243. InsertClause
244. SourceExpr
245. TransformCopyClause
246. E O F
247. error
248. MainModule
249. URILiteral
"

    "Modified: / 08-03-2009 / 22:33:48 / Jan Kurs <kursj1@fel.cvut.cz>"
! !

!XQueryParser class methodsFor:'generated-starting states'!

startingStateForMainModule
	^2
!

startingStateForQueryBody
	^1

    "Modified: / 03-12-2006 / 19:46:11 / ked"
! !

!XQueryParser methodsFor:'generated-reduction actions'!

reduceActionForAbbrevForwardStep1:nodes 
    self informAboutRuleReduction:'AbbrevForwardStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:XMLv2::XPathAxisAttribute new;
        nodeTest:(nodes at:2);
        yourself
!

reduceActionForAbbrevForwardStep2:nodes 
    self informAboutRuleReduction:'AbbrevForwardStep2'.
    ^ (XMLv2::XPathLocationStep new)
        setDefaultAxisFor:(nodes at:1);
        nodeTest:(nodes at:1);
        yourself
!

reduceActionForAbbrevReverseStep1:nodes 
    ^ (XMLv2::XPathLocationStep new)
        axis:XMLv2::XPathAxisParent new;
        nodeTest:XMLv2::XPathAnyKindTest new;
        yourself
!

reduceActionForAdditiveExpr1:nodes 
    self informAboutRuleReduction:'AdditiveExpr1'.
    ^ nodes at:1.
!

reduceActionForAdditiveExpr2:nodes 
    self informAboutRuleReduction:'AdditiveExpr2'.
    ^ (AstAdditiveExpr new)
        multiplicativeExpr:(nodes at:1);
        operand:#plus;
        additiveExpr:(nodes at:3).
!

reduceActionForAdditiveExpr3:nodes 
    self informAboutRuleReduction:'AdditiveExpr3'.
    ^ (AstAdditiveExpr new)
        multiplicativeExpr:(nodes at:1);
        operand:#minus;
        additiveExpr:(nodes at:3).
!

reduceActionForAndExpr1:nodes 
    self informAboutRuleReduction:'AndExpr1'.
    ^ nodes at:1.
!

reduceActionForAndExpr2:nodes 
    self informAboutRuleReduction:'AndExpr2'.
    ^ (AstAndExpr new)
        comparisonExpr:(nodes at:1);
        andExpr:(nodes at:3).
!

reduceActionForAnyKindTest1:nodes 
    self informAboutRuleReduction:'AnyKindTest1'.
    ^ XMLv2::XPathAnyKindTest new
!

reduceActionForAtomicType1:nodes 
    self informAboutRuleReduction:'AtomicType1'.
    ^ nodes at:1.
!

reduceActionForAttribNameOrWildcard1:nodes 
    self informAboutRuleReduction:'AttributeNameOrWildcard1'.
    ^ AstAttribNameOrWildcard new attributeName:(nodes at:1).
!

reduceActionForAttribNameOrWildcard2:nodes 
    self informAboutRuleReduction:'AttributeNameOrWildcard2'.
    ^ AstAttribNameOrWildcard new.
!

reduceActionForAttributeName1:nodes 
    self informAboutRuleReduction:'AttributeName1'.
    ^ nodes at:1.
!

reduceActionForAttributeTest1:nodes 
    self informAboutRuleReduction:'AttributeTest1'.
    ^ XMLv2::XPathAttributeTest new
!

reduceActionForAttributeTest2:nodes 
    self informAboutRuleReduction:'AttributeTest2'.
    ^ XMLv2::XPathAttributeTest halt:'Not yet implemented. See grammar'
!

reduceActionForAxisStep1:nodes 
    self informAboutRuleReduction:'AxisStep2'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself
!

reduceActionForAxisStep2:nodes 
    self informAboutRuleReduction:'AxisStep4'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself
!

reduceActionForAxisStep3:nodes 
    self informAboutRuleReduction:'AxisStep3'.
    ^ nodes at:1.

    "Modified: / 17-11-2007 / 13:50:27 / janfrog"
!

reduceActionForAxisStep4:nodes 
    self informAboutRuleReduction:'AxisStep4'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself

    "Modified: / 17-11-2007 / 13:50:27 / janfrog"
!

reduceActionForCommonContent1:nodes 
    self informAboutRuleReduction:'CommonContent1'.
    ^ nodes at:1.
!

reduceActionForCommonContent2:nodes 
    self informAboutRuleReduction:'CommonContent2'.
    ^ nodes at:1.
!

reduceActionForCommonContent3:nodes 
    self informAboutRuleReduction:'CommonContent3'.
    ^ nodes at:1.
!

reduceActionForCommonContent4:nodes 
    self informAboutRuleReduction:'CommonContent7'.
    ^ nodes at:1.
!

reduceActionForCommonContent5:nodes 
    self informAboutRuleReduction:'CommonContent8'.
    ^ nodes at:1.
!

reduceActionForCommonContent6:nodes 
    Transcript showCR:'[PARSER] CommonContent6'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCommonContent7:nodes 
    Transcript showCR:'[PARSER] CommonContent7'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCommonContent8:nodes 
    Transcript showCR:'[PARSER] CommonContent8'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCompAttrConstructor1:nodes 
    self informAboutRuleReduction:'CompAttrConstructor1'.
    ^ AstCompAttrConstructor new qname:(nodes at:2).
!

reduceActionForCompAttrConstructor2:nodes 
    self informAboutRuleReduction:'CompAttrConstructor2'.
    ^ (AstCompAttrConstructor new)
        qname:(nodes at:2);
        contentExpr:(nodes at:4).
!

reduceActionForCompAttrConstructor3:nodes 
    self informAboutRuleReduction:'CompAttrConstructor3'.
    ^ AstCompAttrConstructor new expr:(nodes at:3).
!

reduceActionForCompAttrConstructor4:nodes 
    self informAboutRuleReduction:'CompAttrConstructor4'.
    ^ (AstCompAttrConstructor new)
        expr:(nodes at:3);
        contentExpr:(nodes at:6).
!

reduceActionForCompDocConstructor1:nodes 
    self informAboutRuleReduction:'CompDocConstructor1'.
    ^ AstCompDocConstructor new expr:(nodes at:3).
!

reduceActionForCompElemConstructor1:nodes 
    self informAboutRuleReduction:'CompElemConstructor1'.
    ^ AstCompElemConstructor new qname:(nodes at:2).
!

reduceActionForCompElemConstructor2:nodes 
    self informAboutRuleReduction:'CompElemConstructor2'.
    ^ (AstCompElemConstructor new)
        qname:(nodes at:2);
        contentExpr:(nodes at:4).
!

reduceActionForCompElemConstructor3:nodes 
    self informAboutRuleReduction:'CompElemConstructor3'.
    ^ AstCompElemConstructor new expr:(nodes at:3).
!

reduceActionForCompElemConstructor4:nodes 
    self informAboutRuleReduction:'CompElemConstructor4'.
    ^ (AstCompElemConstructor new)
        expr:(nodes at:3);
        contentExpr:(nodes at:6).
!

reduceActionForCompTextConstructor1:nodes 
    self informAboutRuleReduction:'CompTextConstructor1'.
    ^ AstCompTextConstructor new expr:(nodes at:3).
!

reduceActionForComparisonExpr1:nodes 
    self informAboutRuleReduction:'ComparisonExpr1'.
    ^ nodes at:1.
!

reduceActionForComparisonExpr2:nodes 
    self informAboutRuleReduction:'ComparisonExpr2'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        valueComp:(nodes at:2);
        rangeExprRight:(nodes at:3).
!

reduceActionForComparisonExpr3:nodes 
    self informAboutRuleReduction:'ComparisonExpr3'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        generalComp:(nodes at:2);
        rangeExprRight:(nodes at:3).
!

reduceActionForComparisonExpr4:nodes 
    self informAboutRuleReduction:'ComparisonExpr4'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        nodeComp:(nodes at:2);
        rangeExprRight:(nodes at:3).
!

reduceActionForComputedConstructor1:nodes 
    self informAboutRuleReduction:'ComputedConstructor1'.
    ^ nodes at:1.
!

reduceActionForComputedConstructor2:nodes 
    self informAboutRuleReduction:'ComputedConstructor2'.
    ^ nodes at:1.
!

reduceActionForComputedConstructor3:nodes 
    self informAboutRuleReduction:'ComputedConstructor3'.
    ^ nodes at:1.
!

reduceActionForComputedConstructor4:nodes 
    self informAboutRuleReduction:'ComputedConstructor4'.
    ^ nodes at:1.
!

reduceActionForConstructor1:nodes 
    self informAboutRuleReduction:'Constructor1'.
    ^ nodes at:1.
!

reduceActionForConstructor2:nodes 
    self informAboutRuleReduction:'Constructor2'.
    ^ nodes at:1.
!

reduceActionForContentExpr1:nodes 
    self informAboutRuleReduction:'ContentExpr'.
    ^ nodes at:1.
!

reduceActionForContextItemExpr1:nodes 
    self informAboutRuleReduction:'ContextItemExpr1'.
    ^ AstContextItemExpr new.
!

reduceActionForDecimalLiteral1:nodes 
    self 
        informAboutRuleReduction:'DecimalLiteral1 -' , ((nodes at:1) asString).
    ^ AstDecimalLiteral new content:((nodes at:1) value asFloat).
!

reduceActionForDefaultNamespaceDecl1:nodes 
    ^ (AstDefaultNamespaceDecl new)
        uri:(nodes at:5);
        type:#element
!

reduceActionForDefaultNamespaceDecl2:nodes 
    ^ (AstDefaultNamespaceDecl new)
        uri:(nodes at:5);
        type:#function
!

reduceActionForDeleteExpr1:nodes 
    self informAboutRuleReduction:'DeleteExpr'.
    ^ (AstDeleteExpr new) targetExpr:(nodes at:3)
!

reduceActionForDirAttributeList1:nodes 
    self informAboutRuleReduction:'DirAttributeList1'.
    ^ (AstDirAttributeList new)
        qname:(nodes at:1);
        dirAttributeValue:(nodes at:3).
!

reduceActionForDirAttributeList2:nodes 
    self informAboutRuleReduction:'DirAttributeList2'.
    ^ (AstDirAttributeList new)
        qname:(nodes at:1);
        dirAttributeValue:(nodes at:3);
        dirAttributeList:(nodes at:4).
!

reduceActionForDirAttributeValue1:nodes 
    self informAboutRuleReduction:'DirAttributeValue1'.
    ^ nodes at:1.
!

reduceActionForDirAttributeValue2:nodes 
    self informAboutRuleReduction:'DirAttributeValue2'.
    ^ nodes at:1.
!

reduceActionForDirElemConstructor1:nodes 
    self informAboutRuleReduction:'DirElemConstructor1'.
    ^ AstDirElemConstructor new qname:(nodes at:2).
!

reduceActionForDirElemConstructor2:nodes 
    self informAboutRuleReduction:'DirElemConstructor2'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirAttributeList:(nodes at:3).
!

reduceActionForDirElemConstructor3:nodes 
    self informAboutRuleReduction:'DirElemConstructor3'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirElemContent:(nodes at:4).
!

reduceActionForDirElemConstructor4:nodes 
    self informAboutRuleReduction:'DirElemConstructor4'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirAttributeList:(nodes at:3);
        dirElemContent:(nodes at:5).
!

reduceActionForDirElemContent1:nodes 
    self informAboutRuleReduction:'DirElemContent1'.
    ^ AstDirElemContent new content:(nodes at:1).
!

reduceActionForDirElemContent2:nodes 
    self informAboutRuleReduction:'DirElemContent2'.
    ^ (AstDirElemContent new)
        content:(nodes at:1);
        dirElemContent:(nodes at:2).
!

reduceActionForDirElemContent3:nodes 
    self informAboutRuleReduction:'DirElemContent3'.
    ^ AstDirElemContent new content:(nodes at:1).
!

reduceActionForDirElemContent4:nodes 
    self informAboutRuleReduction:'DirElemContent4'.
    ^ (AstDirElemContent new)
        content:(nodes at:1);
        dirElemContent:(nodes at:2).
!

reduceActionForDirectConstructor1:nodes 
    self informAboutRuleReduction:'DirectConstructor1'.
    ^ nodes at:1.
!

reduceActionForDocumentTest1:nodes 
    self informAboutRuleReduction:'DocumentTest1'.
    ^ XMLv2::XPathDocumentTest new.
!

reduceActionForDocumentTest2:nodes 
    self informAboutRuleReduction:'DocumentTest2'.
    ^ XMLv2::XPathDocumentTest new elementTest:(nodes at:3).
!

reduceActionForDoubleLiteral1:nodes 
    self 
        informAboutRuleReduction:'DoubleLiteral1 -' , ((nodes at:1) asString).
    ^ AstDoubleLiteral new content:((nodes at:1) value asDouble).
!

reduceActionForElementName1:nodes 
    self informAboutRuleReduction:'ElementName1'.
    ^ nodes at:1.
!

reduceActionForElementNameOrWildcard1:nodes 
    self informAboutRuleReduction:'ElementNameOrWildcard1'.
    ^ AstElementNameOrWildcard new elementName:(nodes at:1).
!

reduceActionForElementNameOrWildcard2:nodes 
    self informAboutRuleReduction:'ElementNameOrWildcard2'.
    ^ AstElementNameOrWildcard new.
!

reduceActionForElementTest1:nodes 
    self informAboutRuleReduction:'ElementTest1'.
    ^ XMLv2::XPathElementTest new.
!

reduceActionForElementTest2:nodes 
    self informAboutRuleReduction:'ElementTest2'.
    ^ XMLv2::XPathElementTest new elementName:(nodes at:3).
!

reduceActionForEmptyParamList1:nodes 
    ^ #()
!

reduceActionForEnclosedExpr1:nodes 
    self informAboutRuleReduction:'EnclosedExpr1'.
    ^ AstEnclosedExpr new expr:(nodes at:2).
!

reduceActionForExpr1:nodes 
    self informAboutRuleReduction:'Expr1'.
    ^ nodes at:1.
!

reduceActionForExpr2:nodes 
    self informAboutRuleReduction:'Expr2'.
    ^ (AstExpr new)
        exprSingle:(nodes at:1);
        expr:(nodes at:3).
!

reduceActionForExprSingle1:nodes 
    self informAboutRuleReduction:'ExprSingle1'.
    ^ nodes at:1.
!

reduceActionForExprSingle2:nodes 
    self informAboutRuleReduction:'ExprSingle2'.
    ^ nodes at:1.
!

reduceActionForExprSingle3:nodes 
    self informAboutRuleReduction:'ExprSingle3'.
    ^ nodes at:1.
!

reduceActionForExprSingle4:nodes 
    self informAboutRuleReduction:'ExprSingle4'.
    ^ nodes at:1.
!

reduceActionForExprSingle5:nodes 
    self informAboutRuleReduction:'ExprSingle5'.
    ^ nodes at:1.
!

reduceActionForExprSingle6:nodes 
    self informAboutRuleReduction:'ExprSingle6'.
    ^ nodes at:1.
!

reduceActionForExprSingle7:nodes 
    self informAboutRuleReduction:'ExprSingle7'.
    ^ nodes at:1.
!

reduceActionForExprSingle8:nodes 
    self informAboutRuleReduction:'ExprSingle8'.
    ^ nodes at:1.
!

reduceActionForExprSingle9:nodes 
    self informAboutRuleReduction:'ExprSingle9'.
    ^ nodes at:1.
!

reduceActionForFLWORExpr1:nodes 
    self informAboutRuleReduction:'FLWORExpr1'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        exprSingle:(nodes at:3).
!

reduceActionForFLWORExpr2:nodes 
    self informAboutRuleReduction:'FLWORExpr2'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        whereClause:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForFLWORExpr3:nodes 
    self informAboutRuleReduction:'FLWORExpr3'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        orderByClause:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForFLWORExpr4:nodes 
    self informAboutRuleReduction:'FLWORExpr4'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        whereClause:(nodes at:2);
        orderByClause:(nodes at:3);
        exprSingle:(nodes at:5).
!

reduceActionForFLWORExpr_ForLet1:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet1'.
    ^ nodes at:1.
!

reduceActionForFLWORExpr_ForLet2:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet2'.
    ^ nodes at:1.
!

reduceActionForFLWORExpr_ForLet3:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet3'.
    ^ (AstFLWORExpr_ForLet new)
        forClause:(nodes at:1);
        flworExpr_ForLet:(nodes at:2).
!

reduceActionForFLWORExpr_ForLet4:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet4'.
    ^ (AstFLWORExpr_ForLet new)
        letClause:(nodes at:1);
        flworExpr_ForLet:(nodes at:2).
!

reduceActionForFilterExpr1:nodes 
    self informAboutRuleReduction:'FilterExpr2'.
    ^ (AstFilterExpr new)
        primaryExpr:(nodes at:1);
        predicateList:(nodes at:2).
!

reduceActionForFilterExpr2:nodes 
    self informAboutRuleReduction:'FilterExpr2'.
    ^ (AstFilterExpr new)
        primaryExpr:(nodes at:1);
        predicateList:(nodes at:2).

    "Modified: / 17-11-2007 / 14:03:09 / janfrog"
!

reduceActionForForClause1:nodes 
    self informAboutRuleReduction:'ForClause1'.
    ^ nodes at:2.
!

reduceActionForForClause_Impl1:nodes 
    self informAboutRuleReduction:'ForClause_Impl1'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForForClause_Impl2:nodes 
    self informAboutRuleReduction:'ForClause_Impl2'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        forClause:(nodes at:6).
!

reduceActionForForClause_Impl3:nodes 
    self informAboutRuleReduction:'ForClause_Impl3'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        positionalVar:(nodes at:3);
        exprSingle:(nodes at:5).
!

reduceActionForForClause_Impl4:nodes 
    self informAboutRuleReduction:'ForClause_Impl4'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        positionalVar:(nodes at:3);
        exprSingle:(nodes at:5);
        forClause:(nodes at:7).
!

reduceActionForForwardAxis1:nodes 
    self informAboutRuleReduction:'ForwardAxis1'.
    ^ XMLv2::XPathAxisChild new
!

reduceActionForForwardAxis2:nodes 
    self informAboutRuleReduction:'ForwardAxis2'.
    ^ XMLv2::XPathAxisDescendant new
!

reduceActionForForwardAxis3:nodes 
    self informAboutRuleReduction:'ForwardAxis3'.
    ^ XMLv2::XPathAxisAttribute new
!

reduceActionForForwardAxis4:nodes 
    self informAboutRuleReduction:'ForwardAxis4'.
    ^ XMLv2::XPathAxisSelf new
!

reduceActionForForwardAxis5:nodes 
    self informAboutRuleReduction:'ForwardAxis5'.
    ^ XMLv2::XPathAxisSedcendantOrSelf new
!

reduceActionForForwardAxis6:nodes 
    self informAboutRuleReduction:'ForwardAxis6'.
    ^ XMLv2::XPathAxisFollowingSibling new
!

reduceActionForForwardAxis7:nodes 
    self informAboutRuleReduction:'ForwardAxis7'.
    ^ XMLv2::XPathAxisFollowing new
!

reduceActionForForwardStep1:nodes 
    self informAboutRuleReduction:'ForwardStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:(nodes at:1);
        nodeTest:(nodes at:2);
        yourself
!

reduceActionForForwardStep2:nodes 
    self informAboutRuleReduction:'ForwardStep2'.
    ^ nodes at:1
!

reduceActionForFunctionCall1:nodes 
    self informAboutRuleReduction:'FunctionCall1'.
    ^ AstFunctionCall new qname:(nodes at:1).
!

reduceActionForFunctionCall2:nodes 
    self informAboutRuleReduction:'FunctionCall2'.
    ^ (AstFunctionCall new)
        qname:(nodes at:1);
        functionParametersList:(nodes at:3).
!

reduceActionForFunctionDecl1:nodes 
    ^ (AstFunctionDecl new)
        name:(nodes at:4);
        paramList:(nodes at:6);
        body:(nodes at:8)
!

reduceActionForFunctionParametersList1:nodes 
    self informAboutRuleReduction:'FunctionParametersList1'.
    ^ AstFunctionParametersList new exprSingle:(nodes at:1).
!

reduceActionForFunctionParametersList2:nodes 
    self informAboutRuleReduction:'FunctionParametersList2'.
    ^ (AstFunctionParametersList new)
        exprSingle:(nodes at:1);
        functionParametersList:(nodes at:3).
!

reduceActionForGeneralComp1:nodes 
    self informAboutRuleReduction:'GeneralComp1'.
    ^ #eqGeneral.
!

reduceActionForGeneralComp2:nodes 
    self informAboutRuleReduction:'GeneralComp2'.
    ^ #neGeneral.
!

reduceActionForGeneralComp3:nodes 
    self informAboutRuleReduction:'GeneralComp3'.
    ^ #ltGeneral.
!

reduceActionForGeneralComp4:nodes 
    self informAboutRuleReduction:'GeneralComp4'.
    ^ #leGeneral.
!

reduceActionForGeneralComp5:nodes 
    self informAboutRuleReduction:'GeneralComp5'.
    ^ #gtGeneral.
!

reduceActionForGeneralComp6:nodes 
    self informAboutRuleReduction:'GeneralComp6'.
    ^ #geGeneral.
!

reduceActionForGroup______updating_1:nodes 
    ^ nodes at:1
!

reduceActionForIfExpr1:nodes 
    self informAboutRuleReduction:'IfExpr1'.
    ^ (AstIfExpr new)
        expr:(nodes at:3);
        trueExprSingle:(nodes at:6);
        falseExprSingle:(nodes at:8).
!

reduceActionForInsertClause1:nodes 
    self informAboutRuleReduction:'InsertIntoClause'.
    ^ (AstInsertIntoExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertClause2:nodes 
    self informAboutRuleReduction:'InsertAsFirstIntoClause'.
    ^ (AstInsertAsFirstIntoExpr new)
        targetExpr:(nodes at:5);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertClause3:nodes 
    self informAboutRuleReduction:'InsertAsLastIntoClause'.
    ^ (AstInsertAsLastIntoExpr new)
        targetExpr:(nodes at:5);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertClause4:nodes 
    self informAboutRuleReduction:'InsertAfterClause'.
    ^ (AstInsertAfterExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertClause5:nodes 
    self informAboutRuleReduction:'InsertBeforeClause'.
    ^ (AstInsertBeforeExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).
!

reduceActionForInsertExpr1:nodes 
    self informAboutRuleReduction:'InsertExpr'.
    ^ nodes at:3.
!

reduceActionForInstanceOfExpr1:nodes 
    self informAboutRuleReduction:'InstanceOfExpr1'.
    ^ nodes at:1.
!

reduceActionForInstanceOfExpr2:nodes 
    self informAboutRuleReduction:'InstanceOfExpr2'.
    ^ (AstInstanceOfExpr new)
        unaryExpr:(nodes at:1);
        sequenceType:(nodes at:4)
!

reduceActionForIntegerLiteral1:nodes 
    self 
        informAboutRuleReduction:'IntegerLiteral1 -' , ((nodes at:1) asString).
    ^ AstIntegerLiteral new content:((nodes at:1) value asInteger).
!

reduceActionForIntersectExceptExpr1:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr1'.
    ^ nodes at:1.
!

reduceActionForIntersectExceptExpr2:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr2'.
    ^ (AstIntersectExceptExpr new)
        unaryExpr:(nodes at:1);
        operand:#intersect;
        intersectExceptExpr:(nodes at:3).
!

reduceActionForIntersectExceptExpr3:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr3'.
    ^ (AstIntersectExceptExpr new)
        unaryExpr:(nodes at:1);
        operand:#except;
        intersectExceptExpr:(nodes at:3).
!

reduceActionForItemType1:nodes 
    self informAboutRuleReduction:'ItemType1'.
    ^ #item.
!

reduceActionForItemType2:nodes 
    self informAboutRuleReduction:'ItemType2'.
    ^ nodes at:1.
!

reduceActionForItemType3:nodes 
    self informAboutRuleReduction:'ItemType3'.
    ^ nodes at:1.
!

reduceActionForKindTest1:nodes 
    self informAboutRuleReduction:'KindTest1'.
    ^ nodes at:1.
!

reduceActionForKindTest2:nodes 
    self informAboutRuleReduction:'KindTest2'.
    ^ nodes at:1.
!

reduceActionForKindTest3:nodes 
    self informAboutRuleReduction:'KindTest3'.
    ^ nodes at:1.
!

reduceActionForKindTest4:nodes 
    self informAboutRuleReduction:'KindTest4'.
    ^ nodes at:1.
!

reduceActionForKindTest5:nodes 
    self informAboutRuleReduction:'KindTest5'.
    ^ nodes at:1.
!

reduceActionForKindTest6:nodes 
    ^ XMLv2::XPathCommentTest new
!

reduceActionForKindTest7:nodes 
    ^ XMLv2::XPathProcessingInstructionTest new
!

reduceActionForLetClause1:nodes 
    self informAboutRuleReduction:'LetClause1'.
    ^ nodes at:2.
!

reduceActionForLetClause_Impl1:nodes 
    self informAboutRuleReduction:'LetClause_Impl1'.
    ^ (AstLetClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForLetClause_Impl2:nodes 
    self informAboutRuleReduction:'LetClause_Impl2'.
    ^ (AstLetClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        letClause:(nodes at:6).
!

reduceActionForLiteral1:nodes 
    self informAboutRuleReduction:'Literal1'.
    ^ nodes at:1.
!

reduceActionForLiteral2:nodes 
    self informAboutRuleReduction:'Literal2'.
    ^ nodes at:1.
!

reduceActionForMainModule1:nodes 
    ^ (AstMainModule new)
        prolog:(nodes at:1);
        queryBody:(nodes at:2)
!

reduceActionForMultiplicativeExpr1:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr1'.
    ^ nodes at:1.
!

reduceActionForMultiplicativeExpr2:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr2'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#krat;
        multiplicativeExpr:(nodes at:3).
!

reduceActionForMultiplicativeExpr3:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr3'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#div;
        multiplicativeExpr:(nodes at:3).
!

reduceActionForMultiplicativeExpr4:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr4'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#idiv;
        multiplicativeExpr:(nodes at:3).
!

reduceActionForMultiplicativeExpr5:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr5'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#mod;
        multiplicativeExpr:(nodes at:3).
!

reduceActionForNCName1:nodes 
    self informAboutRuleReduction:'NCName1 - ' , ((nodes at:1) asString).
    ^ AstNCName new content:((nodes at:1) value).
!

reduceActionForNameTest1:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ XMLv2::XPathNameTest new qName:(nodes at:1) content
!

reduceActionForNameTest2:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ (XMLv2::XPathNameTest new)
        prefix:'*';
        localName:'*'
!

reduceActionForNameTest3:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ (XMLv2::XPathNameTest new)
        prefix:'*';
        localName:(nodes at:3) content
!

reduceActionForNamespaceDecl1:nodes 
    ^ (AstNamespaceDecl new)
        prefix:(nodes at:3);
        nsuri:(nodes at:5)
!

reduceActionForNewNameExpr1:nodes 
    self informAboutRuleReduction:'NewNameExpr'.
    ^ nodes at:1.
!

reduceActionForNodeComp1:nodes 
    self informAboutRuleReduction:'NodeComp1'.
    ^ #is.
!

reduceActionForNodeComp2:nodes 
    self informAboutRuleReduction:'NodeComp2'.
    ^ #isLess.
!

reduceActionForNodeComp3:nodes 
    self informAboutRuleReduction:'NodeComp3'.
    ^ #isMore.
!

reduceActionForNodeTest1:nodes 
    self informAboutRuleReduction:'NodeTest1'.
    ^ nodes at:1.
!

reduceActionForNodeTest2:nodes 
    self informAboutRuleReduction:'NodeTest2'.
    ^ nodes at:1.
!

reduceActionForNumericLiteral1:nodes 
    self informAboutRuleReduction:'NumericLiteral1'.
    ^ nodes at:1.
!

reduceActionForNumericLiteral2:nodes 
    self informAboutRuleReduction:'NumericLiteral2'.
    ^ nodes at:1.
!

reduceActionForNumericLiteral3:nodes 
    self informAboutRuleReduction:'NumericLiteral3'.
    ^ nodes at:1.
!

reduceActionForOccurenceIndicator1:nodes 
    ^ self informAboutRuleReduction:'OccurenceIndicator1'
!

reduceActionForOccurenceIndicator2:nodes 
    ^ self informAboutRuleReduction:'OccurenceIndicator2'
!

reduceActionForOccurenceIndicator3:nodes 
    ^ self informAboutRuleReduction:'OccurenceIndicator3'
!

reduceActionForOneOrMoreParamList1:nodes 
    ^ (nodes at:1)
        add:(nodes at:3);
        yourself
!

reduceActionForOneOrMoreParamList2:nodes 
    ^ OrderedCollection with:(nodes at:1)
!

reduceActionForOptional__Group______updating_1:nodes 
    ^ nil
!

reduceActionForOptional__Group______updating_2:nodes 
    ^ nodes at:1
!

reduceActionForOptional__Group______value___of_1:nodes 
    ^ nil

    "Modified: / 31-10-2007 / 09:24:55 / janfrog"
!

reduceActionForOptional__Group______value___of_2:nodes 
    ^ nodes at:1

    "Modified: / 31-10-2007 / 09:24:55 / janfrog"
!

reduceActionForOptional___updating_1:nodes 
    ^ nil
!

reduceActionForOptional___updating_2:nodes 
    ^ nodes at:1
!

reduceActionForOrExpr1:nodes 
    self informAboutRuleReduction:'OrExpr1'.
    ^ nodes at:1.
!

reduceActionForOrExpr2:nodes 
    self informAboutRuleReduction:'OrExpr2'.
    ^ (AstOrExpr new)
        andExpr:(nodes at:1);
        orExpr:(nodes at:3).
!

reduceActionForOrderByClause1:nodes 
    self informAboutRuleReduction:'OrderByClause1'.
    ^ (AstOrderByClause new)
        isStable:false;
        orderSpecList:(nodes at:3).
!

reduceActionForOrderByClause2:nodes 
    self informAboutRuleReduction:'OrderByClause2'.
    ^ (AstOrderByClause new)
        isStable:true;
        orderSpecList:(nodes at:4).
!

reduceActionForOrderModifier1:nodes 
    self informAboutRuleReduction:'OrderModifier1'.
    ^ AstOrderModifier new ascDesc:(nodes at:1).
!

reduceActionForOrderModifier2:nodes 
    self informAboutRuleReduction:'OrderModifier2'.
    ^ AstOrderModifier new greatestLeast:(nodes at:1).
!

reduceActionForOrderModifier3:nodes 
    self informAboutRuleReduction:'OrderModifier3'.
    ^ (AstOrderModifier new)
        ascDesc:(nodes at:1);
        greatestLeast:(nodes at:2).
!

reduceActionForOrderModifier_AscDesc1:nodes 
    self informAboutRuleReduction:'OrderModifier_AscDesc1'.
    ^ #asc.
!

reduceActionForOrderModifier_AscDesc2:nodes 
    self informAboutRuleReduction:'OrderModifier_AscDesc2'.
    ^ #desc.
!

reduceActionForOrderModifier_GreatestLeast1:nodes 
    self informAboutRuleReduction:'OrderModifier_GreatestLeast1'.
    ^ #greatest.
!

reduceActionForOrderModifier_GreatestLeast2:nodes 
    self informAboutRuleReduction:'OrderModifier_GreatestLeast2'.
    ^ #least.
!

reduceActionForOrderSpec1:nodes 
    self informAboutRuleReduction:'OrderSpec1'.
    ^ AstOrderSpec new exprSingle:(nodes at:1).
!

reduceActionForOrderSpec2:nodes 
    self informAboutRuleReduction:'OrderSpec2'.
    ^ (AstOrderSpec new)
        exprSingle:(nodes at:1);
        orderModifier:(nodes at:2).
!

reduceActionForOrderSpecList1:nodes 
    self informAboutRuleReduction:'OrderSpecList1'.
    ^ nodes at:1.
!

reduceActionForOrderSpecList2:nodes 
    self informAboutRuleReduction:'OrderSpecList2'.
    ^ (AstOrderSpecList new)
        orderSpec:(nodes at:1);
        orderSpecList:(nodes at:3).
!

reduceActionForOrderedExpr1:nodes 
    self informAboutRuleReduction:'OrderedExpr1'.
    ^ nodes at:3.
!

reduceActionForParam1:nodes 
    ^ AstParam new name:(nodes at:2)
!

reduceActionForParamList1:nodes 
    ^ nodes at:1
!

reduceActionForParamList2:nodes 
    ^ '2'
!

reduceActionForParenthesizedExpr1:nodes 
    self informAboutRuleReduction:'ParenthesizedExpr1'.
    ^ AstParenthesizedExpr new.
!

reduceActionForParenthesizedExpr2:nodes 
    self informAboutRuleReduction:'ParenthesizedExpr2'.
    ^ AstParenthesizedExpr new expr:(nodes at:2).
!

reduceActionForPathExpr1:nodes 
    self informAboutRuleReduction:'PathExpr2'.
    ^ (nodes at:2)
        absolute:true;
        yourself
!

reduceActionForPathExpr2:nodes 
    self informAboutRuleReduction:'PathExpr3'.
    ^ (nodes at:2)
        addFirst:((XMLv2::XPathLocationStep new)
                    axis:XMLv2::XPathAxisDescendantOrSelf new;
                    nodeTest:XMLv2::XPathAnyKindTest new);
        yourself
!

reduceActionForPathExpr3:nodes 
    self informAboutRuleReduction:'PathExpr4'.
    ^ nodes at:1.
!

reduceActionForPositionalVar1:nodes 
    self informAboutRuleReduction:'PositionalVar1'.
    ^ nodes at:3.
!

reduceActionForPredefinedEntityRef1:nodes 
    self informAboutRuleReduction:'PredefinedEntityRef1 -' 
                , ((nodes at:1) asString).
    ^ AstPredefinedEntityRef new content:((nodes at:1) value).
!

reduceActionForPredicate1:nodes 
    self informAboutRuleReduction:'Predicate1'.
    ^ XMLv2::XPathPredicate new expr:(nodes at:2).
!

reduceActionForPredicate2:nodes 
    self informAboutRuleReduction:'Predicate2'.
    ^ XMLv2::XPathPredicate new
!

reduceActionForPredicateList1:nodes 
    self informAboutRuleReduction:'PredicateList1'.
    ^ nodes at:1.

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForPredicateList2:nodes 
    self informAboutRuleReduction:'PredicateList2'.
    ^ (AstPredicateList new)
        predicate:(nodes at:1);
        predicateList:(nodes at:2).

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForPrimaryExpr1:nodes 
    self informAboutRuleReduction:'PrimaryExpr1'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr2:nodes 
    self informAboutRuleReduction:'PrimaryExpr2'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr3:nodes 
    self informAboutRuleReduction:'PrimaryExpr3'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr4:nodes 
    self informAboutRuleReduction:'PrimaryExpr4'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr5:nodes 
    self informAboutRuleReduction:'PrimaryExpr5'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr6:nodes 
    self informAboutRuleReduction:'PrimaryExpr6'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr7:nodes 
    self informAboutRuleReduction:'PrimaryExpr7'.
    ^ nodes at:1.
!

reduceActionForPrimaryExpr8:nodes 
    self informAboutRuleReduction:'PrimaryExpr8'.
    ^ nodes at:1.
!

reduceActionForProlog1:nodes 
    ^ AstProlog new declarations:((nodes at:1)
                addAll:(nodes at:2);
                yourself)
!

reduceActionForPrologDeclarationClass11:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass12:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass13:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass1List1:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForPrologDeclarationClass1List2:nodes 
    ^ OrderedCollection new:5
!

reduceActionForPrologDeclarationClass21:nodes 
    ^ nodes at:1

    "Modified: / 28-12-2006 / 13:35:22 / janfrog"
!

reduceActionForPrologDeclarationClass2List1:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 09:42:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClass2List2:nodes 
    ^ OrderedCollection new:5

    "Modified: / 01-12-2008 / 09:42:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClassA1:nodes 
    ^ AstModuleImport new uri:(nodes at:3)
!

reduceActionForPrologDeclarationClassA2:nodes 
    ^ (AstModuleImport new)
        prefix:(nodes at:4);
        uri:(nodes at:6)
!

reduceActionForPrologDeclarationClassB1:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClassB2:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClassB3:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClassB4:nodes 
    ^ nodes at:1
!

reduceActionForQName1:nodes 
    self informAboutRuleReduction:'QName1 - ' , ((nodes at:1) asString).
    ^ AstQName new content:((nodes at:1) value).
!

reduceActionForQuantifiedExpr1:nodes 
    self informAboutRuleReduction:'QuantifiedExpr1'.
    ^ (AstQuantifiedExpr new)
        someEvery:#some;
        quantifiedExpr_Impl:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForQuantifiedExpr2:nodes 
    self informAboutRuleReduction:'QuantifiedExpr2'.
    ^ (AstQuantifiedExpr new)
        someEvery:#every;
        quantifiedExpr_Impl:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForQuantifiedExpr_Impl1:nodes 
    self informAboutRuleReduction:'QuantifiedExpr_Impl1'.
    ^ (AstQuantifiedExpr_Impl new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForQuantifiedExpr_Impl2:nodes 
    self informAboutRuleReduction:'QuantifiedExpr_Impl2'.
    ^ (AstQuantifiedExpr_Impl new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        quantifiedExpr_Impl:(nodes at:6).
!

reduceActionForQueryBody1:nodes 
    self informAboutRuleReduction:'QueryBody1'.
    ^ nodes at:1.
!

reduceActionForRangeExpr1:nodes 
    self informAboutRuleReduction:'RangeExpr1'.
    ^ nodes at:1.
!

reduceActionForRangeExpr2:nodes 
    self informAboutRuleReduction:'RangeExpr2'.
    ^ (AstRangeExpr new)
        additiveExprFrom:(nodes at:1);
        additiveExprTo:(nodes at:3).
!

reduceActionForRelativePathExpr1:nodes 
    self informAboutRuleReduction:'RelativePathExpr1'.
    ^ XMLv2::XPathExpression with:(nodes at:1).
!

reduceActionForRelativePathExpr2:nodes 
    self informAboutRuleReduction:'RelativePathExpr2'.
    ^ (nodes at:1)
        add:(nodes at:3);
        yourself
!

reduceActionForRelativePathExpr3:nodes 
    self informAboutRuleReduction:'RelativePathExpr3'.
    ^ (nodes at:1)
        add:((XMLv2::XPathLocationStep new)
                    axis:XMLv2::XPathAxisDescendantOrSelf new;
                    nodeTest:XMLv2::XPathAnyKindTest new);
        add:(nodes at:3);
        yourself
!

reduceActionForRenameExpr1:nodes 
    self informAboutRuleReduction:'RenameExpr'.
    ^ (AstRenameExpr new)
        targetExpr:(nodes at:3);
        newNameExpr:(nodes at:5).
!

reduceActionForRepeat__Group_____________VarName______ExprSingle1:nodes 
    ^ OrderedCollection new
!

reduceActionForRepeat__Group_____________VarName______ExprSingle2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForRepeat__Predicate1:nodes 
    ^ OrderedCollection new
!

reduceActionForRepeat__Predicate2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForRepeat__PrologDeclarationClassA1:nodes 
    ^ OrderedCollection new
!

reduceActionForRepeat__PrologDeclarationClassA2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForRepeat__PrologDeclarationClassAList1:nodes 
    ^ OrderedCollection new

    "Created: / 01-12-2008 / 09:40:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__PrologDeclarationClassAList2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself

    "Created: / 01-12-2008 / 09:40:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__PrologDeclarationClassB1:nodes 
    ^ OrderedCollection new
!

reduceActionForRepeat__PrologDeclarationClassB2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForReplaceClause1:nodes 
    self informAboutRuleReduction:'ReplaceValueOfClause'.
    ^ (AstReplaceValueOfExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:5).
!

reduceActionForReplaceClause2:nodes 
    self informAboutRuleReduction:'ReplaceClause'.
    ^ (AstReplaceExpr new)
        targetExpr:(nodes at:1);
        sourceExpr:(nodes at:3).
!

reduceActionForReplaceExpr1:nodes 
    self informAboutRuleReduction:'ReplaceExpr'.
    ^ nodes at:3.
!

reduceActionForReverseAxis1:nodes 
    self informAboutRuleReduction:'ReverseAxis1'.
    ^ XMLv2::XPathAxisParent new
!

reduceActionForReverseAxis2:nodes 
    self informAboutRuleReduction:'ReverseAxis2'.
    ^ XMLv2::XPathAxisAncestor new
!

reduceActionForReverseAxis3:nodes 
    self informAboutRuleReduction:'ReverseAxis3'.
    ^ XMLv2::XPathAxisAncestorOrSelf new
!

reduceActionForReverseAxis4:nodes 
    self informAboutRuleReduction:'ReverseAxis4'.
    ^ XMLv2::XPathAxisPrecedingSibling new
!

reduceActionForReverseAxis5:nodes 
    self informAboutRuleReduction:'ReverseAxis5'.
    ^ XMLv2::XPathAxisPreceding new
!

reduceActionForReverseStep1:nodes 
    self informAboutRuleReduction:'ReverseStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:(nodes at:1);
        nodeTest:(nodes at:2);
        yourself
!

reduceActionForReverseStep2:nodes 
    self informAboutRuleReduction:'ReverseStep2'.
    ^ nodes at:1
!

reduceActionForSequenceType1:nodes 
    self informAboutRuleReduction:'SequenceType1'.
    ^ #emptyseq.
!

reduceActionForSequenceType2:nodes 
    self informAboutRuleReduction:'SequenceType2'.
    ^ nodes at:1.
!

reduceActionForSequenceType3:nodes 
    ^ self informAboutRuleReduction:'SequenceType3'

    "Created: / 08-03-2009 / 21:53:59 / Jan Kurs <kursj1@fel.cvut.cz>"
!

reduceActionForSourceExpr1:nodes 
    self informAboutRuleReduction:'SourceExpr'.
    ^ nodes at:1.
!

reduceActionForStepExpr1:nodes 
    self informAboutRuleReduction:'StepExpr1'.
    ^ nodes at:1.
!

reduceActionForStepExpr2:nodes 
    self informAboutRuleReduction:'StepExpr2'.
    ^ nodes at:1.
!

reduceActionForStringLiteral1:nodes 
    self 
        informAboutRuleReduction:'StringLiteral1 -' , ((nodes at:1) asString).
    ^ AstStringLiteral new content:((nodes at:1) value).
!

reduceActionForTargetExpr1:nodes 
    self informAboutRuleReduction:'TargetExpr'.
    ^ nodes at:1.
!

reduceActionForTextTest1:nodes 
    self informAboutRuleReduction:'TextTest1'.
    ^ XMLv2::XPathTextTest new.
!

reduceActionForTransformCopyClause1:nodes 
    self informAboutRuleReduction:'TransformCopyClause1'.
    ^ (AstTransformCopyClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).
!

reduceActionForTransformCopyClause2:nodes 
    self informAboutRuleReduction:'TransformCopyClause2'.
    ^ (AstTransformCopyClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        transformCopyClause:(nodes at:6).
!

reduceActionForTransformExpr1:nodes 
    self informAboutRuleReduction:'TransformExpr'.
    ^ (AstTransformExpr new)
        transformCopyClause:(nodes at:3);
        modifyExpr:(nodes at:5);
        returnExpr:(nodes at:7).
!

reduceActionForTypeDeclaration1:nodes 
    self informAboutRuleReduction:'TypeDeclaration1'.
    ^ nodes at:2
!

reduceActionForURILiteral1:nodes 
    ^ nodes at:1
!

reduceActionForUnaryExpr1:nodes 
    self informAboutRuleReduction:'UnaryExpr1'.
    ^ (AstUnaryExpr new)
        operand:#minus;
        unaryExpr:(nodes at:2).
!

reduceActionForUnaryExpr2:nodes 
    self informAboutRuleReduction:'UnaryExpr2'.
    ^ (AstUnaryExpr new)
        operand:#plus;
        unaryExpr:(nodes at:2).
!

reduceActionForUnaryExpr3:nodes 
    self informAboutRuleReduction:'UnaryExpr3'.
    ^ nodes at:1.
!

reduceActionForUnionExpr1:nodes 
    self informAboutRuleReduction:'UnionExpr1'.
    ^ nodes at:1.
!

reduceActionForUnionExpr2:nodes 
    self informAboutRuleReduction:'UnionExpr2'.
    ^ (AstUnionExpr new)
        intersectExceptExpr:(nodes at:1);
        unionExpr:(nodes at:3).
!

reduceActionForUnionExpr3:nodes 
    self informAboutRuleReduction:'UnionExpr3'.
    ^ (AstUnionExpr new)
        intersectExceptExpr:(nodes at:1);
        unionExpr:(nodes at:3).
!

reduceActionForUnorderedExpr1:nodes 
    self informAboutRuleReduction:'UnorderedExpr1'.
    ^ nodes at:3.
!

reduceActionForValueComp1:nodes 
    self informAboutRuleReduction:'ValueComp1'.
    ^ #eqValue.
!

reduceActionForValueComp2:nodes 
    self informAboutRuleReduction:'ValueComp2'.
    ^ #neValue.
!

reduceActionForValueComp3:nodes 
    self informAboutRuleReduction:'ValueComp3'.
    ^ #ltValue.
!

reduceActionForValueComp4:nodes 
    self informAboutRuleReduction:'ValueComp4'.
    ^ #leValue.
!

reduceActionForValueComp5:nodes 
    self informAboutRuleReduction:'ValueComp5'.
    ^ #gtValue.
!

reduceActionForValueComp6:nodes 
    self informAboutRuleReduction:'ValueComp6'.
    ^ #geValue.
!

reduceActionForValueExpr1:nodes 
    self informAboutRuleReduction:'ValueExpr'.
    ^ nodes at:1.
!

reduceActionForVarDecl1:nodes 
    self informAboutRuleReduction:'VarDecl1'.
    ^ (AstVarDecl new)
        name:(nodes at:4);
        expressionIsExternal
!

reduceActionForVarDecl2:nodes 
    self informAboutRuleReduction:'VarDecl2'.
    ^ (AstVarDecl new)
        name:(nodes at:4);
        type:(nodes at:5);
        expressionIsExternal
!

reduceActionForVarDecl3:nodes 
    self informAboutRuleReduction:'VarDecl3'.
    ^ (AstVarDecl new)
        name:(nodes at:4);
        expression:(nodes at:6)
!

reduceActionForVarDecl4:nodes 
    self informAboutRuleReduction:'VarDecl4'.
    ^ (AstVarDecl new)
        name:(nodes at:4);
        type:(nodes at:5);
        expression:(nodes at:7)
!

reduceActionForVarName1:nodes 
    self informAboutRuleReduction:'VarName1'.
    ^ nodes at:1.
!

reduceActionForVarRef1:nodes 
    self informAboutRuleReduction:'VarRef1'.
    ^ AstVarRef new varName:(nodes at:2).
!

reduceActionForWhereClause1:nodes 
    self informAboutRuleReduction:'WhereClause1'.
    ^ AstWhereClause new exprSingle:(nodes at:2).
!

reduceActionForWildcard1:nodes 
    self informAboutRuleReduction:'Wildcard1'.
    ^ AstWildcard new.

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForWildcard2:nodes 
    self informAboutRuleReduction:'Wildcard2'.
    ^ AstWildcard new ncName:(nodes at:3).

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
! !

!XQueryParser methodsFor:'generated-tables'!

reduceTable
	^#(
#(128 1 #reduceActionForNCName1:)
#(129 6 #reduceActionForDefaultNamespaceDecl1:)
#(129 6 #reduceActionForDefaultNamespaceDecl2:)
#(130 6 #reduceActionForNamespaceDecl1:)
#(131 6 #reduceActionForVarDecl1:)
#(131 7 #reduceActionForVarDecl2:)
#(131 7 #reduceActionForVarDecl3:)
#(131 8 #reduceActionForVarDecl4:)
#(132 9 #reduceActionForFunctionDecl1:)
#(133 1 #reduceActionForStringLiteral1:)
#(134 1 #reduceActionForQName1:)
#(135 2 #reduceActionForTypeDeclaration1:)
#(136 1 #reduceActionForExprSingle1:)
#(136 1 #reduceActionForExprSingle2:)
#(136 1 #reduceActionForExprSingle3:)
#(136 1 #reduceActionForExprSingle4:)
#(136 1 #reduceActionForExprSingle5:)
#(136 1 #reduceActionForExprSingle6:)
#(136 1 #reduceActionForExprSingle7:)
#(136 1 #reduceActionForExprSingle8:)
#(136 1 #reduceActionForExprSingle9:)
#(137 0 #'reduceActionForOptional___updating_1:')
#(137 1 #'reduceActionForOptional___updating_2:')
#(138 1 #reduceActionForParamList1:)
#(138 1 #reduceActionForParamList2:)
#(139 3 #reduceActionForEnclosedExpr1:)
#(140 3 #reduceActionForOneOrMoreParamList1:)
#(140 1 #reduceActionForOneOrMoreParamList2:)
#(141 0 #reduceActionForEmptyParamList1:)
#(142 2 #reduceActionForParam1:)
#(143 1 #reduceActionForExpr1:)
#(143 3 #reduceActionForExpr2:)
#(144 3 #reduceActionForFLWORExpr1:)
#(144 4 #reduceActionForFLWORExpr2:)
#(144 4 #reduceActionForFLWORExpr3:)
#(144 5 #reduceActionForFLWORExpr4:)
#(145 4 #reduceActionForQuantifiedExpr1:)
#(145 4 #reduceActionForQuantifiedExpr2:)
#(146 8 #reduceActionForIfExpr1:)
#(147 1 #reduceActionForOrExpr1:)
#(147 3 #reduceActionForOrExpr2:)
#(148 3 #reduceActionForDeleteExpr1:)
#(149 5 #reduceActionForRenameExpr1:)
#(150 3 #reduceActionForReplaceExpr1:)
#(151 3 #reduceActionForInsertExpr1:)
#(152 7 #reduceActionForTransformExpr1:)
#(153 1 #'reduceActionForFLWORExpr_ForLet1:')
#(153 1 #'reduceActionForFLWORExpr_ForLet2:')
#(153 2 #'reduceActionForFLWORExpr_ForLet3:')
#(153 2 #'reduceActionForFLWORExpr_ForLet4:')
#(154 2 #reduceActionForWhereClause1:)
#(155 3 #reduceActionForOrderByClause1:)
#(155 4 #reduceActionForOrderByClause2:)
#(156 2 #reduceActionForForClause1:)
#(157 2 #reduceActionForLetClause1:)
#(158 4 #'reduceActionForForClause_Impl1:')
#(158 6 #'reduceActionForForClause_Impl2:')
#(158 5 #'reduceActionForForClause_Impl3:')
#(158 7 #'reduceActionForForClause_Impl4:')
#(159 1 #reduceActionForVarName1:)
#(160 3 #reduceActionForPositionalVar1:)
#(161 4 #'reduceActionForLetClause_Impl1:')
#(161 6 #'reduceActionForLetClause_Impl2:')
#(162 1 #reduceActionForOrderSpecList1:)
#(162 3 #reduceActionForOrderSpecList2:)
#(163 1 #reduceActionForOrderSpec1:)
#(163 2 #reduceActionForOrderSpec2:)
#(164 1 #reduceActionForOrderModifier1:)
#(164 1 #reduceActionForOrderModifier2:)
#(164 2 #reduceActionForOrderModifier3:)
#(165 1 #'reduceActionForOrderModifier_AscDesc1:')
#(165 1 #'reduceActionForOrderModifier_AscDesc2:')
#(166 2 #'reduceActionForOrderModifier_GreatestLeast1:')
#(166 2 #'reduceActionForOrderModifier_GreatestLeast2:')
#(167 4 #'reduceActionForQuantifiedExpr_Impl1:')
#(167 6 #'reduceActionForQuantifiedExpr_Impl2:')
#(168 1 #reduceActionForAndExpr1:)
#(168 3 #reduceActionForAndExpr2:)
#(169 1 #reduceActionForComparisonExpr1:)
#(169 3 #reduceActionForComparisonExpr2:)
#(169 3 #reduceActionForComparisonExpr3:)
#(169 3 #reduceActionForComparisonExpr4:)
#(170 1 #reduceActionForRangeExpr1:)
#(170 3 #reduceActionForRangeExpr2:)
#(171 1 #reduceActionForValueComp1:)
#(171 1 #reduceActionForValueComp2:)
#(171 1 #reduceActionForValueComp3:)
#(171 1 #reduceActionForValueComp4:)
#(171 1 #reduceActionForValueComp5:)
#(171 1 #reduceActionForValueComp6:)
#(172 1 #reduceActionForGeneralComp1:)
#(172 1 #reduceActionForGeneralComp2:)
#(172 1 #reduceActionForGeneralComp3:)
#(172 1 #reduceActionForGeneralComp4:)
#(172 1 #reduceActionForGeneralComp5:)
#(172 1 #reduceActionForGeneralComp6:)
#(173 1 #reduceActionForNodeComp1:)
#(173 1 #reduceActionForNodeComp2:)
#(173 1 #reduceActionForNodeComp3:)
#(174 1 #reduceActionForAdditiveExpr1:)
#(174 3 #reduceActionForAdditiveExpr2:)
#(174 3 #reduceActionForAdditiveExpr3:)
#(175 1 #reduceActionForMultiplicativeExpr1:)
#(175 3 #reduceActionForMultiplicativeExpr2:)
#(175 3 #reduceActionForMultiplicativeExpr3:)
#(175 3 #reduceActionForMultiplicativeExpr4:)
#(175 3 #reduceActionForMultiplicativeExpr5:)
#(176 1 #reduceActionForUnionExpr1:)
#(176 3 #reduceActionForUnionExpr2:)
#(176 3 #reduceActionForUnionExpr3:)
#(177 1 #reduceActionForIntersectExceptExpr1:)
#(177 3 #reduceActionForIntersectExceptExpr2:)
#(177 3 #reduceActionForIntersectExceptExpr3:)
#(178 1 #reduceActionForInstanceOfExpr1:)
#(178 4 #reduceActionForInstanceOfExpr2:)
#(179 2 #reduceActionForUnaryExpr1:)
#(179 2 #reduceActionForUnaryExpr2:)
#(179 1 #reduceActionForUnaryExpr3:)
#(180 3 #reduceActionForSequenceType1:)
#(180 1 #reduceActionForSequenceType2:)
#(181 2 #reduceActionForProlog1:)
#(182 1 #reduceActionForKindTest1:)
#(182 1 #reduceActionForKindTest2:)
#(182 1 #reduceActionForKindTest3:)
#(182 1 #reduceActionForKindTest4:)
#(182 1 #reduceActionForKindTest5:)
#(182 3 #reduceActionForKindTest6:)
#(182 3 #reduceActionForKindTest7:)
#(183 1 #reduceActionForAtomicType1:)
#(184 1 #reduceActionForOccurenceIndicator1:)
#(184 1 #reduceActionForOccurenceIndicator2:)
#(184 1 #reduceActionForOccurenceIndicator3:)
#(185 1 #reduceActionForValueExpr1:)
#(186 2 #reduceActionForPathExpr1:)
#(186 2 #reduceActionForPathExpr2:)
#(186 1 #reduceActionForPathExpr3:)
#(187 1 #reduceActionForRelativePathExpr1:)
#(187 3 #reduceActionForRelativePathExpr2:)
#(187 3 #reduceActionForRelativePathExpr3:)
#(188 1 #reduceActionForStepExpr1:)
#(188 1 #reduceActionForStepExpr2:)
#(189 2 #reduceActionForAxisStep1:)
#(189 2 #reduceActionForAxisStep2:)
#(190 2 #reduceActionForFilterExpr1:)
#(191 2 #reduceActionForForwardStep1:)
#(191 1 #reduceActionForForwardStep2:)
#(192 3 #reduceActionForPredicate1:)
#(192 2 #reduceActionForPredicate2:)
#(193 0 #'reduceActionForRepeat__Predicate1:')
#(193 2 #'reduceActionForRepeat__Predicate2:')
#(194 2 #reduceActionForReverseStep1:)
#(194 1 #reduceActionForReverseStep2:)
#(195 2 #reduceActionForForwardAxis1:)
#(195 2 #reduceActionForForwardAxis2:)
#(195 2 #reduceActionForForwardAxis3:)
#(195 2 #reduceActionForForwardAxis4:)
#(195 2 #reduceActionForForwardAxis5:)
#(195 2 #reduceActionForForwardAxis6:)
#(195 2 #reduceActionForForwardAxis7:)
#(196 1 #reduceActionForNodeTest1:)
#(196 1 #reduceActionForNodeTest2:)
#(197 2 #reduceActionForAbbrevForwardStep1:)
#(197 1 #reduceActionForAbbrevForwardStep2:)
#(198 2 #reduceActionForReverseAxis1:)
#(198 2 #reduceActionForReverseAxis2:)
#(198 2 #reduceActionForReverseAxis3:)
#(198 2 #reduceActionForReverseAxis4:)
#(198 2 #reduceActionForReverseAxis5:)
#(199 1 #reduceActionForAbbrevReverseStep1:)
#(200 1 #reduceActionForNameTest1:)
#(200 1 #reduceActionForNameTest2:)
#(200 3 #reduceActionForNameTest3:)
#(201 1 #reduceActionForPrimaryExpr1:)
#(201 1 #reduceActionForPrimaryExpr2:)
#(201 1 #reduceActionForPrimaryExpr3:)
#(201 1 #reduceActionForPrimaryExpr4:)
#(201 1 #reduceActionForPrimaryExpr5:)
#(201 1 #reduceActionForPrimaryExpr6:)
#(201 1 #reduceActionForPrimaryExpr7:)
#(201 1 #reduceActionForPrimaryExpr8:)
#(202 1 #reduceActionForLiteral1:)
#(202 1 #reduceActionForLiteral2:)
#(203 2 #reduceActionForVarRef1:)
#(204 2 #reduceActionForParenthesizedExpr1:)
#(204 3 #reduceActionForParenthesizedExpr2:)
#(205 1 #reduceActionForContextItemExpr1:)
#(206 3 #reduceActionForFunctionCall1:)
#(206 4 #reduceActionForFunctionCall2:)
#(207 1 #reduceActionForConstructor1:)
#(207 1 #reduceActionForConstructor2:)
#(208 4 #reduceActionForOrderedExpr1:)
#(209 4 #reduceActionForUnorderedExpr1:)
#(210 1 #reduceActionForNumericLiteral1:)
#(210 1 #reduceActionForNumericLiteral2:)
#(210 1 #reduceActionForNumericLiteral3:)
#(211 1 #reduceActionForIntegerLiteral1:)
#(212 1 #reduceActionForDecimalLiteral1:)
#(213 1 #reduceActionForDoubleLiteral1:)
#(214 1 #reduceActionForFunctionParametersList1:)
#(214 3 #reduceActionForFunctionParametersList2:)
#(215 1 #reduceActionForDirectConstructor1:)
#(216 1 #reduceActionForComputedConstructor1:)
#(216 1 #reduceActionForComputedConstructor2:)
#(216 1 #reduceActionForComputedConstructor3:)
#(216 1 #reduceActionForComputedConstructor4:)
#(217 3 #reduceActionForDirElemConstructor1:)
#(217 4 #reduceActionForDirElemConstructor2:)
#(217 7 #reduceActionForDirElemConstructor3:)
#(217 8 #reduceActionForDirElemConstructor4:)
#(218 3 #reduceActionForDirAttributeList1:)
#(218 4 #reduceActionForDirAttributeList2:)
#(219 1 #reduceActionForDirElemContent1:)
#(219 2 #reduceActionForDirElemContent2:)
#(219 1 #reduceActionForDirElemContent3:)
#(219 2 #reduceActionForDirElemContent4:)
#(220 1 #reduceActionForDirAttributeValue1:)
#(220 1 #reduceActionForDirAttributeValue2:)
#(221 1 #reduceActionForCommonContent1:)
#(221 1 #reduceActionForCommonContent2:)
#(221 1 #reduceActionForCommonContent3:)
#(221 1 #reduceActionForCommonContent4:)
#(221 1 #reduceActionForCommonContent5:)
#(222 1 #reduceActionForPredefinedEntityRef1:)
#(223 4 #reduceActionForCompDocConstructor1:)
#(224 4 #reduceActionForCompElemConstructor1:)
#(224 5 #reduceActionForCompElemConstructor2:)
#(224 6 #reduceActionForCompElemConstructor3:)
#(224 7 #reduceActionForCompElemConstructor4:)
#(225 4 #reduceActionForCompAttrConstructor1:)
#(225 5 #reduceActionForCompAttrConstructor2:)
#(225 6 #reduceActionForCompAttrConstructor3:)
#(225 7 #reduceActionForCompAttrConstructor4:)
#(226 4 #reduceActionForCompTextConstructor1:)
#(227 1 #reduceActionForContentExpr1:)
#(228 3 #reduceActionForDocumentTest1:)
#(228 4 #reduceActionForDocumentTest2:)
#(229 3 #reduceActionForElementTest1:)
#(229 4 #reduceActionForElementTest2:)
#(230 3 #reduceActionForAttributeTest1:)
#(230 4 #reduceActionForAttributeTest2:)
#(231 3 #reduceActionForTextTest1:)
#(232 3 #reduceActionForAnyKindTest1:)
#(233 1 #reduceActionForAttribNameOrWildcard1:)
#(233 1 #reduceActionForAttribNameOrWildcard2:)
#(234 1 #reduceActionForAttributeName1:)
#(235 1 #reduceActionForElementNameOrWildcard1:)
#(235 1 #reduceActionForElementNameOrWildcard2:)
#(236 1 #reduceActionForElementName1:)
#(237 1 #reduceActionForPrologDeclarationClassB1:)
#(237 1 #reduceActionForPrologDeclarationClassB2:)
#(237 1 #reduceActionForPrologDeclarationClassB3:)
#(237 1 #reduceActionForPrologDeclarationClassB4:)
#(238 0 #'reduceActionForRepeat__PrologDeclarationClassA1:')
#(238 2 #'reduceActionForRepeat__PrologDeclarationClassA2:')
#(239 4 #reduceActionForPrologDeclarationClassA1:)
#(239 7 #reduceActionForPrologDeclarationClassA2:)
#(240 0 #'reduceActionForRepeat__PrologDeclarationClassB1:')
#(240 2 #'reduceActionForRepeat__PrologDeclarationClassB2:')
#(241 1 #reduceFor:)
#(242 3 #reduceActionForItemType1:)
#(242 1 #reduceActionForItemType2:)
#(242 1 #reduceActionForItemType3:)
#(243 1 #reduceActionForQueryBody1:)
#(244 1 #reduceActionForTargetExpr1:)
#(245 1 #reduceActionForNewNameExpr1:)
#(246 5 #reduceActionForReplaceClause1:)
#(246 3 #reduceActionForReplaceClause2:)
#(247 3 #reduceActionForInsertClause1:)
#(247 5 #reduceActionForInsertClause2:)
#(247 5 #reduceActionForInsertClause3:)
#(247 3 #reduceActionForInsertClause4:)
#(247 3 #reduceActionForInsertClause5:)
#(248 1 #reduceActionForSourceExpr1:)
#(249 4 #reduceActionForTransformCopyClause1:)
#(249 6 #reduceActionForTransformCopyClause2:)
#(252 2 #reduceActionForMainModule1:)
#(253 1 #reduceActionForURILiteral1:)
)
!

transitionTable
	^#(
#[1 3 246 0 5 3 246 0 7 3 246 0 9 3 246 0 12 3 246 0 13 3 246 0 14 3 246 0 30 3 246 0 31 3 246 0 36 3 246 0 37 3 246 0 38 3 246 0 49 3 246 0 56 3 246 0 59 3 246 0 61 3 246 0 62 3 246 0 63 3 246 0 65 3 246 0 67 3 246 0 68 3 246 0 69 3 246 0 71 3 246 0 72 3 246 0 73 3 246 0 82 3 246 0 95 3 246 0 97 3 246 0 103 3 246 0 106 3 246 0 107 3 246 0 108 3 246 0 109 3 246 0 110 3 246 0 111 3 246 0 112 3 246 0 113 3 246 0 114 3 246 0 115 3 246 0 116 3 246 0 117 3 246 0 118 3 246 0 122 3 246 0 123 3 246 0 124 3 246 0 125 3 246 0 127 0 13 0 181 0 17 0 238 0 21 0 252]
#[1 3 246 0 5 3 246 0 7 3 246 0 9 3 246 0 12 3 246 0 13 3 246 0 14 3 246 0 30 3 246 0 31 3 246 0 36 3 246 0 37 3 246 0 38 3 246 0 49 3 246 0 56 3 246 0 59 3 246 0 61 3 246 0 62 3 246 0 63 3 246 0 65 3 246 0 67 3 246 0 68 3 246 0 69 3 246 0 71 3 246 0 72 3 246 0 73 3 246 0 82 3 246 0 95 3 246 0 97 3 246 0 103 3 246 0 106 3 246 0 107 3 246 0 108 3 246 0 109 3 246 0 110 3 246 0 111 3 246 0 112 3 246 0 113 3 246 0 114 3 246 0 115 3 246 0 116 3 246 0 117 3 246 0 118 3 246 0 122 3 246 0 123 3 246 0 124 3 246 0 125 3 246 0 127 0 13 0 181 0 17 0 238 0 25 0 252]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 0 217 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 1 209 0 243]
#[1 4 6 0 5 4 6 0 7 4 6 0 9 4 6 0 12 4 6 0 13 4 6 0 14 4 6 0 30 4 6 0 31 4 6 0 36 4 6 0 37 1 213 0 38 4 6 0 49 4 6 0 56 4 6 0 59 4 6 0 61 4 6 0 62 4 6 0 63 4 6 0 65 4 6 0 67 4 6 0 68 4 6 0 69 4 6 0 71 4 6 0 72 4 6 0 73 4 6 0 82 4 6 0 95 4 6 0 97 4 6 0 103 4 6 0 106 4 6 0 107 4 6 0 108 4 6 0 109 4 6 0 110 4 6 0 111 4 6 0 112 4 6 0 113 4 6 0 114 4 6 0 115 4 6 0 116 4 6 0 117 4 6 0 118 4 6 0 122 4 6 0 123 4 6 0 124 4 6 0 125 4 6 0 127 1 217 0 239 1 221 0 240]
#[0 0 0 0 250]
#[0 0 0 0 250]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 1 225 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 1 229 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 1 233 0 37 1 237 0 167]
#[0 1 241 0 56]
#[1 2 174 0 1 2 174 0 2 2 174 0 3 2 174 0 4 2 174 0 5 2 174 0 7 2 174 0 10 2 174 0 11 2 174 0 13 2 174 0 16 2 174 0 20 2 174 0 21 2 174 0 23 2 174 0 24 2 174 0 25 2 174 0 26 2 174 0 27 2 174 0 28 2 174 0 29 2 174 0 30 2 174 0 40 2 174 0 42 2 174 0 45 2 174 0 46 2 174 0 47 2 174 0 49 2 174 0 50 2 174 0 52 2 174 0 53 2 174 0 54 2 174 0 55 2 174 0 58 2 174 0 59 2 174 0 60 2 174 0 74 2 174 0 75 2 174 0 77 2 174 0 78 2 174 0 81 2 174 0 88 2 174 0 89 2 174 0 90 2 174 0 91 2 174 0 92 2 174 0 93 2 174 0 94 2 174 0 95 2 174 0 96 2 174 0 97 2 174 0 98 2 174 0 99 2 174 0 100 2 174 0 102 2 174 0 104 1 245 0 105 2 174 0 250]
#[1 1 233 0 37 1 249 0 167]
#[1 0 185 0 122 1 253 0 134]
#[1 2 1 0 56 2 5 0 70 0 185 0 122 2 9 0 134]
#[1 0 185 0 122 2 13 0 134 2 17 0 159]
#[1 2 21 0 37 2 25 0 161]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 2 29 0 53 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 2 33 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 2 37 0 37 2 41 0 158]
#[0 2 45 0 70]
#[1 2 49 0 56 2 53 0 70]
#[0 2 57 0 56]
#[0 2 61 0 56]
#[0 2 65 0 56]
#[0 2 234 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 69 0 70]
#[1 2 73 0 83 2 77 0 84 2 81 0 86 2 85 0 87]
#[0 2 89 0 70]
#[0 2 93 0 56]
#[0 2 97 0 80]
#[1 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 1 49 0 182 2 101 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 1 49 0 182 2 105 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 2 109 0 101]
#[0 2 113 0 101]
#[0 2 117 0 101]
#[0 2 121 0 101]
#[0 2 125 0 101]
#[0 2 166 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 129 0 101]
#[0 2 133 0 101]
#[1 2 137 0 56 2 141 0 70 2 145 0 101 0 185 0 122 2 149 0 134]
#[0 2 153 0 101]
#[0 2 157 0 101]
#[1 0 45 0 13 2 161 0 31 2 165 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 113 0 73 2 169 0 113 0 185 0 122 2 173 0 134 1 49 0 182 2 177 0 196 1 105 0 200 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 2 181 0 101]
#[0 2 185 0 101]
#[0 0 46 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 64 0 66 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 3 18 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 3 22 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 3 26 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 0 42 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 66 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 2 218 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[1 2 170 0 1 2 170 0 2 2 170 0 3 2 170 0 4 2 170 0 5 2 170 0 7 2 170 0 10 2 170 0 11 2 170 0 13 2 170 0 16 2 170 0 20 2 170 0 21 2 170 0 23 2 170 0 24 2 170 0 25 2 170 0 26 2 170 0 27 2 170 0 28 2 170 0 29 2 170 0 30 2 170 0 40 2 170 0 42 2 170 0 45 2 170 0 46 2 170 0 47 2 170 0 49 2 170 0 50 2 170 0 52 2 170 0 53 2 170 0 54 2 170 0 55 2 189 0 56 2 170 0 58 2 170 0 59 2 170 0 60 2 170 0 74 2 170 0 75 2 170 0 77 2 170 0 78 2 170 0 81 2 170 0 88 2 170 0 89 2 170 0 90 2 170 0 91 2 170 0 92 2 170 0 93 2 170 0 94 2 170 0 95 2 170 0 96 2 170 0 97 2 170 0 98 2 170 0 99 2 170 0 100 2 170 0 102 2 170 0 104 2 170 0 250]
#[1 0 126 0 53 2 193 0 54 0 126 0 74 0 126 0 75 0 126 0 250]
#[0 4 30 0 250]
#[0 0 54 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 58 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 62 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 66 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 70 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 74 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 78 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 82 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 86 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[1 2 197 0 46 2 201 0 47 2 205 0 52 2 209 0 55 2 213 0 154 2 217 0 155]
#[1 0 190 0 46 0 190 0 47 0 65 0 49 0 190 0 52 0 190 0 55 0 73 0 59 2 221 0 153 1 5 0 156 1 9 0 157]
#[1 0 194 0 46 0 194 0 47 0 65 0 49 0 194 0 52 0 194 0 55 0 73 0 59 2 225 0 153 1 5 0 156 1 9 0 157]
#[1 2 229 0 1 0 162 0 4 0 162 0 10 0 162 0 16 0 162 0 28 0 162 0 40 0 162 0 46 0 162 0 47 0 162 0 49 0 162 0 50 0 162 0 52 0 162 0 53 0 162 0 54 0 162 0 55 0 162 0 58 0 162 0 59 0 162 0 60 0 162 0 74 0 162 0 75 0 162 0 77 0 162 0 78 0 162 0 81 0 162 0 89 0 162 0 250]
#[1 1 54 0 1 2 233 0 2 1 54 0 4 1 54 0 10 1 54 0 16 1 54 0 28 1 54 0 40 1 54 0 46 1 54 0 47 1 54 0 49 1 54 0 50 1 54 0 52 1 54 0 53 1 54 0 54 1 54 0 55 1 54 0 58 1 54 0 59 1 54 0 60 1 54 0 74 1 54 0 75 1 54 0 77 1 54 0 78 1 54 0 81 1 54 0 89 1 54 0 250]
#[1 1 62 0 1 1 62 0 2 1 62 0 4 1 62 0 10 1 62 0 16 2 237 0 20 1 62 0 28 2 241 0 30 1 62 0 40 2 245 0 42 2 249 0 45 1 62 0 46 1 62 0 47 1 62 0 49 1 62 0 50 1 62 0 52 1 62 0 53 1 62 0 54 1 62 0 55 1 62 0 58 1 62 0 59 1 62 0 60 1 62 0 74 1 62 0 75 1 62 0 77 1 62 0 78 1 62 0 81 1 62 0 89 2 253 0 90 3 1 0 91 3 5 0 92 3 9 0 93 3 13 0 94 3 17 0 96 3 21 0 98 3 25 0 99 3 29 0 100 3 33 0 102 3 37 0 104 3 41 0 171 3 45 0 172 3 49 0 173 1 62 0 250]
#[1 1 78 0 1 1 78 0 2 3 53 0 3 1 78 0 4 1 78 0 10 1 78 0 16 1 78 0 20 1 78 0 28 1 78 0 30 1 78 0 40 1 78 0 42 1 78 0 45 1 78 0 46 1 78 0 47 1 78 0 49 1 78 0 50 1 78 0 52 1 78 0 53 1 78 0 54 1 78 0 55 1 78 0 58 1 78 0 59 1 78 0 60 1 78 0 74 1 78 0 75 1 78 0 77 1 78 0 78 1 78 0 81 1 78 0 89 1 78 0 90 1 78 0 91 1 78 0 92 1 78 0 93 1 78 0 94 1 78 0 96 1 78 0 98 1 78 0 99 1 78 0 100 1 78 0 102 1 78 0 104 1 78 0 250]
#[1 1 146 0 1 1 146 0 2 1 146 0 3 1 146 0 4 3 57 0 5 3 61 0 7 1 146 0 10 1 146 0 16 1 146 0 20 1 146 0 28 1 146 0 30 1 146 0 40 1 146 0 42 1 146 0 45 1 146 0 46 1 146 0 47 1 146 0 49 1 146 0 50 1 146 0 52 1 146 0 53 1 146 0 54 1 146 0 55 1 146 0 58 1 146 0 59 1 146 0 60 1 146 0 74 1 146 0 75 1 146 0 77 1 146 0 78 1 146 0 81 1 146 0 89 1 146 0 90 1 146 0 91 1 146 0 92 1 146 0 93 1 146 0 94 1 146 0 96 1 146 0 98 1 146 0 99 1 146 0 100 1 146 0 102 1 146 0 104 1 146 0 250]
#[1 1 158 0 1 1 158 0 2 1 158 0 3 1 158 0 4 1 158 0 5 1 158 0 7 1 158 0 10 3 65 0 11 3 69 0 13 1 158 0 16 1 158 0 20 3 73 0 23 3 77 0 26 1 158 0 28 1 158 0 30 1 158 0 40 1 158 0 42 1 158 0 45 1 158 0 46 1 158 0 47 1 158 0 49 1 158 0 50 1 158 0 52 1 158 0 53 1 158 0 54 1 158 0 55 1 158 0 58 1 158 0 59 1 158 0 60 1 158 0 74 1 158 0 75 1 158 0 77 1 158 0 78 1 158 0 81 1 158 0 89 1 158 0 90 1 158 0 91 1 158 0 92 1 158 0 93 1 158 0 94 1 158 0 96 1 158 0 98 1 158 0 99 1 158 0 100 1 158 0 102 1 158 0 104 1 158 0 250]
#[1 1 178 0 1 1 178 0 2 1 178 0 3 1 178 0 4 1 178 0 5 1 178 0 7 1 178 0 10 1 178 0 11 1 178 0 13 1 178 0 16 1 178 0 20 1 178 0 23 3 81 0 24 3 85 0 25 1 178 0 26 1 178 0 28 1 178 0 30 1 178 0 40 1 178 0 42 1 178 0 45 1 178 0 46 1 178 0 47 1 178 0 49 1 178 0 50 1 178 0 52 1 178 0 53 1 178 0 54 1 178 0 55 1 178 0 58 1 178 0 59 1 178 0 60 1 178 0 74 1 178 0 75 1 178 0 77 1 178 0 78 1 178 0 81 1 178 0 89 1 178 0 90 1 178 0 91 1 178 0 92 1 178 0 93 1 178 0 94 1 178 0 96 1 178 0 98 1 178 0 99 1 178 0 100 1 178 0 102 1 178 0 104 1 178 0 250]
#[1 1 190 0 1 1 190 0 2 1 190 0 3 1 190 0 4 1 190 0 5 1 190 0 7 1 190 0 10 1 190 0 11 1 190 0 13 1 190 0 16 1 190 0 20 1 190 0 23 1 190 0 24 1 190 0 25 1 190 0 26 3 89 0 27 1 190 0 28 3 93 0 29 1 190 0 30 1 190 0 40 1 190 0 42 1 190 0 45 1 190 0 46 1 190 0 47 1 190 0 49 1 190 0 50 1 190 0 52 1 190 0 53 1 190 0 54 1 190 0 55 1 190 0 58 1 190 0 59 1 190 0 60 1 190 0 74 1 190 0 75 1 190 0 77 1 190 0 78 1 190 0 81 1 190 0 89 1 190 0 90 1 190 0 91 1 190 0 92 1 190 0 93 1 190 0 94 1 190 0 96 1 190 0 98 1 190 0 99 1 190 0 100 1 190 0 102 1 190 0 104 1 190 0 250]
#[1 1 202 0 1 1 202 0 2 1 202 0 3 1 202 0 4 1 202 0 5 1 202 0 7 1 202 0 10 1 202 0 11 1 202 0 13 1 202 0 16 1 202 0 20 3 97 0 21 1 202 0 23 1 202 0 24 1 202 0 25 1 202 0 26 1 202 0 27 1 202 0 28 1 202 0 29 1 202 0 30 1 202 0 40 1 202 0 42 1 202 0 45 1 202 0 46 1 202 0 47 1 202 0 49 1 202 0 50 1 202 0 52 1 202 0 53 1 202 0 54 1 202 0 55 1 202 0 58 1 202 0 59 1 202 0 60 1 202 0 74 1 202 0 75 1 202 0 77 1 202 0 78 1 202 0 81 1 202 0 89 1 202 0 90 1 202 0 91 1 202 0 92 1 202 0 93 1 202 0 94 1 202 0 96 1 202 0 98 1 202 0 99 1 202 0 100 1 202 0 102 1 202 0 104 1 202 0 250]
#[0 2 134 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 218 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 22 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 2 34 0 1 2 34 0 2 2 34 0 3 2 34 0 4 2 34 0 5 2 34 0 7 2 34 0 10 2 34 0 11 2 34 0 13 2 34 0 16 2 34 0 20 2 34 0 21 2 34 0 23 2 34 0 24 2 34 0 25 2 34 0 26 2 34 0 27 2 34 0 28 2 34 0 29 2 34 0 30 2 34 0 40 2 34 0 42 2 34 0 45 2 34 0 46 2 34 0 47 2 34 0 49 2 34 0 50 2 34 0 52 2 34 0 53 2 34 0 54 2 34 0 55 2 34 0 58 2 34 0 59 2 34 0 60 2 34 0 74 2 34 0 75 2 34 0 77 2 34 0 78 2 34 0 81 2 34 0 89 2 34 0 90 2 34 0 91 2 34 0 92 2 34 0 93 2 34 0 94 3 101 0 95 2 34 0 96 3 105 0 97 2 34 0 98 2 34 0 99 2 34 0 100 2 34 0 102 2 34 0 104 2 34 0 250]
#[0 2 38 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 50 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 54 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 2 86 0 1 2 86 0 2 2 86 0 3 2 86 0 4 2 86 0 5 2 86 0 7 2 86 0 10 2 86 0 11 2 86 0 13 2 86 0 16 2 86 0 20 2 86 0 21 2 86 0 23 2 86 0 24 2 86 0 25 2 86 0 26 2 86 0 27 2 86 0 28 2 86 0 29 2 86 0 30 2 86 0 40 2 86 0 42 2 86 0 45 2 86 0 46 2 86 0 47 2 86 0 49 2 86 0 50 2 86 0 52 2 86 0 53 2 86 0 54 2 86 0 55 2 86 0 58 2 86 0 59 2 86 0 60 2 86 0 74 2 86 0 75 2 86 0 77 2 86 0 78 2 86 0 81 2 86 0 88 2 86 0 89 2 86 0 90 2 86 0 91 2 86 0 92 2 86 0 93 2 86 0 94 2 86 0 95 2 86 0 96 2 86 0 97 2 86 0 98 2 86 0 99 2 86 0 100 2 86 0 102 2 86 0 104 3 109 0 193 2 86 0 250]
#[1 2 86 0 1 2 86 0 2 2 86 0 3 2 86 0 4 2 86 0 5 2 86 0 7 2 86 0 10 2 86 0 11 2 86 0 13 2 86 0 16 2 86 0 20 2 86 0 21 2 86 0 23 2 86 0 24 2 86 0 25 2 86 0 26 2 86 0 27 2 86 0 28 2 86 0 29 2 86 0 30 2 86 0 40 2 86 0 42 2 86 0 45 2 86 0 46 2 86 0 47 2 86 0 49 2 86 0 50 2 86 0 52 2 86 0 53 2 86 0 54 2 86 0 55 2 86 0 58 2 86 0 59 2 86 0 60 2 86 0 74 2 86 0 75 2 86 0 77 2 86 0 78 2 86 0 81 2 86 0 88 2 86 0 89 2 86 0 90 2 86 0 91 2 86 0 92 2 86 0 93 2 86 0 94 2 86 0 95 2 86 0 96 2 86 0 97 2 86 0 98 2 86 0 99 2 86 0 100 2 86 0 102 2 86 0 104 3 113 0 193 2 86 0 250]
#[1 0 45 0 13 2 161 0 31 2 165 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 113 0 73 2 169 0 113 0 185 0 122 2 173 0 134 1 49 0 182 3 117 0 196 1 105 0 200 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 2 142 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 74 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 0 45 0 13 2 161 0 31 2 165 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 113 0 73 2 169 0 113 0 185 0 122 2 173 0 134 1 49 0 182 3 121 0 196 1 105 0 200 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 2 98 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 130 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 2 86 0 1 2 86 0 2 2 86 0 3 2 86 0 4 2 86 0 5 2 86 0 7 2 86 0 10 2 86 0 11 2 86 0 13 2 86 0 16 2 86 0 20 2 86 0 21 2 86 0 23 2 86 0 24 2 86 0 25 2 86 0 26 2 86 0 27 2 86 0 28 2 86 0 29 2 86 0 30 2 86 0 40 2 86 0 42 2 86 0 45 2 86 0 46 2 86 0 47 2 86 0 49 2 86 0 50 2 86 0 52 2 86 0 53 2 86 0 54 2 86 0 55 2 86 0 58 2 86 0 59 2 86 0 60 2 86 0 74 2 86 0 75 2 86 0 77 2 86 0 78 2 86 0 81 2 86 0 88 2 86 0 89 2 86 0 90 2 86 0 91 2 86 0 92 2 86 0 93 2 86 0 94 2 86 0 95 2 86 0 96 2 86 0 97 2 86 0 98 2 86 0 99 2 86 0 100 2 86 0 102 2 86 0 104 3 125 0 193 2 86 0 250]
#[0 2 182 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 186 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 190 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 194 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 198 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 202 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 206 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 210 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 214 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 3 6 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 3 10 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 3 14 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 2 246 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 250 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 38 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 3 42 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 46 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 50 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 54 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 234 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 238 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 242 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 246 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 250 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 4 82 0 250]
#[0 3 129 0 39]
#[0 3 250 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 38 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[1 1 230 0 5 1 230 0 7 1 230 0 9 1 230 0 12 1 230 0 13 1 230 0 14 1 230 0 30 1 230 0 31 3 133 0 36 1 230 0 37 1 230 0 49 1 230 0 56 1 230 0 59 1 230 0 61 1 230 0 62 1 230 0 63 1 230 0 65 1 230 0 67 1 230 0 68 1 230 0 69 1 230 0 71 1 230 0 72 1 230 0 73 1 230 0 82 1 230 0 95 1 230 0 97 1 230 0 103 1 230 0 106 1 230 0 107 1 230 0 108 1 230 0 109 1 230 0 110 1 230 0 111 1 230 0 112 1 230 0 113 1 230 0 114 1 230 0 115 1 230 0 116 1 230 0 117 1 230 0 118 1 230 0 122 1 230 0 123 1 230 0 124 1 230 0 125 1 230 0 127 3 137 0 129 3 141 0 130 3 145 0 131 3 149 0 132 3 153 0 237]
#[0 1 210 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 214 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 0 185 0 122 2 13 0 134 3 157 0 159]
#[0 3 161 0 10]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 3 165 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 3 169 0 121 3 173 0 128]
#[0 3 177 0 10]
#[1 3 181 0 66 3 185 0 90 0 185 0 122 3 189 0 134 3 193 0 218]
#[1 3 197 0 13 3 201 0 53 0 185 0 122 3 205 0 134 3 209 0 235 3 213 0 236]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 3 217 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 221 0 70]
#[0 0 242 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 222 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 0 185 0 122 2 13 0 134 3 225 0 159]
#[0 0 222 0 46 0 47 0 49 0 52 0 55 0 59]
#[0 2 226 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 229 0 53]
#[1 0 185 0 122 2 13 0 134 3 233 0 159]
#[0 0 218 0 46 0 47 0 49 0 52 0 55 0 59]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 3 237 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 241 0 53]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 3 245 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 249 0 53]
#[0 3 253 0 53]
#[0 4 1 0 53]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 4 5 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 4 13 0 244]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 4 17 0 85 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 4 21 0 244 4 25 0 246]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 4 29 0 244]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 33 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 4 37 0 247 4 41 0 248]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 4 45 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 2 161 0 31 4 49 0 53 4 53 0 229]
#[1 4 57 0 37 4 61 0 249]
#[1 2 30 0 1 2 30 0 2 2 30 0 3 2 30 0 4 2 30 0 5 2 30 0 7 2 30 0 10 2 30 0 11 2 30 0 13 2 30 0 16 2 30 0 20 2 30 0 21 2 30 0 23 2 30 0 24 2 30 0 25 2 30 0 26 2 30 0 27 2 30 0 28 2 30 0 29 2 30 0 30 2 30 0 40 2 30 0 42 2 30 0 45 2 30 0 46 2 30 0 47 2 30 0 49 2 30 0 50 2 30 0 52 2 30 0 53 2 30 0 54 2 30 0 55 2 30 0 58 2 30 0 59 2 30 0 60 2 30 0 74 2 30 0 75 2 30 0 77 2 30 0 78 2 30 0 81 2 30 0 89 2 30 0 90 2 30 0 91 2 30 0 92 2 30 0 93 2 30 0 94 3 101 0 95 2 30 0 96 3 105 0 97 2 30 0 98 2 30 0 99 2 30 0 100 2 30 0 102 2 30 0 104 2 30 0 250]
#[1 2 26 0 1 2 26 0 2 2 26 0 3 2 26 0 4 2 26 0 5 2 26 0 7 2 26 0 10 2 26 0 11 2 26 0 13 2 26 0 16 2 26 0 20 2 26 0 21 2 26 0 23 2 26 0 24 2 26 0 25 2 26 0 26 2 26 0 27 2 26 0 28 2 26 0 29 2 26 0 30 2 26 0 40 2 26 0 42 2 26 0 45 2 26 0 46 2 26 0 47 2 26 0 49 2 26 0 50 2 26 0 52 2 26 0 53 2 26 0 54 2 26 0 55 2 26 0 58 2 26 0 59 2 26 0 60 2 26 0 74 2 26 0 75 2 26 0 77 2 26 0 78 2 26 0 81 2 26 0 89 2 26 0 90 2 26 0 91 2 26 0 92 2 26 0 93 2 26 0 94 3 101 0 95 2 26 0 96 3 105 0 97 2 26 0 98 2 26 0 99 2 26 0 100 2 26 0 102 2 26 0 104 2 26 0 250]
#[0 2 102 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 150 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 154 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 158 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 106 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 146 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 162 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[1 4 65 0 13 4 69 0 53 0 185 0 122 4 73 0 134 4 77 0 233 4 81 0 234]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 4 85 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 2 110 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 4 89 0 70]
#[0 2 114 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 118 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 1 0 56]
#[0 2 49 0 56]
#[0 2 137 0 56]
#[0 2 170 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 138 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 126 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[0 2 122 0 13 0 31 0 62 0 63 0 65 0 67 0 73 0 113 0 122]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 4 93 0 53 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 97 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 4 101 0 214 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 4 105 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 109 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 4 113 0 48]
#[0 4 117 0 47]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 121 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 2 201 0 47 2 205 0 52 4 125 0 55 4 129 0 155]
#[0 4 133 0 55]
#[0 0 198 0 46 0 47 0 52 0 55]
#[0 0 202 0 46 0 47 0 52 0 55]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 137 0 147 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 141 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 1 114 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 118 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 110 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 122 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 126 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 134 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 138 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 142 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 106 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 102 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 130 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 86 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 90 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 98 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 1 94 0 5 0 7 0 13 0 30 0 31 0 37 0 56 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 72 0 73 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 145 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 149 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 153 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 157 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 161 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 165 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 169 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 173 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 177 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 181 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 185 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 189 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 193 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 197 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 4 201 0 19]
#[1 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 1 49 0 182 4 205 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 45 0 13 0 53 0 30 0 57 0 31 0 61 0 37 0 69 0 56 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 109 0 72 0 113 0 73 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 1 49 0 182 4 209 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 2 58 0 1 2 58 0 2 2 58 0 3 2 58 0 4 2 58 0 5 2 58 0 7 2 58 0 10 2 58 0 11 2 58 0 13 2 58 0 16 2 58 0 20 2 58 0 21 2 58 0 23 2 58 0 24 2 58 0 25 2 58 0 26 2 58 0 27 2 58 0 28 2 58 0 29 2 58 0 30 2 58 0 40 2 58 0 42 2 58 0 45 2 58 0 46 2 58 0 47 2 58 0 49 2 58 0 50 2 58 0 52 2 58 0 53 2 58 0 54 2 58 0 55 2 58 0 58 2 58 0 59 2 58 0 60 2 58 0 74 2 58 0 75 2 58 0 77 2 58 0 78 2 58 0 81 4 213 0 88 2 58 0 89 2 58 0 90 2 58 0 91 2 58 0 92 2 58 0 93 2 58 0 94 2 58 0 95 2 58 0 96 2 58 0 97 2 58 0 98 2 58 0 99 2 58 0 100 2 58 0 102 2 58 0 104 4 217 0 192 2 58 0 250]
#[1 2 62 0 1 2 62 0 2 2 62 0 3 2 62 0 4 2 62 0 5 2 62 0 7 2 62 0 10 2 62 0 11 2 62 0 13 2 62 0 16 2 62 0 20 2 62 0 21 2 62 0 23 2 62 0 24 2 62 0 25 2 62 0 26 2 62 0 27 2 62 0 28 2 62 0 29 2 62 0 30 2 62 0 40 2 62 0 42 2 62 0 45 2 62 0 46 2 62 0 47 2 62 0 49 2 62 0 50 2 62 0 52 2 62 0 53 2 62 0 54 2 62 0 55 2 62 0 58 2 62 0 59 2 62 0 60 2 62 0 74 2 62 0 75 2 62 0 77 2 62 0 78 2 62 0 81 4 213 0 88 2 62 0 89 2 62 0 90 2 62 0 91 2 62 0 92 2 62 0 93 2 62 0 94 2 62 0 95 2 62 0 96 2 62 0 97 2 62 0 98 2 62 0 99 2 62 0 100 2 62 0 102 2 62 0 104 4 217 0 192 2 62 0 250]
#[0 2 70 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 94 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 2 66 0 1 2 66 0 2 2 66 0 3 2 66 0 4 2 66 0 5 2 66 0 7 2 66 0 10 2 66 0 11 2 66 0 13 2 66 0 16 2 66 0 20 2 66 0 21 2 66 0 23 2 66 0 24 2 66 0 25 2 66 0 26 2 66 0 27 2 66 0 28 2 66 0 29 2 66 0 30 2 66 0 40 2 66 0 42 2 66 0 45 2 66 0 46 2 66 0 47 2 66 0 49 2 66 0 50 2 66 0 52 2 66 0 53 2 66 0 54 2 66 0 55 2 66 0 58 2 66 0 59 2 66 0 60 2 66 0 74 2 66 0 75 2 66 0 77 2 66 0 78 2 66 0 81 4 213 0 88 2 66 0 89 2 66 0 90 2 66 0 91 2 66 0 92 2 66 0 93 2 66 0 94 2 66 0 95 2 66 0 96 2 66 0 97 2 66 0 98 2 66 0 99 2 66 0 100 2 66 0 102 2 66 0 104 4 217 0 192 2 66 0 250]
#[1 4 221 0 44 0 201 0 127 4 225 0 133 4 229 0 253]
#[1 0 90 0 32 4 233 0 33 4 237 0 34 4 241 0 41 4 245 0 44 4 249 0 137]
#[0 3 230 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 3 234 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 3 238 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 3 242 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 4 10 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 4 253 0 57]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 5 1 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 5 5 0 53]
#[0 0 6 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 2 178 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 5 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 58 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[1 0 53 0 30 5 13 0 70 3 169 0 121 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 5 17 0 126 0 201 0 127 5 21 0 128 0 205 0 133 5 25 0 134 5 29 0 139 5 33 0 202 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 5 37 0 215 1 169 0 217 5 41 0 219 5 45 0 221 5 49 0 222]
#[0 5 53 0 42]
#[1 5 57 0 66 5 61 0 90]
#[0 3 222 0 53]
#[0 3 182 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 226 0 53]
#[0 5 65 0 53]
#[0 3 218 0 53]
#[0 5 69 0 74]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 5 73 0 74 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 5 77 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 5 81 0 227 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 5 85 0 43]
#[0 2 230 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 5 89 0 51 5 93 0 57 5 97 0 160]
#[0 5 101 0 74]
#[0 3 198 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 5 105 0 74]
#[0 1 254 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 202 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 2 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 5 109 0 74]
#[0 4 34 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 5 113 0 16]
#[0 5 117 0 19]
#[0 5 121 0 89]
#[0 0 178 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 170 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 4 70 0 16 0 77 0 78 0 81]
#[0 0 182 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[1 5 125 0 16 5 129 0 77 5 133 0 78 5 137 0 81]
#[0 5 141 0 74]
#[0 3 174 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 5 145 0 53]
#[1 0 185 0 122 2 13 0 134 5 149 0 159]
#[0 5 153 0 60]
#[0 3 210 0 53]
#[0 3 190 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 214 0 53]
#[0 5 157 0 53]
#[0 3 206 0 53]
#[0 5 161 0 74]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 5 165 0 74 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 5 169 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 2 238 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 3 30 0 53 5 173 0 54]
#[0 5 177 0 53]
#[0 0 130 0 53 0 74 0 75 0 250]
#[0 0 206 0 47 0 52 0 55]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 5 181 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 5 185 0 162 5 189 0 163 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 5 193 0 48]
#[0 0 134 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 5 197 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 5 201 0 55]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 5 205 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 0 166 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 1 58 0 1 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 1 66 0 1 0 2 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 1 70 0 1 0 2 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 1 74 0 1 0 2 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 1 82 0 1 0 2 0 4 0 10 0 16 0 20 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 154 0 1 0 2 0 3 0 4 0 10 0 16 0 20 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 150 0 1 0 2 0 3 0 4 0 10 0 16 0 20 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 16 0 20 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 162 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 16 0 20 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 174 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 16 0 20 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 170 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 16 0 20 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 182 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 26 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 186 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 26 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 198 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 194 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 28 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 5 209 0 17 5 213 0 18 2 161 0 31 2 165 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 113 0 73 2 169 0 113 0 185 0 122 5 217 0 134 5 221 0 180 5 225 0 182 5 229 0 183 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 5 233 0 242]
#[0 2 46 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 42 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 5 237 0 75 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 5 241 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 2 90 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 3 169 0 121 5 245 0 128]
#[0 4 86 0 40]
#[0 5 249 0 40]
#[0 5 253 0 37]
#[1 6 1 0 31 6 5 0 32]
#[0 0 94 0 32]
#[1 3 169 0 121 6 9 0 128]
#[0 6 13 0 32]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 17 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 0 150 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 6 21 0 6]
#[0 0 154 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 6 25 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 126 0 30 0 64 0 70 0 121 0 122 0 123 0 124 0 125 0 126 0 127]
#[0 3 118 0 30 0 64 0 70 0 121 0 122 0 123 0 124 0 125 0 126 0 127]
#[0 3 122 0 30 0 64 0 70 0 121 0 122 0 123 0 124 0 125 0 126 0 127]
#[0 3 110 0 30 0 64 0 70 0 121 0 122 0 123 0 124 0 125 0 126 0 127]
#[0 3 114 0 30 0 64 0 70 0 121 0 122 0 123 0 124 0 125 0 126 0 127]
#[1 0 53 0 30 3 82 0 64 5 13 0 70 3 169 0 121 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 5 17 0 126 0 201 0 127 5 21 0 128 0 205 0 133 5 25 0 134 5 29 0 139 5 33 0 202 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 5 37 0 215 1 169 0 217 6 29 0 219 5 45 0 221 5 49 0 222]
#[0 6 33 0 64]
#[1 0 53 0 30 3 90 0 64 5 13 0 70 3 169 0 121 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 5 17 0 126 0 201 0 127 5 21 0 128 0 205 0 133 5 25 0 134 5 29 0 139 5 33 0 202 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 5 37 0 215 1 169 0 217 6 37 0 219 5 45 0 221 5 49 0 222]
#[0 3 106 0 30 0 64 0 70 0 121 0 122 0 123 0 124 0 125 0 126 0 127]
#[1 5 13 0 70 0 201 0 127 6 41 0 133 6 45 0 139 6 49 0 220]
#[0 3 62 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[1 0 53 0 30 5 13 0 70 3 169 0 121 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 5 17 0 126 0 201 0 127 5 21 0 128 0 205 0 133 5 25 0 134 5 29 0 139 5 33 0 202 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 5 37 0 215 1 169 0 217 6 53 0 219 5 45 0 221 5 49 0 222]
#[0 3 186 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 6 57 0 70]
#[0 3 134 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 170 0 74]
#[0 6 61 0 74]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 65 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 6 69 0 37]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 73 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 6 77 0 57]
#[0 3 130 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 166 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 254 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 81 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 6 85 0 245]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 6 89 0 244]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 93 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 6 97 0 76 6 101 0 79]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 6 105 0 244]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 6 109 0 244]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 6 113 0 244]
#[0 3 2 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 178 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 6 117 0 43]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 121 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 194 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 6 125 0 70]
#[0 3 150 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 6 129 0 74]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 97 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 6 133 0 214 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 2 242 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 6 137 0 28 6 141 0 50 1 10 0 54 1 10 0 55 6 145 0 58 6 149 0 164 6 153 0 165 6 157 0 166]
#[0 0 210 0 55]
#[1 6 161 0 54 1 2 0 55]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 5 181 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 6 165 0 162 5 189 0 163 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 0 138 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 169 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 0 142 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 6 173 0 56]
#[0 6 177 0 56]
#[0 2 6 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 206 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 4 22 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 4 26 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 1 226 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 2 82 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 6 181 0 75]
#[0 6 185 0 42]
#[0 3 254 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 38 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[1 0 185 0 122 6 189 0 134]
#[0 6 193 0 44]
#[0 6 197 0 44]
#[0 6 201 0 42]
#[1 0 185 0 122 6 205 0 134]
#[1 1 46 0 10 6 209 0 54]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 213 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 6 217 0 74]
#[0 3 86 0 64]
#[1 0 185 0 122 6 221 0 134]
#[0 3 94 0 64]
#[0 3 98 0 66 0 90 0 122]
#[0 3 102 0 66 0 90 0 122]
#[1 3 74 0 66 3 74 0 90 0 185 0 122 3 189 0 134 6 225 0 218]
#[0 6 229 0 64]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 6 233 0 74 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 5 77 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 6 237 0 227 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 138 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 0 250 0 46 0 250 0 47 0 250 0 49 0 250 0 52 6 241 0 54 0 250 0 55 0 250 0 59]
#[1 0 185 0 122 2 13 0 134 6 245 0 159]
#[1 0 226 0 46 0 226 0 47 0 226 0 49 0 226 0 52 6 249 0 54 0 226 0 55 0 226 0 59]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 6 253 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 4 38 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 0 174 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 7 1 0 89]
#[0 4 46 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 7 5 0 81]
#[0 7 9 0 81]
#[0 4 62 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 4 66 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 4 50 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 7 13 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 7 17 0 55]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 7 21 0 74 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 0 213 0 136 7 25 0 143 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 154 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 3 34 0 53]
#[1 7 29 0 8 7 33 0 15]
#[0 1 30 0 28 0 54 0 55]
#[0 1 34 0 28 0 54 0 55]
#[0 1 14 0 54 0 55]
#[1 6 137 0 28 1 18 0 54 1 18 0 55 7 37 0 166]
#[0 1 22 0 54 0 55]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 5 181 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 7 41 0 162 5 189 0 163 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 0 214 0 55]
#[0 0 146 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 7 45 0 53]
#[0 7 49 0 53]
#[0 2 78 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[1 0 201 0 127 4 225 0 133 7 53 0 253]
#[1 7 57 0 16 7 61 0 35 7 65 0 43 7 69 0 135]
#[1 0 201 0 127 4 225 0 133 7 73 0 253]
#[1 0 201 0 127 4 225 0 133 7 77 0 253]
#[1 0 201 0 127 4 225 0 133 7 81 0 253]
#[0 7 85 0 56]
#[1 1 233 0 37 7 89 0 167]
#[0 7 93 0 4]
#[0 0 106 0 30 0 40 0 64 0 66 0 70 0 90 0 121 0 122 0 123 0 124 0 125 0 126 0 127]
#[0 7 97 0 90]
#[0 3 78 0 66 0 90]
#[1 0 185 0 122 7 101 0 134]
#[0 3 142 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 7 105 0 74]
#[1 2 21 0 37 7 109 0 161]
#[0 0 246 0 57]
#[1 2 37 0 37 7 113 0 158]
#[1 0 234 0 46 0 234 0 47 0 234 0 49 0 234 0 52 7 117 0 54 0 234 0 55 0 234 0 59]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 7 121 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 7 125 0 244]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 4 9 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 7 129 0 244]
#[1 7 133 0 54 4 74 0 60]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 7 137 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 158 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 7 141 0 74]
#[0 1 42 0 54 0 55]
#[0 1 38 0 54 0 55]
#[0 1 26 0 54 0 55]
#[0 1 6 0 55]
#[0 1 222 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 4 18 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 35 0 40 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 90 0 91 0 92 0 93 0 94 0 96 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 7 145 0 40]
#[1 5 209 0 17 5 213 0 18 2 161 0 31 2 165 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 113 0 73 2 169 0 113 0 185 0 122 5 217 0 134 7 149 0 180 5 225 0 182 5 229 0 183 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232 5 233 0 242]
#[0 7 153 0 40]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 7 157 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[1 7 161 0 35 7 165 0 43]
#[0 7 169 0 40]
#[0 7 173 0 40]
#[0 7 177 0 40]
#[1 7 181 0 37 0 118 0 53 0 118 0 54 7 185 0 138 7 189 0 140 7 193 0 141 7 197 0 142]
#[0 1 50 0 10]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 7 201 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 3 66 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 7 205 0 90]
#[0 3 146 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 0 254 0 46 0 47 0 49 0 52 0 55 0 59]
#[0 0 230 0 46 0 47 0 49 0 52 0 55 0 59]
#[1 2 37 0 37 7 209 0 158]
#[0 4 42 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 4 58 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 4 54 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[1 4 57 0 37 7 213 0 249]
#[0 0 186 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 3 162 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 250]
#[0 4 2 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 38 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 0 50 0 35 0 43]
#[0 0 22 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 7 217 0 40]
#[0 7 221 0 40]
#[1 0 29 0 5 0 33 0 7 0 37 0 9 0 41 0 12 0 45 0 13 0 49 0 14 0 53 0 30 0 57 0 31 0 61 0 37 0 65 0 49 0 69 0 56 0 73 0 59 0 77 0 61 0 81 0 62 0 85 0 63 0 89 0 65 0 93 0 67 0 97 0 68 0 101 0 69 0 105 0 71 0 109 0 72 0 113 0 73 0 117 0 82 0 121 0 95 0 125 0 97 0 129 0 103 0 133 0 106 0 137 0 107 0 141 0 108 0 145 0 109 0 149 0 110 0 153 0 111 0 157 0 112 0 161 0 113 0 165 0 114 0 169 0 115 0 173 0 116 0 177 0 117 0 181 0 118 0 185 0 122 0 189 0 123 0 193 0 124 0 197 0 125 0 201 0 127 0 205 0 133 0 209 0 134 7 225 0 136 0 221 0 144 0 225 0 145 0 229 0 146 0 233 0 147 0 237 0 148 0 241 0 149 0 245 0 150 0 249 0 151 0 253 0 152 1 1 0 153 1 5 0 156 1 9 0 157 1 13 0 168 1 17 0 169 1 21 0 170 1 25 0 174 1 29 0 175 1 33 0 176 1 37 0 177 1 41 0 178 1 45 0 179 1 49 0 182 1 53 0 185 1 57 0 186 1 61 0 187 1 65 0 188 1 69 0 189 1 73 0 190 1 77 0 191 1 81 0 194 1 85 0 195 1 89 0 196 1 93 0 197 1 97 0 198 1 101 0 199 1 105 0 200 1 109 0 201 1 113 0 202 1 117 0 203 1 121 0 204 1 125 0 205 1 129 0 206 1 133 0 207 1 137 0 208 1 141 0 209 1 145 0 210 1 149 0 211 1 153 0 212 1 157 0 213 1 161 0 215 1 165 0 216 1 169 0 217 1 173 0 223 1 177 0 224 1 181 0 225 1 185 0 226 1 189 0 228 1 193 0 229 1 197 0 230 1 201 0 231 1 205 0 232]
#[0 0 10 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 0 14 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 0 18 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[1 0 185 0 122 7 229 0 134]
#[1 7 233 0 53 7 237 0 54]
#[0 0 98 0 53 0 54]
#[0 0 102 0 53 0 54]
#[0 0 114 0 53 0 54]
#[0 0 158 0 4 0 10 0 16 0 28 0 40 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 74 0 75 0 77 0 78 0 81 0 89 0 250]
#[0 3 70 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 16 0 20 0 21 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 40 0 42 0 45 0 46 0 47 0 49 0 50 0 52 0 53 0 54 0 55 0 58 0 59 0 60 0 64 0 70 0 74 0 75 0 77 0 78 0 81 0 88 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 100 0 102 0 104 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 250]
#[0 0 238 0 46 0 47 0 49 0 52 0 55 0 59]
#[0 4 78 0 60]
#[0 0 30 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 0 26 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 7 241 0 40]
#[0 0 122 0 53 0 54]
#[1 5 13 0 70 7 245 0 139]
#[1 7 181 0 37 7 249 0 142]
#[0 0 34 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
#[0 7 253 0 40]
#[0 0 110 0 53 0 54]
#[0 0 38 0 5 0 7 0 9 0 12 0 13 0 14 0 30 0 31 0 36 0 37 0 49 0 56 0 59 0 61 0 62 0 63 0 65 0 67 0 68 0 69 0 71 0 72 0 73 0 82 0 95 0 97 0 103 0 106 0 107 0 108 0 109 0 110 0 111 0 112 0 113 0 114 0 115 0 116 0 117 0 118 0 122 0 123 0 124 0 125 0 127]
)
! !

!XQueryParser methodsFor:'informing'!

informAboutRuleReduction: aString

    (Smalltalk isStandAloneApp or:[self class isVerbose]) ifTrue:
        [Transcript show: '[XQuery::Parser] reducing rule '; showCR: aString]

    "Created: / 10-02-2007 / 13:00:28 / janfrog"
    "Modified: / 12-04-2007 / 11:16:11 / janfrog"
! !

!XQueryParser methodsFor:'private'!

actionForCurrentToken
        | ids action |
        ids := currentToken id.
        1 to: ids size
                do: 
                        [:i | 
                        action := self actionFor: (ids at: i).
                        (action bitAnd: self actionMask) = self errorAction ifFalse: [^action].
                        "(ids at: i) = scanner negative_numberId 
                                ifTrue: 
                                        [currentToken := SmaCCToken 
                                                                value: '-'
                                                                start: currentToken startPosition
                                                                id: (Array with: scanner binary_symbolId).
                                        scanner position: currentToken stopPosition - 1.
                                        ^self actionForCurrentToken]"].
        ^self errorAction

    "Created: / 17-03-2006 / 14:55:30 / ked"
! !

!XQueryParser class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryParser.st,v 1.16 2008-01-02 14:05:41 wrobll1 Exp $'
! !
