"{ Package: 'stx:goodies/xmlsuite/xquery' }"

"{ NameSpace: XQuery }"

Perseus::Parser subclass:#XQueryParser
	instanceVariableNames:''
	classVariableNames:'Verbose'
	poolDictionaries:''
	category:'XQuery-Core'
!


!XQueryParser class methodsFor:'accessing'!

isVerbose

    ^Verbose == true

    "Created: / 12-04-2007 / 11:15:13 / janfrog"
!

parseQuery: aString
        ^self parse: aString startingAt: self startingStateForQueryBody

    "Created: / 17-03-2006 / 15:00:57 / ked"
    "Modified: / 02-06-2006 / 12:26:34 / ked"
!

verbose: aBoolean

    "
        self verbose: true  

        self verbose: false
    "

    Verbose := aBoolean

    "Created: / 12-04-2007 / 11:15:13 / janfrog"
    "Modified: / 17-11-2007 / 14:37:07 / janfrog"
! !

!XQueryParser class methodsFor:'generated-accessing'!

scannerClass
	^XQuery::XQueryScanner

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryParser class methodsFor:'generated-comments'!

parserDefinitionComment

	"%start MainModule;

MainModule :
    Prolog QueryBody
	{ AstMainModule new
	    prolog: '1' ;
	    queryBody: '2' }
    ;

Prolog:
    PrologDeclarationClassA* PrologDeclarationClassB*
	{ AstProlog new
		declarations: ('1' addAll: '2'; yourself) }
    ;

PrologDeclarationClassA:
      ""import"" ""module"" URILiteral "";""
          { AstModuleImport new
	      uri: '3' }	      	      
    | ""import"" ""module"" ""namespace"" NCName ""="" URILiteral "";""
          { AstModuleImport new
	      prefix: '4';
	      uri: '6' }
    ;


PrologDeclarationClassB:
      DefaultNamespaceDecl
	{ '1' }
    | NamespaceDecl
	{ '1' }
    | FunctionDecl
	{ '1' }
    ;

DefaultNamespaceDecl:
      ""declare"" ""default"" ""element"" ""namespace"" URILiteral "";""
	{ AstDefaultNamespaceDecl new
	    uri: '5';
	    type: #element }
    | ""declare"" ""default"" ""function"" ""namespace"" URILiteral "";""
	{ AstDefaultNamespaceDecl new
	    uri: '5';
	    type: #function }
    ;

NamespaceDecl:
    ""declare"" ""namespace"" NCName ""="" URILiteral "";""
	{ AstNamespaceDecl new
	    prefix: '3' ;
	    nsuri: '5'  }
    ;



URILiteral:
    StringLiteral
	{ '1' }
    ;

FunctionDecl:
      ""declare"" ""updating""? ""function"" QName ""("" ParamList "")"" EnclosedExpr "";""
	{ AstFunctionDecl new
	    name: '4';
	    paramList: '6';
	    body: '8'
	}
    ;

ParamList:
    OneOrMoreParamList
	{ '1' }
    | EmptyParamList
	{ '2' }
    ;

EmptyParamList:
	{ #() }
    ;

OneOrMoreParamList:
    ParamList "","" Param
	{ '1' add: '3' ; yourself }
    | Param
	{ OrderedCollection with:'1' }
    ;

Param:
    ""$"" QName
	{ AstParam new
	    name: '2'  }
    ;






QueryBody :
  Expr {
    self informAboutRuleReduction:'QueryBody1'.
    '1'.
  };

Expr :
  ExprSingle {
    self informAboutRuleReduction:'Expr1'.
    '1'.
  } |
  ExprSingle "","" Expr {
    self informAboutRuleReduction:'Expr2'.
    AstExpr new exprSingle: '1'; expr: '3'.
  } ;

ExprSingle :
  FLWORExpr {
    self informAboutRuleReduction:'ExprSingle1'.
    '1'.
  } |
  QuantifiedExpr {
    self informAboutRuleReduction:'ExprSingle2'.
    '1'.
  } |
  IfExpr {
    self informAboutRuleReduction:'ExprSingle3'.
    '1'.
  } |
  OrExpr {
    self informAboutRuleReduction:'ExprSingle4'.
    '1'.
  } |
  DeleteExpr {
    self informAboutRuleReduction:'ExprSingle5'.
    '1'.
  } |
  RenameExpr {
    self informAboutRuleReduction:'ExprSingle6'.
    '1'.
  } |
  ReplaceExpr {
    self informAboutRuleReduction:'ExprSingle7'.
    '1'.
  } |
  InsertExpr {
    self informAboutRuleReduction:'ExprSingle8'.
    '1'.
  } |  
  TransformExpr {
    self informAboutRuleReduction:'ExprSingle9'.
    '1'. 
  } ;

FLWORExpr :
  FLWORExpr_ForLet ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr1'.
    AstFLWORExpr new flworExpr_ForLet: '1'; exprSingle: '3'.
  } |
  FLWORExpr_ForLet WhereClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr2'.
    AstFLWORExpr new flworExpr_ForLet: '1'; whereClause: '2'; exprSingle: '4'.
  } |
  FLWORExpr_ForLet OrderByClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr3'.
    AstFLWORExpr new flworExpr_ForLet: '1'; orderByClause: '2'; exprSingle: '4'.
  } |
  FLWORExpr_ForLet WhereClause OrderByClause ""return"" ExprSingle {
    self informAboutRuleReduction:'FLWORExpr4'.
    AstFLWORExpr new flworExpr_ForLet: '1'; whereClause: '2'; orderByClause: '3'; exprSingle: '5'.
  } ;

FLWORExpr_ForLet :
  ForClause {
    self informAboutRuleReduction:'FLWORExpr_ForLet1'.
    '1'.
  } |
  LetClause {
    self informAboutRuleReduction:'FLWORExpr_ForLet2'.
    '1'.
  } |
  ForClause FLWORExpr_ForLet {
    self informAboutRuleReduction:'FLWORExpr_ForLet3'.
    AstFLWORExpr_ForLet new forClause: '1'; flworExpr_ForLet: '2'.
  } |
  LetClause FLWORExpr_ForLet {
    self informAboutRuleReduction:'FLWORExpr_ForLet4'.
    AstFLWORExpr_ForLet new letClause: '1'; flworExpr_ForLet: '2'.
  } ;

ForClause :
  ""for"" ForClause_Impl {
    self informAboutRuleReduction:'ForClause1'.
    '2'.
  } ;

ForClause_Impl :
  ""$"" VarName ""in"" ExprSingle {
    self informAboutRuleReduction:'ForClause_Impl1'.
    AstForClause new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName ""in"" ExprSingle "","" ForClause_Impl {
    self informAboutRuleReduction:'ForClause_Impl2'.
    AstForClause new varName: '2'; exprSingle: '4'; forClause: '6'.
  } |
  ""$"" VarName PositionalVar ""in"" ExprSingle {
    self informAboutRuleReduction:'ForClause_Impl3'.
    AstForClause new varName: '2'; positionalVar: '3'; exprSingle: '5'.
  } |
  ""$"" VarName PositionalVar ""in"" ExprSingle "","" ForClause_Impl {
    self informAboutRuleReduction:'ForClause_Impl4'.
    AstForClause new varName: '2'; positionalVar: '3'; exprSingle: '5'; forClause: '7'.
  } ;

PositionalVar:
  ""at"" ""$"" VarName {
    self informAboutRuleReduction:'PositionalVar1'.
    '3'.
  } ;

LetClause :
  ""let"" LetClause_Impl {
    self informAboutRuleReduction:'LetClause1'.
    '2'.
  } ;

LetClause_Impl :
  ""$"" VarName "":="" ExprSingle {
    self informAboutRuleReduction:'LetClause_Impl1'.
    AstLetClause new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName "":="" ExprSingle "","" LetClause_Impl {
    self informAboutRuleReduction:'LetClause_Impl2'.
    AstLetClause new varName: '2'; exprSingle: '4'; letClause: '6'.
  } ;

WhereClause :
  ""where"" ExprSingle {
    self informAboutRuleReduction:'WhereClause1'.
    AstWhereClause new exprSingle: '2'.
  } ;

OrderByClause :
  ""order"" ""by"" OrderSpecList {
    self informAboutRuleReduction:'OrderByClause1'.
    AstOrderByClause new isStable: false; orderSpecList: '3'.
  } |
  ""stable"" ""order"" ""by"" OrderSpecList {
    self informAboutRuleReduction:'OrderByClause2'.
    AstOrderByClause new isStable: true; orderSpecList: '4'.
  } ;

OrderSpecList :
  OrderSpec {
    self informAboutRuleReduction:'OrderSpecList1'.
   '1'.
  } |
  OrderSpec "","" OrderSpecList {
    self informAboutRuleReduction:'OrderSpecList2'.
    AstOrderSpecList new orderSpec: '1'; orderSpecList: '3'.
  } ;

OrderSpec :
  ExprSingle {
    self informAboutRuleReduction:'OrderSpec1'.
    AstOrderSpec new exprSingle: '1'.
  } |
  ExprSingle OrderModifier {
    self informAboutRuleReduction:'OrderSpec2'.
    AstOrderSpec new exprSingle: '1'; orderModifier: '2'.
  } ;

OrderModifier :
  OrderModifier_AscDesc {
    self informAboutRuleReduction:'OrderModifier1'.
    AstOrderModifier new ascDesc: '1'.
  } |
  OrderModifier_GreatestLeast {
    self informAboutRuleReduction:'OrderModifier2'.
    AstOrderModifier new greatestLeast: '1'.
  } |
  OrderModifier_AscDesc OrderModifier_GreatestLeast {
    self informAboutRuleReduction:'OrderModifier3'.
    AstOrderModifier new ascDesc: '1'; greatestLeast: '2'.
  } ;

OrderModifier_AscDesc:
  ""ascending"" {
    self informAboutRuleReduction:'OrderModifier_AscDesc1'.
    ^#asc.
  } |
  ""descending"" {
    self informAboutRuleReduction:'OrderModifier_AscDesc2'.
    ^#desc.
  } ;

OrderModifier_GreatestLeast:
  ""empty"" ""greatest"" {
    self informAboutRuleReduction:'OrderModifier_GreatestLeast1'.
    ^#greatest.
  } |
  ""empty"" ""least"" {
    self informAboutRuleReduction:'OrderModifier_GreatestLeast2'.
    ^#least.
  } ;

QuantifiedExpr :
  ""some"" QuantifiedExpr_Impl ""satisfies"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr1'.
    AstQuantifiedExpr new someEvery: #some; quantifiedExpr_Impl: '2'; exprSingle: '4'.
  } |
  ""every"" QuantifiedExpr_Impl ""satisfies"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr2'.
    AstQuantifiedExpr new someEvery: #every; quantifiedExpr_Impl: '2'; exprSingle: '4'.
  } ;

QuantifiedExpr_Impl :
  ""$"" VarName ""in"" ExprSingle {
    self informAboutRuleReduction:'QuantifiedExpr_Impl1'.
    AstQuantifiedExpr_Impl new varName: '2'; exprSingle: '4'.
  } |
  ""$"" VarName ""in"" ExprSingle "","" QuantifiedExpr_Impl {
    self informAboutRuleReduction:'QuantifiedExpr_Impl2'.
    AstQuantifiedExpr_Impl new varName: '2'; exprSingle: '4'; quantifiedExpr_Impl: '6'.
  } ;

IfExpr :
  ""if"" ""("" Expr "")"" ""then"" ExprSingle ""else"" ExprSingle {
    self informAboutRuleReduction:'IfExpr1'.
    AstIfExpr new expr: '3'; trueExprSingle: '6'; falseExprSingle: '8'.
  } ;

OrExpr :
  AndExpr {
    self informAboutRuleReduction:'OrExpr1'.
    '1'.
  } |
  AndExpr ""or"" OrExpr {
    self informAboutRuleReduction:'OrExpr2'.
    AstOrExpr new andExpr: '1'; orExpr: '3'.
  } ;

AndExpr :
  ComparisonExpr {
    self informAboutRuleReduction:'AndExpr1'.
    '1'.
  } |
  ComparisonExpr ""and"" AndExpr {
    self informAboutRuleReduction:'AndExpr2'.
    AstAndExpr new comparisonExpr: '1'; andExpr: '3'.
  } ;

ComparisonExpr :
  RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr1'.
    '1'.
  } |
  RangeExpr ValueComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr2'.
    AstComparisonExpr new rangeExprLeft: '1'; valueComp: '2'; rangeExprRight: '3'.
  } |
  RangeExpr GeneralComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr3'.
    AstComparisonExpr new rangeExprLeft: '1'; generalComp: '2'; rangeExprRight: '3'.
  } |
  RangeExpr NodeComp RangeExpr {
    self informAboutRuleReduction:'ComparisonExpr4'.
    AstComparisonExpr new rangeExprLeft: '1'; nodeComp: '2'; rangeExprRight: '3'.
  } ;

RangeExpr :
  AdditiveExpr {
    self informAboutRuleReduction:'RangeExpr1'.
    '1'.
  } |
  AdditiveExpr ""to"" AdditiveExpr {
    self informAboutRuleReduction:'RangeExpr2'.
    AstRangeExpr new additiveExprFrom: '1'; additiveExprTo: '3'.
  } ;

AdditiveExpr :
  MultiplicativeExpr {
    self informAboutRuleReduction:'AdditiveExpr1'.
    '1'.
  } |
  MultiplicativeExpr ""+"" AdditiveExpr {
    self informAboutRuleReduction:'AdditiveExpr2'.
    AstAdditiveExpr new multiplicativeExpr: '1'; operand: #plus; additiveExpr: '3'.
  } |
  MultiplicativeExpr ""-"" AdditiveExpr {
    self informAboutRuleReduction:'AdditiveExpr3'.
    AstAdditiveExpr new multiplicativeExpr: '1'; operand: #minus; additiveExpr: '3'.
  } ;

MultiplicativeExpr :
  UnionExpr {
    self informAboutRuleReduction:'MultiplicativeExpr1'.
    '1'.
  } |
  UnionExpr ""*"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr2'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #krat; multiplicativeExpr: '3'.
  } |
  UnionExpr ""div"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr3'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #div; multiplicativeExpr: '3'.
  } |
  UnionExpr ""idiv"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr4'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #idiv; multiplicativeExpr: '3'.
  } |
  UnionExpr ""mod"" MultiplicativeExpr {
    self informAboutRuleReduction:'MultiplicativeExpr5'.
    AstMultiplicativeExpr new unionExpr: '1'; operand: #mod; multiplicativeExpr: '3'.
  } ;

UnionExpr :
  IntersectExceptExpr {
    self informAboutRuleReduction:'UnionExpr1'.
    '1'.
  } |
  IntersectExceptExpr ""union"" UnionExpr {
    self informAboutRuleReduction:'UnionExpr2'.
    AstUnionExpr new intersectExceptExpr: '1'; unionExpr: '3'.
  } |
  IntersectExceptExpr ""|"" UnionExpr {
    self informAboutRuleReduction:'UnionExpr3'.
    AstUnionExpr new intersectExceptExpr: '1'; unionExpr: '3'.
  } ;

IntersectExceptExpr :
  UnaryExpr {
    self informAboutRuleReduction:'IntersectExceptExpr1'.
    '1'.
  } |
  UnaryExpr ""intersect"" IntersectExceptExpr {
    self informAboutRuleReduction:'IntersectExceptExpr2'.
    AstIntersectExceptExpr new unaryExpr: '1'; operand: #intersect; intersectExceptExpr: '3'.
  } |
  UnaryExpr ""except"" IntersectExceptExpr {
    self informAboutRuleReduction:'IntersectExceptExpr3'.
    AstIntersectExceptExpr new unaryExpr: '1'; operand: #except; intersectExceptExpr: '3'.
  } ;

UnaryExpr :
  ""-"" UnaryExpr {
    self informAboutRuleReduction:'UnaryExpr1'.
    AstUnaryExpr new operand: #minus; unaryExpr: '2'.
  } |
  ""+"" UnaryExpr {
    self informAboutRuleReduction:'UnaryExpr2'.
    AstUnaryExpr new operand: #plus; unaryExpr: '2'.
  } |
  ValueExpr {
   self informAboutRuleReduction:'UnaryExpr3'.
   '1'.
  } ;

ValueExpr :
  PathExpr {
    self informAboutRuleReduction:'ValueExpr'.
    '1'.
  } ;

GeneralComp :
  ""="" {
    self informAboutRuleReduction:'GeneralComp1'.
    ^#eqGeneral.
  } |
  ""!!="" {
    self informAboutRuleReduction:'GeneralComp2'.
    ^#neGeneral.
  } |
  ""<"" {
    self informAboutRuleReduction:'GeneralComp3'.
    ^#ltGeneral.
  } |
  ""<="" {
    self informAboutRuleReduction:'GeneralComp4'.
    ^#leGeneral.
  } |
  "">"" {
    self informAboutRuleReduction:'GeneralComp5'.
    ^#gtGeneral.
  } |
  "">="" {
    self informAboutRuleReduction:'GeneralComp6'.
    ^#geGeneral.
  } ;

ValueComp :
  ""eq"" {
    self informAboutRuleReduction:'ValueComp1'.
    ^#eqValue.
  } |
  ""ne"" {
    self informAboutRuleReduction:'ValueComp2'.
    ^#neValue.
  } |
  ""lt"" {
    self informAboutRuleReduction:'ValueComp3'.
    ^#ltValue.
  } |
  ""le"" {
    self informAboutRuleReduction:'ValueComp4'.
    ^#leValue.
  } |
  ""gt"" {
    self informAboutRuleReduction:'ValueComp5'.
    ^#gtValue.
  } |
  ""ge""{
    self informAboutRuleReduction:'ValueComp6'.
    ^#geValue.
  } ;

NodeComp :
  ""is"" {
    self informAboutRuleReduction:'NodeComp1'.
    ^#is.
  } |
  ""<<"" {
    self informAboutRuleReduction:'NodeComp2'.
    ^#isLess.
  } |
  "">>"" {
    self informAboutRuleReduction:'NodeComp3'.
    ^#isMore.
  } ;

PathExpr :
	  ""/"" RelativePathExpr 
	  	{
		    self informAboutRuleReduction:'PathExpr2'.
		    '2' absolute: true; yourself 
 		 } 
	| ""//"" RelativePathExpr 
		{
		    self informAboutRuleReduction:'PathExpr3'.
			'2'
				addFirst:
			    	(XMLv2::XPathLocationStep new
			        	axis: XMLv2::XPathAxisDescendantOrSelf new;
						nodeTest: XMLv2::XPathAnyKindTest new);
				yourself		    
		}	
	| RelativePathExpr 
		{
		    self informAboutRuleReduction:'PathExpr4'.
		    '1'.
		}
	;

RelativePathExpr :
	  StepExpr 
	  	{
		    self informAboutRuleReduction:'RelativePathExpr1'.
    		XMLv2::XPathExpression with: '1'.
		}    	
	| RelativePathExpr ""/"" StepExpr  
		{
		    self informAboutRuleReduction:'RelativePathExpr2'.
		    '1' add: '3'; yourself
		}		  
	| RelativePathExpr ""//"" StepExpr 
		{
		    self informAboutRuleReduction:'RelativePathExpr3'.
		    '1'
		    	add:
		    		(XMLv2::XPathLocationStep new
		    			axis: XMLv2::XPathAxisDescendantOrSelf new;
		    			nodeTest: XMLv2::XPathAnyKindTest new);
				add: '3';
				yourself
		}
	;

StepExpr :
	  AxisStep 
	  	{
		    self informAboutRuleReduction:'StepExpr1'.
		    '1'.
		}		   
	| FilterExpr 
		{
		    self informAboutRuleReduction:'StepExpr2'.
		    '1'.
		}		   
	;

AxisStep :
  ForwardStep Predicate* {
    self informAboutRuleReduction:'AxisStep2'.
    '1' predicates: '2'; yourself
  } |
  ReverseStep Predicate* {
    self informAboutRuleReduction:'AxisStep4'.
    '1' predicates: '2'; yourself
  } ;

ForwardStep :
	  ForwardAxis NodeTest
		{
    		self informAboutRuleReduction:'ForwardStep1'.
			XMLv2::XPathLocationStep new
				axis: '1';
				nodeTest: '2';
				yourself
		} 
	| AbbrevForwardStep 
		{
			self informAboutRuleReduction:'ForwardStep2'.
			'1'
  		} 
  	;

ForwardAxis :
	  ""child"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ForwardAxis1'.
		    XMLv2::XPathAxisChild new
		}	    
	|  ""descendant"" ""::"" 
		{
		    self informAboutRuleReduction:'ForwardAxis2'.
			XMLv2::XPathAxisDescendant new
		}
	| ""attribute"" ""::""
	  	{
  			self informAboutRuleReduction:'ForwardAxis3'.
		    XMLv2::XPathAxisAttribute new
		}	    	
	| ""self"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ForwardAxis4'.
		    XMLv2::XPathAxisSelf new
		}	    	
	| ""descendant-or-self"" ""::""	
	  	{
  			self informAboutRuleReduction:'ForwardAxis5'.
		    XMLv2::XPathAxisSedcendantOrSelf new
		}	    	
	| ""following-sibling"" ""::"" 
		{
  			self informAboutRuleReduction:'ForwardAxis6'.
		    XMLv2::XPathAxisFollowingSibling new
		}	    	
	| ""following"" ""::"" 
		{
  			self informAboutRuleReduction:'ForwardAxis7'.
		    XMLv2::XPathAxisFollowing new
		}	    	
	;

AbbrevForwardStep :
	  ""@"" NodeTest 
	  	{
			self informAboutRuleReduction:'AbbrevForwardStep1'.
			XMLv2::XPathLocationStep new
				axis: XMLv2::XPathAxisAttribute new;
				nodeTest: '2';
				yourself
		}			
	| NodeTest
	  	{
			self informAboutRuleReduction:'AbbrevForwardStep2'.
			XMLv2::XPathLocationStep new
				axis: XMLv2::XPathAxisChild new;
				nodeTest: '1';
				yourself
		}			
	;
	
ReverseStep :
	  ReverseAxis NodeTest
		{
    		self informAboutRuleReduction:'ReverseStep1'.
			XMLv2::XPathLocationStep new
				axis: '1';
				nodeTest: '2';
				yourself
		} 
	| AbbrevReverseStep 
		{
			self informAboutRuleReduction:'ReverseStep2'.
			'1'
  		} 
  	;

ReverseAxis :
	  ""parent"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis1'.
		    XMLv2::XPathAxisParent new
		}	    
	| ""ancestor"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis2'.
		    XMLv2::XPathAxisAncestor new
		}
	| ""ancestor-or-self"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis3'.
		    XMLv2::XPathAxisAncestorOrSelf new
		}
	| ""preceding-sibling"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis4'.
		    XMLv2::XPathAxisPrecedingSibling new
		}
	| ""preceding"" ""::"" 
	  	{
  			self informAboutRuleReduction:'ReverseAxis5'.
		    XMLv2::XPathAxisPreceding new
		}
	;
		
AbbrevReverseStep :
	"".."" 
		{
			XMLv2::XPathLocationStep new
				axis: XMLv2::XPathAxisParent new;
				nodeTest: XMLv2::XPathAnyKindTest new;
				yourself
		}
	;

NodeTest :
	  NameTest
		{
	  	 	self informAboutRuleReduction:'NodeTest1'.
		    '1'.
		}
	| KindTest 
		{
		    self informAboutRuleReduction:'NodeTest2'.
		    '1'.
		} 
	;

NameTest :
	QName 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new qName: '1' content
		}			
	| ""*"" 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new prefix:'*'; localName:'*'
		}			
	| ""*"" "":"" NCName 
		{
			self informAboutRuleReduction:'NameTest1'.
			XMLv2::XPathNameTest new prefix:'*'; localName:'3' content
		}			
	;

FilterExpr :
	PrimaryExpr Predicate* 
		{
		    self informAboutRuleReduction:'FilterExpr2'.
		    AstFilterExpr new primaryExpr: '1'; predicateList: '2'.
		}
	;


Predicate :
  ""["" Expr ""]"" {
    self informAboutRuleReduction:'Predicate1'.
    XMLv2::XPathPredicate new expr: '2'.
  } |
  ""["" ""]"" {
    self informAboutRuleReduction:'Predicate2'.
    XMLv2::XPathPredicate new
  } ;

PrimaryExpr :
  Literal {
    self informAboutRuleReduction:'PrimaryExpr1'.
    '1'.
  } |
  VarRef {
    self informAboutRuleReduction:'PrimaryExpr2'.
    '1'.
  } |
  ParenthesizedExpr {
    self informAboutRuleReduction:'PrimaryExpr3'.
    '1'.
  } |
  ContextItemExpr {
    self informAboutRuleReduction:'PrimaryExpr4'.
    '1'.
  } |
  FunctionCall {
    self informAboutRuleReduction:'PrimaryExpr5'.
    '1'.
  } |
  Constructor {
    self informAboutRuleReduction:'PrimaryExpr6'.
    '1'.
  } |
  OrderedExpr {
    self informAboutRuleReduction:'PrimaryExpr7'.
    '1'.
  } |
  UnorderedExpr {
    self informAboutRuleReduction:'PrimaryExpr8'.
    '1'.
  } ;

Literal :
  NumericLiteral {
    self informAboutRuleReduction:'Literal1'.
    '1'.
  } |
  StringLiteral {
    self informAboutRuleReduction:'Literal2'.
    '1'.
  } ;

NumericLiteral :
  IntegerLiteral {
    self informAboutRuleReduction:'NumericLiteral1'.
    '1'.
  } |
  DecimalLiteral {
    self informAboutRuleReduction:'NumericLiteral2'.
    '1'.
  } |
  DoubleLiteral {
    self informAboutRuleReduction:'NumericLiteral3'.
    '1'.
  } ;

VarRef :
  ""$"" VarName {
    self informAboutRuleReduction:'VarRef1'.
    AstVarRef new varName: '2'.
  } ;

VarName :
  QName {
    self informAboutRuleReduction:'VarName1'.
    '1'.
  };

ParenthesizedExpr :
  ""("" "")"" {
    self informAboutRuleReduction:'ParenthesizedExpr1'.
    AstParenthesizedExpr new.
  } |
  ""("" Expr "")"" {
    self informAboutRuleReduction:'ParenthesizedExpr2'.
    AstParenthesizedExpr new expr: '2'.
  } ;

ContextItemExpr :
  ""."" {
    self informAboutRuleReduction:'ContextItemExpr1'.
    AstContextItemExpr new.
  } ;

OrderedExpr :
  ""ordered"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'OrderedExpr1'.
    '3'.
  } ;

UnorderedExpr :
  ""unordered"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'UnorderedExpr1'.
    '3'.
  } ;

FunctionCall :
  QName ""("" "")"" {
    self informAboutRuleReduction:'FunctionCall1'.
    AstFunctionCall new qname: '1'.
  } |
  QName ""("" FunctionParametersList "")"" {
    self informAboutRuleReduction:'FunctionCall2'.
    AstFunctionCall new qname: '1'; functionParametersList: '3'.
  } ;

FunctionParametersList:
    ExprSingle {
	self informAboutRuleReduction:'FunctionParametersList1'.
	AstFunctionParametersList new exprSingle: '1'.
    } |
    ExprSingle "","" FunctionParametersList {
	self informAboutRuleReduction:'FunctionParametersList2'.
	AstFunctionParametersList new exprSingle: '1'; functionParametersList: '3'.
    } ;

Constructor :
  DirectConstructor {
    self informAboutRuleReduction:'Constructor1'.
    '1'.
  } |
  ComputedConstructor {
    self informAboutRuleReduction:'Constructor2'.
    '1'.
  } ;

DirectConstructor :
  DirElemConstructor {
    self informAboutRuleReduction:'DirectConstructor1'.
    '1'.
  } ;

DirElemConstructor :
  ""<"" QName ""/>"" {
    self informAboutRuleReduction:'DirElemConstructor1'.
    AstDirElemConstructor new qname: '2'.
  } |
  ""<"" QName DirAttributeList ""/>"" {
    self informAboutRuleReduction:'DirElemConstructor2'.
    AstDirElemConstructor new qname: '2'; dirAttributeList: '3'.
  } |
  ""<"" QName "">"" DirElemContent ""</"" QName "">"" {
    self informAboutRuleReduction:'DirElemConstructor3'.
    AstDirElemConstructor new qname: '2'; dirElemContent: '4'.
  } |
  ""<"" QName DirAttributeList "">"" DirElemContent ""</"" QName "">"" {
    self informAboutRuleReduction:'DirElemConstructor4'.
    AstDirElemConstructor new qname: '2'; dirAttributeList: '3'; dirElemContent: '5'.
  } ;

DirAttributeList :
  QName ""="" DirAttributeValue {
    self informAboutRuleReduction:'DirAttributeList1'.
    AstDirAttributeList new qname: '1'; dirAttributeValue: '3'.
  } |
  QName ""="" DirAttributeValue DirAttributeList {
    self informAboutRuleReduction:'DirAttributeList2'.
    AstDirAttributeList new qname: '1'; dirAttributeValue: '3'; dirAttributeList: '4'.
  } ;

DirAttributeValue :
  StringLiteral {
    self informAboutRuleReduction:'DirAttributeValue1'.
    '1'.
  } |
  EnclosedExpr {
    self informAboutRuleReduction:'DirAttributeValue2'.
    '1'.
  } ;

DirElemContent :
  DirectConstructor {
    self informAboutRuleReduction:'DirElemContent1'.
    AstDirElemContent new content: '1'.
  } |
  DirectConstructor DirElemContent {
    self informAboutRuleReduction:'DirElemContent2'.
    AstDirElemContent new content: '1'; dirElemContent: '2'.
  } |
  CommonContent {
    self informAboutRuleReduction:'DirElemContent3'.
    AstDirElemContent new content: '1'.
  } |
  CommonContent DirElemContent {
    self informAboutRuleReduction:'DirElemContent4'.
    AstDirElemContent new content: '1'; dirElemContent: '2'.
  } ;

CommonContent :
  PredefinedEntityRef {
    self informAboutRuleReduction:'CommonContent1'.
    '1'.
  } |
  EnclosedExpr {
    self informAboutRuleReduction:'CommonContent2'.
    '1'.
  } |
  Literal {
    self informAboutRuleReduction:'CommonContent3'.
    '1'.
  } |
  NCName {
    self informAboutRuleReduction:'CommonContent7'.
    '1'.
  } |
  QName {
    self informAboutRuleReduction:'CommonContent8'.
    '1'.
  } ;

ComputedConstructor :
  CompDocConstructor {
    self informAboutRuleReduction:'ComputedConstructor1'.
    '1'.
  } |
  CompElemConstructor {
    self informAboutRuleReduction:'ComputedConstructor2'.
    '1'.
  } |
  CompAttrConstructor {
    self informAboutRuleReduction:'ComputedConstructor3'.
    '1'.
  } |
  CompTextConstructor {
    self informAboutRuleReduction:'ComputedConstructor4'.
    '1'.
  } ;

CompDocConstructor :
  ""document"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompDocConstructor1'.
    AstCompDocConstructor new expr: '3'.
  } ;

CompElemConstructor :
  ""element"" QName ""{"" ""}"" {
    self informAboutRuleReduction:'CompElemConstructor1'.
    AstCompElemConstructor new qname: '2'.
  } |
  ""element"" QName ""{"" ContentExpr ""}"" {
    self informAboutRuleReduction:'CompElemConstructor2'.
    AstCompElemConstructor new qname: '2'; contentExpr: '4'.
  } |
  ""element"" ""{"" Expr ""}"" ""{"" ""}"" {
    self informAboutRuleReduction:'CompElemConstructor3'.
    AstCompElemConstructor new expr: '3'.
  } |
  ""element"" ""{"" Expr ""}"" ""{"" ContentExpr ""}"" {
    self informAboutRuleReduction:'CompElemConstructor4'.
    AstCompElemConstructor new expr: '3'; contentExpr: '6'.
  } ;

ContentExpr :
  Expr {
    self informAboutRuleReduction:'ContentExpr'.
    '1'.
  } ;

CompAttrConstructor :
  ""attribute"" QName ""{"" ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor1'.
    AstCompAttrConstructor new qname: '2'.
  } |
  ""attribute"" QName ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor2'.
    AstCompAttrConstructor new qname: '2'; contentExpr: '4'.
  } |
  ""attribute"" ""{"" Expr ""}"" ""{"" ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor3'.
    AstCompAttrConstructor new expr: '3'.
  } |
  ""attribute"" ""{"" Expr ""}"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompAttrConstructor4'.
    AstCompAttrConstructor new expr: '3'; contentExpr: '6'.
  } ;

CompTextConstructor :
  ""text"" ""{"" Expr ""}"" {
    self informAboutRuleReduction:'CompTextConstructor1'.
    AstCompTextConstructor new expr: '3'.
  } ;

KindTest :
  DocumentTest {
    self informAboutRuleReduction:'KindTest1'.
    '1'.
  } |
  ElementTest {
    self informAboutRuleReduction:'KindTest2'.
    '1'.
  } |
  AttributeTest {
    self informAboutRuleReduction:'KindTest3'.
    '1'.
  } |
  TextTest {
    self informAboutRuleReduction:'KindTest4'.
    '1'.
  } |
  AnyKindTest {
    self informAboutRuleReduction:'KindTest5'.
    '1'.
  }
  | ""comment"" ""("" "")""
  	{ XMLv2::XPathCommentTest new }  	
  | ""processing-instruction"" ""("" "")""
  	{ XMLv2::XPathProcessingInstructionTest new }
  ;

AnyKindTest :
  ""node"" ""("" "")"" {
    self informAboutRuleReduction:'AnyKindTest1'.
    XMLv2::XPathAnyKindTest new
  } ;

DocumentTest :
  ""document-node"" ""("" "")"" {
    self informAboutRuleReduction:'DocumentTest1'.
    XMLv2::XPathDocumentTest new.
  } |
  ""document-node"" ""("" ElementTest "")"" {
    self informAboutRuleReduction:'DocumentTest2'.
    XMLv2::XPathDocumentTest new elementTest: '3'.
  } ;

TextTest :
  ""text"" ""("" "")"" {
    self informAboutRuleReduction:'TextTest1'.
    XMLv2::XPathTextTest new.
  } ;
  
AttributeTest :
  ""attribute"" ""("" "")"" {
    self informAboutRuleReduction:'AttributeTest1'.
    XMLv2::XPathAttributeTest new
  } |
  ""attribute"" ""("" AttribNameOrWildcard "")"" {
    self informAboutRuleReduction:'AttributeTest2'.
	XMLv2::XPathAttributeTest halt:'Not yet implemented. See grammar'
  } ;

AttribNameOrWildcard :
  AttributeName {
    self informAboutRuleReduction:'AttributeNameOrWildcard1'.
    AstAttribNameOrWildcard new attributeName: '1'.
  } |
  ""*"" {
    self informAboutRuleReduction:'AttributeNameOrWildcard2'.
    AstAttribNameOrWildcard new.
  } ;

ElementTest :
  ""element"" ""("" "")"" {
    self informAboutRuleReduction:'ElementTest1'.
    AstElementTest new.
  } |
  ""element"" ""("" ElementNameOrWildcard "")"" {
    self informAboutRuleReduction:'ElementTest2'.
    AstElementTest new elementName: '3'.
  } ;

ElementNameOrWildcard :
  ElementName {
    self informAboutRuleReduction:'ElementNameOrWildcard1'.
    AstElementNameOrWildcard new elementName: '1'.
  } |
  ""*"" {
    self informAboutRuleReduction:'ElementNameOrWildcard2'.
    AstElementNameOrWildcard new.
  } ;

AttributeName :
  QName {
    self informAboutRuleReduction:'AttributeName1'.
    '1'.
  } ;

ElementName :
  QName {
    self informAboutRuleReduction:'ElementName1'.
    '1'.
  } ;

EnclosedExpr :
  ""{"" Expr ""}"" {
    self informAboutRuleReduction:'EnclosedExpr1'.
    AstEnclosedExpr new expr: '2'.
  } ;

PredefinedEntityRef :
  <predefined_entity_ref> {
    self informAboutRuleReduction:'PredefinedEntityRef1 -', ('1' asString).
    AstPredefinedEntityRef new content: ('1' value).
  } ;

QName :
  <qname> {
    self informAboutRuleReduction:'QName1 - ', ('1' asString).
    AstQName new content: ('1' value).
  } ;

NCName :
  <ncname> {
    self informAboutRuleReduction:'NCName1 - ', ('1' asString).
    AstNCName new content: ('1' value).
  } ;

StringLiteral :
  <string_literal> {
    self informAboutRuleReduction:'StringLiteral1 -', ('1' asString).
    AstStringLiteral new content: ('1' value).
  } ;

IntegerLiteral :
  <integer_literal> {
    self informAboutRuleReduction:'IntegerLiteral1 -', ('1' asString).
    AstIntegerLiteral new content: ('1' value asInteger).
  } ;

DecimalLiteral :
  <decimal_literal> {
    self informAboutRuleReduction:'DecimalLiteral1 -', ('1' asString).
    AstDecimalLiteral new content: ('1' value asFloat).
  } ;

DoubleLiteral :
  <double_literal> {
    self informAboutRuleReduction:'DoubleLiteral1 -', ('1' asString).
    AstDoubleLiteral new content: ('1' value asDouble).
  } ;

DeleteExpr :
  ""do"" ""delete"" TargetExpr {
    self informAboutRuleReduction:'DeleteExpr'.
    (AstDeleteExpr new) targetExpr: '3'
  };

RenameExpr:
  ""do"" ""rename"" TargetExpr ""as"" NewNameExpr {
    self informAboutRuleReduction:'RenameExpr'.
    (AstRenameExpr new) targetExpr: '3'; newNameExpr: '5'.
  };

ReplaceExpr :
  ""do"" ""replace"" ReplaceClause {
    self informAboutRuleReduction:'ReplaceExpr'.
    '3'.
  };

ReplaceClause :
  ""value"" ""of"" TargetExpr ""with"" ExprSingle {
    self informAboutRuleReduction:'ReplaceValueOfClause'.
    (AstReplaceValueOfExpr new) targetExpr: '3'; sourceExpr: '5'.
  } |
  TargetExpr ""with"" ExprSingle {
    self informAboutRuleReduction:'ReplaceClause'.
    (AstReplaceExpr new) targetExpr: '1'; sourceExpr: '3'.
  };



InsertExpr :
  ""do"" ""insert"" InsertClause  {
    self informAboutRuleReduction:'InsertExpr'.
    '3'.
  };

InsertClause :
  SourceExpr ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertIntoClause'.
    (AstInsertIntoExpr new) targetExpr: '3'; sourceExpr: '1'.
  } |
  SourceExpr ""as"" ""first"" ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertAsFirstIntoClause'.
    (AstInsertAsFirstIntoExpr new) targetExpr: '5'; sourceExpr: '1'.
  } |
  SourceExpr ""as"" ""last"" ""into"" TargetExpr {
    self informAboutRuleReduction:'InsertAsLastIntoClause'.
    (AstInsertAsLastIntoExpr new) targetExpr: '5'; sourceExpr: '1'.
  } |
  SourceExpr ""after"" TargetExpr {
    self informAboutRuleReduction:'InsertAfterClause'.
    (AstInsertAfterExpr new) targetExpr: '3'; sourceExpr: '1'.
  } |
  SourceExpr ""before"" TargetExpr {
    self informAboutRuleReduction:'InsertBeforeClause'.
    (AstInsertBeforeExpr new) targetExpr: '3'; sourceExpr: '1'.
  };
  
TransformExpr:
  ""transform"" ""copy"" TransformCopyClause ""modify"" ExprSingle ""return"" ExprSingle {
    self informAboutRuleReduction:'TransformExpr'.
    (AstTransformExpr new) transformCopyClause: '3'; modifyExpr: '5'; returnExpr: '7'.
  };

TransformCopyClause:
	""$"" VarName "":="" ExprSingle {
	    self informAboutRuleReduction:'TransformCopyClause1'.
	    (AstTransformCopyClause new) varName: '2'; exprSingle: '4'.
  }|
	""$"" VarName "":="" ExprSingle "","" TransformCopyClause {
  		self informAboutRuleReduction:'TransformCopyClause2'.
	    (AstTransformCopyClause new) varName: '2'; exprSingle: '4' ; transformCopyClause: '6'.
  };


TargetExpr :
  ExprSingle{
    self informAboutRuleReduction:'TargetExpr'.
    '1'.
  };

SourceExpr :
  ExprSingle{
    self informAboutRuleReduction:'SourceExpr'.
    '1'.
  };


NewNameExpr :
  ExprSingle{
    self informAboutRuleReduction:'NewNameExpr'.
    '1'.
  };









"

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryParser class methodsFor:'generated-starting states'!

startingStateForMainModule
	^1

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

startingStateForQueryBody
	^1

    "Modified: / 03-12-2006 / 19:46:11 / ked"
! !

!XQueryParser methodsFor:'generated-reduction actions'!

reduceActionForAbbrevForwardStep1:nodes 
    self informAboutRuleReduction:'AbbrevForwardStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:XMLv2::XPathAxisAttribute new;
        nodeTest:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAbbrevForwardStep2:nodes 
    self informAboutRuleReduction:'AbbrevForwardStep2'.
    ^ (XMLv2::XPathLocationStep new)
        axis:XMLv2::XPathAxisChild new;
        nodeTest:(nodes at:1);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAbbrevReverseStep1:nodes 
    ^ (XMLv2::XPathLocationStep new)
        axis:XMLv2::XPathAxisParent new;
        nodeTest:XMLv2::XPathAnyKindTest new;
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAdditiveExpr1:nodes 
    self informAboutRuleReduction:'AdditiveExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAdditiveExpr2:nodes 
    self informAboutRuleReduction:'AdditiveExpr2'.
    ^ (AstAdditiveExpr new)
        multiplicativeExpr:(nodes at:1);
        operand:#plus;
        additiveExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAdditiveExpr3:nodes 
    self informAboutRuleReduction:'AdditiveExpr3'.
    ^ (AstAdditiveExpr new)
        multiplicativeExpr:(nodes at:1);
        operand:#minus;
        additiveExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAndExpr1:nodes 
    self informAboutRuleReduction:'AndExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAndExpr2:nodes 
    self informAboutRuleReduction:'AndExpr2'.
    ^ (AstAndExpr new)
        comparisonExpr:(nodes at:1);
        andExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAnyKindTest1:nodes 
    self informAboutRuleReduction:'AnyKindTest1'.
    ^ XMLv2::XPathAnyKindTest new

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAttribNameOrWildcard1:nodes 
    self informAboutRuleReduction:'AttributeNameOrWildcard1'.
    ^ AstAttribNameOrWildcard new attributeName:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAttribNameOrWildcard2:nodes 
    self informAboutRuleReduction:'AttributeNameOrWildcard2'.
    ^ AstAttribNameOrWildcard new.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAttributeName1:nodes 
    self informAboutRuleReduction:'AttributeName1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAttributeTest1:nodes 
    self informAboutRuleReduction:'AttributeTest1'.
    ^ XMLv2::XPathAttributeTest new

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAttributeTest2:nodes 
    self informAboutRuleReduction:'AttributeTest2'.
    ^ XMLv2::XPathAttributeTest halt:'Not yet implemented. See grammar'

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAxisStep1:nodes 
    self informAboutRuleReduction:'AxisStep2'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAxisStep2:nodes 
    self informAboutRuleReduction:'AxisStep4'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForAxisStep3:nodes 
    self informAboutRuleReduction:'AxisStep3'.
    ^ nodes at:1.

    "Modified: / 17-11-2007 / 13:50:27 / janfrog"
!

reduceActionForAxisStep4:nodes 
    self informAboutRuleReduction:'AxisStep4'.
    ^ (nodes at:1)
        predicates:(nodes at:2);
        yourself

    "Modified: / 17-11-2007 / 13:50:27 / janfrog"
!

reduceActionForCommonContent1:nodes 
    self informAboutRuleReduction:'CommonContent1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCommonContent2:nodes 
    self informAboutRuleReduction:'CommonContent2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCommonContent3:nodes 
    self informAboutRuleReduction:'CommonContent3'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCommonContent4:nodes 
    self informAboutRuleReduction:'CommonContent7'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCommonContent5:nodes 
    self informAboutRuleReduction:'CommonContent8'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCommonContent6:nodes 
    Transcript showCR:'[PARSER] CommonContent6'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCommonContent7:nodes 
    Transcript showCR:'[PARSER] CommonContent7'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCommonContent8:nodes 
    Transcript showCR:'[PARSER] CommonContent8'.
    ^ nodes at:1.

    "Created: / 17-11-2006 / 22:20:50 / ked"
!

reduceActionForCompAttrConstructor1:nodes 
    self informAboutRuleReduction:'CompAttrConstructor1'.
    ^ AstCompAttrConstructor new qname:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompAttrConstructor2:nodes 
    self informAboutRuleReduction:'CompAttrConstructor2'.
    ^ (AstCompAttrConstructor new)
        qname:(nodes at:2);
        contentExpr:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompAttrConstructor3:nodes 
    self informAboutRuleReduction:'CompAttrConstructor3'.
    ^ AstCompAttrConstructor new expr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompAttrConstructor4:nodes 
    self informAboutRuleReduction:'CompAttrConstructor4'.
    ^ (AstCompAttrConstructor new)
        expr:(nodes at:3);
        contentExpr:(nodes at:6).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompDocConstructor1:nodes 
    self informAboutRuleReduction:'CompDocConstructor1'.
    ^ AstCompDocConstructor new expr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompElemConstructor1:nodes 
    self informAboutRuleReduction:'CompElemConstructor1'.
    ^ AstCompElemConstructor new qname:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompElemConstructor2:nodes 
    self informAboutRuleReduction:'CompElemConstructor2'.
    ^ (AstCompElemConstructor new)
        qname:(nodes at:2);
        contentExpr:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompElemConstructor3:nodes 
    self informAboutRuleReduction:'CompElemConstructor3'.
    ^ AstCompElemConstructor new expr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompElemConstructor4:nodes 
    self informAboutRuleReduction:'CompElemConstructor4'.
    ^ (AstCompElemConstructor new)
        expr:(nodes at:3);
        contentExpr:(nodes at:6).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForCompTextConstructor1:nodes 
    self informAboutRuleReduction:'CompTextConstructor1'.
    ^ AstCompTextConstructor new expr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForComparisonExpr1:nodes 
    self informAboutRuleReduction:'ComparisonExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForComparisonExpr2:nodes 
    self informAboutRuleReduction:'ComparisonExpr2'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        valueComp:(nodes at:2);
        rangeExprRight:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForComparisonExpr3:nodes 
    self informAboutRuleReduction:'ComparisonExpr3'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        generalComp:(nodes at:2);
        rangeExprRight:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForComparisonExpr4:nodes 
    self informAboutRuleReduction:'ComparisonExpr4'.
    ^ (AstComparisonExpr new)
        rangeExprLeft:(nodes at:1);
        nodeComp:(nodes at:2);
        rangeExprRight:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForComputedConstructor1:nodes 
    self informAboutRuleReduction:'ComputedConstructor1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForComputedConstructor2:nodes 
    self informAboutRuleReduction:'ComputedConstructor2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForComputedConstructor3:nodes 
    self informAboutRuleReduction:'ComputedConstructor3'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForComputedConstructor4:nodes 
    self informAboutRuleReduction:'ComputedConstructor4'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForConstructor1:nodes 
    self informAboutRuleReduction:'Constructor1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForConstructor2:nodes 
    self informAboutRuleReduction:'Constructor2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForContentExpr1:nodes 
    self informAboutRuleReduction:'ContentExpr'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForContextItemExpr1:nodes 
    self informAboutRuleReduction:'ContextItemExpr1'.
    ^ AstContextItemExpr new.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDecimalLiteral1:nodes 
    self 
        informAboutRuleReduction:'DecimalLiteral1 -' , ((nodes at:1) asString).
    ^ AstDecimalLiteral new content:((nodes at:1) value asFloat).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDefaultNamespaceDecl1:nodes 
    ^ (AstDefaultNamespaceDecl new)
        uri:(nodes at:5);
        type:#element

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDefaultNamespaceDecl2:nodes 
    ^ (AstDefaultNamespaceDecl new)
        uri:(nodes at:5);
        type:#function

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDeleteExpr1:nodes 
    self informAboutRuleReduction:'DeleteExpr'.
    ^ (AstDeleteExpr new) targetExpr:(nodes at:3)

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirAttributeList1:nodes 
    self informAboutRuleReduction:'DirAttributeList1'.
    ^ (AstDirAttributeList new)
        qname:(nodes at:1);
        dirAttributeValue:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirAttributeList2:nodes 
    self informAboutRuleReduction:'DirAttributeList2'.
    ^ (AstDirAttributeList new)
        qname:(nodes at:1);
        dirAttributeValue:(nodes at:3);
        dirAttributeList:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirAttributeValue1:nodes 
    self informAboutRuleReduction:'DirAttributeValue1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirAttributeValue2:nodes 
    self informAboutRuleReduction:'DirAttributeValue2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirElemConstructor1:nodes 
    self informAboutRuleReduction:'DirElemConstructor1'.
    ^ AstDirElemConstructor new qname:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirElemConstructor2:nodes 
    self informAboutRuleReduction:'DirElemConstructor2'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirAttributeList:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirElemConstructor3:nodes 
    self informAboutRuleReduction:'DirElemConstructor3'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirElemContent:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirElemConstructor4:nodes 
    self informAboutRuleReduction:'DirElemConstructor4'.
    ^ (AstDirElemConstructor new)
        qname:(nodes at:2);
        dirAttributeList:(nodes at:3);
        dirElemContent:(nodes at:5).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirElemContent1:nodes 
    self informAboutRuleReduction:'DirElemContent1'.
    ^ AstDirElemContent new content:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirElemContent2:nodes 
    self informAboutRuleReduction:'DirElemContent2'.
    ^ (AstDirElemContent new)
        content:(nodes at:1);
        dirElemContent:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirElemContent3:nodes 
    self informAboutRuleReduction:'DirElemContent3'.
    ^ AstDirElemContent new content:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirElemContent4:nodes 
    self informAboutRuleReduction:'DirElemContent4'.
    ^ (AstDirElemContent new)
        content:(nodes at:1);
        dirElemContent:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDirectConstructor1:nodes 
    self informAboutRuleReduction:'DirectConstructor1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDocumentTest1:nodes 
    self informAboutRuleReduction:'DocumentTest1'.
    ^ XMLv2::XPathDocumentTest new.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDocumentTest2:nodes 
    self informAboutRuleReduction:'DocumentTest2'.
    ^ XMLv2::XPathDocumentTest new elementTest:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForDoubleLiteral1:nodes 
    self 
        informAboutRuleReduction:'DoubleLiteral1 -' , ((nodes at:1) asString).
    ^ AstDoubleLiteral new content:((nodes at:1) value asDouble).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForElementName1:nodes 
    self informAboutRuleReduction:'ElementName1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForElementNameOrWildcard1:nodes 
    self informAboutRuleReduction:'ElementNameOrWildcard1'.
    ^ AstElementNameOrWildcard new elementName:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForElementNameOrWildcard2:nodes 
    self informAboutRuleReduction:'ElementNameOrWildcard2'.
    ^ AstElementNameOrWildcard new.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForElementTest1:nodes 
    self informAboutRuleReduction:'ElementTest1'.
    ^ AstElementTest new.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForElementTest2:nodes 
    self informAboutRuleReduction:'ElementTest2'.
    ^ AstElementTest new elementName:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForEmptyParamList1:nodes 
    ^ #()

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForEnclosedExpr1:nodes 
    self informAboutRuleReduction:'EnclosedExpr1'.
    ^ AstEnclosedExpr new expr:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExpr1:nodes 
    self informAboutRuleReduction:'Expr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExpr2:nodes 
    self informAboutRuleReduction:'Expr2'.
    ^ (AstExpr new)
        exprSingle:(nodes at:1);
        expr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle1:nodes 
    self informAboutRuleReduction:'ExprSingle1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle2:nodes 
    self informAboutRuleReduction:'ExprSingle2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle3:nodes 
    self informAboutRuleReduction:'ExprSingle3'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle4:nodes 
    self informAboutRuleReduction:'ExprSingle4'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle5:nodes 
    self informAboutRuleReduction:'ExprSingle5'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle6:nodes 
    self informAboutRuleReduction:'ExprSingle6'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle7:nodes 
    self informAboutRuleReduction:'ExprSingle7'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle8:nodes 
    self informAboutRuleReduction:'ExprSingle8'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForExprSingle9:nodes 
    self informAboutRuleReduction:'ExprSingle9'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFLWORExpr1:nodes 
    self informAboutRuleReduction:'FLWORExpr1'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        exprSingle:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFLWORExpr2:nodes 
    self informAboutRuleReduction:'FLWORExpr2'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        whereClause:(nodes at:2);
        exprSingle:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFLWORExpr3:nodes 
    self informAboutRuleReduction:'FLWORExpr3'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        orderByClause:(nodes at:2);
        exprSingle:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFLWORExpr4:nodes 
    self informAboutRuleReduction:'FLWORExpr4'.
    ^ (AstFLWORExpr new)
        flworExpr_ForLet:(nodes at:1);
        whereClause:(nodes at:2);
        orderByClause:(nodes at:3);
        exprSingle:(nodes at:5).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFLWORExpr_ForLet1:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFLWORExpr_ForLet2:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFLWORExpr_ForLet3:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet3'.
    ^ (AstFLWORExpr_ForLet new)
        forClause:(nodes at:1);
        flworExpr_ForLet:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFLWORExpr_ForLet4:nodes 
    self informAboutRuleReduction:'FLWORExpr_ForLet4'.
    ^ (AstFLWORExpr_ForLet new)
        letClause:(nodes at:1);
        flworExpr_ForLet:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFilterExpr1:nodes 
    self informAboutRuleReduction:'FilterExpr2'.
    ^ (AstFilterExpr new)
        primaryExpr:(nodes at:1);
        predicateList:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFilterExpr2:nodes 
    self informAboutRuleReduction:'FilterExpr2'.
    ^ (AstFilterExpr new)
        primaryExpr:(nodes at:1);
        predicateList:(nodes at:2).

    "Modified: / 17-11-2007 / 14:03:09 / janfrog"
!

reduceActionForForClause1:nodes 
    self informAboutRuleReduction:'ForClause1'.
    ^ nodes at:2.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForClause_Impl1:nodes 
    self informAboutRuleReduction:'ForClause_Impl1'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForClause_Impl2:nodes 
    self informAboutRuleReduction:'ForClause_Impl2'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        forClause:(nodes at:6).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForClause_Impl3:nodes 
    self informAboutRuleReduction:'ForClause_Impl3'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        positionalVar:(nodes at:3);
        exprSingle:(nodes at:5).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForClause_Impl4:nodes 
    self informAboutRuleReduction:'ForClause_Impl4'.
    ^ (AstForClause new)
        varName:(nodes at:2);
        positionalVar:(nodes at:3);
        exprSingle:(nodes at:5);
        forClause:(nodes at:7).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardAxis1:nodes 
    self informAboutRuleReduction:'ForwardAxis1'.
    ^ XMLv2::XPathAxisChild new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardAxis2:nodes 
    self informAboutRuleReduction:'ForwardAxis2'.
    ^ XMLv2::XPathAxisDescendant new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardAxis3:nodes 
    self informAboutRuleReduction:'ForwardAxis3'.
    ^ XMLv2::XPathAxisAttribute new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardAxis4:nodes 
    self informAboutRuleReduction:'ForwardAxis4'.
    ^ XMLv2::XPathAxisSelf new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardAxis5:nodes 
    self informAboutRuleReduction:'ForwardAxis5'.
    ^ XMLv2::XPathAxisSedcendantOrSelf new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardAxis6:nodes 
    self informAboutRuleReduction:'ForwardAxis6'.
    ^ XMLv2::XPathAxisFollowingSibling new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardAxis7:nodes 
    self informAboutRuleReduction:'ForwardAxis7'.
    ^ XMLv2::XPathAxisFollowing new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardStep1:nodes 
    self informAboutRuleReduction:'ForwardStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:(nodes at:1);
        nodeTest:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForForwardStep2:nodes 
    self informAboutRuleReduction:'ForwardStep2'.
    ^ nodes at:1

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFunctionCall1:nodes 
    self informAboutRuleReduction:'FunctionCall1'.
    ^ AstFunctionCall new qname:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFunctionCall2:nodes 
    self informAboutRuleReduction:'FunctionCall2'.
    ^ (AstFunctionCall new)
        qname:(nodes at:1);
        functionParametersList:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFunctionDecl1:nodes 
    ^ (AstFunctionDecl new)
        name:(nodes at:4);
        paramList:(nodes at:6);
        body:(nodes at:8)

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFunctionParametersList1:nodes 
    self informAboutRuleReduction:'FunctionParametersList1'.
    ^ AstFunctionParametersList new exprSingle:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForFunctionParametersList2:nodes 
    self informAboutRuleReduction:'FunctionParametersList2'.
    ^ (AstFunctionParametersList new)
        exprSingle:(nodes at:1);
        functionParametersList:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForGeneralComp1:nodes 
    self informAboutRuleReduction:'GeneralComp1'.
    ^ #eqGeneral.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForGeneralComp2:nodes 
    self informAboutRuleReduction:'GeneralComp2'.
    ^ #neGeneral.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForGeneralComp3:nodes 
    self informAboutRuleReduction:'GeneralComp3'.
    ^ #ltGeneral.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForGeneralComp4:nodes 
    self informAboutRuleReduction:'GeneralComp4'.
    ^ #leGeneral.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForGeneralComp5:nodes 
    self informAboutRuleReduction:'GeneralComp5'.
    ^ #gtGeneral.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForGeneralComp6:nodes 
    self informAboutRuleReduction:'GeneralComp6'.
    ^ #geGeneral.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForGroup______updating_1:nodes 
    ^ nodes at:1
!

reduceActionForIfExpr1:nodes 
    self informAboutRuleReduction:'IfExpr1'.
    ^ (AstIfExpr new)
        expr:(nodes at:3);
        trueExprSingle:(nodes at:6);
        falseExprSingle:(nodes at:8).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForInsertClause1:nodes 
    self informAboutRuleReduction:'InsertIntoClause'.
    ^ (AstInsertIntoExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForInsertClause2:nodes 
    self informAboutRuleReduction:'InsertAsFirstIntoClause'.
    ^ (AstInsertAsFirstIntoExpr new)
        targetExpr:(nodes at:5);
        sourceExpr:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForInsertClause3:nodes 
    self informAboutRuleReduction:'InsertAsLastIntoClause'.
    ^ (AstInsertAsLastIntoExpr new)
        targetExpr:(nodes at:5);
        sourceExpr:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForInsertClause4:nodes 
    self informAboutRuleReduction:'InsertAfterClause'.
    ^ (AstInsertAfterExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForInsertClause5:nodes 
    self informAboutRuleReduction:'InsertBeforeClause'.
    ^ (AstInsertBeforeExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForInsertExpr1:nodes 
    self informAboutRuleReduction:'InsertExpr'.
    ^ nodes at:3.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForIntegerLiteral1:nodes 
    self 
        informAboutRuleReduction:'IntegerLiteral1 -' , ((nodes at:1) asString).
    ^ AstIntegerLiteral new content:((nodes at:1) value asInteger).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForIntersectExceptExpr1:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForIntersectExceptExpr2:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr2'.
    ^ (AstIntersectExceptExpr new)
        unaryExpr:(nodes at:1);
        operand:#intersect;
        intersectExceptExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForIntersectExceptExpr3:nodes 
    self informAboutRuleReduction:'IntersectExceptExpr3'.
    ^ (AstIntersectExceptExpr new)
        unaryExpr:(nodes at:1);
        operand:#except;
        intersectExceptExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForKindTest1:nodes 
    self informAboutRuleReduction:'KindTest1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForKindTest2:nodes 
    self informAboutRuleReduction:'KindTest2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForKindTest3:nodes 
    self informAboutRuleReduction:'KindTest3'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForKindTest4:nodes 
    self informAboutRuleReduction:'KindTest4'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForKindTest5:nodes 
    self informAboutRuleReduction:'KindTest5'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForKindTest6:nodes 
    ^ XMLv2::XPathCommentTest new

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForKindTest7:nodes 
    ^ XMLv2::XPathProcessingInstructionTest new

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForLetClause1:nodes 
    self informAboutRuleReduction:'LetClause1'.
    ^ nodes at:2.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForLetClause_Impl1:nodes 
    self informAboutRuleReduction:'LetClause_Impl1'.
    ^ (AstLetClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForLetClause_Impl2:nodes 
    self informAboutRuleReduction:'LetClause_Impl2'.
    ^ (AstLetClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        letClause:(nodes at:6).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForLiteral1:nodes 
    self informAboutRuleReduction:'Literal1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForLiteral2:nodes 
    self informAboutRuleReduction:'Literal2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForMainModule1:nodes 
    ^ (AstMainModule new)
        prolog:(nodes at:1);
        queryBody:(nodes at:2)

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForMultiplicativeExpr1:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForMultiplicativeExpr2:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr2'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#krat;
        multiplicativeExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForMultiplicativeExpr3:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr3'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#div;
        multiplicativeExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForMultiplicativeExpr4:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr4'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#idiv;
        multiplicativeExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForMultiplicativeExpr5:nodes 
    self informAboutRuleReduction:'MultiplicativeExpr5'.
    ^ (AstMultiplicativeExpr new)
        unionExpr:(nodes at:1);
        operand:#mod;
        multiplicativeExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNCName1:nodes 
    self informAboutRuleReduction:'NCName1 - ' , ((nodes at:1) asString).
    ^ AstNCName new content:((nodes at:1) value).

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNameTest1:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ XMLv2::XPathNameTest new qName:(nodes at:1) content

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNameTest2:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ (XMLv2::XPathNameTest new)
        prefix:'*';
        localName:'*'

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNameTest3:nodes 
    self informAboutRuleReduction:'NameTest1'.
    ^ (XMLv2::XPathNameTest new)
        prefix:'*';
        localName:(nodes at:3) content

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNamespaceDecl1:nodes 
    ^ (AstNamespaceDecl new)
        prefix:(nodes at:3);
        nsuri:(nodes at:5)

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNewNameExpr1:nodes 
    self informAboutRuleReduction:'NewNameExpr'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNodeComp1:nodes 
    self informAboutRuleReduction:'NodeComp1'.
    ^ #is.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNodeComp2:nodes 
    self informAboutRuleReduction:'NodeComp2'.
    ^ #isLess.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNodeComp3:nodes 
    self informAboutRuleReduction:'NodeComp3'.
    ^ #isMore.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNodeTest1:nodes 
    self informAboutRuleReduction:'NodeTest1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNodeTest2:nodes 
    self informAboutRuleReduction:'NodeTest2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNumericLiteral1:nodes 
    self informAboutRuleReduction:'NumericLiteral1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNumericLiteral2:nodes 
    self informAboutRuleReduction:'NumericLiteral2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForNumericLiteral3:nodes 
    self informAboutRuleReduction:'NumericLiteral3'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOneOrMoreParamList1:nodes 
    ^ (nodes at:1)
        add:(nodes at:3);
        yourself

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOneOrMoreParamList2:nodes 
    ^ OrderedCollection with:(nodes at:1)

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOptional__Group______updating_1:nodes 
    ^ nil
!

reduceActionForOptional__Group______updating_2:nodes 
    ^ nodes at:1
!

reduceActionForOptional__Group______value___of_1:nodes 
    ^ nil

    "Modified: / 31-10-2007 / 09:24:55 / janfrog"
!

reduceActionForOptional__Group______value___of_2:nodes 
    ^ nodes at:1

    "Modified: / 31-10-2007 / 09:24:55 / janfrog"
!

reduceActionForOptional___updating_1:nodes 
    ^ nil

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOptional___updating_2:nodes 
    ^ nodes at:1

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrExpr1:nodes 
    self informAboutRuleReduction:'OrExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrExpr2:nodes 
    self informAboutRuleReduction:'OrExpr2'.
    ^ (AstOrExpr new)
        andExpr:(nodes at:1);
        orExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderByClause1:nodes 
    self informAboutRuleReduction:'OrderByClause1'.
    ^ (AstOrderByClause new)
        isStable:false;
        orderSpecList:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderByClause2:nodes 
    self informAboutRuleReduction:'OrderByClause2'.
    ^ (AstOrderByClause new)
        isStable:true;
        orderSpecList:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderModifier1:nodes 
    self informAboutRuleReduction:'OrderModifier1'.
    ^ AstOrderModifier new ascDesc:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderModifier2:nodes 
    self informAboutRuleReduction:'OrderModifier2'.
    ^ AstOrderModifier new greatestLeast:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderModifier3:nodes 
    self informAboutRuleReduction:'OrderModifier3'.
    ^ (AstOrderModifier new)
        ascDesc:(nodes at:1);
        greatestLeast:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderModifier_AscDesc1:nodes 
    self informAboutRuleReduction:'OrderModifier_AscDesc1'.
    ^ #asc.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderModifier_AscDesc2:nodes 
    self informAboutRuleReduction:'OrderModifier_AscDesc2'.
    ^ #desc.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderModifier_GreatestLeast1:nodes 
    self informAboutRuleReduction:'OrderModifier_GreatestLeast1'.
    ^ #greatest.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderModifier_GreatestLeast2:nodes 
    self informAboutRuleReduction:'OrderModifier_GreatestLeast2'.
    ^ #least.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderSpec1:nodes 
    self informAboutRuleReduction:'OrderSpec1'.
    ^ AstOrderSpec new exprSingle:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderSpec2:nodes 
    self informAboutRuleReduction:'OrderSpec2'.
    ^ (AstOrderSpec new)
        exprSingle:(nodes at:1);
        orderModifier:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderSpecList1:nodes 
    self informAboutRuleReduction:'OrderSpecList1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderSpecList2:nodes 
    self informAboutRuleReduction:'OrderSpecList2'.
    ^ (AstOrderSpecList new)
        orderSpec:(nodes at:1);
        orderSpecList:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForOrderedExpr1:nodes 
    self informAboutRuleReduction:'OrderedExpr1'.
    ^ nodes at:3.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForParam1:nodes 
    ^ AstParam new name:(nodes at:2)

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForParamList1:nodes 
    ^ nodes at:1

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForParamList2:nodes 
    ^ '2'

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForParenthesizedExpr1:nodes 
    self informAboutRuleReduction:'ParenthesizedExpr1'.
    ^ AstParenthesizedExpr new.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForParenthesizedExpr2:nodes 
    self informAboutRuleReduction:'ParenthesizedExpr2'.
    ^ AstParenthesizedExpr new expr:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPathExpr1:nodes 
    self informAboutRuleReduction:'PathExpr2'.
    ^ (nodes at:2)
        absolute:true;
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPathExpr2:nodes 
    self informAboutRuleReduction:'PathExpr3'.
    ^ (nodes at:2)
        addFirst:((XMLv2::XPathLocationStep new)
                    axis:XMLv2::XPathAxisDescendantOrSelf new;
                    nodeTest:XMLv2::XPathAnyKindTest new);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPathExpr3:nodes 
    self informAboutRuleReduction:'PathExpr4'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPositionalVar1:nodes 
    self informAboutRuleReduction:'PositionalVar1'.
    ^ nodes at:3.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPredefinedEntityRef1:nodes 
    self informAboutRuleReduction:'PredefinedEntityRef1 -' 
                , ((nodes at:1) asString).
    ^ AstPredefinedEntityRef new content:((nodes at:1) value).

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPredicate1:nodes 
    self informAboutRuleReduction:'Predicate1'.
    ^ XMLv2::XPathPredicate new expr:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPredicate2:nodes 
    self informAboutRuleReduction:'Predicate2'.
    ^ XMLv2::XPathPredicate new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPredicateList1:nodes 
    self informAboutRuleReduction:'PredicateList1'.
    ^ nodes at:1.

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForPredicateList2:nodes 
    self informAboutRuleReduction:'PredicateList2'.
    ^ (AstPredicateList new)
        predicate:(nodes at:1);
        predicateList:(nodes at:2).

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForPrimaryExpr1:nodes 
    self informAboutRuleReduction:'PrimaryExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrimaryExpr2:nodes 
    self informAboutRuleReduction:'PrimaryExpr2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrimaryExpr3:nodes 
    self informAboutRuleReduction:'PrimaryExpr3'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrimaryExpr4:nodes 
    self informAboutRuleReduction:'PrimaryExpr4'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrimaryExpr5:nodes 
    self informAboutRuleReduction:'PrimaryExpr5'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrimaryExpr6:nodes 
    self informAboutRuleReduction:'PrimaryExpr6'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrimaryExpr7:nodes 
    self informAboutRuleReduction:'PrimaryExpr7'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrimaryExpr8:nodes 
    self informAboutRuleReduction:'PrimaryExpr8'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForProlog1:nodes 
    ^ AstProlog new declarations:((nodes at:1)
                addAll:(nodes at:2);
                yourself)

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClass11:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass12:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass13:nodes 
    ^ nodes at:1
!

reduceActionForPrologDeclarationClass1List1:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForPrologDeclarationClass1List2:nodes 
    ^ OrderedCollection new:5
!

reduceActionForPrologDeclarationClass21:nodes 
    ^ nodes at:1

    "Modified: / 28-12-2006 / 13:35:22 / janfrog"
!

reduceActionForPrologDeclarationClass2List1:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 09:42:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClass2List2:nodes 
    ^ OrderedCollection new:5

    "Modified: / 01-12-2008 / 09:42:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClassA1:nodes 
    ^ AstModuleImport new uri:(nodes at:3)

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClassA2:nodes 
    ^ (AstModuleImport new)
        prefix:(nodes at:4);
        uri:(nodes at:6)

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClassB1:nodes 
    ^ nodes at:1

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClassB2:nodes 
    ^ nodes at:1

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForPrologDeclarationClassB3:nodes 
    ^ nodes at:1

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForQName1:nodes 
    self informAboutRuleReduction:'QName1 - ' , ((nodes at:1) asString).
    ^ AstQName new content:((nodes at:1) value).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForQuantifiedExpr1:nodes 
    self informAboutRuleReduction:'QuantifiedExpr1'.
    ^ (AstQuantifiedExpr new)
        someEvery:#some;
        quantifiedExpr_Impl:(nodes at:2);
        exprSingle:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForQuantifiedExpr2:nodes 
    self informAboutRuleReduction:'QuantifiedExpr2'.
    ^ (AstQuantifiedExpr new)
        someEvery:#every;
        quantifiedExpr_Impl:(nodes at:2);
        exprSingle:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForQuantifiedExpr_Impl1:nodes 
    self informAboutRuleReduction:'QuantifiedExpr_Impl1'.
    ^ (AstQuantifiedExpr_Impl new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForQuantifiedExpr_Impl2:nodes 
    self informAboutRuleReduction:'QuantifiedExpr_Impl2'.
    ^ (AstQuantifiedExpr_Impl new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        quantifiedExpr_Impl:(nodes at:6).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForQueryBody1:nodes 
    self informAboutRuleReduction:'QueryBody1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRangeExpr1:nodes 
    self informAboutRuleReduction:'RangeExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRangeExpr2:nodes 
    self informAboutRuleReduction:'RangeExpr2'.
    ^ (AstRangeExpr new)
        additiveExprFrom:(nodes at:1);
        additiveExprTo:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRelativePathExpr1:nodes 
    self informAboutRuleReduction:'RelativePathExpr1'.
    ^ XMLv2::XPathExpression with:(nodes at:1).

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRelativePathExpr2:nodes 
    self informAboutRuleReduction:'RelativePathExpr2'.
    ^ (nodes at:1)
        add:(nodes at:3);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRelativePathExpr3:nodes 
    self informAboutRuleReduction:'RelativePathExpr3'.
    ^ (nodes at:1)
        add:((XMLv2::XPathLocationStep new)
                    axis:XMLv2::XPathAxisDescendantOrSelf new;
                    nodeTest:XMLv2::XPathAnyKindTest new);
        add:(nodes at:3);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRenameExpr1:nodes 
    self informAboutRuleReduction:'RenameExpr'.
    ^ (AstRenameExpr new)
        targetExpr:(nodes at:3);
        newNameExpr:(nodes at:5).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__Group_____________VarName______ExprSingle1:nodes 
    ^ OrderedCollection new
!

reduceActionForRepeat__Group_____________VarName______ExprSingle2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself
!

reduceActionForRepeat__Predicate1:nodes 
    ^ OrderedCollection new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__Predicate2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__PrologDeclarationClassA1:nodes 
    ^ OrderedCollection new

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__PrologDeclarationClassA2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__PrologDeclarationClassAList1:nodes 
    ^ OrderedCollection new

    "Created: / 01-12-2008 / 09:40:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__PrologDeclarationClassAList2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself

    "Created: / 01-12-2008 / 09:40:26 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__PrologDeclarationClassB1:nodes 
    ^ OrderedCollection new

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForRepeat__PrologDeclarationClassB2:nodes 
    ^ (nodes at:1)
        add:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReplaceClause1:nodes 
    self informAboutRuleReduction:'ReplaceValueOfClause'.
    ^ (AstReplaceValueOfExpr new)
        targetExpr:(nodes at:3);
        sourceExpr:(nodes at:5).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReplaceClause2:nodes 
    self informAboutRuleReduction:'ReplaceClause'.
    ^ (AstReplaceExpr new)
        targetExpr:(nodes at:1);
        sourceExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReplaceExpr1:nodes 
    self informAboutRuleReduction:'ReplaceExpr'.
    ^ nodes at:3.

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReverseAxis1:nodes 
    self informAboutRuleReduction:'ReverseAxis1'.
    ^ XMLv2::XPathAxisParent new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReverseAxis2:nodes 
    self informAboutRuleReduction:'ReverseAxis2'.
    ^ XMLv2::XPathAxisAncestor new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReverseAxis3:nodes 
    self informAboutRuleReduction:'ReverseAxis3'.
    ^ XMLv2::XPathAxisAncestorOrSelf new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReverseAxis4:nodes 
    self informAboutRuleReduction:'ReverseAxis4'.
    ^ XMLv2::XPathAxisPrecedingSibling new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReverseAxis5:nodes 
    self informAboutRuleReduction:'ReverseAxis5'.
    ^ XMLv2::XPathAxisPreceding new

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReverseStep1:nodes 
    self informAboutRuleReduction:'ReverseStep1'.
    ^ (XMLv2::XPathLocationStep new)
        axis:(nodes at:1);
        nodeTest:(nodes at:2);
        yourself

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForReverseStep2:nodes 
    self informAboutRuleReduction:'ReverseStep2'.
    ^ nodes at:1

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForSourceExpr1:nodes 
    self informAboutRuleReduction:'SourceExpr'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForStepExpr1:nodes 
    self informAboutRuleReduction:'StepExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForStepExpr2:nodes 
    self informAboutRuleReduction:'StepExpr2'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForStringLiteral1:nodes 
    self 
        informAboutRuleReduction:'StringLiteral1 -' , ((nodes at:1) asString).
    ^ AstStringLiteral new content:((nodes at:1) value).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForTargetExpr1:nodes 
    self informAboutRuleReduction:'TargetExpr'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForTextTest1:nodes 
    self informAboutRuleReduction:'TextTest1'.
    ^ XMLv2::XPathTextTest new.

    "Modified: / 01-12-2008 / 10:19:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForTransformCopyClause1:nodes 
    self informAboutRuleReduction:'TransformCopyClause1'.
    ^ (AstTransformCopyClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForTransformCopyClause2:nodes 
    self informAboutRuleReduction:'TransformCopyClause2'.
    ^ (AstTransformCopyClause new)
        varName:(nodes at:2);
        exprSingle:(nodes at:4);
        transformCopyClause:(nodes at:6).

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForTransformExpr1:nodes 
    self informAboutRuleReduction:'TransformExpr'.
    ^ (AstTransformExpr new)
        transformCopyClause:(nodes at:3);
        modifyExpr:(nodes at:5);
        returnExpr:(nodes at:7).

    "Modified: / 01-12-2008 / 10:19:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForURILiteral1:nodes 
    ^ nodes at:1

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForUnaryExpr1:nodes 
    self informAboutRuleReduction:'UnaryExpr1'.
    ^ (AstUnaryExpr new)
        operand:#minus;
        unaryExpr:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForUnaryExpr2:nodes 
    self informAboutRuleReduction:'UnaryExpr2'.
    ^ (AstUnaryExpr new)
        operand:#plus;
        unaryExpr:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForUnaryExpr3:nodes 
    self informAboutRuleReduction:'UnaryExpr3'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForUnionExpr1:nodes 
    self informAboutRuleReduction:'UnionExpr1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForUnionExpr2:nodes 
    self informAboutRuleReduction:'UnionExpr2'.
    ^ (AstUnionExpr new)
        intersectExceptExpr:(nodes at:1);
        unionExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForUnionExpr3:nodes 
    self informAboutRuleReduction:'UnionExpr3'.
    ^ (AstUnionExpr new)
        intersectExceptExpr:(nodes at:1);
        unionExpr:(nodes at:3).

    "Modified: / 01-12-2008 / 10:19:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForUnorderedExpr1:nodes 
    self informAboutRuleReduction:'UnorderedExpr1'.
    ^ nodes at:3.

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForValueComp1:nodes 
    self informAboutRuleReduction:'ValueComp1'.
    ^ #eqValue.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForValueComp2:nodes 
    self informAboutRuleReduction:'ValueComp2'.
    ^ #neValue.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForValueComp3:nodes 
    self informAboutRuleReduction:'ValueComp3'.
    ^ #ltValue.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForValueComp4:nodes 
    self informAboutRuleReduction:'ValueComp4'.
    ^ #leValue.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForValueComp5:nodes 
    self informAboutRuleReduction:'ValueComp5'.
    ^ #gtValue.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForValueComp6:nodes 
    self informAboutRuleReduction:'ValueComp6'.
    ^ #geValue.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForValueExpr1:nodes 
    self informAboutRuleReduction:'ValueExpr'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForVarName1:nodes 
    self informAboutRuleReduction:'VarName1'.
    ^ nodes at:1.

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForVarRef1:nodes 
    self informAboutRuleReduction:'VarRef1'.
    ^ AstVarRef new varName:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForWhereClause1:nodes 
    self informAboutRuleReduction:'WhereClause1'.
    ^ AstWhereClause new exprSingle:(nodes at:2).

    "Modified: / 01-12-2008 / 10:19:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

reduceActionForWildcard1:nodes 
    self informAboutRuleReduction:'Wildcard1'.
    ^ AstWildcard new.

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
!

reduceActionForWildcard2:nodes 
    self informAboutRuleReduction:'Wildcard2'.
    ^ AstWildcard new ncName:(nodes at:3).

    "Modified: / 17-11-2007 / 14:00:00 / janfrog"
! !

!XQueryParser methodsFor:'generated-tables'!

reduceTable
	^#(
#(121 1 #reduceActionForURILiteral1:)
#(122 1 #reduceActionForNCName1:)
#(123 6 #reduceActionForDefaultNamespaceDecl1:)
#(123 6 #reduceActionForDefaultNamespaceDecl2:)
#(124 6 #reduceActionForNamespaceDecl1:)
#(125 9 #reduceActionForFunctionDecl1:)
#(126 1 #reduceActionForStringLiteral1:)
#(127 0 #'reduceActionForOptional___updating_1:')
#(127 1 #'reduceActionForOptional___updating_2:')
#(128 1 #reduceActionForQName1:)
#(129 1 #reduceActionForParamList1:)
#(129 1 #reduceActionForParamList2:)
#(130 3 #reduceActionForEnclosedExpr1:)
#(131 3 #reduceActionForOneOrMoreParamList1:)
#(131 1 #reduceActionForOneOrMoreParamList2:)
#(132 0 #reduceActionForEmptyParamList1:)
#(133 2 #reduceActionForParam1:)
#(134 1 #reduceActionForExpr1:)
#(134 3 #reduceActionForExpr2:)
#(135 1 #reduceActionForExprSingle1:)
#(135 1 #reduceActionForExprSingle2:)
#(135 1 #reduceActionForExprSingle3:)
#(135 1 #reduceActionForExprSingle4:)
#(135 1 #reduceActionForExprSingle5:)
#(135 1 #reduceActionForExprSingle6:)
#(135 1 #reduceActionForExprSingle7:)
#(135 1 #reduceActionForExprSingle8:)
#(135 1 #reduceActionForExprSingle9:)
#(136 3 #reduceActionForFLWORExpr1:)
#(136 4 #reduceActionForFLWORExpr2:)
#(136 4 #reduceActionForFLWORExpr3:)
#(136 5 #reduceActionForFLWORExpr4:)
#(137 4 #reduceActionForQuantifiedExpr1:)
#(137 4 #reduceActionForQuantifiedExpr2:)
#(138 8 #reduceActionForIfExpr1:)
#(139 1 #reduceActionForOrExpr1:)
#(139 3 #reduceActionForOrExpr2:)
#(140 3 #reduceActionForDeleteExpr1:)
#(141 5 #reduceActionForRenameExpr1:)
#(142 3 #reduceActionForReplaceExpr1:)
#(143 3 #reduceActionForInsertExpr1:)
#(144 7 #reduceActionForTransformExpr1:)
#(145 1 #'reduceActionForFLWORExpr_ForLet1:')
#(145 1 #'reduceActionForFLWORExpr_ForLet2:')
#(145 2 #'reduceActionForFLWORExpr_ForLet3:')
#(145 2 #'reduceActionForFLWORExpr_ForLet4:')
#(146 2 #reduceActionForWhereClause1:)
#(147 3 #reduceActionForOrderByClause1:)
#(147 4 #reduceActionForOrderByClause2:)
#(148 2 #reduceActionForForClause1:)
#(149 2 #reduceActionForLetClause1:)
#(150 4 #'reduceActionForForClause_Impl1:')
#(150 6 #'reduceActionForForClause_Impl2:')
#(150 5 #'reduceActionForForClause_Impl3:')
#(150 7 #'reduceActionForForClause_Impl4:')
#(151 1 #reduceActionForVarName1:)
#(152 3 #reduceActionForPositionalVar1:)
#(153 4 #'reduceActionForLetClause_Impl1:')
#(153 6 #'reduceActionForLetClause_Impl2:')
#(154 1 #reduceActionForOrderSpecList1:)
#(154 3 #reduceActionForOrderSpecList2:)
#(155 1 #reduceActionForOrderSpec1:)
#(155 2 #reduceActionForOrderSpec2:)
#(156 1 #reduceActionForOrderModifier1:)
#(156 1 #reduceActionForOrderModifier2:)
#(156 2 #reduceActionForOrderModifier3:)
#(157 1 #'reduceActionForOrderModifier_AscDesc1:')
#(157 1 #'reduceActionForOrderModifier_AscDesc2:')
#(158 2 #'reduceActionForOrderModifier_GreatestLeast1:')
#(158 2 #'reduceActionForOrderModifier_GreatestLeast2:')
#(159 4 #'reduceActionForQuantifiedExpr_Impl1:')
#(159 6 #'reduceActionForQuantifiedExpr_Impl2:')
#(160 1 #reduceActionForAndExpr1:)
#(160 3 #reduceActionForAndExpr2:)
#(161 1 #reduceActionForComparisonExpr1:)
#(161 3 #reduceActionForComparisonExpr2:)
#(161 3 #reduceActionForComparisonExpr3:)
#(161 3 #reduceActionForComparisonExpr4:)
#(162 1 #reduceActionForRangeExpr1:)
#(162 3 #reduceActionForRangeExpr2:)
#(163 1 #reduceActionForValueComp1:)
#(163 1 #reduceActionForValueComp2:)
#(163 1 #reduceActionForValueComp3:)
#(163 1 #reduceActionForValueComp4:)
#(163 1 #reduceActionForValueComp5:)
#(163 1 #reduceActionForValueComp6:)
#(164 1 #reduceActionForGeneralComp1:)
#(164 1 #reduceActionForGeneralComp2:)
#(164 1 #reduceActionForGeneralComp3:)
#(164 1 #reduceActionForGeneralComp4:)
#(164 1 #reduceActionForGeneralComp5:)
#(164 1 #reduceActionForGeneralComp6:)
#(165 1 #reduceActionForNodeComp1:)
#(165 1 #reduceActionForNodeComp2:)
#(165 1 #reduceActionForNodeComp3:)
#(166 1 #reduceActionForAdditiveExpr1:)
#(166 3 #reduceActionForAdditiveExpr2:)
#(166 3 #reduceActionForAdditiveExpr3:)
#(167 1 #reduceActionForMultiplicativeExpr1:)
#(167 3 #reduceActionForMultiplicativeExpr2:)
#(167 3 #reduceActionForMultiplicativeExpr3:)
#(167 3 #reduceActionForMultiplicativeExpr4:)
#(167 3 #reduceActionForMultiplicativeExpr5:)
#(168 1 #reduceActionForUnionExpr1:)
#(168 3 #reduceActionForUnionExpr2:)
#(168 3 #reduceActionForUnionExpr3:)
#(169 1 #reduceActionForIntersectExceptExpr1:)
#(169 3 #reduceActionForIntersectExceptExpr2:)
#(169 3 #reduceActionForIntersectExceptExpr3:)
#(170 2 #reduceActionForUnaryExpr1:)
#(170 2 #reduceActionForUnaryExpr2:)
#(170 1 #reduceActionForUnaryExpr3:)
#(171 2 #reduceActionForMainModule1:)
#(172 2 #reduceActionForPathExpr1:)
#(172 2 #reduceActionForPathExpr2:)
#(172 1 #reduceActionForPathExpr3:)
#(173 1 #reduceActionForRelativePathExpr1:)
#(173 3 #reduceActionForRelativePathExpr2:)
#(173 3 #reduceActionForRelativePathExpr3:)
#(174 1 #reduceActionForStepExpr1:)
#(174 1 #reduceActionForStepExpr2:)
#(175 2 #reduceActionForAxisStep1:)
#(175 2 #reduceActionForAxisStep2:)
#(176 2 #reduceActionForFilterExpr1:)
#(177 2 #reduceActionForForwardStep1:)
#(177 1 #reduceActionForForwardStep2:)
#(178 3 #reduceActionForPredicate1:)
#(178 2 #reduceActionForPredicate2:)
#(179 0 #'reduceActionForRepeat__Predicate1:')
#(179 2 #'reduceActionForRepeat__Predicate2:')
#(180 2 #reduceActionForReverseStep1:)
#(180 1 #reduceActionForReverseStep2:)
#(181 2 #reduceActionForForwardAxis1:)
#(181 2 #reduceActionForForwardAxis2:)
#(181 2 #reduceActionForForwardAxis3:)
#(181 2 #reduceActionForForwardAxis4:)
#(181 2 #reduceActionForForwardAxis5:)
#(181 2 #reduceActionForForwardAxis6:)
#(181 2 #reduceActionForForwardAxis7:)
#(182 1 #reduceActionForNodeTest1:)
#(182 1 #reduceActionForNodeTest2:)
#(183 2 #reduceActionForAbbrevForwardStep1:)
#(183 1 #reduceActionForAbbrevForwardStep2:)
#(184 2 #reduceActionForReverseAxis1:)
#(184 2 #reduceActionForReverseAxis2:)
#(184 2 #reduceActionForReverseAxis3:)
#(184 2 #reduceActionForReverseAxis4:)
#(184 2 #reduceActionForReverseAxis5:)
#(185 1 #reduceActionForAbbrevReverseStep1:)
#(186 1 #reduceActionForNameTest1:)
#(186 1 #reduceActionForNameTest2:)
#(186 3 #reduceActionForNameTest3:)
#(187 1 #reduceActionForKindTest1:)
#(187 1 #reduceActionForKindTest2:)
#(187 1 #reduceActionForKindTest3:)
#(187 1 #reduceActionForKindTest4:)
#(187 1 #reduceActionForKindTest5:)
#(187 3 #reduceActionForKindTest6:)
#(187 3 #reduceActionForKindTest7:)
#(188 1 #reduceActionForPrimaryExpr1:)
#(188 1 #reduceActionForPrimaryExpr2:)
#(188 1 #reduceActionForPrimaryExpr3:)
#(188 1 #reduceActionForPrimaryExpr4:)
#(188 1 #reduceActionForPrimaryExpr5:)
#(188 1 #reduceActionForPrimaryExpr6:)
#(188 1 #reduceActionForPrimaryExpr7:)
#(188 1 #reduceActionForPrimaryExpr8:)
#(189 1 #reduceActionForLiteral1:)
#(189 1 #reduceActionForLiteral2:)
#(190 2 #reduceActionForVarRef1:)
#(191 2 #reduceActionForParenthesizedExpr1:)
#(191 3 #reduceActionForParenthesizedExpr2:)
#(192 1 #reduceActionForContextItemExpr1:)
#(193 3 #reduceActionForFunctionCall1:)
#(193 4 #reduceActionForFunctionCall2:)
#(194 1 #reduceActionForConstructor1:)
#(194 1 #reduceActionForConstructor2:)
#(195 4 #reduceActionForOrderedExpr1:)
#(196 4 #reduceActionForUnorderedExpr1:)
#(197 1 #reduceActionForNumericLiteral1:)
#(197 1 #reduceActionForNumericLiteral2:)
#(197 1 #reduceActionForNumericLiteral3:)
#(198 1 #reduceActionForIntegerLiteral1:)
#(199 1 #reduceActionForDecimalLiteral1:)
#(200 1 #reduceActionForDoubleLiteral1:)
#(201 1 #reduceActionForFunctionParametersList1:)
#(201 3 #reduceActionForFunctionParametersList2:)
#(202 1 #reduceActionForDirectConstructor1:)
#(203 1 #reduceActionForComputedConstructor1:)
#(203 1 #reduceActionForComputedConstructor2:)
#(203 1 #reduceActionForComputedConstructor3:)
#(203 1 #reduceActionForComputedConstructor4:)
#(204 3 #reduceActionForDirElemConstructor1:)
#(204 4 #reduceActionForDirElemConstructor2:)
#(204 7 #reduceActionForDirElemConstructor3:)
#(204 8 #reduceActionForDirElemConstructor4:)
#(205 3 #reduceActionForDirAttributeList1:)
#(205 4 #reduceActionForDirAttributeList2:)
#(206 1 #reduceActionForDirElemContent1:)
#(206 2 #reduceActionForDirElemContent2:)
#(206 1 #reduceActionForDirElemContent3:)
#(206 2 #reduceActionForDirElemContent4:)
#(207 1 #reduceActionForDirAttributeValue1:)
#(207 1 #reduceActionForDirAttributeValue2:)
#(208 1 #reduceActionForCommonContent1:)
#(208 1 #reduceActionForCommonContent2:)
#(208 1 #reduceActionForCommonContent3:)
#(208 1 #reduceActionForCommonContent4:)
#(208 1 #reduceActionForCommonContent5:)
#(209 1 #reduceActionForPredefinedEntityRef1:)
#(210 4 #reduceActionForCompDocConstructor1:)
#(211 4 #reduceActionForCompElemConstructor1:)
#(211 5 #reduceActionForCompElemConstructor2:)
#(211 6 #reduceActionForCompElemConstructor3:)
#(211 7 #reduceActionForCompElemConstructor4:)
#(212 4 #reduceActionForCompAttrConstructor1:)
#(212 5 #reduceActionForCompAttrConstructor2:)
#(212 6 #reduceActionForCompAttrConstructor3:)
#(212 7 #reduceActionForCompAttrConstructor4:)
#(213 4 #reduceActionForCompTextConstructor1:)
#(214 1 #reduceActionForContentExpr1:)
#(215 3 #reduceActionForDocumentTest1:)
#(215 4 #reduceActionForDocumentTest2:)
#(216 3 #reduceActionForElementTest1:)
#(216 4 #reduceActionForElementTest2:)
#(217 3 #reduceActionForAttributeTest1:)
#(217 4 #reduceActionForAttributeTest2:)
#(218 3 #reduceActionForTextTest1:)
#(219 3 #reduceActionForAnyKindTest1:)
#(220 1 #reduceActionForAttribNameOrWildcard1:)
#(220 1 #reduceActionForAttribNameOrWildcard2:)
#(221 1 #reduceActionForAttributeName1:)
#(222 1 #reduceActionForElementNameOrWildcard1:)
#(222 1 #reduceActionForElementNameOrWildcard2:)
#(223 1 #reduceActionForElementName1:)
#(224 0 #'reduceActionForRepeat__PrologDeclarationClassA1:')
#(224 2 #'reduceActionForRepeat__PrologDeclarationClassA2:')
#(225 4 #reduceActionForPrologDeclarationClassA1:)
#(225 7 #reduceActionForPrologDeclarationClassA2:)
#(226 1 #reduceFor:)
#(227 1 #reduceActionForPrologDeclarationClassB1:)
#(227 1 #reduceActionForPrologDeclarationClassB2:)
#(227 1 #reduceActionForPrologDeclarationClassB3:)
#(228 1 #reduceActionForQueryBody1:)
#(229 1 #reduceActionForValueExpr1:)
#(230 2 #reduceActionForProlog1:)
#(231 1 #reduceActionForTargetExpr1:)
#(232 1 #reduceActionForNewNameExpr1:)
#(233 5 #reduceActionForReplaceClause1:)
#(233 3 #reduceActionForReplaceClause2:)
#(234 3 #reduceActionForInsertClause1:)
#(234 5 #reduceActionForInsertClause2:)
#(234 5 #reduceActionForInsertClause3:)
#(234 3 #reduceActionForInsertClause4:)
#(234 3 #reduceActionForInsertClause5:)
#(235 1 #reduceActionForSourceExpr1:)
#(236 4 #reduceActionForTransformCopyClause1:)
#(236 6 #reduceActionForTransformCopyClause2:)
#(239 0 #'reduceActionForRepeat__PrologDeclarationClassB1:')
#(239 2 #'reduceActionForRepeat__PrologDeclarationClassB2:')
)

    "Modified: / 01-12-2008 / 10:19:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

transitionTable
	^#(
#[1 3 178 0 5 3 178 0 7 3 178 0 9 3 178 0 12 3 178 0 13 3 178 0 14 3 178 0 15 3 178 0 29 3 178 0 34 3 178 0 35 3 178 0 36 3 178 0 39 3 178 0 51 3 178 0 54 3 178 0 58 3 178 0 59 3 178 0 60 3 178 0 61 3 178 0 63 3 178 0 64 3 178 0 66 3 178 0 69 3 178 0 78 3 178 0 84 3 178 0 86 3 178 0 88 3 178 0 89 3 178 0 90 3 178 0 91 3 178 0 92 3 178 0 96 3 178 0 98 3 178 0 100 3 178 0 103 3 178 0 104 3 178 0 105 3 178 0 107 3 178 0 108 3 178 0 109 3 178 0 111 3 178 0 112 3 178 0 115 3 178 0 116 3 178 0 117 3 178 0 118 3 178 0 120 0 13 0 171 0 17 0 224 0 21 0 230]
#[1 3 178 0 5 3 178 0 7 3 178 0 9 3 178 0 12 3 178 0 13 3 178 0 14 3 178 0 15 3 178 0 29 3 178 0 34 3 178 0 35 3 178 0 36 3 178 0 39 3 178 0 51 3 178 0 54 3 178 0 58 3 178 0 59 3 178 0 60 3 178 0 61 3 178 0 63 3 178 0 64 3 178 0 66 3 178 0 69 3 178 0 78 3 178 0 84 3 178 0 86 3 178 0 88 3 178 0 89 3 178 0 90 3 178 0 91 3 178 0 92 3 178 0 96 3 178 0 98 3 178 0 100 3 178 0 103 3 178 0 104 3 178 0 105 3 178 0 107 3 178 0 108 3 178 0 109 3 178 0 111 3 178 0 112 3 178 0 115 3 178 0 116 3 178 0 117 3 178 0 118 3 178 0 120 0 25 0 171 0 17 0 224 0 21 0 230]
#[0 0 0 0 237]
#[1 4 14 0 5 4 14 0 7 4 14 0 9 4 14 0 12 4 14 0 13 4 14 0 14 4 14 0 15 4 14 0 29 4 14 0 34 4 14 0 35 0 29 0 36 4 14 0 39 4 14 0 51 4 14 0 54 4 14 0 58 4 14 0 59 4 14 0 60 4 14 0 61 4 14 0 63 4 14 0 64 4 14 0 66 4 14 0 69 4 14 0 78 4 14 0 84 4 14 0 86 4 14 0 88 4 14 0 89 4 14 0 90 4 14 0 91 4 14 0 92 4 14 0 96 4 14 0 98 4 14 0 100 4 14 0 103 4 14 0 104 4 14 0 105 4 14 0 107 4 14 0 108 4 14 0 109 4 14 0 111 4 14 0 112 4 14 0 115 4 14 0 116 4 14 0 117 4 14 0 118 4 14 0 120 0 33 0 225 0 37 0 239]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 0 225 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 213 0 228 1 217 0 229]
#[0 0 0 0 237]
#[0 1 221 0 37]
#[0 3 182 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 36 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[1 3 218 0 5 3 218 0 7 3 218 0 9 3 218 0 12 3 218 0 13 3 218 0 14 3 218 0 15 3 218 0 29 1 225 0 34 3 218 0 35 3 218 0 39 3 218 0 51 3 218 0 54 3 218 0 58 3 218 0 59 3 218 0 60 3 218 0 61 3 218 0 63 3 218 0 64 3 218 0 66 3 218 0 69 3 218 0 78 3 218 0 84 3 218 0 86 3 218 0 88 3 218 0 89 3 218 0 90 3 218 0 91 3 218 0 92 3 218 0 96 3 218 0 98 3 218 0 100 3 218 0 103 3 218 0 104 3 218 0 105 3 218 0 107 3 218 0 108 3 218 0 109 3 218 0 111 3 218 0 112 3 218 0 115 3 218 0 116 3 218 0 117 3 218 0 118 3 218 0 120 1 229 0 123 1 233 0 124 1 237 0 125 1 241 0 227]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 1 245 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 1 249 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 1 253 0 39 2 1 0 159]
#[0 2 5 0 35]
#[1 2 94 0 1 2 94 0 2 2 94 0 3 2 94 0 4 2 94 0 5 2 94 0 7 2 94 0 10 2 94 0 11 2 94 0 13 2 94 0 15 2 94 0 16 2 94 0 17 2 94 0 18 2 94 0 19 2 94 0 20 2 94 0 21 2 94 0 22 2 94 0 23 2 94 0 24 2 94 0 26 2 94 0 27 2 94 0 28 2 94 0 33 2 94 0 40 2 94 0 41 2 94 0 43 2 94 0 45 2 94 0 46 2 94 0 47 2 94 0 49 2 94 0 50 2 94 0 51 2 94 0 53 2 94 0 54 2 94 0 55 2 94 0 57 2 94 0 65 2 94 0 68 2 94 0 73 2 94 0 74 2 94 0 77 2 94 0 85 2 94 0 89 2 94 0 91 2 94 0 93 2 94 0 94 2 94 0 95 2 94 0 97 2 94 0 99 2 9 0 101 2 94 0 102 2 94 0 106 2 94 0 110 2 94 0 237]
#[1 1 253 0 39 2 13 0 159]
#[1 0 197 0 115 2 17 0 128]
#[1 2 21 0 35 2 25 0 82 0 197 0 115 2 29 0 128]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 2 33 0 33 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 2 37 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 197 0 115 2 41 0 128 2 45 0 151]
#[1 2 49 0 39 2 53 0 150]
#[1 2 57 0 39 2 61 0 153]
#[0 2 65 0 35]
#[0 2 69 0 35]
#[0 2 73 0 35]
#[0 2 77 0 35]
#[1 2 81 0 35 2 85 0 82]
#[1 2 89 0 62 2 93 0 70 2 97 0 79 2 101 0 83]
#[0 2 105 0 82]
#[0 2 109 0 82]
#[0 2 113 0 76]
#[0 2 117 0 82]
#[0 2 121 0 87]
#[0 2 125 0 87]
#[1 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 141 0 90 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 2 129 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219]
#[0 2 133 0 87]
#[1 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 141 0 90 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 2 137 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219]
#[1 2 141 0 35 2 145 0 82 2 149 0 87 0 197 0 115 2 153 0 128]
#[0 2 157 0 87]
#[0 2 161 0 87]
#[0 2 86 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 165 0 87]
#[0 2 182 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 169 0 87]
#[0 2 173 0 87]
#[1 0 57 0 13 2 177 0 29 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 2 181 0 63 2 185 0 92 0 197 0 115 2 189 0 128 2 193 0 182 1 105 0 186 1 109 0 187 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219]
#[0 2 197 0 87]
#[0 2 201 0 87]
#[0 2 205 0 87]
#[0 0 42 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 35 0 40 0 41 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 65 0 67 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 222 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 226 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 230 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 0 30 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 38 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 67 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 166 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[1 2 90 0 1 2 90 0 2 2 90 0 3 2 90 0 4 2 90 0 5 2 90 0 7 2 90 0 10 2 90 0 11 2 90 0 13 2 90 0 15 2 90 0 16 2 90 0 17 2 90 0 18 2 90 0 19 2 90 0 20 2 90 0 21 2 90 0 22 2 90 0 23 2 90 0 24 2 90 0 26 2 90 0 27 2 90 0 28 2 90 0 33 2 209 0 35 2 90 0 40 2 90 0 41 2 90 0 43 2 90 0 45 2 90 0 46 2 90 0 47 2 90 0 49 2 90 0 50 2 90 0 51 2 90 0 53 2 90 0 54 2 90 0 55 2 90 0 57 2 90 0 65 2 90 0 68 2 90 0 73 2 90 0 74 2 90 0 77 2 90 0 85 2 90 0 89 2 90 0 91 2 90 0 93 2 90 0 94 2 90 0 95 2 90 0 97 2 90 0 99 2 90 0 102 2 90 0 106 2 90 0 110 2 90 0 237]
#[0 3 210 0 237]
#[1 0 74 0 33 2 213 0 41 0 74 0 65 0 74 0 106 0 74 0 237]
#[0 0 82 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 86 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 90 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 94 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 98 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 102 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 106 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 110 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 114 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[1 2 217 0 43 2 221 0 45 2 225 0 46 2 229 0 50 2 233 0 146 2 237 0 147]
#[1 0 174 0 43 0 174 0 45 0 174 0 46 0 174 0 50 0 81 0 51 0 85 0 54 2 241 0 145 1 17 0 148 1 21 0 149]
#[1 0 178 0 43 0 178 0 45 0 178 0 46 0 178 0 50 0 81 0 51 0 85 0 54 2 245 0 145 1 17 0 148 1 21 0 149]
#[1 2 249 0 1 0 146 0 4 0 146 0 10 0 146 0 27 0 146 0 33 0 146 0 41 0 146 0 43 0 146 0 45 0 146 0 46 0 146 0 47 0 146 0 49 0 146 0 50 0 146 0 51 0 146 0 54 0 146 0 57 0 146 0 65 0 146 0 68 0 146 0 73 0 146 0 74 0 146 0 77 0 146 0 85 0 146 0 106 0 146 0 237]
#[1 1 38 0 1 2 253 0 2 1 38 0 4 1 38 0 10 1 38 0 27 1 38 0 33 1 38 0 41 1 38 0 43 1 38 0 45 1 38 0 46 1 38 0 47 1 38 0 49 1 38 0 50 1 38 0 51 1 38 0 54 1 38 0 57 1 38 0 65 1 38 0 68 1 38 0 73 1 38 0 74 1 38 0 77 1 38 0 85 1 38 0 106 1 38 0 237]
#[1 1 46 0 1 1 46 0 2 1 46 0 4 1 46 0 10 3 1 0 15 3 5 0 16 3 9 0 17 3 13 0 18 3 17 0 19 3 21 0 21 1 46 0 27 1 46 0 33 3 25 0 40 1 46 0 41 1 46 0 43 1 46 0 45 1 46 0 46 1 46 0 47 1 46 0 49 1 46 0 50 1 46 0 51 3 29 0 53 1 46 0 54 3 33 0 55 1 46 0 57 1 46 0 65 1 46 0 68 1 46 0 73 1 46 0 74 1 46 0 77 1 46 0 85 3 37 0 93 3 41 0 94 3 45 0 95 3 49 0 97 3 53 0 99 1 46 0 106 3 57 0 110 3 61 0 163 3 65 0 164 3 69 0 165 1 46 0 237]
#[1 1 62 0 1 1 62 0 2 3 73 0 3 1 62 0 4 1 62 0 10 1 62 0 15 1 62 0 16 1 62 0 17 1 62 0 18 1 62 0 19 1 62 0 21 1 62 0 27 1 62 0 33 1 62 0 40 1 62 0 41 1 62 0 43 1 62 0 45 1 62 0 46 1 62 0 47 1 62 0 49 1 62 0 50 1 62 0 51 1 62 0 53 1 62 0 54 1 62 0 55 1 62 0 57 1 62 0 65 1 62 0 68 1 62 0 73 1 62 0 74 1 62 0 77 1 62 0 85 1 62 0 93 1 62 0 94 1 62 0 95 1 62 0 97 1 62 0 99 1 62 0 106 1 62 0 110 1 62 0 237]
#[1 1 130 0 1 1 130 0 2 1 130 0 3 1 130 0 4 3 77 0 5 3 81 0 7 1 130 0 10 1 130 0 15 1 130 0 16 1 130 0 17 1 130 0 18 1 130 0 19 1 130 0 21 1 130 0 27 1 130 0 33 1 130 0 40 1 130 0 41 1 130 0 43 1 130 0 45 1 130 0 46 1 130 0 47 1 130 0 49 1 130 0 50 1 130 0 51 1 130 0 53 1 130 0 54 1 130 0 55 1 130 0 57 1 130 0 65 1 130 0 68 1 130 0 73 1 130 0 74 1 130 0 77 1 130 0 85 1 130 0 93 1 130 0 94 1 130 0 95 1 130 0 97 1 130 0 99 1 130 0 106 1 130 0 110 1 130 0 237]
#[1 1 142 0 1 1 142 0 2 1 142 0 3 1 142 0 4 1 142 0 5 1 142 0 7 1 142 0 10 3 85 0 11 3 89 0 13 1 142 0 15 1 142 0 16 1 142 0 17 1 142 0 18 1 142 0 19 1 142 0 21 3 93 0 22 3 97 0 23 1 142 0 27 1 142 0 33 1 142 0 40 1 142 0 41 1 142 0 43 1 142 0 45 1 142 0 46 1 142 0 47 1 142 0 49 1 142 0 50 1 142 0 51 1 142 0 53 1 142 0 54 1 142 0 55 1 142 0 57 1 142 0 65 1 142 0 68 1 142 0 73 1 142 0 74 1 142 0 77 1 142 0 85 1 142 0 93 1 142 0 94 1 142 0 95 1 142 0 97 1 142 0 99 1 142 0 106 1 142 0 110 1 142 0 237]
#[1 1 162 0 1 1 162 0 2 1 162 0 3 1 162 0 4 1 162 0 5 1 162 0 7 1 162 0 10 1 162 0 11 1 162 0 13 1 162 0 15 1 162 0 16 1 162 0 17 1 162 0 18 1 162 0 19 1 162 0 21 1 162 0 22 1 162 0 23 3 101 0 24 1 162 0 27 3 105 0 28 1 162 0 33 1 162 0 40 1 162 0 41 1 162 0 43 1 162 0 45 1 162 0 46 1 162 0 47 1 162 0 49 1 162 0 50 1 162 0 51 1 162 0 53 1 162 0 54 1 162 0 55 1 162 0 57 1 162 0 65 1 162 0 68 1 162 0 73 1 162 0 74 1 162 0 77 1 162 0 85 1 162 0 93 1 162 0 94 1 162 0 95 1 162 0 97 1 162 0 99 1 162 0 106 1 162 0 110 1 162 0 237]
#[1 1 174 0 1 1 174 0 2 1 174 0 3 1 174 0 4 1 174 0 5 1 174 0 7 1 174 0 10 1 174 0 11 1 174 0 13 1 174 0 15 1 174 0 16 1 174 0 17 1 174 0 18 1 174 0 19 3 109 0 20 1 174 0 21 1 174 0 22 1 174 0 23 1 174 0 24 3 113 0 26 1 174 0 27 1 174 0 28 1 174 0 33 1 174 0 40 1 174 0 41 1 174 0 43 1 174 0 45 1 174 0 46 1 174 0 47 1 174 0 49 1 174 0 50 1 174 0 51 1 174 0 53 1 174 0 54 1 174 0 55 1 174 0 57 1 174 0 65 1 174 0 68 1 174 0 73 1 174 0 74 1 174 0 77 1 174 0 85 1 174 0 93 1 174 0 94 1 174 0 95 1 174 0 97 1 174 0 99 1 174 0 106 1 174 0 110 1 174 0 237]
#[0 3 214 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[1 1 210 0 1 1 210 0 2 1 210 0 3 1 210 0 4 1 210 0 5 1 210 0 7 1 210 0 10 1 210 0 11 1 210 0 13 1 210 0 15 1 210 0 16 1 210 0 17 1 210 0 18 1 210 0 19 1 210 0 20 1 210 0 21 1 210 0 22 1 210 0 23 1 210 0 24 1 210 0 26 1 210 0 27 1 210 0 28 1 210 0 33 1 210 0 40 1 210 0 41 1 210 0 43 1 210 0 45 1 210 0 46 1 210 0 47 1 210 0 49 1 210 0 50 1 210 0 51 1 210 0 53 1 210 0 54 1 210 0 55 1 210 0 57 1 210 0 65 1 210 0 68 1 210 0 73 1 210 0 74 1 210 0 77 1 210 0 85 3 117 0 89 3 121 0 91 1 210 0 93 1 210 0 94 1 210 0 95 1 210 0 97 1 210 0 99 1 210 0 106 1 210 0 110 1 210 0 237]
#[0 1 214 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 226 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 230 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[1 2 6 0 1 2 6 0 2 2 6 0 3 2 6 0 4 2 6 0 5 2 6 0 7 2 6 0 10 2 6 0 11 2 6 0 13 2 6 0 15 2 6 0 16 2 6 0 17 2 6 0 18 2 6 0 19 2 6 0 20 2 6 0 21 2 6 0 22 2 6 0 23 2 6 0 24 2 6 0 26 2 6 0 27 2 6 0 28 2 6 0 33 2 6 0 40 2 6 0 41 2 6 0 43 2 6 0 45 2 6 0 46 2 6 0 47 2 6 0 49 2 6 0 50 2 6 0 51 2 6 0 53 2 6 0 54 2 6 0 55 2 6 0 57 2 6 0 65 2 6 0 68 2 6 0 73 2 6 0 74 2 6 0 77 2 6 0 85 2 6 0 89 2 6 0 91 2 6 0 93 2 6 0 94 2 6 0 95 2 6 0 97 2 6 0 99 2 6 0 102 2 6 0 106 2 6 0 110 3 125 0 179 2 6 0 237]
#[1 2 6 0 1 2 6 0 2 2 6 0 3 2 6 0 4 2 6 0 5 2 6 0 7 2 6 0 10 2 6 0 11 2 6 0 13 2 6 0 15 2 6 0 16 2 6 0 17 2 6 0 18 2 6 0 19 2 6 0 20 2 6 0 21 2 6 0 22 2 6 0 23 2 6 0 24 2 6 0 26 2 6 0 27 2 6 0 28 2 6 0 33 2 6 0 40 2 6 0 41 2 6 0 43 2 6 0 45 2 6 0 46 2 6 0 47 2 6 0 49 2 6 0 50 2 6 0 51 2 6 0 53 2 6 0 54 2 6 0 55 2 6 0 57 2 6 0 65 2 6 0 68 2 6 0 73 2 6 0 74 2 6 0 77 2 6 0 85 2 6 0 89 2 6 0 91 2 6 0 93 2 6 0 94 2 6 0 95 2 6 0 97 2 6 0 99 2 6 0 102 2 6 0 106 2 6 0 110 3 129 0 179 2 6 0 237]
#[1 0 57 0 13 2 177 0 29 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 2 181 0 63 2 185 0 92 0 197 0 115 2 189 0 128 3 133 0 182 1 105 0 186 1 109 0 187 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219]
#[0 2 62 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 1 250 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 0 57 0 13 2 177 0 29 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 2 181 0 63 2 185 0 92 0 197 0 115 2 189 0 128 3 137 0 182 1 105 0 186 1 109 0 187 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219]
#[0 2 18 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 50 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 54 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 2 6 0 1 2 6 0 2 2 6 0 3 2 6 0 4 2 6 0 5 2 6 0 7 2 6 0 10 2 6 0 11 2 6 0 13 2 6 0 15 2 6 0 16 2 6 0 17 2 6 0 18 2 6 0 19 2 6 0 20 2 6 0 21 2 6 0 22 2 6 0 23 2 6 0 24 2 6 0 26 2 6 0 27 2 6 0 28 2 6 0 33 2 6 0 40 2 6 0 41 2 6 0 43 2 6 0 45 2 6 0 46 2 6 0 47 2 6 0 49 2 6 0 50 2 6 0 51 2 6 0 53 2 6 0 54 2 6 0 55 2 6 0 57 2 6 0 65 2 6 0 68 2 6 0 73 2 6 0 74 2 6 0 77 2 6 0 85 2 6 0 89 2 6 0 91 2 6 0 93 2 6 0 94 2 6 0 95 2 6 0 97 2 6 0 99 2 6 0 102 2 6 0 106 2 6 0 110 3 141 0 179 2 6 0 237]
#[0 2 130 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 134 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 138 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 142 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 146 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 150 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 154 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 158 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 162 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 210 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 214 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 218 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 194 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 198 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 242 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 246 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 250 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 254 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 2 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 102 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 106 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 110 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 114 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 118 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 1 198 0 237]
#[0 1 194 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[1 3 145 0 42 0 213 0 120 3 149 0 121 3 153 0 126]
#[1 0 34 0 30 3 157 0 31 3 161 0 32 3 165 0 42 3 169 0 127]
#[0 3 198 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 3 202 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 3 206 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 4 18 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 186 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 190 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[1 0 197 0 115 2 41 0 128 3 173 0 151]
#[0 3 177 0 10]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 3 181 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 3 185 0 114 3 189 0 122]
#[0 3 193 0 10]
#[1 3 197 0 17 3 201 0 67 0 197 0 115 3 205 0 128 3 209 0 205]
#[1 3 213 0 13 3 217 0 33 0 197 0 115 3 221 0 128 3 225 0 222 3 229 0 223]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 3 233 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 3 237 0 82]
#[0 2 174 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 241 0 33]
#[0 0 226 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 170 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 0 197 0 115 2 41 0 128 3 245 0 151]
#[0 0 202 0 43 0 45 0 46 0 50 0 51 0 54]
#[1 0 197 0 115 2 41 0 128 3 249 0 151]
#[0 0 206 0 43 0 45 0 46 0 50 0 51 0 54]
#[0 3 253 0 33]
#[0 4 1 0 33]
#[1 2 177 0 29 4 5 0 33 4 9 0 216]
#[0 4 13 0 33]
#[0 4 17 0 33]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 21 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 4 29 0 231]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 4 33 0 231]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 4 37 0 80 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 4 41 0 231 4 45 0 233]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 49 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 4 53 0 234 4 57 0 235]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 61 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 65 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 4 69 0 39 4 73 0 236]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 77 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 2 22 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 2 26 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[1 1 206 0 1 1 206 0 2 1 206 0 3 1 206 0 4 1 206 0 5 1 206 0 7 1 206 0 10 1 206 0 11 1 206 0 13 1 206 0 15 1 206 0 16 1 206 0 17 1 206 0 18 1 206 0 19 1 206 0 20 1 206 0 21 1 206 0 22 1 206 0 23 1 206 0 24 1 206 0 26 1 206 0 27 1 206 0 28 1 206 0 33 1 206 0 40 1 206 0 41 1 206 0 43 1 206 0 45 1 206 0 46 1 206 0 47 1 206 0 49 1 206 0 50 1 206 0 51 1 206 0 53 1 206 0 54 1 206 0 55 1 206 0 57 1 206 0 65 1 206 0 68 1 206 0 73 1 206 0 74 1 206 0 77 1 206 0 85 3 117 0 89 3 121 0 91 1 206 0 93 1 206 0 94 1 206 0 95 1 206 0 97 1 206 0 99 1 206 0 106 1 206 0 110 1 206 0 237]
#[0 2 34 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[1 1 202 0 1 1 202 0 2 1 202 0 3 1 202 0 4 1 202 0 5 1 202 0 7 1 202 0 10 1 202 0 11 1 202 0 13 1 202 0 15 1 202 0 16 1 202 0 17 1 202 0 18 1 202 0 19 1 202 0 20 1 202 0 21 1 202 0 22 1 202 0 23 1 202 0 24 1 202 0 26 1 202 0 27 1 202 0 28 1 202 0 33 1 202 0 40 1 202 0 41 1 202 0 43 1 202 0 45 1 202 0 46 1 202 0 47 1 202 0 49 1 202 0 50 1 202 0 51 1 202 0 53 1 202 0 54 1 202 0 55 1 202 0 57 1 202 0 65 1 202 0 68 1 202 0 73 1 202 0 74 1 202 0 77 1 202 0 85 3 117 0 89 3 121 0 91 1 202 0 93 1 202 0 94 1 202 0 95 1 202 0 97 1 202 0 99 1 202 0 106 1 202 0 110 1 202 0 237]
#[1 4 81 0 13 4 85 0 33 0 197 0 115 4 89 0 128 4 93 0 220 4 97 0 221]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 101 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 2 30 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 4 105 0 82]
#[0 2 42 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 2 38 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 2 82 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 2 78 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 2 46 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 2 21 0 35]
#[0 2 81 0 35]
#[0 2 141 0 35]
#[0 2 90 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 58 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 66 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 2 74 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[0 2 70 0 13 0 29 0 58 0 59 0 60 0 61 0 63 0 92 0 115]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 4 109 0 33 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 113 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 4 117 0 201 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 121 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 4 125 0 44]
#[0 4 129 0 43]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 133 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 137 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 2 217 0 43 2 221 0 45 4 141 0 50 4 145 0 147]
#[0 4 149 0 50]
#[0 0 182 0 43 0 45 0 46 0 50]
#[0 0 186 0 43 0 45 0 46 0 50]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 153 0 139 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 157 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 1 102 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 106 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 110 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 98 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 70 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 114 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 94 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 78 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 74 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 86 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 90 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 118 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 126 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 122 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 1 82 0 5 0 7 0 13 0 15 0 29 0 35 0 39 0 58 0 59 0 60 0 61 0 63 0 66 0 69 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 161 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 165 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 169 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 173 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 177 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 181 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 185 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 189 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 193 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 197 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 201 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 205 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 209 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 213 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 141 0 90 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 217 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219]
#[1 0 57 0 13 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 113 0 66 0 117 0 69 0 125 0 84 0 129 0 86 0 133 0 88 0 141 0 90 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 221 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219]
#[1 1 234 0 1 1 234 0 2 1 234 0 3 1 234 0 4 1 234 0 5 1 234 0 7 1 234 0 10 1 234 0 11 1 234 0 13 1 234 0 15 1 234 0 16 1 234 0 17 1 234 0 18 1 234 0 19 1 234 0 20 1 234 0 21 1 234 0 22 1 234 0 23 1 234 0 24 1 234 0 26 1 234 0 27 1 234 0 28 1 234 0 33 1 234 0 40 1 234 0 41 1 234 0 43 1 234 0 45 1 234 0 46 1 234 0 47 1 234 0 49 1 234 0 50 1 234 0 51 1 234 0 53 1 234 0 54 1 234 0 55 1 234 0 57 1 234 0 65 1 234 0 68 1 234 0 73 1 234 0 74 1 234 0 77 1 234 0 85 1 234 0 89 1 234 0 91 1 234 0 93 1 234 0 94 1 234 0 95 1 234 0 97 1 234 0 99 4 225 0 102 1 234 0 106 1 234 0 110 4 229 0 178 1 234 0 237]
#[1 1 238 0 1 1 238 0 2 1 238 0 3 1 238 0 4 1 238 0 5 1 238 0 7 1 238 0 10 1 238 0 11 1 238 0 13 1 238 0 15 1 238 0 16 1 238 0 17 1 238 0 18 1 238 0 19 1 238 0 20 1 238 0 21 1 238 0 22 1 238 0 23 1 238 0 24 1 238 0 26 1 238 0 27 1 238 0 28 1 238 0 33 1 238 0 40 1 238 0 41 1 238 0 43 1 238 0 45 1 238 0 46 1 238 0 47 1 238 0 49 1 238 0 50 1 238 0 51 1 238 0 53 1 238 0 54 1 238 0 55 1 238 0 57 1 238 0 65 1 238 0 68 1 238 0 73 1 238 0 74 1 238 0 77 1 238 0 85 1 238 0 89 1 238 0 91 1 238 0 93 1 238 0 94 1 238 0 95 1 238 0 97 1 238 0 99 4 225 0 102 1 238 0 106 1 238 0 110 4 229 0 178 1 238 0 237]
#[0 1 246 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 14 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 1 242 0 1 1 242 0 2 1 242 0 3 1 242 0 4 1 242 0 5 1 242 0 7 1 242 0 10 1 242 0 11 1 242 0 13 1 242 0 15 1 242 0 16 1 242 0 17 1 242 0 18 1 242 0 19 1 242 0 20 1 242 0 21 1 242 0 22 1 242 0 23 1 242 0 24 1 242 0 26 1 242 0 27 1 242 0 28 1 242 0 33 1 242 0 40 1 242 0 41 1 242 0 43 1 242 0 45 1 242 0 46 1 242 0 47 1 242 0 49 1 242 0 50 1 242 0 51 1 242 0 53 1 242 0 54 1 242 0 55 1 242 0 57 1 242 0 65 1 242 0 68 1 242 0 73 1 242 0 74 1 242 0 77 1 242 0 85 1 242 0 89 1 242 0 91 1 242 0 93 1 242 0 94 1 242 0 95 1 242 0 97 1 242 0 99 4 225 0 102 1 242 0 106 1 242 0 110 4 229 0 178 1 242 0 237]
#[1 3 185 0 114 4 233 0 122]
#[0 4 237 0 38]
#[0 0 6 0 38]
#[0 0 38 0 30]
#[1 4 241 0 29 4 245 0 30]
#[1 3 185 0 114 4 249 0 122]
#[0 4 253 0 30]
#[0 5 1 0 52]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 5 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 5 9 0 33]
#[0 0 10 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 2 98 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 13 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 65 0 15 5 17 0 82 3 185 0 114 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 5 21 0 119 0 213 0 120 5 25 0 122 0 217 0 126 5 29 0 128 5 33 0 130 5 37 0 189 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 5 41 0 202 1 173 0 204 5 45 0 206 5 49 0 208 5 53 0 209]
#[0 3 6 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 5 57 0 40]
#[1 5 61 0 17 5 65 0 67]
#[0 3 170 0 33]
#[0 3 130 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 174 0 33]
#[0 5 69 0 33]
#[0 3 166 0 33]
#[0 5 73 0 65]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 5 77 0 65 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 81 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 5 85 0 214 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 2 178 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 5 89 0 52 5 93 0 56 5 97 0 152]
#[0 5 101 0 48]
#[0 2 126 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 150 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 122 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 5 105 0 33]
#[0 2 122 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 146 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 5 109 0 65]
#[0 3 222 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 154 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 5 113 0 68]
#[0 5 117 0 81]
#[0 5 121 0 85]
#[0 0 162 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 4 2 0 68 0 73 0 74 0 77]
#[0 0 166 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[1 5 125 0 68 5 129 0 73 5 133 0 74 5 137 0 77]
#[0 5 141 0 65]
#[0 5 145 0 65]
#[1 0 197 0 115 2 41 0 128 5 149 0 151]
#[0 5 153 0 57]
#[0 5 157 0 65]
#[0 3 158 0 33]
#[0 3 138 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 162 0 33]
#[0 5 161 0 33]
#[0 3 154 0 33]
#[0 5 165 0 65]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 5 169 0 65 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 173 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 2 186 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 2 234 0 33 5 177 0 41]
#[0 5 181 0 33]
#[0 0 78 0 33 0 65 0 106 0 237]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 185 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 5 189 0 154 5 193 0 155 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 5 197 0 44]
#[0 0 190 0 43 0 45 0 50]
#[0 0 118 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 201 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 5 205 0 50]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 209 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 0 150 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 1 42 0 1 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 1 50 0 1 0 2 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 1 54 0 1 0 2 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 1 58 0 1 0 2 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 1 66 0 1 0 2 0 4 0 10 0 15 0 16 0 17 0 18 0 19 0 21 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 138 0 1 0 2 0 3 0 4 0 10 0 15 0 16 0 17 0 18 0 19 0 21 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 134 0 1 0 2 0 3 0 4 0 10 0 15 0 16 0 17 0 18 0 19 0 21 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 150 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 15 0 16 0 17 0 18 0 19 0 21 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 146 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 15 0 16 0 17 0 18 0 19 0 21 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 154 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 15 0 16 0 17 0 18 0 19 0 21 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 158 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 15 0 16 0 17 0 18 0 19 0 21 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 21 0 22 0 23 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 170 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 21 0 22 0 23 0 27 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 182 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 21 0 22 0 23 0 24 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 178 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 21 0 22 0 23 0 24 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 222 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[0 1 218 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 106 0 110 0 237]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 5 213 0 106 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 217 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 2 10 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 5 221 0 40]
#[0 3 186 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 36 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 5 225 0 42]
#[0 5 229 0 42]
#[0 5 233 0 40]
#[1 0 197 0 115 5 237 0 128]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 241 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 0 134 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 5 245 0 6]
#[0 0 138 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 249 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 3 74 0 15 0 71 0 82 0 114 0 115 0 116 0 117 0 118 0 119 0 120]
#[0 3 66 0 15 0 71 0 82 0 114 0 115 0 116 0 117 0 118 0 119 0 120]
#[0 3 70 0 15 0 71 0 82 0 114 0 115 0 116 0 117 0 118 0 119 0 120]
#[0 3 58 0 15 0 71 0 82 0 114 0 115 0 116 0 117 0 118 0 119 0 120]
#[0 3 62 0 15 0 71 0 82 0 114 0 115 0 116 0 117 0 118 0 119 0 120]
#[1 0 65 0 15 3 30 0 71 5 17 0 82 3 185 0 114 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 5 21 0 119 0 213 0 120 5 25 0 122 0 217 0 126 5 29 0 128 5 33 0 130 5 37 0 189 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 5 41 0 202 1 173 0 204 5 253 0 206 5 49 0 208 5 53 0 209]
#[0 6 1 0 71]
#[1 0 65 0 15 3 38 0 71 5 17 0 82 3 185 0 114 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 5 21 0 119 0 213 0 120 5 25 0 122 0 217 0 126 5 29 0 128 5 33 0 130 5 37 0 189 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 5 41 0 202 1 173 0 204 6 5 0 206 5 49 0 208 5 53 0 209]
#[0 3 54 0 15 0 71 0 82 0 114 0 115 0 116 0 117 0 118 0 119 0 120]
#[1 5 17 0 82 0 213 0 120 6 9 0 126 6 13 0 130 6 17 0 207]
#[1 0 65 0 15 5 17 0 82 3 185 0 114 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 5 21 0 119 0 213 0 120 5 25 0 122 0 217 0 126 5 29 0 128 5 33 0 130 5 37 0 189 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 5 41 0 202 1 173 0 204 6 21 0 206 5 49 0 208 5 53 0 209]
#[0 3 10 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 3 134 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 6 25 0 82]
#[0 3 82 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 118 0 65]
#[0 6 29 0 65]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 33 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 6 37 0 39]
#[0 6 41 0 52]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 45 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 3 126 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 114 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 49 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 6 53 0 232]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 6 57 0 231]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 61 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 6 65 0 72 6 69 0 75]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 6 73 0 231]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 6 77 0 231]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 6 81 0 231]
#[0 2 206 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 78 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 6 85 0 48]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 89 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 2 202 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 3 142 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 6 93 0 82]
#[0 3 98 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 6 97 0 65]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 113 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 6 101 0 201 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 2 190 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 6 105 0 27 0 250 0 41 6 109 0 47 6 113 0 49 0 250 0 50 6 117 0 156 6 121 0 157 6 125 0 158]
#[0 0 194 0 50]
#[1 6 129 0 41 0 242 0 50]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 185 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 6 133 0 154 5 193 0 155 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 0 122 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 137 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 0 126 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 2 2 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 6 141 0 106]
#[1 0 213 0 120 6 145 0 121 3 153 0 126]
#[1 0 213 0 120 6 149 0 121 3 153 0 126]
#[1 0 213 0 120 6 153 0 121 3 153 0 126]
#[1 0 213 0 120 6 157 0 121 3 153 0 126]
#[0 6 161 0 35]
#[1 1 30 0 10 6 165 0 41]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 169 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 6 173 0 65]
#[0 3 34 0 71]
#[1 0 197 0 115 6 177 0 128]
#[0 3 42 0 71]
#[0 3 46 0 17 0 67 0 115]
#[0 3 50 0 17 0 67 0 115]
#[1 3 22 0 17 3 22 0 67 0 197 0 115 3 205 0 128 6 181 0 205]
#[0 6 185 0 71]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 6 189 0 65 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 81 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 6 193 0 214 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 3 86 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[1 6 197 0 41 0 210 0 43 0 210 0 45 0 210 0 46 0 210 0 50 0 210 0 51 0 210 0 54]
#[1 0 197 0 115 2 41 0 128 6 201 0 151]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 205 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 6 209 0 41 0 234 0 43 0 234 0 45 0 234 0 46 0 234 0 50 0 234 0 51 0 234 0 54]
#[0 3 226 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 0 158 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 6 213 0 85]
#[0 3 234 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 6 217 0 77]
#[0 6 221 0 77]
#[0 3 250 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 3 254 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 3 238 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 225 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 6 229 0 50]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 6 233 0 65 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 6 237 0 134 0 229 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 3 102 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 2 238 0 33]
#[1 6 241 0 8 6 245 0 25]
#[0 1 18 0 27 0 41 0 50]
#[0 1 14 0 27 0 41 0 50]
#[0 0 254 0 41 0 50]
#[1 6 105 0 27 1 2 0 41 1 2 0 50 6 249 0 158]
#[0 1 6 0 41 0 50]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 5 185 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 6 253 0 154 5 193 0 155 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 0 198 0 50]
#[0 0 130 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 1 254 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 7 1 0 38]
#[0 7 5 0 38]
#[0 7 9 0 38]
#[0 7 13 0 38]
#[1 0 66 0 33 7 17 0 39 0 66 0 41 7 21 0 129 7 25 0 131 7 29 0 132 7 33 0 133]
#[1 1 253 0 39 7 37 0 159]
#[0 7 41 0 4]
#[0 0 54 0 15 0 17 0 38 0 67 0 71 0 82 0 114 0 115 0 116 0 117 0 118 0 119 0 120]
#[0 7 45 0 17]
#[0 3 26 0 17 0 67]
#[1 0 197 0 115 7 49 0 128]
#[0 3 90 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 7 53 0 65]
#[1 2 49 0 39 7 57 0 150]
#[0 0 230 0 52]
#[1 7 61 0 41 0 218 0 43 0 218 0 45 0 218 0 46 0 218 0 50 0 218 0 51 0 218 0 54]
#[1 2 57 0 39 7 65 0 153]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 7 69 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 7 73 0 231]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 4 25 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229 7 77 0 231]
#[1 7 81 0 41 4 6 0 57]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 7 85 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 3 106 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 7 89 0 65]
#[0 1 26 0 41 0 50]
#[0 1 22 0 41 0 50]
#[0 1 10 0 41 0 50]
#[0 0 246 0 50]
#[0 3 190 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 36 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 0 14 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 0 18 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[0 0 22 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
#[1 0 197 0 115 7 93 0 128]
#[1 7 97 0 33 7 101 0 41]
#[0 0 46 0 33 0 41]
#[0 0 50 0 33 0 41]
#[0 0 62 0 33 0 41]
#[0 1 34 0 10]
#[1 0 41 0 5 0 45 0 7 0 49 0 9 0 53 0 12 0 57 0 13 0 61 0 14 0 65 0 15 0 69 0 29 0 73 0 35 0 77 0 39 0 81 0 51 0 85 0 54 0 89 0 58 0 93 0 59 0 97 0 60 0 101 0 61 0 105 0 63 0 109 0 64 0 113 0 66 0 117 0 69 0 121 0 78 0 125 0 84 0 129 0 86 0 133 0 88 0 137 0 89 0 141 0 90 0 145 0 91 0 149 0 92 0 153 0 96 0 157 0 98 0 161 0 100 0 165 0 103 0 169 0 104 0 173 0 105 0 177 0 107 0 181 0 108 0 185 0 109 0 189 0 111 0 193 0 112 0 197 0 115 0 201 0 116 0 205 0 117 0 209 0 118 0 213 0 120 0 217 0 126 0 221 0 128 7 105 0 135 0 233 0 136 0 237 0 137 0 241 0 138 0 245 0 139 0 249 0 140 0 253 0 141 1 1 0 142 1 5 0 143 1 9 0 144 1 13 0 145 1 17 0 148 1 21 0 149 1 25 0 160 1 29 0 161 1 33 0 162 1 37 0 166 1 41 0 167 1 45 0 168 1 49 0 169 1 53 0 170 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 1 77 0 177 1 81 0 180 1 85 0 181 1 89 0 182 1 93 0 183 1 97 0 184 1 101 0 185 1 105 0 186 1 109 0 187 1 113 0 188 1 117 0 189 1 121 0 190 1 125 0 191 1 129 0 192 1 133 0 193 1 137 0 194 1 141 0 195 1 145 0 196 1 149 0 197 1 153 0 198 1 157 0 199 1 161 0 200 1 165 0 202 1 169 0 203 1 173 0 204 1 177 0 210 1 181 0 211 1 185 0 212 1 189 0 213 1 193 0 215 1 197 0 216 1 201 0 217 1 205 0 218 1 209 0 219 1 217 0 229]
#[0 3 14 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 7 109 0 17]
#[0 3 94 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 0 214 0 43 0 45 0 46 0 50 0 51 0 54]
#[1 2 49 0 39 7 113 0 150]
#[0 0 238 0 43 0 45 0 46 0 50 0 51 0 54]
#[0 3 230 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 3 246 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 3 242 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[1 4 69 0 39 7 117 0 236]
#[0 0 170 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 3 110 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 237]
#[0 0 70 0 33 0 41]
#[1 5 17 0 82 7 121 0 130]
#[1 7 17 0 39 7 125 0 133]
#[0 0 142 0 4 0 10 0 27 0 33 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 54 0 57 0 65 0 68 0 73 0 74 0 77 0 85 0 106 0 237]
#[0 3 18 0 1 0 2 0 3 0 4 0 5 0 7 0 10 0 11 0 13 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 27 0 28 0 33 0 40 0 41 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 53 0 54 0 55 0 57 0 65 0 68 0 71 0 73 0 74 0 77 0 82 0 85 0 89 0 91 0 93 0 94 0 95 0 97 0 99 0 102 0 106 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 237]
#[0 0 222 0 43 0 45 0 46 0 50 0 51 0 54]
#[0 4 10 0 57]
#[0 7 129 0 38]
#[0 0 58 0 33 0 41]
#[0 0 26 0 5 0 7 0 9 0 12 0 13 0 14 0 15 0 29 0 34 0 35 0 39 0 51 0 54 0 58 0 59 0 60 0 61 0 63 0 64 0 66 0 69 0 78 0 84 0 86 0 88 0 89 0 90 0 91 0 92 0 96 0 98 0 100 0 103 0 104 0 105 0 107 0 108 0 109 0 111 0 112 0 115 0 116 0 117 0 118 0 120]
)

    "Modified: / 01-12-2008 / 10:19:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XQueryParser methodsFor:'informing'!

informAboutRuleReduction: aString

    (Smalltalk isStandAloneApp or:[self class isVerbose]) ifTrue:
        [Transcript show: '[XQuery::Parser] reducing rule '; showCR: aString]

    "Created: / 10-02-2007 / 13:00:28 / janfrog"
    "Modified: / 12-04-2007 / 11:16:11 / janfrog"
! !

!XQueryParser methodsFor:'private'!

actionForCurrentToken
        | ids action |
        ids := currentToken id.
        1 to: ids size
                do: 
                        [:i | 
                        action := self actionFor: (ids at: i).
                        (action bitAnd: self actionMask) = self errorAction ifFalse: [^action].
                        "(ids at: i) = scanner negative_numberId 
                                ifTrue: 
                                        [currentToken := SmaCCToken 
                                                                value: '-'
                                                                start: currentToken startPosition
                                                                id: (Array with: scanner binary_symbolId).
                                        scanner position: currentToken stopPosition - 1.
                                        ^self actionForCurrentToken]"].
        ^self errorAction

    "Created: / 17-03-2006 / 14:55:30 / ked"
! !

!XQueryParser class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/stx/goodies/xmlsuite/xquery/XQuery__XQueryParser.st,v 1.16 2008-01-02 14:05:41 wrobll1 Exp $'
! !
